"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/event","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/process","os","vs/platform/environment/common/environment","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetry","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","vs/platform/uriIdentity/common/uriIdentity","vs/server/node/serverEnvironmentService","vs/base/common/codicons","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/base/common/iterator","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/performance","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/base/common/functional","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/assert","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/normalization","vs/base/common/htmlContent","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/telemetry/common/commonProperties","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","zlib","vs/server/node/server.main"],ye=function(oe){for(var e=[],v=0,t=oe.length;v<t;v++)e[v]=we[oe[v]];return e};define(we[133],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class v{static get(){const D=new Map,C=new Map,T=new Map,I=new Map;function p(y,h){y.has(h.detail)||y.set(h.detail,-h.timestamp)}function b(y,h){const w=y.get(h.detail);!w||w>=0||y.set(h.detail,w+h.timestamp)}const R=oe.getStats().slice(0).sort((y,h)=>y.timestamp-h.timestamp);for(const y of R)switch(y.type){case 10:p(D,y);break;case 11:case 12:b(D,y);break;case 21:p(C,y);break;case 22:b(C,y);break;case 33:p(T,y);break;case 34:b(T,y);break;case 31:p(I,y);break;case 32:b(I,y);break}let k=0;T.forEach(y=>k+=y);function S(y){const h=[];return y.forEach((w,E)=>h.push([E,w])),h}return{amdLoad:S(D),amdInvoke:S(C),nodeRequire:S(T),nodeEval:S(I),nodeRequireTotal:k}}static toMarkdownTable(D,C){let T="";const I=[];return D.forEach((p,b)=>{I[b]=p.length}),C.forEach(p=>{p.forEach((b,R)=>{typeof b>"u"&&(b=p[R]="-");const k=b.toString().length;I[R]=Math.max(k,I[R])})}),D.forEach((p,b)=>{T+=`| ${p+" ".repeat(I[b]-p.toString().length)} `}),T+=`|
`,D.forEach((p,b)=>{T+=`| ${"-".repeat(I[b])} `}),T+=`|
`,C.forEach(p=>{p.forEach((b,R)=>{typeof b<"u"&&(T+=`| ${b+" ".repeat(I[R]-b.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=v}),define(we[41],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(T){return T?T.replace(/\$\((.*?)\)/g,(I,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(I,p,b){this.id=I,this.definition=p,this.description=b,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(T,I){const p=["codicon","codicon-"+T];return I&&p.push("codicon-modifier-"+I),p}e.getClassNamesArray=D;var C;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p(k){if(k instanceof t)return["codicon","codicon-"+k.id];const S=I.exec(k.id);if(!S)return p(t.error);const[,y,h]=S,w=["codicon","codicon-"+y];return h&&w.push("codicon-modifier-"+h.substr(1)),w}T.asClassNameArray=p;function b(k){return p(k).join(" ")}T.asClassName=b;function R(k){return"."+p(k).join(".")}T.asCSSSelector=R})(C=e.CSSIcon||(e.CSSIcon={}))}),define(we[83],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(T){return(I,p,b)=>{let R=null,k=null;if(typeof b.value=="function"?(R="value",k=b.value):typeof b.get=="function"&&(R="get",k=b.get),!k)throw new Error("not supported");b[R]=T(k,p)}}e.createDecorator=v;function t(T,I,p){let b=null,R=null;if(typeof p.value=="function"?(b="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(b="get",R=p.get),!R)throw new Error("not supported");const k=`$memoize$${I}`;p[b]=function(...S){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,S)}),this[k]}}e.memoize=t;function D(T,I,p){return v((b,R)=>{const k=`$debounce$${R}`,S=`$debounce$result$${R}`;return function(...y){this[S]||(this[S]=p?p():void 0),clearTimeout(this[k]),I&&(this[S]=I(this[S],...y),y=[this[S]]),this[k]=setTimeout(()=>{b.apply(this,y),this[S]=p?p():void 0},T)}})}e.debounce=D;function C(T,I,p){return v((b,R)=>{const k=`$throttle$timer$${R}`,S=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,h=`$throttle$pending$${R}`;return function(...w){if(this[S]||(this[S]=p?p():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),I&&(this[S]=I(this[S],...w)),this[h])return;const E=this[y]+T;E<=Date.now()?(this[y]=Date.now(),b.apply(this,[this[S]]),this[S]=p?p():void 0):(this[h]=!0,this[k]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),b.apply(this,[this[S]]),this[S]=p?p():void 0},E-Date.now()))}})}e.throttle=C}),define(we[8],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?u.isErrorNoTelemetry(r)?new u(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=v,e.errorHandler=new v;function t(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=t;function D(f){p(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=D;function C(f){p(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=C;function T(f){if(f instanceof Error){const{name:r,message:o}=f,n=f.stacktrace||f.stack;return{$isError:!0,name:r,message:o,stack:n,noTelemetry:u.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=T;const I="Canceled";function p(f){return f instanceof b?!0:f instanceof Error&&f.name===I&&f.message===I}e.isCancellationError=p;class b extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=b;function R(){const f=new Error(I);return f.name=f.message,f}e.canceled=R;function k(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=k;function S(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=S;function y(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(f){const r=new Error(`${f} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function w(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=w;class E extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=E;class g extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=g;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class u extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof u)return r;const o=new u;return o.message=r.message,o.stack=r.stack,o}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class l extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(we[18],ye([1,0,8]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(H,Y=0){return H[H.length-(1+Y)]}e.tail=t;function D(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=D;function C(H,Y,te=(W,q)=>W===q){if(H===Y)return!0;if(!H||!Y||H.length!==Y.length)return!1;for(let W=0,q=H.length;W<q;W++)if(!te(H[W],Y[W]))return!1;return!0}e.equals=C;function T(H,Y){const te=H.length-1;Y<te&&(H[Y]=H[te]),H.pop()}e.removeFastWithoutKeepingOrder=T;function I(H,Y,te){return p(H.length,W=>te(H[W],Y))}e.binarySearch=I;function p(H,Y){let te=0,W=H-1;for(;te<=W;){const q=(te+W)/2|0,j=Y(q);if(j<0)te=q+1;else if(j>0)W=q-1;else return q}return-(te+1)}e.binarySearch2=p;function b(H,Y){let te=0,W=H.length;if(W===0)return 0;for(;te<W;){const q=Math.floor((te+W)/2);Y(H[q])?W=q:te=q+1}return te}e.findFirstInSorted=b;function R(H,Y,te){if(H=H|0,H>=Y.length)throw new TypeError("invalid index");const W=Y[Math.floor(Y.length*Math.random())],q=[],j=[],Q=[];for(const le of Y){const pe=te(le,W);pe<0?q.push(le):pe>0?j.push(le):Q.push(le)}return H<q.length?R(H,q,te):H<q.length+Q.length?Q[0]:R(H-(q.length+Q.length),j,te)}e.quickSelect=R;function k(H,Y){const te=[];let W;for(const q of H.slice(0).sort(Y))!W||Y(W[0],q)!==0?(W=[q],te.push(W)):W.push(q);return te}e.groupBy=k;function S(H,Y,te){const W=[];function q(le,pe,ke){if(pe===0&&ke.length===0)return;const Te=W[W.length-1];Te&&Te.start+Te.deleteCount===le?(Te.deleteCount+=pe,Te.toInsert.push(...ke)):W.push({start:le,deleteCount:pe,toInsert:ke})}let j=0,Q=0;for(;;){if(j===H.length){q(j,0,Y.slice(Q));break}if(Q===Y.length){q(j,H.length-j,[]);break}const le=H[j],pe=Y[Q],ke=te(le,pe);ke===0?(j+=1,Q+=1):ke<0?(q(j,1,[]),j+=1):ke>0&&(q(j,0,[pe]),Q+=1)}return W}e.sortedDiff=S;function y(H,Y,te){const W=S(H,Y,te),q=[],j=[];for(const Q of W)q.push(...H.slice(Q.start,Q.start+Q.deleteCount)),j.push(...Q.toInsert);return{removed:q,added:j}}e.delta=y;function h(H,Y,te){if(te===0)return[];const W=H.slice(0,te).sort(Y);return E(H,Y,W,te,H.length),W}e.top=h;function w(H,Y,te,W,q){return te===0?Promise.resolve([]):new Promise((j,Q)=>{(async()=>{const le=H.length,pe=H.slice(0,te).sort(Y);for(let ke=te,Te=Math.min(te+W,le);ke<le;ke=Te,Te=Math.min(Te+W,le)){if(ke>te&&await new Promise(Ne=>setTimeout(Ne)),q&&q.isCancellationRequested)throw new v.CancellationError;E(H,Y,pe,ke,Te)}return pe})().then(j,Q)})}e.topAsync=w;function E(H,Y,te,W,q){for(const j=te.length;W<q;W++){const Q=H[W];if(Y(Q,te[j-1])<0){te.pop();const le=b(te,pe=>Y(Q,pe)<0);te.splice(le,0,Q)}}}function g(H){return H.filter(Y=>!!Y)}e.coalesce=g;function m(H){let Y=0;for(let te=0;te<H.length;te++)H[te]&&(H[Y]=H[te],Y+=1);H.length=Y}e.coalesceInPlace=m;function u(H,Y,te){H.splice(te,0,H.splice(Y,1)[0])}e.move=u;function l(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=l;function f(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=f;function r(H,Y=te=>te){const te=new Set;return H.filter(W=>{const q=Y(W);return te.has(q)?!1:(te.add(q),!0)})}e.distinct=r;function o(H){const Y=new Set;return te=>{const W=H(te);return Y.has(W)?!1:(Y.add(W),!0)}}e.uniqueFilter=o;function n(H,Y){const te=i(H,Y);if(te!==-1)return H[te]}e.findLast=n;function i(H,Y){for(let te=H.length-1;te>=0;te--){const W=H[te];if(Y(W))return te}return-1}e.lastIndex=i;function s(H,Y){return H.length>0?H[0]:Y}e.firstOrDefault=s;function a(H,Y){return H.length>0?H[H.length-1]:Y}e.lastOrDefault=a;function c(H,Y,te=(W,q)=>W===q){let W=0;for(let q=0,j=Math.min(H.length,Y.length);q<j&&te(H[q],Y[q]);q++)W++;return W}e.commonPrefixLength=c;function d(H){return[].concat(...H)}e.flatten=d;function P(H,Y){let te=typeof Y=="number"?H:0;typeof Y=="number"?te=H:(te=0,Y=H);const W=[];if(te<=Y)for(let q=te;q<Y;q++)W.push(q);else for(let q=te;q>Y;q--)W.push(q);return W}e.range=P;function F(H,Y,te){return H.reduce((W,q)=>(W[Y(q)]=te?te(q):q,W),Object.create(null))}e.index=F;function $(H,Y){return H.push(Y),()=>Z(H,Y)}e.insert=$;function Z(H,Y){const te=H.indexOf(Y);if(te>-1)return H.splice(te,1),Y}e.remove=Z;function J(H,Y,te){const W=H.slice(0,Y),q=H.slice(Y);return W.concat(te,q)}e.arrayInsert=J;function _(H,Y){let te;if(typeof Y=="number"){let W=Y;te=()=>{const q=Math.sin(W++)*179426549;return q-Math.floor(q)}}else te=Math.random;for(let W=H.length-1;W>0;W-=1){const q=Math.floor(te()*(W+1)),j=H[W];H[W]=H[q],H[q]=j}}e.shuffle=_;function ee(H,Y){const te=H.indexOf(Y);te>-1&&(H.splice(te,1),H.unshift(Y))}e.pushToStart=ee;function ne(H,Y){const te=H.indexOf(Y);te>-1&&(H.splice(te,1),H.push(Y))}e.pushToEnd=ne;function B(H,Y){for(const te of Y)H.push(te)}e.pushMany=B;function ue(H,Y){return Array.isArray(H)?H.map(Y):Y(H)}e.mapArrayOrNot=ue;function z(H){return Array.isArray(H)?H:[H]}e.asArray=z;function X(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=X;function O(H,Y){for(const te of H){const W=Y(te);if(W!==void 0)return W}}e.mapFind=O;function U(H,Y,te){const W=ae(H,Y),q=H.length,j=te.length;H.length=q+j;for(let Q=q-1;Q>=W;Q--)H[Q+j]=H[Q];for(let Q=0;Q<j;Q++)H[Q+W]=te[Q]}e.insertInto=U;function x(H,Y,te,W){const q=ae(H,Y),j=H.splice(q,te);return U(H,q,W),j}e.splice=x;function ae(H,Y){return Y<0?Math.max(Y+H.length,0):Math.min(Y,H.length)}var fe;(function(H){function Y(q){return q<0}H.isLessThan=Y;function te(q){return q>0}H.isGreaterThan=te;function W(q){return q===0}H.isNeitherLessOrGreaterThan=W,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(fe=e.CompareResult||(e.CompareResult={}));function K(H,Y){return(te,W)=>Y(H(te),H(W))}e.compareBy=K;function ie(...H){return(Y,te)=>{for(const W of H){const q=W(Y,te);if(!fe.isNeitherLessOrGreaterThan(q))return q}return fe.neitherLessOrGreaterThan}}e.tieBreakComparators=ie;const L=(H,Y)=>H-Y;e.numberComparator=L;function M(H,Y){if(H.length===0)return;let te=H[0];for(let W=1;W<H.length;W++){const q=H[W];Y(q,te)>0&&(te=q)}return te}e.findMaxBy=M;function G(H,Y){if(H.length===0)return;let te=H[0];for(let W=1;W<H.length;W++){const q=H[W];Y(q,te)>=0&&(te=q)}return te}e.findLastMaxBy=G;function re(H,Y){return M(H,(te,W)=>-Y(te,W))}e.findMinBy=re;class he{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let te=this.firstIdx;for(;te<this.items.length&&Y(this.items[te]);)te++;const W=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,W}takeFromEndWhile(Y){let te=this.lastIdx;for(;te>=0&&Y(this.items[te]);)te--;const W=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,W}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}removeLast(){const Y=this.items[this.lastIdx];return this.lastIdx--,Y}takeCount(Y){const te=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,te}}e.ArrayQueue=he;class ve{constructor(Y){this.iterate=Y}forEach(Y){this.iterate(te=>(Y(te),!0))}toArray(){const Y=[];return this.iterate(te=>(Y.push(te),!0)),Y}filter(Y){return new ve(te=>this.iterate(W=>Y(W)?te(W):!0))}map(Y){return new ve(te=>this.iterate(W=>te(Y(W))))}some(Y){let te=!1;return this.iterate(W=>(te=Y(W),!te)),te}findFirst(Y){let te;return this.iterate(W=>Y(W)?(te=W,!1):!0),te}findLast(Y){let te;return this.iterate(W=>(Y(W)&&(te=W),!0)),te}findLastMaxBy(Y){let te,W=!0;return this.iterate(q=>((W||fe.isGreaterThan(Y(q,te)))&&(W=!1,te=q),!0)),te}}e.CallbackIterable=ve,ve.empty=new ve(H=>{})}),define(we[84],ye([1,0,8]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(p,b){if(!p)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=t;function D(p,b="Unreachable"){throw new Error(b)}e.assertNever=D;function C(p){if(!p)throw new v.BugIndicatingError("Assertion Failed")}e.assert=C;function T(p){if(!p()){debugger;p(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function I(p,b){let R=0;for(;R<p.length-1;){const k=p[R],S=p[R+1];if(!b(k,S))return!1;R++}return!0}e.checkAdjacentItems=I}),define(we[64],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const D=this;let C=!1,T;return function(){return C||(C=!0,T=t.apply(D,arguments)),T}}e.once=v}),define(we[44],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function D(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=D;const C=Object.freeze([]);function T(){return C}t.empty=T;function*I(o){yield o}t.single=I;function p(o){return o||C}t.from=p;function b(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=b;function R(o){return o[Symbol.iterator]().next().value}t.first=R;function k(o,n){for(const i of o)if(n(i))return!0;return!1}t.some=k;function S(o,n){for(const i of o)if(n(i))return i}t.find=S;function*y(o,n){for(const i of o)n(i)&&(yield i)}t.filter=y;function*h(o,n){let i=0;for(const s of o)yield n(s,i++)}t.map=h;function*w(...o){for(const n of o)for(const i of n)yield i}t.concat=w;function*E(o){for(const n of o)for(const i of n)yield i}t.concatNested=E;function g(o,n,i){let s=i;for(const a of o)s=n(s,a);return s}t.reduce=g;function m(o,n){let i=0;for(const s of o)n(s,i++)}t.forEach=m;function*u(o,n,i=o.length){for(n<0&&(n+=o.length),i<0?i+=o.length:i>o.length&&(i=o.length);n<i;n++)yield o[n]}t.slice=u;function l(o,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,o];const s=o[Symbol.iterator]();for(let a=0;a<n;a++){const c=s.next();if(c.done)return[i,t.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=l;function f(o){return l(o)[0]}t.collect=f;function r(o,n,i=(s,a)=>s===a){const s=o[Symbol.iterator](),a=n[Symbol.iterator]();for(;;){const c=s.next(),d=a.next();if(c.done!==d.done)return!1;if(c.done)return!0;if(!i(c.value,d.value))return!1}}t.equals=r})(v=e.Iterable||(e.Iterable={}))}),define(we[65],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(r){r.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function T(r,o=!1){let n=0;const i=r.length;let s="",a=0,c=16,d=0;function P(ne){let B=0,ue=0;for(;B<ne;){const z=r.charCodeAt(n);if(z>=48&&z<=57)ue=ue*16+z-48;else if(z>=65&&z<=70)ue=ue*16+z-65+10;else if(z>=97&&z<=102)ue=ue*16+z-97+10;else break;n++,B++}return B<ne&&(ue=-1),ue}function F(ne){n=ne,s="",a=0,c=16,d=0}function $(){const ne=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&b(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&b(r.charCodeAt(n)))for(n++;n<r.length&&b(r.charCodeAt(n));)n++;else return d=3,r.substring(ne,n);let B=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&b(r.charCodeAt(n))){for(n++;n<r.length&&b(r.charCodeAt(n));)n++;B=n}else d=3;return r.substring(ne,B)}function Z(){let ne="",B=n;for(;;){if(n>=i){ne+=r.substring(B,n),d=2;break}const ue=r.charCodeAt(n);if(ue===34){ne+=r.substring(B,n),n++;break}if(ue===92){if(ne+=r.substring(B,n),n++,n>=i){d=2;break}switch(r.charCodeAt(n++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const X=P(4);X>=0?ne+=String.fromCharCode(X):d=4;break}default:d=5}B=n;continue}if(ue>=0&&ue<=31)if(p(ue)){ne+=r.substring(B,n),d=2;break}else d=6;n++}return ne}function J(){if(s="",d=0,a=n,n>=i)return a=i,c=17;let ne=r.charCodeAt(n);if(I(ne)){do n++,s+=String.fromCharCode(ne),ne=r.charCodeAt(n);while(I(ne));return c=15}if(p(ne))return n++,s+=String.fromCharCode(ne),ne===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),c=14;switch(ne){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,s=Z(),c=10;case 47:{const B=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<i&&!p(r.charCodeAt(n));)n++;return s=r.substring(B,n),c=12}if(r.charCodeAt(n+1)===42){n+=2;const ue=i-1;let z=!1;for(;n<ue;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,z=!0;break}n++}return z||(n++,d=1),s=r.substring(B,n),c=13}return s+=String.fromCharCode(ne),n++,c=16}case 45:if(s+=String.fromCharCode(ne),n++,n===i||!b(r.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=$(),c=11;default:for(;n<i&&_(ne);)n++,ne=r.charCodeAt(n);if(a!==n){switch(s=r.substring(a,n),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(ne),n++,c=16}}function _(ne){if(I(ne)||p(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let ne;do ne=J();while(ne>=12&&ne<=15);return ne}return{setPosition:F,getPosition:()=>n,scan:o?ee:J,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>d}}e.createScanner=T;function I(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function p(r){return r===10||r===13||r===8232||r===8233}function b(r){return r>=48&&r<=57}var R;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(R||(R={}));function k(r,o){const n=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function d(P,F,$,Z){a.value=P,a.offset=F,a.length=$,a.type=Z,a.colonOffset=void 0,s=a}try{u(r,{onObjectBegin:(P,F)=>{if(o<=P)throw i;s=void 0,c=o>P,n.push("")},onObjectProperty:(P,F,$)=>{if(o<F||(d(P,F,$,"property"),n[n.length-1]=P,o<=F+$))throw i},onObjectEnd:(P,F)=>{if(o<=P)throw i;s=void 0,n.pop()},onArrayBegin:(P,F)=>{if(o<=P)throw i;s=void 0,n.push(0)},onArrayEnd:(P,F)=>{if(o<=P)throw i;s=void 0,n.pop()},onLiteralValue:(P,F,$)=>{if(o<F||(d(P,F,$,f(P)),o<=F+$))throw i},onSeparator:(P,F,$)=>{if(o<=F)throw i;if(P===":"&&s&&s.type==="property")s.colonOffset=F,c=!1,s=void 0;else if(P===","){const Z=n[n.length-1];typeof Z=="number"?n[n.length-1]=Z+1:(c=!0,n[n.length-1]=""),s=void 0}}})}catch(P){if(P!==i)throw P}return{path:n,previousNode:s,isAtPropertyKey:c,matches:P=>{let F=0;for(let $=0;F<P.length&&$<n.length;$++)if(P[F]===n[$]||P[F]==="*")F++;else if(P[F]!=="**")return!1;return F===P.length}}}e.getLocation=k;function S(r,o=[],n=C.DEFAULT){let i=null,s=[];const a=[];function c(P){Array.isArray(s)?s.push(P):i!==null&&(s[i]=P)}return u(r,{onObjectBegin:()=>{const P={};c(P),a.push(s),s=P,i=null},onObjectProperty:P=>{i=P},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const P=[];c(P),a.push(s),s=P,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:c,onError:(P,F,$)=>{o.push({error:P,offset:F,length:$})}},n),s[0]}e.parse=S;function y(r,o=[],n=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(P){i.type==="property"&&(i.length=P-i.offset,i=i.parent)}function a(P){return i.children.push(P),P}u(r,{onObjectBegin:P=>{i=a({type:"object",offset:P,length:-1,parent:i,children:[]})},onObjectProperty:(P,F,$)=>{i=a({type:"property",offset:F,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:P,offset:F,length:$,parent:i})},onObjectEnd:(P,F)=>{i.length=P+F-i.offset,i=i.parent,s(P+F)},onArrayBegin:(P,F)=>{i=a({type:"array",offset:P,length:-1,parent:i,children:[]})},onArrayEnd:(P,F)=>{i.length=P+F-i.offset,i=i.parent,s(P+F)},onLiteralValue:(P,F,$)=>{a({type:f(P),offset:F,length:$,parent:i,value:P}),s(F+$)},onSeparator:(P,F,$)=>{i.type==="property"&&(P===":"?i.colonOffset=F:P===","&&s(F))},onError:(P,F,$)=>{o.push({error:P,offset:F,length:$})}},n);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=y;function h(r,o){if(!r)return;let n=r;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function w(r){if(!r.parent||!r.parent.children)return[];const o=w(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;o.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&o.push(n)}return o}e.getNodePath=w;function E(r){switch(r.type){case"array":return r.children.map(E);case"object":{const o=Object.create(null);for(const n of r.children){const i=n.children[1];i&&(o[n.children[0].value]=E(i))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=E;function g(r,o,n=!1){return o>=r.offset&&o<r.offset+r.length||n&&o===r.offset+r.length}e.contains=g;function m(r,o,n=!1){if(g(r,o,n)){const i=r.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const a=m(i[s],o,n);if(a)return a}return r}}e.findNodeAtOffset=m;function u(r,o,n=C.DEFAULT){const i=T(r,!1);function s(K){return K?()=>K(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(K){return K?ie=>K(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=s(o.onObjectBegin),d=a(o.onObjectProperty),P=s(o.onObjectEnd),F=s(o.onArrayBegin),$=s(o.onArrayEnd),Z=a(o.onLiteralValue),J=a(o.onSeparator),_=s(o.onComment),ee=a(o.onError),ne=n&&n.disallowComments,B=n&&n.allowTrailingComma;function ue(){for(;;){const K=i.scan();switch(i.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:ne||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(K){case 12:case 13:ne?z(10):_();break;case 16:z(1);break;case 15:case 14:break;default:return K}}}function z(K,ie=[],L=[]){if(ee(K),ie.length+L.length>0){let M=i.getToken();for(;M!==17;){if(ie.indexOf(M)!==-1){ue();break}else if(L.indexOf(M)!==-1)break;M=ue()}}}function X(K){const ie=i.getTokenValue();return K?Z(ie):d(ie),ue(),!0}function O(){switch(i.getToken()){case 11:{let K=0;try{K=JSON.parse(i.getTokenValue()),typeof K!="number"&&(z(2),K=0)}catch{z(2)}Z(K);break}case 7:Z(null);break;case 8:Z(!0);break;case 9:Z(!1);break;default:return!1}return ue(),!0}function U(){return i.getToken()!==10?(z(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(J(":"),ue(),fe()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function x(){c(),ue();let K=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(K||z(4,[],[]),J(","),ue(),i.getToken()===2&&B)break}else K&&z(6,[],[]);U()||z(4,[],[2,5]),K=!0}return P(),i.getToken()!==2?z(7,[2],[]):ue(),!0}function ae(){F(),ue();let K=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(K||z(4,[],[]),J(","),ue(),i.getToken()===4&&B)break}else K&&z(6,[],[]);fe()||z(4,[],[4,5]),K=!0}return $(),i.getToken()!==4?z(8,[4],[]):ue(),!0}function fe(){switch(i.getToken()){case 3:return ae();case 1:return x();case 10:return X(!0);default:return O()}}return ue(),i.getToken()===17?n.allowEmptyContent?!0:(z(4,[],[]),!1):fe()?(i.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=u;function l(r,o){const n=T(r),i=[];let s,a=0,c;do switch(c=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==c&&i.push(r.substring(a,c)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(s!==17);return i.join("")}e.stripComments=l;function f(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(we[134],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(we[2],ye([1,0,64,44]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function T(s){C=s}if(e.setDisposableTracker=T,D){const s="__is_disposable_tracked__";T(new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(c)},3e3)}setParent(a,c){if(a&&a!==m.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==m.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function I(s){return C?.trackDisposable(s),s}function p(s){C?.markAsDisposed(s)}function b(s,a){C?.setParent(s,a)}function R(s,a){if(!!C)for(const c of s)C.setParent(c,a)}function k(s){return C?.markAsSingleton(s),s}e.markAsSingleton=k;function S(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=S;function y(s){if(t.Iterable.is(s)){const a=[];for(const c of s)if(c)try{c.dispose()}catch(d){a.push(d)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=y;function h(s){for(const a of s)S(a)&&a.dispose();return[]}e.disposeIfDisposable=h;function w(...s){const a=E(()=>y(s));return R(s,a),a}e.combinedDisposable=w;function E(s){const a=I({dispose:(0,v.once)(()=>{p(a),s()})});return a}e.toDisposable=E;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{y(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new g,I(this),b(this._store,this)}dispose(){p(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&b(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&b(a,null),a}}e.MutableDisposable=u;class l{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(a){let c=a;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,p(this))},this}}e.SafeDisposable=f;class r{constructor(){this.references=new Map}acquire(a,...c){let d=this.references.get(a);d||(d={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,d));const{object:P}=d,F=(0,v.once)(()=>{--d.counter===0&&(this.destroyReferencedObject(a,d.object),this.references.delete(a))});return d.counter++,{object:P,dispose:F}}}e.ReferenceCollection=r;class o{constructor(a){this.referenceCollection=a}async acquire(a,...c){const d=this.referenceCollection.acquire(a,...c);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(P){throw d.dispose(),P}}}e.AsyncReferenceCollection=o;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function i(s){const a=new g;try{s(a)}finally{a.dispose()}}e.disposeOnReturn=i}),define(we[135],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(C){this.element=C,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let C=this._first;for(;C!==v.Undefined;){const T=C.next;C.prev=v.Undefined,C.next=v.Undefined,C=T}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,T){const I=new v(C);if(this._first===v.Undefined)this._first=I,this._last=I;else if(T){const b=this._last;this._last=I,I.prev=b,b.next=I}else{const b=this._first;this._first=I,I.next=b,b.prev=I}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(I))}}shift(){if(this._first!==v.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==v.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==v.Undefined&&C.next!==v.Undefined){const T=C.prev;T.next=C.next,C.next.prev=T}else C.prev===v.Undefined&&C.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):C.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):C.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==v.Undefined;)yield C.element,C=C.next}}e.LinkedList=t}),function(oe,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(we[136],ye([0]),e):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(H,Y){for(var te=0;te<Y.length;te++){var W=Y[te];W.enumerable=W.enumerable||!1,W.configurable=!0,"value"in W&&(W.writable=!0),Object.defineProperty(H,W.key,W)}}function v(H,Y,te){return Y&&e(H.prototype,Y),te&&e(H,te),Object.defineProperty(H,"prototype",{writable:!1}),H}function t(H,Y){if(!!H){if(typeof H=="string")return D(H,Y);var te=Object.prototype.toString.call(H).slice(8,-1);if(te==="Object"&&H.constructor&&(te=H.constructor.name),te==="Map"||te==="Set")return Array.from(H);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return D(H,Y)}}function D(H,Y){(Y==null||Y>H.length)&&(Y=H.length);for(var te=0,W=new Array(Y);te<Y;te++)W[te]=H[te];return W}function C(H,Y){var te=typeof Symbol<"u"&&H[Symbol.iterator]||H["@@iterator"];if(te)return(te=te.call(H)).next.bind(te);if(Array.isArray(H)||(te=t(H))||Y&&H&&typeof H.length=="number"){te&&(H=te);var W=0;return function(){return W>=H.length?{done:!0}:{done:!1,value:H[W++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=T();function I(H){oe.defaults=H}var p=/[&<>"']/,b=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(Y){return S[Y]};function h(H,Y){if(Y){if(p.test(H))return H.replace(b,y)}else if(R.test(H))return H.replace(k,y);return H}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function E(H){return H.replace(w,function(Y,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var g=/(^|[^\[])\^/g;function m(H,Y){H=typeof H=="string"?H:H.source,Y=Y||"";var te={replace:function(q,j){return j=j.source||j,j=j.replace(g,"$1"),H=H.replace(q,j),te},getRegex:function(){return new RegExp(H,Y)}};return te}var u=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(H,Y,te){if(H){var W;try{W=decodeURIComponent(E(te)).replace(u,"").toLowerCase()}catch{return null}if(W.indexOf("javascript:")===0||W.indexOf("vbscript:")===0||W.indexOf("data:")===0)return null}Y&&!l.test(te)&&(te=s(Y,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var r={},o=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(H,Y){r[" "+H]||(o.test(H)?r[" "+H]=H+"/":r[" "+H]=P(H,"/",!0)),H=r[" "+H];var te=H.indexOf(":")===-1;return Y.substring(0,2)==="//"?te?Y:H.replace(n,"$1")+Y:Y.charAt(0)==="/"?te?Y:H.replace(i,"$1")+Y:H+Y}var a={exec:function(){}};function c(H){for(var Y=1,te,W;Y<arguments.length;Y++){te=arguments[Y];for(W in te)Object.prototype.hasOwnProperty.call(te,W)&&(H[W]=te[W])}return H}function d(H,Y){var te=H.replace(/\|/g,function(j,Q,le){for(var pe=!1,ke=Q;--ke>=0&&le[ke]==="\\";)pe=!pe;return pe?"|":" |"}),W=te.split(/ \|/),q=0;if(W[0].trim()||W.shift(),W.length>0&&!W[W.length-1].trim()&&W.pop(),W.length>Y)W.splice(Y);else for(;W.length<Y;)W.push("");for(;q<W.length;q++)W[q]=W[q].trim().replace(/\\\|/g,"|");return W}function P(H,Y,te){var W=H.length;if(W===0)return"";for(var q=0;q<W;){var j=H.charAt(W-q-1);if(j===Y&&!te)q++;else if(j!==Y&&te)q++;else break}return H.slice(0,W-q)}function F(H,Y){if(H.indexOf(Y[1])===-1)return-1;for(var te=H.length,W=0,q=0;q<te;q++)if(H[q]==="\\")q++;else if(H[q]===Y[0])W++;else if(H[q]===Y[1]&&(W--,W<0))return q;return-1}function $(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Z(H,Y){if(Y<1)return"";for(var te="";Y>1;)Y&1&&(te+=H),Y>>=1,H+=H;return te+H}function J(H,Y,te,W){var q=Y.href,j=Y.title?h(Y.title):null,Q=H[1].replace(/\\([\[\]])/g,"$1");if(H[0].charAt(0)!=="!"){W.state.inLink=!0;var le={type:"link",raw:te,href:q,title:j,text:Q,tokens:W.inlineTokens(Q)};return W.state.inLink=!1,le}return{type:"image",raw:te,href:q,title:j,text:h(Q)}}function _(H,Y){var te=H.match(/^(\s+)(?:```)/);if(te===null)return Y;var W=te[1];return Y.split(`
`).map(function(q){var j=q.match(/^\s+/);if(j===null)return q;var Q=j[0];return Q.length>=W.length?q.slice(W.length):q}).join(`
`)}var ee=function(){function H(te){this.options=te||oe.defaults}var Y=H.prototype;return Y.space=function(W){var q=this.rules.block.newline.exec(W);if(q&&q[0].length>0)return{type:"space",raw:q[0]}},Y.code=function(W){var q=this.rules.block.code.exec(W);if(q){var j=q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:q[0],codeBlockStyle:"indented",text:this.options.pedantic?j:P(j,`
`)}}},Y.fences=function(W){var q=this.rules.block.fences.exec(W);if(q){var j=q[0],Q=_(j,q[3]||"");return{type:"code",raw:j,lang:q[2]?q[2].trim():q[2],text:Q}}},Y.heading=function(W){var q=this.rules.block.heading.exec(W);if(q){var j=q[2].trim();if(/#$/.test(j)){var Q=P(j,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(j=Q.trim())}return{type:"heading",raw:q[0],depth:q[1].length,text:j,tokens:this.lexer.inline(j)}}},Y.hr=function(W){var q=this.rules.block.hr.exec(W);if(q)return{type:"hr",raw:q[0]}},Y.blockquote=function(W){var q=this.rules.block.blockquote.exec(W);if(q){var j=q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:q[0],tokens:this.lexer.blockTokens(j,[]),text:j}}},Y.list=function(W){var q=this.rules.block.list.exec(W);if(q){var j,Q,le,pe,ke,Te,Ne,Le,me,be,Ee,Me,Be=q[1].trim(),Ve=Be.length>1,ze={type:"list",raw:"",ordered:Ve,start:Ve?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ve?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ve?Be:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");W&&(Me=!1,!(!(q=Ye.exec(W))||this.rules.block.hr.test(W)));){if(j=q[0],W=W.substring(j.length),Le=q[2].split(`
`,1)[0],me=W.split(`
`,1)[0],this.options.pedantic?(pe=2,Ee=Le.trimLeft()):(pe=q[2].search(/[^ ]/),pe=pe>4?1:pe,Ee=Le.slice(pe),pe+=q[1].length),Te=!1,!Le&&/^ *$/.test(me)&&(j+=me+`
`,W=W.substring(me.length+1),Me=!0),!Me)for(var Ke=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),qe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),je=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),xe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");W&&(be=W.split(`
`,1)[0],Le=be,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(je.test(Le)||xe.test(Le)||Ke.test(Le)||qe.test(W)));){if(Le.search(/[^ ]/)>=pe||!Le.trim())Ee+=`
`+Le.slice(pe);else if(!Te)Ee+=`
`+Le;else break;!Te&&!Le.trim()&&(Te=!0),j+=be+`
`,W=W.substring(be.length+1)}ze.loose||(Ne?ze.loose=!0:/\n *\n *$/.test(j)&&(Ne=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(Ee),Q&&(le=Q[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:j,task:!!Q,checked:le,loose:!1,text:Ee}),ze.raw+=j}ze.items[ze.items.length-1].raw=j.trimRight(),ze.items[ze.items.length-1].text=Ee.trimRight(),ze.raw=ze.raw.trimRight();var Ge=ze.items.length;for(ke=0;ke<Ge;ke++){this.lexer.state.top=!1,ze.items[ke].tokens=this.lexer.blockTokens(ze.items[ke].text,[]);var ce=ze.items[ke].tokens.filter(function(Ie){return Ie.type==="space"}),Ce=ce.every(function(Ie){for(var Ae=Ie.raw.split(""),Fe=0,$e=C(Ae),Qe;!(Qe=$e()).done;){var rt=Qe.value;if(rt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!ze.loose&&ce.length&&Ce&&(ze.loose=!0,ze.items[ke].loose=!0)}return ze}},Y.html=function(W){var q=this.rules.block.html.exec(W);if(q){var j={type:"html",raw:q[0],pre:!this.options.sanitizer&&(q[1]==="pre"||q[1]==="script"||q[1]==="style"),text:q[0]};if(this.options.sanitize){var Q=this.options.sanitizer?this.options.sanitizer(q[0]):h(q[0]);j.type="paragraph",j.text=Q,j.tokens=this.lexer.inline(Q)}return j}},Y.def=function(W){var q=this.rules.block.def.exec(W);if(q){q[3]&&(q[3]=q[3].substring(1,q[3].length-1));var j=q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:j,raw:q[0],href:q[2],title:q[3]}}},Y.table=function(W){var q=this.rules.block.table.exec(W);if(q){var j={type:"table",header:d(q[1]).map(function(Ne){return{text:Ne}}),align:q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:q[3]&&q[3].trim()?q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(j.header.length===j.align.length){j.raw=q[0];var Q=j.align.length,le,pe,ke,Te;for(le=0;le<Q;le++)/^ *-+: *$/.test(j.align[le])?j.align[le]="right":/^ *:-+: *$/.test(j.align[le])?j.align[le]="center":/^ *:-+ *$/.test(j.align[le])?j.align[le]="left":j.align[le]=null;for(Q=j.rows.length,le=0;le<Q;le++)j.rows[le]=d(j.rows[le],j.header.length).map(function(Ne){return{text:Ne}});for(Q=j.header.length,pe=0;pe<Q;pe++)j.header[pe].tokens=this.lexer.inline(j.header[pe].text);for(Q=j.rows.length,pe=0;pe<Q;pe++)for(Te=j.rows[pe],ke=0;ke<Te.length;ke++)Te[ke].tokens=this.lexer.inline(Te[ke].text);return j}}},Y.lheading=function(W){var q=this.rules.block.lheading.exec(W);if(q)return{type:"heading",raw:q[0],depth:q[2].charAt(0)==="="?1:2,text:q[1],tokens:this.lexer.inline(q[1])}},Y.paragraph=function(W){var q=this.rules.block.paragraph.exec(W);if(q){var j=q[1].charAt(q[1].length-1)===`
`?q[1].slice(0,-1):q[1];return{type:"paragraph",raw:q[0],text:j,tokens:this.lexer.inline(j)}}},Y.text=function(W){var q=this.rules.block.text.exec(W);if(q)return{type:"text",raw:q[0],text:q[0],tokens:this.lexer.inline(q[0])}},Y.escape=function(W){var q=this.rules.inline.escape.exec(W);if(q)return{type:"escape",raw:q[0],text:h(q[1])}},Y.tag=function(W){var q=this.rules.inline.tag.exec(W);if(q)return!this.lexer.state.inLink&&/^<a /i.test(q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(q[0]):h(q[0]):q[0]}},Y.link=function(W){var q=this.rules.inline.link.exec(W);if(q){var j=q[2].trim();if(!this.options.pedantic&&/^</.test(j)){if(!/>$/.test(j))return;var Q=P(j.slice(0,-1),"\\");if((j.length-Q.length)%2===0)return}else{var le=F(q[2],"()");if(le>-1){var pe=q[0].indexOf("!")===0?5:4,ke=pe+q[1].length+le;q[2]=q[2].substring(0,le),q[0]=q[0].substring(0,ke).trim(),q[3]=""}}var Te=q[2],Ne="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Le&&(Te=Le[1],Ne=Le[3])}else Ne=q[3]?q[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(j)?Te=Te.slice(1):Te=Te.slice(1,-1)),J(q,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},q[0],this.lexer)}},Y.reflink=function(W,q){var j;if((j=this.rules.inline.reflink.exec(W))||(j=this.rules.inline.nolink.exec(W))){var Q=(j[2]||j[1]).replace(/\s+/g," ");if(Q=q[Q.toLowerCase()],!Q||!Q.href){var le=j[0].charAt(0);return{type:"text",raw:le,text:le}}return J(j,Q,j[0],this.lexer)}},Y.emStrong=function(W,q,j){j===void 0&&(j="");var Q=this.rules.inline.emStrong.lDelim.exec(W);if(!!Q&&!(Q[3]&&j.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=Q[1]||Q[2]||"";if(!le||le&&(j===""||this.rules.inline.punctuation.exec(j))){var pe=Q[0].length-1,ke,Te,Ne=pe,Le=0,me=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,q=q.slice(-1*W.length+pe);(Q=me.exec(q))!=null;)if(ke=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!ke){if(Te=ke.length,Q[3]||Q[4]){Ne+=Te;continue}else if((Q[5]||Q[6])&&pe%3&&!((pe+Te)%3)){Le+=Te;continue}if(Ne-=Te,!(Ne>0)){if(Te=Math.min(Te,Te+Ne+Le),Math.min(pe,Te)%2){var be=W.slice(1,pe+Q.index+Te);return{type:"em",raw:W.slice(0,pe+Q.index+Te+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=W.slice(2,pe+Q.index+Te-1);return{type:"strong",raw:W.slice(0,pe+Q.index+Te+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Y.codespan=function(W){var q=this.rules.inline.code.exec(W);if(q){var j=q[2].replace(/\n/g," "),Q=/[^ ]/.test(j),le=/^ /.test(j)&&/ $/.test(j);return Q&&le&&(j=j.substring(1,j.length-1)),j=h(j,!0),{type:"codespan",raw:q[0],text:j}}},Y.br=function(W){var q=this.rules.inline.br.exec(W);if(q)return{type:"br",raw:q[0]}},Y.del=function(W){var q=this.rules.inline.del.exec(W);if(q)return{type:"del",raw:q[0],text:q[2],tokens:this.lexer.inlineTokens(q[2])}},Y.autolink=function(W,q){var j=this.rules.inline.autolink.exec(W);if(j){var Q,le;return j[2]==="@"?(Q=h(this.options.mangle?q(j[1]):j[1]),le="mailto:"+Q):(Q=h(j[1]),le=Q),{type:"link",raw:j[0],text:Q,href:le,tokens:[{type:"text",raw:Q,text:Q}]}}},Y.url=function(W,q){var j;if(j=this.rules.inline.url.exec(W)){var Q,le;if(j[2]==="@")Q=h(this.options.mangle?q(j[0]):j[0]),le="mailto:"+Q;else{var pe;do pe=j[0],j[0]=this.rules.inline._backpedal.exec(j[0])[0];while(pe!==j[0]);Q=h(j[0]),j[1]==="www."?le="http://"+Q:le=Q}return{type:"link",raw:j[0],text:Q,href:le,tokens:[{type:"text",raw:Q,text:Q}]}}},Y.inlineText=function(W,q){var j=this.rules.inline.text.exec(W);if(j){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(j[0]):h(j[0]):j[0]:Q=h(this.options.smartypants?q(j[0]):j[0]),{type:"text",raw:j[0],text:Q}}},H}(),ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=m(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=m(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=m(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=m(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=m(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=m(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=c({},ne),ne.gfm=c({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=m(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.paragraph=m(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ne.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=c({},ne.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:m(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=m(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=m(ne._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=m(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=m(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=m(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=m(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=m(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=m(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=m(B.reflink).replace("label",B._label).replace("ref",ne._label).getRegex(),B.nolink=m(B.nolink).replace("ref",ne._label).getRegex(),B.reflinkSearch=m(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=c({},B),B.pedantic=c({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=c({},B.normal,{escape:m(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=m(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=c({},B.gfm,{br:m(B.br).replace("{2,}","*").getRegex(),text:m(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ue(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(H){var Y="",te,W,q=H.length;for(te=0;te<q;te++)W=H.charCodeAt(te),Math.random()>.5&&(W="x"+W.toString(16)),Y+="&#"+W+";";return Y}var X=function(){function H(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||oe.defaults,this.options.tokenizer=this.options.tokenizer||new ee,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var W={block:ne.normal,inline:B.normal};this.options.pedantic?(W.block=ne.pedantic,W.inline=B.pedantic):this.options.gfm&&(W.block=ne.gfm,this.options.breaks?W.inline=B.breaks:W.inline=B.gfm),this.tokenizer.rules=W}H.lex=function(W,q){var j=new H(q);return j.lex(W)},H.lexInline=function(W,q){var j=new H(q);return j.inlineTokens(W)};var Y=H.prototype;return Y.lex=function(W){W=W.replace(/\r\n|\r/g,`
`),this.blockTokens(W,this.tokens);for(var q;q=this.inlineQueue.shift();)this.inlineTokens(q.src,q.tokens);return this.tokens},Y.blockTokens=function(W,q){var j=this;q===void 0&&(q=[]),this.options.pedantic?W=W.replace(/\t/g,"    ").replace(/^ +$/gm,""):W=W.replace(/^( *)(\t+)/gm,function(Ne,Le,me){return Le+"    ".repeat(me.length)});for(var Q,le,pe,ke;W;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(Q=Ne.call({lexer:j},W,q))?(W=W.substring(Q.raw.length),q.push(Q),!0):!1}))){if(Q=this.tokenizer.space(W)){W=W.substring(Q.raw.length),Q.raw.length===1&&q.length>0?q[q.length-1].raw+=`
`:q.push(Q);continue}if(Q=this.tokenizer.code(W)){W=W.substring(Q.raw.length),le=q[q.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+Q.raw,le.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=le.text):q.push(Q);continue}if(Q=this.tokenizer.fences(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.heading(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.hr(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.blockquote(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.list(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.html(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.def(W)){W=W.substring(Q.raw.length),le=q[q.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+Q.raw,le.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=le.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.lheading(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(pe=W,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,Le=W.slice(1),me=void 0;j.options.extensions.startBlock.forEach(function(be){me=be.call({lexer:this},Le),typeof me=="number"&&me>=0&&(Ne=Math.min(Ne,me))}),Ne<1/0&&Ne>=0&&(pe=W.substring(0,Ne+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(pe))){le=q[q.length-1],ke&&le.type==="paragraph"?(le.raw+=`
`+Q.raw,le.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):q.push(Q),ke=pe.length!==W.length,W=W.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(W)){W=W.substring(Q.raw.length),le=q[q.length-1],le&&le.type==="text"?(le.raw+=`
`+Q.raw,le.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):q.push(Q);continue}if(W){var Te="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,q},Y.inline=function(W,q){return q===void 0&&(q=[]),this.inlineQueue.push({src:W,tokens:q}),q},Y.inlineTokens=function(W,q){var j=this;q===void 0&&(q=[]);var Q,le,pe,ke=W,Te,Ne,Le;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)me.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Te.index)+"["+Z("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"["+Z("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;W;)if(Ne||(Le=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(Q=Ee.call({lexer:j},W,q))?(W=W.substring(Q.raw.length),q.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.tag(W)){W=W.substring(Q.raw.length),le=q[q.length-1],le&&Q.type==="text"&&le.type==="text"?(le.raw+=Q.raw,le.text+=Q.text):q.push(Q);continue}if(Q=this.tokenizer.link(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.reflink(W,this.tokens.links)){W=W.substring(Q.raw.length),le=q[q.length-1],le&&Q.type==="text"&&le.type==="text"?(le.raw+=Q.raw,le.text+=Q.text):q.push(Q);continue}if(Q=this.tokenizer.emStrong(W,ke,Le)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.codespan(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.br(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.del(W)){W=W.substring(Q.raw.length),q.push(Q);continue}if(Q=this.tokenizer.autolink(W,z)){W=W.substring(Q.raw.length),q.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(W,z))){W=W.substring(Q.raw.length),q.push(Q);continue}if(pe=W,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,Me=W.slice(1),Be=void 0;j.options.extensions.startInline.forEach(function(Ve){Be=Ve.call({lexer:this},Me),typeof Be=="number"&&Be>=0&&(Ee=Math.min(Ee,Be))}),Ee<1/0&&Ee>=0&&(pe=W.substring(0,Ee+1))}(),Q=this.tokenizer.inlineText(pe,ue)){W=W.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&(Le=Q.raw.slice(-1)),Ne=!0,le=q[q.length-1],le&&le.type==="text"?(le.raw+=Q.raw,le.text+=Q.text):q.push(Q);continue}if(W){var be="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return q},v(H,null,[{key:"rules",get:function(){return{block:ne,inline:B}}}]),H}(),O=function(){function H(te){this.options=te||oe.defaults}var Y=H.prototype;return Y.code=function(W,q,j){var Q=(q||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(W,Q);le!=null&&le!==W&&(j=!0,W=le)}return W=W.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+h(Q,!0)+'">'+(j?W:h(W,!0))+`</code></pre>
`:"<pre><code>"+(j?W:h(W,!0))+`</code></pre>
`},Y.blockquote=function(W){return`<blockquote>
`+W+`</blockquote>
`},Y.html=function(W){return W},Y.heading=function(W,q,j,Q){if(this.options.headerIds){var le=this.options.headerPrefix+Q.slug(j);return"<h"+q+' id="'+le+'">'+W+"</h"+q+`>
`}return"<h"+q+">"+W+"</h"+q+`>
`},Y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Y.list=function(W,q,j){var Q=q?"ol":"ul",le=q&&j!==1?' start="'+j+'"':"";return"<"+Q+le+`>
`+W+"</"+Q+`>
`},Y.listitem=function(W){return"<li>"+W+`</li>
`},Y.checkbox=function(W){return"<input "+(W?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Y.paragraph=function(W){return"<p>"+W+`</p>
`},Y.table=function(W,q){return q&&(q="<tbody>"+q+"</tbody>"),`<table>
<thead>
`+W+`</thead>
`+q+`</table>
`},Y.tablerow=function(W){return`<tr>
`+W+`</tr>
`},Y.tablecell=function(W,q){var j=q.header?"th":"td",Q=q.align?"<"+j+' align="'+q.align+'">':"<"+j+">";return Q+W+("</"+j+`>
`)},Y.strong=function(W){return"<strong>"+W+"</strong>"},Y.em=function(W){return"<em>"+W+"</em>"},Y.codespan=function(W){return"<code>"+W+"</code>"},Y.br=function(){return this.options.xhtml?"<br/>":"<br>"},Y.del=function(W){return"<del>"+W+"</del>"},Y.link=function(W,q,j){if(W=f(this.options.sanitize,this.options.baseUrl,W),W===null)return j;var Q='<a href="'+h(W)+'"';return q&&(Q+=' title="'+q+'"'),Q+=">"+j+"</a>",Q},Y.image=function(W,q,j){if(W=f(this.options.sanitize,this.options.baseUrl,W),W===null)return j;var Q='<img src="'+W+'" alt="'+j+'"';return q&&(Q+=' title="'+q+'"'),Q+=this.options.xhtml?"/>":">",Q},Y.text=function(W){return W},H}(),U=function(){function H(){}var Y=H.prototype;return Y.strong=function(W){return W},Y.em=function(W){return W},Y.codespan=function(W){return W},Y.del=function(W){return W},Y.html=function(W){return W},Y.text=function(W){return W},Y.link=function(W,q,j){return""+j},Y.image=function(W,q,j){return""+j},Y.br=function(){return""},H}(),x=function(){function H(){this.seen={}}var Y=H.prototype;return Y.serialize=function(W){return W.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Y.getNextSafeSlug=function(W,q){var j=W,Q=0;if(this.seen.hasOwnProperty(j)){Q=this.seen[W];do Q++,j=W+"-"+Q;while(this.seen.hasOwnProperty(j))}return q||(this.seen[W]=Q,this.seen[j]=0),j},Y.slug=function(W,q){q===void 0&&(q={});var j=this.serialize(W);return this.getNextSafeSlug(j,q.dryrun)},H}(),ae=function(){function H(te){this.options=te||oe.defaults,this.options.renderer=this.options.renderer||new O,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new U,this.slugger=new x}H.parse=function(W,q){var j=new H(q);return j.parse(W)},H.parseInline=function(W,q){var j=new H(q);return j.parseInline(W)};var Y=H.prototype;return Y.parse=function(W,q){q===void 0&&(q=!0);var j="",Q,le,pe,ke,Te,Ne,Le,me,be,Ee,Me,Be,Ve,ze,Ye,Ke,qe,je,xe,Ge=W.length;for(Q=0;Q<Ge;Q++){if(Ee=W[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(xe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){j+=xe||"";continue}switch(Ee.type){case"space":continue;case"hr":{j+=this.renderer.hr();continue}case"heading":{j+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,E(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{j+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(me="",Le="",ke=Ee.header.length,le=0;le<ke;le++)Le+=this.renderer.tablecell(this.parseInline(Ee.header[le].tokens),{header:!0,align:Ee.align[le]});for(me+=this.renderer.tablerow(Le),be="",ke=Ee.rows.length,le=0;le<ke;le++){for(Ne=Ee.rows[le],Le="",Te=Ne.length,pe=0;pe<Te;pe++)Le+=this.renderer.tablecell(this.parseInline(Ne[pe].tokens),{header:!1,align:Ee.align[pe]});be+=this.renderer.tablerow(Le)}j+=this.renderer.table(me,be);continue}case"blockquote":{be=this.parse(Ee.tokens),j+=this.renderer.blockquote(be);continue}case"list":{for(Me=Ee.ordered,Be=Ee.start,Ve=Ee.loose,ke=Ee.items.length,be="",le=0;le<ke;le++)Ye=Ee.items[le],Ke=Ye.checked,qe=Ye.task,ze="",Ye.task&&(je=this.renderer.checkbox(Ke),Ve?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=je+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=je+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:je}):ze+=je),ze+=this.parse(Ye.tokens,Ve),be+=this.renderer.listitem(ze,qe,Ke);j+=this.renderer.list(be,Me,Be);continue}case"html":{j+=this.renderer.html(Ee.text);continue}case"paragraph":{j+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;Q+1<Ge&&W[Q+1].type==="text";)Ee=W[++Q],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);j+=q?this.renderer.paragraph(be):be;continue}default:{var ce='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(ce);return}else throw new Error(ce)}}}return j},Y.parseInline=function(W,q){q=q||this.renderer;var j="",Q,le,pe,ke=W.length;for(Q=0;Q<ke;Q++){if(le=W[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(pe=this.options.extensions.renderers[le.type].call({parser:this},le),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(le.type))){j+=pe||"";continue}switch(le.type){case"escape":{j+=q.text(le.text);break}case"html":{j+=q.html(le.text);break}case"link":{j+=q.link(le.href,le.title,this.parseInline(le.tokens,q));break}case"image":{j+=q.image(le.href,le.title,le.text);break}case"strong":{j+=q.strong(this.parseInline(le.tokens,q));break}case"em":{j+=q.em(this.parseInline(le.tokens,q));break}case"codespan":{j+=q.codespan(le.text);break}case"br":{j+=q.br();break}case"del":{j+=q.del(this.parseInline(le.tokens,q));break}case"text":{j+=q.text(le.text);break}default:{var Te='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return j},H}();function fe(H,Y,te){if(typeof H>"u"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof Y=="function"&&(te=Y,Y=null),Y=c({},fe.defaults,Y||{}),$(Y),te){var W=Y.highlight,q;try{q=X.lex(H,Y)}catch(ke){return te(ke)}var j=function(Te){var Ne;if(!Te)try{Y.walkTokens&&fe.walkTokens(q,Y.walkTokens),Ne=ae.parse(q,Y)}catch(Le){Te=Le}return Y.highlight=W,Te?te(Te):te(null,Ne)};if(!W||W.length<3||(delete Y.highlight,!q.length))return j();var Q=0;fe.walkTokens(q,function(ke){ke.type==="code"&&(Q++,setTimeout(function(){W(ke.text,ke.lang,function(Te,Ne){if(Te)return j(Te);Ne!=null&&Ne!==ke.text&&(ke.text=Ne,ke.escaped=!0),Q--,Q===0&&j()})},0))}),Q===0&&j();return}function le(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+h(ke.message+"",!0)+"</pre>";throw ke}try{var pe=X.lex(H,Y);if(Y.walkTokens){if(Y.async)return Promise.all(fe.walkTokens(pe,Y.walkTokens)).then(function(){return ae.parse(pe,Y)}).catch(le);fe.walkTokens(pe,Y.walkTokens)}return ae.parse(pe,Y)}catch(ke){le(ke)}}fe.options=fe.setOptions=function(H){return c(fe.defaults,H),I(fe.defaults),fe},fe.getDefaults=T,fe.defaults=oe.defaults,fe.use=function(){for(var H=arguments.length,Y=new Array(H),te=0;te<H;te++)Y[te]=arguments[te];var W=c.apply(void 0,[{}].concat(Y)),q=fe.defaults.extensions||{renderers:{},childTokens:{}},j;Y.forEach(function(Q){if(Q.extensions&&(j=!0,Q.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var ke=q.renderers?q.renderers[pe.name]:null;ke?q.renderers[pe.name]=function(){for(var Te=arguments.length,Ne=new Array(Te),Le=0;Le<Te;Le++)Ne[Le]=arguments[Le];var me=pe.renderer.apply(this,Ne);return me===!1&&(me=ke.apply(this,Ne)),me}:q.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");q[pe.level]?q[pe.level].unshift(pe.tokenizer):q[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?q.startBlock?q.startBlock.push(pe.start):q.startBlock=[pe.start]:pe.level==="inline"&&(q.startInline?q.startInline.push(pe.start):q.startInline=[pe.start]))}pe.childTokens&&(q.childTokens[pe.name]=pe.childTokens)})),Q.renderer&&function(){var pe=fe.defaults.renderer||new O,ke=function(Le){var me=pe[Le];pe[Le]=function(){for(var be=arguments.length,Ee=new Array(be),Me=0;Me<be;Me++)Ee[Me]=arguments[Me];var Be=Q.renderer[Le].apply(pe,Ee);return Be===!1&&(Be=me.apply(pe,Ee)),Be}};for(var Te in Q.renderer)ke(Te);W.renderer=pe}(),Q.tokenizer&&function(){var pe=fe.defaults.tokenizer||new ee,ke=function(Le){var me=pe[Le];pe[Le]=function(){for(var be=arguments.length,Ee=new Array(be),Me=0;Me<be;Me++)Ee[Me]=arguments[Me];var Be=Q.tokenizer[Le].apply(pe,Ee);return Be===!1&&(Be=me.apply(pe,Ee)),Be}};for(var Te in Q.tokenizer)ke(Te);W.tokenizer=pe}(),Q.walkTokens){var le=fe.defaults.walkTokens;W.walkTokens=function(pe){var ke=[];return ke.push(Q.walkTokens.call(this,pe)),le&&(ke=ke.concat(le.call(this,pe))),ke}}j&&(W.extensions=q),fe.setOptions(W)})},fe.walkTokens=function(H,Y){for(var te=[],W=function(){var le=j.value;switch(te=te.concat(Y.call(fe,le)),le.type){case"table":{for(var pe=C(le.header),ke;!(ke=pe()).done;){var Te=ke.value;te=te.concat(fe.walkTokens(Te.tokens,Y))}for(var Ne=C(le.rows),Le;!(Le=Ne()).done;)for(var me=Le.value,be=C(me),Ee;!(Ee=be()).done;){var Me=Ee.value;te=te.concat(fe.walkTokens(Me.tokens,Y))}break}case"list":{te=te.concat(fe.walkTokens(le.items,Y));break}default:fe.defaults.extensions&&fe.defaults.extensions.childTokens&&fe.defaults.extensions.childTokens[le.type]?fe.defaults.extensions.childTokens[le.type].forEach(function(Be){te=te.concat(fe.walkTokens(le[Be],Y))}):le.tokens&&(te=te.concat(fe.walkTokens(le.tokens,Y)))}},q=C(H),j;!(j=q()).done;)W();return te},fe.parseInline=function(H,Y){if(typeof H>"u"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");Y=c({},fe.defaults,Y||{}),$(Y);try{var te=X.lexInline(H,Y);return Y.walkTokens&&fe.walkTokens(te,Y.walkTokens),ae.parseInline(te,Y)}catch(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+h(W.message+"",!0)+"</pre>";throw W}},fe.Parser=ae,fe.parser=ae.parse,fe.Renderer=O,fe.TextRenderer=U,fe.Lexer=X,fe.lexer=X.lex,fe.Tokenizer=ee,fe.Slugger=x,fe.parse=fe;var K=fe.options,ie=fe.setOptions,L=fe.use,M=fe.walkTokens,G=fe.parseInline,re=fe,he=ae.parse,ve=X.lex;oe.Lexer=X,oe.Parser=ae,oe.Renderer=O,oe.Slugger=x,oe.TextRenderer=U,oe.Tokenizer=ee,oe.getDefaults=T,oe.lexer=ve,oe.marked=fe,oe.options=K,oe.parse=re,oe.parseInline=G,oe.parser=he,oe.setOptions=ie,oe.use=L,oe.walkTokens=M,Object.defineProperty(oe,"__esModule",{value:!0})}),function(){function oe(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function T(p){C.push(p,Date.now())}function I(){const p=[];for(let b=0;b<C.length;b+=2)p.push({name:C[b],startTime:C[b+1]});return p}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(D+T.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),define(we[3],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let v=!1,t=!1,D=!1,C=!1,T=!1,I=!1,p=!1,b=!1,R=!1,k=!1,S,y=e.LANGUAGE_DEFAULT,h,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?E=e.globals.vscode.process:typeof process<"u"&&(E=process);const g=typeof E?.versions?.electron=="string",m=g&&E?.type==="renderer";if(typeof navigator=="object"&&!m){w=navigator.userAgent,v=w.indexOf("Windows")>=0,t=w.indexOf("Macintosh")>=0,b=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=w.indexOf("Linux")>=0,k=w?.indexOf("Mobi")>=0,I=!0,S=e.LANGUAGE_DEFAULT,y=S;const a=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),c=a&&a.getAttribute("data-settings");if(c)try{const d=JSON.parse(c);S=d.locale,h=d._translationsConfigFile,y=d.availableLanguages["*"]||e.LANGUAGE_DEFAULT}catch{}}else if(typeof E=="object"){v=E.platform==="win32",t=E.platform==="darwin",D=E.platform==="linux",C=D&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,p=g,R=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const a=E.env.VSCODE_NLS_CONFIG;if(a)try{const c=JSON.parse(a),d=c.availableLanguages["*"];S=c.locale,y=d||e.LANGUAGE_DEFAULT,h=c._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var u;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function l(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let f=0;t?f=1:v?f=3:D&&(f=2),e.isWindows=v,e.isMacintosh=t,e.isLinux=D,e.isLinuxSnap=C,e.isNative=T,e.isElectron=p,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=k,e.isCI=R,e.platform=f,e.userAgent=w,e.language=y;var r;(function(a){function c(){return e.language}a.value=c;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=d;function P(){return e.language==="en"}a.isDefault=P})(r=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let P=0,F=a.length;P<F;P++){const $=a[P];if($.id===d.data.vscodeScheduleAsyncWork){a.splice(P,1),$.callback();return}}});let c=0;return d=>{const P=++c;a.push({id:P,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:P},"*")}}return a=>setTimeout(a)})();var o;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=t||b?2:v?1:3;let n=!0,i=!1;function s(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,n=new Uint16Array(a.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[27],ye([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const D=v.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[6],ye([1,0,27]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,C=90,T=122,I=46,p=47,b=92,R=58,k=63;class S extends Error{constructor(l,f,r){let o;typeof f=="string"&&f.indexOf("not ")===0?(o="must not be",f=f.replace(/^not /,"")):o="must be";const n=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${n} ${o} of type ${f}`;i+=`. Received type ${typeof r}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function y(u,l){if(typeof u!="string")throw new S(l,"string",u)}function h(u){return u===p||u===b}function w(u){return u===p}function E(u){return u>=t&&u<=C||u>=D&&u<=T}function g(u,l,f,r){let o="",n=0,i=-1,s=0,a=0;for(let c=0;c<=u.length;++c){if(c<u.length)a=u.charCodeAt(c);else{if(r(a))break;a=p}if(r(a)){if(!(i===c-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==I||o.charCodeAt(o.length-2)!==I){if(o.length>2){const d=o.lastIndexOf(f);d===-1?(o="",n=0):(o=o.slice(0,d),n=o.length-1-o.lastIndexOf(f)),i=c,s=0;continue}else if(o.length!==0){o="",n=0,i=c,s=0;continue}}l&&(o+=o.length>0?`${f}..`:"..",n=2)}else o.length>0?o+=`${f}${u.slice(i+1,c)}`:o=u.slice(i+1,c),n=c-i-1;i=c,s=0}else a===I&&s!==-1?++s:s=-1}return o}function m(u,l){if(l===null||typeof l!="object")throw new S("pathObject","Object",l);const f=l.dir||l.root,r=l.base||`${l.name||""}${l.ext||""}`;return f?f===l.root?`${f}${r}`:`${f}${u}${r}`:r}e.win32={resolve(...u){let l="",f="",r=!1;for(let o=u.length-1;o>=-1;o--){let n;if(o>=0){if(n=u[o],y(n,"path"),n.length===0)continue}else l.length===0?n=v.cwd():(n=v.env[`=${l}`]||v.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${l}\\`));const i=n.length;let s=0,a="",c=!1;const d=n.charCodeAt(0);if(i===1)h(d)&&(s=1,c=!0);else if(h(d))if(c=!0,h(n.charCodeAt(1))){let P=2,F=P;for(;P<i&&!h(n.charCodeAt(P));)P++;if(P<i&&P!==F){const $=n.slice(F,P);for(F=P;P<i&&h(n.charCodeAt(P));)P++;if(P<i&&P!==F){for(F=P;P<i&&!h(n.charCodeAt(P));)P++;(P===i||P!==F)&&(a=`\\\\${$}\\${n.slice(F,P)}`,s=P)}}}else s=1;else E(d)&&n.charCodeAt(1)===R&&(a=n.slice(0,2),s=2,i>2&&h(n.charCodeAt(2))&&(c=!0,s=3));if(a.length>0)if(l.length>0){if(a.toLowerCase()!==l.toLowerCase())continue}else l=a;if(r){if(l.length>0)break}else if(f=`${n.slice(s)}\\${f}`,r=c,c&&l.length>0)break}return f=g(f,!r,"\\",h),r?`${l}\\${f}`:`${l}${f}`||"."},normalize(u){y(u,"path");const l=u.length;if(l===0)return".";let f=0,r,o=!1;const n=u.charCodeAt(0);if(l===1)return w(n)?"\\":u;if(h(n))if(o=!0,h(u.charCodeAt(1))){let s=2,a=s;for(;s<l&&!h(u.charCodeAt(s));)s++;if(s<l&&s!==a){const c=u.slice(a,s);for(a=s;s<l&&h(u.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&!h(u.charCodeAt(s));)s++;if(s===l)return`\\\\${c}\\${u.slice(a)}\\`;s!==a&&(r=`\\\\${c}\\${u.slice(a,s)}`,f=s)}}}else f=1;else E(n)&&u.charCodeAt(1)===R&&(r=u.slice(0,2),f=2,l>2&&h(u.charCodeAt(2))&&(o=!0,f=3));let i=f<l?g(u.slice(f),!o,"\\",h):"";return i.length===0&&!o&&(i="."),i.length>0&&h(u.charCodeAt(l-1))&&(i+="\\"),r===void 0?o?`\\${i}`:i:o?`${r}\\${i}`:`${r}${i}`},isAbsolute(u){y(u,"path");const l=u.length;if(l===0)return!1;const f=u.charCodeAt(0);return h(f)||l>2&&E(f)&&u.charCodeAt(1)===R&&h(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let l,f;for(let n=0;n<u.length;++n){const i=u[n];y(i,"path"),i.length>0&&(l===void 0?l=f=i:l+=`\\${i}`)}if(l===void 0)return".";let r=!0,o=0;if(typeof f=="string"&&h(f.charCodeAt(0))){++o;const n=f.length;n>1&&h(f.charCodeAt(1))&&(++o,n>2&&(h(f.charCodeAt(2))?++o:r=!1))}if(r){for(;o<l.length&&h(l.charCodeAt(o));)o++;o>=2&&(l=`\\${l.slice(o)}`)}return e.win32.normalize(l)},relative(u,l){if(y(u,"from"),y(l,"to"),u===l)return"";const f=e.win32.resolve(u),r=e.win32.resolve(l);if(f===r||(u=f.toLowerCase(),l=r.toLowerCase(),u===l))return"";let o=0;for(;o<u.length&&u.charCodeAt(o)===b;)o++;let n=u.length;for(;n-1>o&&u.charCodeAt(n-1)===b;)n--;const i=n-o;let s=0;for(;s<l.length&&l.charCodeAt(s)===b;)s++;let a=l.length;for(;a-1>s&&l.charCodeAt(a-1)===b;)a--;const c=a-s,d=i<c?i:c;let P=-1,F=0;for(;F<d;F++){const Z=u.charCodeAt(o+F);if(Z!==l.charCodeAt(s+F))break;Z===b&&(P=F)}if(F!==d){if(P===-1)return r}else{if(c>d){if(l.charCodeAt(s+F)===b)return r.slice(s+F+1);if(F===2)return r.slice(s+F)}i>d&&(u.charCodeAt(o+F)===b?P=F:F===2&&(P=3)),P===-1&&(P=0)}let $="";for(F=o+P+1;F<=n;++F)(F===n||u.charCodeAt(F)===b)&&($+=$.length===0?"..":"\\..");return s+=P,$.length>0?`${$}${r.slice(s,a)}`:(r.charCodeAt(s)===b&&++s,r.slice(s,a))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const l=e.win32.resolve(u);if(l.length<=2)return u;if(l.charCodeAt(0)===b){if(l.charCodeAt(1)===b){const f=l.charCodeAt(2);if(f!==k&&f!==I)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(E(l.charCodeAt(0))&&l.charCodeAt(1)===R&&l.charCodeAt(2)===b)return`\\\\?\\${l}`;return u},dirname(u){y(u,"path");const l=u.length;if(l===0)return".";let f=-1,r=0;const o=u.charCodeAt(0);if(l===1)return h(o)?u:".";if(h(o)){if(f=r=1,h(u.charCodeAt(1))){let s=2,a=s;for(;s<l&&!h(u.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&h(u.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&!h(u.charCodeAt(s));)s++;if(s===l)return u;s!==a&&(f=r=s+1)}}}}else E(o)&&u.charCodeAt(1)===R&&(f=l>2&&h(u.charCodeAt(2))?3:2,r=f);let n=-1,i=!0;for(let s=l-1;s>=r;--s)if(h(u.charCodeAt(s))){if(!i){n=s;break}}else i=!1;if(n===-1){if(f===-1)return".";n=f}return u.slice(0,n)},basename(u,l){l!==void 0&&y(l,"ext"),y(u,"path");let f=0,r=-1,o=!0,n;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===R&&(f=2),l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let i=l.length-1,s=-1;for(n=u.length-1;n>=f;--n){const a=u.charCodeAt(n);if(h(a)){if(!o){f=n+1;break}}else s===-1&&(o=!1,s=n+1),i>=0&&(a===l.charCodeAt(i)?--i===-1&&(r=n):(i=-1,r=s))}return f===r?r=s:r===-1&&(r=u.length),u.slice(f,r)}for(n=u.length-1;n>=f;--n)if(h(u.charCodeAt(n))){if(!o){f=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":u.slice(f,r)},extname(u){y(u,"path");let l=0,f=-1,r=0,o=-1,n=!0,i=0;u.length>=2&&u.charCodeAt(1)===R&&E(u.charCodeAt(0))&&(l=r=2);for(let s=u.length-1;s>=l;--s){const a=u.charCodeAt(s);if(h(a)){if(!n){r=s+1;break}continue}o===-1&&(n=!1,o=s+1),a===I?f===-1?f=s:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||o===-1||i===0||i===1&&f===o-1&&f===r+1?"":u.slice(f,o)},format:m.bind(null,"\\"),parse(u){y(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const f=u.length;let r=0,o=u.charCodeAt(0);if(f===1)return h(o)?(l.root=l.dir=u,l):(l.base=l.name=u,l);if(h(o)){if(r=1,h(u.charCodeAt(1))){let P=2,F=P;for(;P<f&&!h(u.charCodeAt(P));)P++;if(P<f&&P!==F){for(F=P;P<f&&h(u.charCodeAt(P));)P++;if(P<f&&P!==F){for(F=P;P<f&&!h(u.charCodeAt(P));)P++;P===f?r=P:P!==F&&(r=P+1)}}}}else if(E(o)&&u.charCodeAt(1)===R){if(f<=2)return l.root=l.dir=u,l;if(r=2,h(u.charCodeAt(2))){if(f===3)return l.root=l.dir=u,l;r=3}}r>0&&(l.root=u.slice(0,r));let n=-1,i=r,s=-1,a=!0,c=u.length-1,d=0;for(;c>=r;--c){if(o=u.charCodeAt(c),h(o)){if(!a){i=c+1;break}continue}s===-1&&(a=!1,s=c+1),o===I?n===-1?n=c:d!==1&&(d=1):n!==-1&&(d=-1)}return s!==-1&&(n===-1||d===0||d===1&&n===s-1&&n===i+1?l.base=l.name=u.slice(i,s):(l.name=u.slice(i,n),l.base=u.slice(i,s),l.ext=u.slice(n,s))),i>0&&i!==r?l.dir=u.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let l="",f=!1;for(let r=u.length-1;r>=-1&&!f;r--){const o=r>=0?u[r]:v.cwd();y(o,"path"),o.length!==0&&(l=`${o}/${l}`,f=o.charCodeAt(0)===p)}return l=g(l,!f,"/",w),f?`/${l}`:l.length>0?l:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===p,f=u.charCodeAt(u.length-1)===p;return u=g(u,!l,"/",w),u.length===0?l?"/":f?"./":".":(f&&(u+="/"),l?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===p},join(...u){if(u.length===0)return".";let l;for(let f=0;f<u.length;++f){const r=u[f];y(r,"path"),r.length>0&&(l===void 0?l=r:l+=`/${r}`)}return l===void 0?".":e.posix.normalize(l)},relative(u,l){if(y(u,"from"),y(l,"to"),u===l||(u=e.posix.resolve(u),l=e.posix.resolve(l),u===l))return"";const f=1,r=u.length,o=r-f,n=1,i=l.length-n,s=o<i?o:i;let a=-1,c=0;for(;c<s;c++){const P=u.charCodeAt(f+c);if(P!==l.charCodeAt(n+c))break;P===p&&(a=c)}if(c===s)if(i>s){if(l.charCodeAt(n+c)===p)return l.slice(n+c+1);if(c===0)return l.slice(n+c)}else o>s&&(u.charCodeAt(f+c)===p?a=c:c===0&&(a=0));let d="";for(c=f+a+1;c<=r;++c)(c===r||u.charCodeAt(c)===p)&&(d+=d.length===0?"..":"/..");return`${d}${l.slice(n+a)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===p;let f=-1,r=!0;for(let o=u.length-1;o>=1;--o)if(u.charCodeAt(o)===p){if(!r){f=o;break}}else r=!1;return f===-1?l?"/":".":l&&f===1?"//":u.slice(0,f)},basename(u,l){l!==void 0&&y(l,"ext"),y(u,"path");let f=0,r=-1,o=!0,n;if(l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let i=l.length-1,s=-1;for(n=u.length-1;n>=0;--n){const a=u.charCodeAt(n);if(a===p){if(!o){f=n+1;break}}else s===-1&&(o=!1,s=n+1),i>=0&&(a===l.charCodeAt(i)?--i===-1&&(r=n):(i=-1,r=s))}return f===r?r=s:r===-1&&(r=u.length),u.slice(f,r)}for(n=u.length-1;n>=0;--n)if(u.charCodeAt(n)===p){if(!o){f=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":u.slice(f,r)},extname(u){y(u,"path");let l=-1,f=0,r=-1,o=!0,n=0;for(let i=u.length-1;i>=0;--i){const s=u.charCodeAt(i);if(s===p){if(!o){f=i+1;break}continue}r===-1&&(o=!1,r=i+1),s===I?l===-1?l=i:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||r===-1||n===0||n===1&&l===r-1&&l===f+1?"":u.slice(l,r)},format:m.bind(null,"/"),parse(u){y(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const f=u.charCodeAt(0)===p;let r;f?(l.root="/",r=1):r=0;let o=-1,n=0,i=-1,s=!0,a=u.length-1,c=0;for(;a>=r;--a){const d=u.charCodeAt(a);if(d===p){if(!s){n=a+1;break}continue}i===-1&&(s=!1,i=a+1),d===I?o===-1?o=a:c!==1&&(c=1):o!==-1&&(c=-1)}if(i!==-1){const d=n===0&&f?1:n;o===-1||c===0||c===1&&o===i-1&&o===n+1?l.base=l.name=u.slice(d,i):(l.name=u.slice(d,o),l.base=u.slice(d,i),l.ext=u.slice(o,i))}return n>0?l.dir=u.slice(0,n-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[66],ye([1,0,6]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(R){const k=(0,v.extname)(R),S=t[k.toLowerCase()];return S!==void 0?S:T(R)}e.getMediaOrTextMime=C;function T(R){const k=(0,v.extname)(R);return D[k.toLowerCase()]}e.getMediaMime=T;function I(R){for(const k in D)if(D[k]===R)return k}e.getExtensionForMimeType=I;const p=/^(.+)\/(.+?)(;.+)?$/;function b(R,k){const S=p.exec(R);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:k?void 0:R}e.normalizeMimeType=b}),define(we[56],ye([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(I,...p){const b=p.reduce((S,y)=>(S[y]=!0,S),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(I).filter(S=>!b[S]).forEach(S=>{for(let y=0;y<R.length;y++)if(S.search(R[y])!==-1){delete I[S];break}})}e.sanitizeProcessEnvironment=C;function T(I){!I||(delete I.DEBUG,v.isMacintosh&&delete I.DYLD_LIBRARY_PATH,v.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:oe)[t]=v[t]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function v(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return oe[t].call(D.exports,D,D.exports,v),D.l=!0,D.exports}return v.m=oe,v.c=e,v.d=function(t,D,C){v.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:C})},v.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,D){if(1&D&&(t=v(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var C=Object.create(null);if(v.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var T in t)v.d(C,T,function(I){return t[I]}.bind(null,T));return C},v.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(D,"a",D),D},v.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},v.p="",v(v.s=0)}([function(oe,e,v){(function(t){var D;e=oe.exports=L,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],p=e.src=[],b=0,R=b++;p[R]="0|[1-9]\\d*";var k=b++;p[k]="[0-9]+";var S=b++;p[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=b++;p[y]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var h=b++;p[h]="("+p[k]+")\\.("+p[k]+")\\.("+p[k]+")";var w=b++;p[w]="(?:"+p[R]+"|"+p[S]+")";var E=b++;p[E]="(?:"+p[k]+"|"+p[S]+")";var g=b++;p[g]="(?:-("+p[w]+"(?:\\."+p[w]+")*))";var m=b++;p[m]="(?:-?("+p[E]+"(?:\\."+p[E]+")*))";var u=b++;p[u]="[0-9A-Za-z-]+";var l=b++;p[l]="(?:\\+("+p[u]+"(?:\\."+p[u]+")*))";var f=b++,r="v?"+p[y]+p[g]+"?"+p[l]+"?";p[f]="^"+r+"$";var o="[v=\\s]*"+p[h]+p[m]+"?"+p[l]+"?",n=b++;p[n]="^"+o+"$";var i=b++;p[i]="((?:<|>)?=?)";var s=b++;p[s]=p[k]+"|x|X|\\*";var a=b++;p[a]=p[R]+"|x|X|\\*";var c=b++;p[c]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[g]+")?"+p[l]+"?)?)?";var d=b++;p[d]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[m]+")?"+p[l]+"?)?)?";var P=b++;p[P]="^"+p[i]+"\\s*"+p[c]+"$";var F=b++;p[F]="^"+p[i]+"\\s*"+p[d]+"$";var $=b++;p[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Z=b++;p[Z]="(?:~>?)";var J=b++;p[J]="(\\s*)"+p[Z]+"\\s+",I[J]=new RegExp(p[J],"g");var _=b++;p[_]="^"+p[Z]+p[c]+"$";var ee=b++;p[ee]="^"+p[Z]+p[d]+"$";var ne=b++;p[ne]="(?:\\^)";var B=b++;p[B]="(\\s*)"+p[ne]+"\\s+",I[B]=new RegExp(p[B],"g");var ue=b++;p[ue]="^"+p[ne]+p[c]+"$";var z=b++;p[z]="^"+p[ne]+p[d]+"$";var X=b++;p[X]="^"+p[i]+"\\s*("+o+")$|^$";var O=b++;p[O]="^"+p[i]+"\\s*("+r+")$|^$";var U=b++;p[U]="(\\s*)"+p[i]+"\\s*("+o+"|"+p[c]+")",I[U]=new RegExp(p[U],"g");var x=b++;p[x]="^\\s*("+p[c]+")\\s+-\\s+("+p[c]+")\\s*$";var ae=b++;p[ae]="^\\s*("+p[d]+")\\s+-\\s+("+p[d]+")\\s*$";var fe=b++;p[fe]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)D(K,p[K]),I[K]||(I[K]=new RegExp(p[K]));function ie(me,be){if(me instanceof L)return me;if(typeof me!="string"||me.length>C||!(be?I[n]:I[f]).test(me))return null;try{return new L(me,be)}catch{return null}}function L(me,be){if(me instanceof L){if(me.loose===be)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof L))return new L(me,be);D("SemVer",me,be),this.loose=be;var Ee=me.trim().match(be?I[n]:I[f]);if(!Ee)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Be=+Me;if(Be>=0&&Be<T)return Be}return Me}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ie,e.valid=function(me,be){var Ee=ie(me,be);return Ee?Ee.version:null},e.clean=function(me,be){var Ee=ie(me.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(me){return D("SemVer.compare",this.version,this.loose,me),me instanceof L||(me=new L(me,this.loose)),this.compareMain(me)||this.comparePre(me)},L.prototype.compareMain=function(me){return me instanceof L||(me=new L(me,this.loose)),G(this.major,me.major)||G(this.minor,me.minor)||G(this.patch,me.patch)},L.prototype.comparePre=function(me){if(me instanceof L||(me=new L(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],Me=me.prerelease[be];if(D("prerelease compare",be,Ee,Me),Ee===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==Me)return G(Ee,Me)}while(++be)},L.prototype.inc=function(me,be){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,be,Ee,Me){typeof Ee=="string"&&(Me=Ee,Ee=void 0);try{return new L(me,Ee).inc(be,Me).version}catch{return null}},e.diff=function(me,be){if(H(me,be))return null;var Ee=ie(me),Me=ie(be);if(Ee.prerelease.length||Me.prerelease.length){for(var Be in Ee)if((Be==="major"||Be==="minor"||Be==="patch")&&Ee[Be]!==Me[Be])return"pre"+Be;return"prerelease"}for(var Be in Ee)if((Be==="major"||Be==="minor"||Be==="patch")&&Ee[Be]!==Me[Be])return Be},e.compareIdentifiers=G;var M=/^[0-9]+$/;function G(me,be){var Ee=M.test(me),Me=M.test(be);return Ee&&Me&&(me=+me,be=+be),Ee&&!Me?-1:Me&&!Ee?1:me<be?-1:me>be?1:0}function re(me,be,Ee){return new L(me,Ee).compare(new L(be,Ee))}function he(me,be,Ee){return re(me,be,Ee)>0}function ve(me,be,Ee){return re(me,be,Ee)<0}function H(me,be,Ee){return re(me,be,Ee)===0}function Y(me,be,Ee){return re(me,be,Ee)!==0}function te(me,be,Ee){return re(me,be,Ee)>=0}function W(me,be,Ee){return re(me,be,Ee)<=0}function q(me,be,Ee,Me){var Be;switch(be){case"===":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),Be=me===Ee;break;case"!==":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),Be=me!==Ee;break;case"":case"=":case"==":Be=H(me,Ee,Me);break;case"!=":Be=Y(me,Ee,Me);break;case">":Be=he(me,Ee,Me);break;case">=":Be=te(me,Ee,Me);break;case"<":Be=ve(me,Ee,Me);break;case"<=":Be=W(me,Ee,Me);break;default:throw new TypeError("Invalid operator: "+be)}return Be}function j(me,be){if(me instanceof j){if(me.loose===be)return me;me=me.value}if(!(this instanceof j))return new j(me,be);D("comparator",me,be),this.loose=be,this.parse(me),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(me,be){return G(be,me)},e.major=function(me,be){return new L(me,be).major},e.minor=function(me,be){return new L(me,be).minor},e.patch=function(me,be){return new L(me,be).patch},e.compare=re,e.compareLoose=function(me,be){return re(me,be,!0)},e.rcompare=function(me,be,Ee){return re(be,me,Ee)},e.sort=function(me,be){return me.sort(function(Ee,Me){return e.compare(Ee,Me,be)})},e.rsort=function(me,be){return me.sort(function(Ee,Me){return e.rcompare(Ee,Me,be)})},e.gt=he,e.lt=ve,e.eq=H,e.neq=Y,e.gte=te,e.lte=W,e.cmp=q,e.Comparator=j;var Q={};function le(me,be){if(me instanceof le)return me.loose===be?me:new le(me.raw,be);if(me instanceof j)return new le(me.value,be);if(!(this instanceof le))return new le(me,be);if(this.loose=be,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function pe(me){return!me||me.toLowerCase()==="x"||me==="*"}function ke(me,be,Ee,Me,Be,Ve,ze,Ye,Ke,qe,je,xe,Ge){return((be=pe(Ee)?"":pe(Me)?">="+Ee+".0.0":pe(Be)?">="+Ee+"."+Me+".0":">="+be)+" "+(Ye=pe(Ke)?"":pe(qe)?"<"+(+Ke+1)+".0.0":pe(je)?"<"+Ke+"."+(+qe+1)+".0":xe?"<="+Ke+"."+qe+"."+je+"-"+xe:"<="+Ye)).trim()}function Te(me,be){for(var Ee=0;Ee<me.length;Ee++)if(!me[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<me.length;Ee++)if(D(me[Ee].semver),me[Ee].semver!==Q&&me[Ee].semver.prerelease.length>0){var Me=me[Ee].semver;if(Me.major===be.major&&Me.minor===be.minor&&Me.patch===be.patch)return!0}return!1}return!0}function Ne(me,be,Ee){try{be=new le(be,Ee)}catch{return!1}return be.test(me)}function Le(me,be,Ee,Me){var Be,Ve,ze,Ye,Ke;switch(me=new L(me,Me),be=new le(be,Me),Ee){case">":Be=he,Ve=W,ze=ve,Ye=">",Ke=">=";break;case"<":Be=ve,Ve=te,ze=he,Ye="<",Ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(me,be,Me))return!1;for(var qe=0;qe<be.set.length;++qe){var je=be.set[qe],xe=null,Ge=null;if(je.forEach(function(ce){ce.semver===Q&&(ce=new j(">=0.0.0")),xe=xe||ce,Ge=Ge||ce,Be(ce.semver,xe.semver,Me)?xe=ce:ze(ce.semver,Ge.semver,Me)&&(Ge=ce)}),xe.operator===Ye||xe.operator===Ke||(!Ge.operator||Ge.operator===Ye)&&Ve(me,Ge.semver)||Ge.operator===Ke&&ze(me,Ge.semver))return!1}return!0}j.prototype.parse=function(me){var be=this.loose?I[X]:I[O],Ee=me.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+me);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new L(Ee[2],this.loose):this.semver=Q},j.prototype.toString=function(){return this.value},j.prototype.test=function(me){return D("Comparator.test",me,this.loose),this.semver===Q||(typeof me=="string"&&(me=new L(me,this.loose)),q(me,this.operator,this.semver,this.loose))},j.prototype.intersects=function(me,be){if(!(me instanceof j))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new le(me.value,be),Ne(this.value,Ee,be);if(me.operator==="")return Ee=new le(this.value,be),Ne(me.semver,Ee,be);var Me=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Ve=this.semver.version===me.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ye=q(this.semver,"<",me.semver,be)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Ke=q(this.semver,">",me.semver,be)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Me||Be||Ve&&ze||Ye||Ke},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(me){var be=this.loose;me=me.trim(),D("range",me,be);var Ee=be?I[ae]:I[x];me=me.replace(Ee,ke),D("hyphen replace",me),me=me.replace(I[U],"$1$2$3"),D("comparator trim",me,I[U]),me=(me=(me=me.replace(I[J],"$1~")).replace(I[B],"$1^")).split(/\s+/).join(" ");var Me=be?I[X]:I[O],Be=me.split(" ").map(function(Ve){return function(ze,Ye){return D("comp",ze),ze=function(Ke,qe){return Ke.trim().split(/\s+/).map(function(je){return function(xe,Ge){D("caret",xe,Ge);var ce=Ge?I[z]:I[ue];return xe.replace(ce,function(Ce,Ie,Ae,Fe,$e){var Qe;return D("caret",xe,Ce,Ie,Ae,Fe,$e),pe(Ie)?Qe="":pe(Ae)?Qe=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pe(Fe)?Qe=Ie==="0"?">="+Ie+"."+Ae+".0 <"+Ie+"."+(+Ae+1)+".0":">="+Ie+"."+Ae+".0 <"+(+Ie+1)+".0.0":$e?(D("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Qe=Ie==="0"?Ae==="0"?">="+Ie+"."+Ae+"."+Fe+$e+" <"+Ie+"."+Ae+"."+(+Fe+1):">="+Ie+"."+Ae+"."+Fe+$e+" <"+Ie+"."+(+Ae+1)+".0":">="+Ie+"."+Ae+"."+Fe+$e+" <"+(+Ie+1)+".0.0"):(D("no pr"),Qe=Ie==="0"?Ae==="0"?">="+Ie+"."+Ae+"."+Fe+" <"+Ie+"."+Ae+"."+(+Fe+1):">="+Ie+"."+Ae+"."+Fe+" <"+Ie+"."+(+Ae+1)+".0":">="+Ie+"."+Ae+"."+Fe+" <"+(+Ie+1)+".0.0"),D("caret return",Qe),Qe})}(je,qe)}).join(" ")}(ze,Ye),D("caret",ze),ze=function(Ke,qe){return Ke.trim().split(/\s+/).map(function(je){return function(xe,Ge){var ce=Ge?I[ee]:I[_];return xe.replace(ce,function(Ce,Ie,Ae,Fe,$e){var Qe;return D("tilde",xe,Ce,Ie,Ae,Fe,$e),pe(Ie)?Qe="":pe(Ae)?Qe=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pe(Fe)?Qe=">="+Ie+"."+Ae+".0 <"+Ie+"."+(+Ae+1)+".0":$e?(D("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Qe=">="+Ie+"."+Ae+"."+Fe+$e+" <"+Ie+"."+(+Ae+1)+".0"):Qe=">="+Ie+"."+Ae+"."+Fe+" <"+Ie+"."+(+Ae+1)+".0",D("tilde return",Qe),Qe})}(je,qe)}).join(" ")}(ze,Ye),D("tildes",ze),ze=function(Ke,qe){return D("replaceXRanges",Ke,qe),Ke.split(/\s+/).map(function(je){return function(xe,Ge){xe=xe.trim();var ce=Ge?I[F]:I[P];return xe.replace(ce,function(Ce,Ie,Ae,Fe,$e,Qe){D("xRange",xe,Ce,Ie,Ae,Fe,$e,Qe);var rt=pe(Ae),it=rt||pe(Fe),Ze=it||pe($e);return Ie==="="&&Ze&&(Ie=""),rt?Ce=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&Ze?(it&&(Fe=0),Ze&&($e=0),Ie===">"?(Ie=">=",it?(Ae=+Ae+1,Fe=0,$e=0):Ze&&(Fe=+Fe+1,$e=0)):Ie==="<="&&(Ie="<",it?Ae=+Ae+1:Fe=+Fe+1),Ce=Ie+Ae+"."+Fe+"."+$e):it?Ce=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ze&&(Ce=">="+Ae+"."+Fe+".0 <"+Ae+"."+(+Fe+1)+".0"),D("xRange return",Ce),Ce})}(je,qe)}).join(" ")}(ze,Ye),D("xrange",ze),ze=function(Ke,qe){return D("replaceStars",Ke,qe),Ke.trim().replace(I[fe],"")}(ze,Ye),D("stars",ze),ze}(Ve,be)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ve){return!!Ve.match(Me)})),Be=Be.map(function(Ve){return new j(Ve,be)})},le.prototype.intersects=function(me,be){if(!(me instanceof le))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(Me){return me.set.some(function(Be){return Be.every(function(Ve){return Me.intersects(Ve,be)})})})})},e.toComparators=function(me,be){return new le(me,be).set.map(function(Ee){return Ee.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},le.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new L(me,this.loose));for(var be=0;be<this.set.length;be++)if(Te(this.set[be],me))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(me,be,Ee){var Me=null,Be=null;try{var Ve=new le(be,Ee)}catch{return null}return me.forEach(function(ze){Ve.test(ze)&&(Me&&Be.compare(ze)!==-1||(Be=new L(Me=ze,Ee)))}),Me},e.minSatisfying=function(me,be,Ee){var Me=null,Be=null;try{var Ve=new le(be,Ee)}catch{return null}return me.forEach(function(ze){Ve.test(ze)&&(Me&&Be.compare(ze)!==1||(Be=new L(Me=ze,Ee)))}),Me},e.validRange=function(me,be){try{return new le(me,be).range||"*"}catch{return null}},e.ltr=function(me,be,Ee){return Le(me,be,"<",Ee)},e.gtr=function(me,be,Ee){return Le(me,be,">",Ee)},e.outside=Le,e.prerelease=function(me,be){var Ee=ie(me,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(me,be,Ee){return me=new le(me,Ee),be=new le(be,Ee),me.intersects(be)},e.coerce=function(me){if(me instanceof L)return me;if(typeof me!="string")return null;var be=me.match(I[$]);return be==null?null:ie((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,v(1))},function(oe,e){var v,t,D=oe.exports={};function C(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(E){if(v===setTimeout)return setTimeout(E,0);if((v===C||!v)&&setTimeout)return v=setTimeout,setTimeout(E,0);try{return v(E,0)}catch{try{return v.call(null,E,0)}catch{return v.call(this,E,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:C}catch{v=C}try{t=typeof clearTimeout=="function"?clearTimeout:T}catch{t=T}})();var p,b=[],R=!1,k=-1;function S(){R&&p&&(R=!1,p.length?b=p.concat(b):k=-1,b.length&&y())}function y(){if(!R){var E=I(S);R=!0;for(var g=b.length;g;){for(p=b,b=[];++k<g;)p&&p[k].run();k=-1,g=b.length}p=null,R=!1,function(m){if(t===clearTimeout)return clearTimeout(m);if((t===T||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(m);try{t(m)}catch{try{return t.call(null,m)}catch{return t.call(this,m)}}}(E)}}function h(E,g){this.fun=E,this.array=g}function w(){}D.nextTick=function(E){var g=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)g[m-1]=arguments[m];b.push(new h(E,g)),b.length!==1||R||I(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=w,D.addListener=w,D.once=w,D.off=w,D.removeListener=w,D.removeAllListeners=w,D.emit=w,D.prependListener=w,D.prependOnceListener=w,D.listeners=function(E){return[]},D.binding=function(E){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(E){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(we[137],ye([1,0]),function(oe,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,p,b){this.level=I,this.key=p,this.value=b,this.forward=[]}}const D=void 0;class C{constructor(I,p=2**16){this.comparator=I,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new t(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,D,D)}has(I){return Boolean(C._search(this,I,this.comparator))}get(I){return C._search(this,I,this.comparator)?.value}set(I,p){return C._insert(this,I,p,this.comparator)&&(this._size+=1),this}delete(I){const p=C._delete(this,I,this.comparator);return p&&(this._size-=1),p}forEach(I,p){let b=this._header.forward[0];for(;b;)I.call(p,b.value,b.key,this),b=b.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",p=this._header.forward[0];for(;p;)I+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return I}static _search(I,p,b){let R=I._header;for(let k=I._level-1;k>=0;k--)for(;R.forward[k]&&b(R.forward[k].key,p)<0;)R=R.forward[k];if(R=R.forward[0],R&&b(R.key,p)===0)return R}static _insert(I,p,b,R){const k=[];let S=I._header;for(let y=I._level-1;y>=0;y--){for(;S.forward[y]&&R(S.forward[y].key,p)<0;)S=S.forward[y];k[y]=S}if(S=S.forward[0],S&&R(S.key,p)===0)return S.value=b,!1;{const y=C._randomLevel(I);if(y>I._level){for(let h=I._level;h<y;h++)k[h]=I._header;I._level=y}S=new t(y,p,b);for(let h=0;h<y;h++)S.forward[h]=k[h].forward[h],k[h].forward[h]=S;return!0}}static _randomLevel(I,p=.5){let b=1;for(;Math.random()<p&&b<I._maxLevel;)b+=1;return b}static _delete(I,p,b){const R=[];let k=I._header;for(let S=I._level-1;S>=0;S--){for(;k.forward[S]&&b(k.forward[S].key,p)<0;)k=k.forward[S];R[S]=k}if(k=k.forward[0],!k||b(k.key,p)!==0)return!1;for(let S=0;S<I._level&&R[S].forward[S]===k;S++)R[S].forward[S]=k.forward[S];for(;I._level>0&&I._header.forward[I._level-1]===D;)I._level-=1;return!0}}e.SkipList=C}),define(we[138],ye([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class D{static create(T=!0){return new D(T)}constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(we[7],ye([1,0,8,64,2,135,138]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,p=!1;var b;(function(a){a.None=()=>D.Disposable.None;function c(M){if(p){const{onListenerDidAdd:G}=M,re=h.create();let he=0;M.onListenerDidAdd=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),G?.()}}}function d(M){return(G,re=null,he)=>{let ve=!1,H;return H=M(Y=>{if(!ve)return H?H.dispose():ve=!0,G.call(re,Y)},null,he),ve&&H.dispose(),H}}a.once=d;function P(M,G,re){return ee((he,ve=null,H)=>M(Y=>he.call(ve,G(Y)),null,H),re)}a.map=P;function F(M,G,re){return ee((he,ve=null,H)=>M(Y=>{G(Y),he.call(ve,Y)},null,H),re)}a.forEach=F;function $(M,G,re){return ee((he,ve=null,H)=>M(Y=>G(Y)&&he.call(ve,Y),null,H),re)}a.filter=$;function Z(M){return M}a.signal=Z;function J(...M){return(G,re=null,he)=>(0,D.combinedDisposable)(...M.map(ve=>ve(H=>G.call(re,H),null,he)))}a.any=J;function _(M,G,re,he){let ve=re;return P(M,H=>(ve=G(ve,H),ve),he)}a.reduce=_;function ee(M,G){let re;const he={onFirstListenerAdd(){re=M(ve.fire,ve)},onLastListenerRemove(){re?.dispose()}};G||c(he);const ve=new E(he);return G?.add(ve),ve.event}function ne(M,G,re=100,he=!1,ve,H){let Y,te,W,q=0;const j={leakWarningThreshold:ve,onFirstListenerAdd(){Y=M(le=>{q++,te=G(te,le),he&&!W&&(Q.fire(te),te=void 0),clearTimeout(W),W=setTimeout(()=>{const pe=te;te=void 0,W=void 0,(!he||q>1)&&Q.fire(pe),q=0},re)})},onLastListenerRemove(){Y.dispose()}};H||c(j);const Q=new E(j);return H?.add(Q),Q.event}a.debounce=ne;function B(M,G=(he,ve)=>he===ve,re){let he=!0,ve;return $(M,H=>{const Y=he||!G(H,ve);return he=!1,ve=H,Y},re)}a.latch=B;function ue(M,G,re){return[a.filter(M,G,re),a.filter(M,he=>!G(he),re)]}a.split=ue;function z(M,G=!1,re=[]){let he=re.slice(),ve=M(te=>{he?he.push(te):Y.fire(te)});const H=()=>{he?.forEach(te=>Y.fire(te)),he=null},Y=new E({onFirstListenerAdd(){ve||(ve=M(te=>Y.fire(te)))},onFirstListenerDidAdd(){he&&(G?setTimeout(H):H())},onLastListenerRemove(){ve&&ve.dispose(),ve=null}});return Y.event}a.buffer=z;class X{constructor(G){this.event=G,this.disposables=new D.DisposableStore}map(G){return new X(P(this.event,G,this.disposables))}forEach(G){return new X(F(this.event,G,this.disposables))}filter(G){return new X($(this.event,G,this.disposables))}reduce(G,re){return new X(_(this.event,G,re,this.disposables))}latch(){return new X(B(this.event,void 0,this.disposables))}debounce(G,re=100,he=!1,ve){return new X(ne(this.event,G,re,he,ve,this.disposables))}on(G,re,he){return this.event(G,re,he)}once(G,re,he){return d(this.event)(G,re,he)}dispose(){this.disposables.dispose()}}function O(M){return new X(M)}a.chain=O;function U(M,G,re=he=>he){const he=(...te)=>Y.fire(re(...te)),ve=()=>M.on(G,he),H=()=>M.removeListener(G,he),Y=new E({onFirstListenerAdd:ve,onLastListenerRemove:H});return Y.event}a.fromNodeEventEmitter=U;function x(M,G,re=he=>he){const he=(...te)=>Y.fire(re(...te)),ve=()=>M.addEventListener(G,he),H=()=>M.removeEventListener(G,he),Y=new E({onFirstListenerAdd:ve,onLastListenerRemove:H});return Y.event}a.fromDOMEventEmitter=x;function ae(M){return new Promise(G=>d(M)(G))}a.toPromise=ae;function fe(M,G){return G(void 0),M(re=>G(re))}a.runAndSubscribe=fe;function K(M,G){let re=null;function he(H){re?.dispose(),re=new D.DisposableStore,G(H,re)}he(void 0);const ve=M(H=>he(H));return(0,D.toDisposable)(()=>{ve.dispose(),re?.dispose()})}a.runAndSubscribeWithStore=K;class ie{constructor(G,re){this.obs=G,this._counter=0,this._hasChanged=!1;const he={onFirstListenerAdd:()=>{G.addObserver(this)},onLastListenerRemove:()=>{G.removeObserver(this)}};re||c(he),this.emitter=new E(he),re&&re.add(this.emitter)}beginUpdate(G){this._counter++}handleChange(G,re){this._hasChanged=!0}endUpdate(G){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(M,G){return new ie(M,G).emitter.event}a.fromObservable=L})(b=e.Event||(e.Event={}));class R{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${R._idPool++}`,R.all.add(this)}start(c){this._stopWatch=new T.StopWatch(!0),this.listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=R,R.all=new Set,R._idPool=0;let k=-1;function S(a){const c=k;return k=a,{dispose(){k=c}}}e.setGlobalLeakWarningThreshold=S;class y{constructor(c,d=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,d){let P=k;if(typeof this.customThreshold=="number"&&(P=this.customThreshold),P<=0||d<P)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let $,Z=0;for(const[J,_]of this._stacks)(!$||Z<_)&&($=J,Z=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${Z}):`),console.warn($)}return()=>{const $=this._stacks.get(c.value)||0;this._stacks.set(c.value,$-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(c,d,P){this.callback=c,this.callbackThis=d,this.stack=P,this.subscription=new D.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class E{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=k>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const d of c)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,d,P)=>{this._listeners||(this._listeners=new C.LinkedList);const F=this._listeners.isEmpty();F&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let $,Z;this._leakageMon&&this._listeners.size>=30&&(Z=h.create(),$=this._leakageMon.check(Z,this._listeners.size+1)),I&&(Z=Z??h.create());const J=new w(c,d,Z),_=this._listeners.push(J);F&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,d);const ee=J.subscription.set(()=>{$?.(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return P instanceof D.DisposableStore?P.add(ee):Array.isArray(P)&&P.push(ee),ee}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const d of this._listeners)this._deliveryQueue.push(this,d,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=E;class g{constructor(){this._queue=new C.LinkedList}get size(){return this._queue.size}push(c,d,P){this._queue.push(new u(c,d,P))}clear(c){const d=new C.LinkedList;for(const P of this._queue)P.emitter!==c&&d.push(P);this._queue=d}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(d){(0,v.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=g;class m extends g{clear(c){this._queue.clear()}}class u{constructor(c,d,P){this.emitter=c,this.listener=d,this.event=P}}class l extends E{async fireAsync(c,d,P){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const F of this._listeners)this._asyncDeliveryQueue.push([F,c]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[F,$]=this._asyncDeliveryQueue.shift(),Z=[],J={...$,token:d,waitUntil:_=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");P&&(_=P(_,F.callback)),Z.push(_)}};try{F.invoke(J)}catch(_){(0,v.onUnexpectedError)(_);continue}Object.freeze(Z),await Promise.allSettled(Z).then(_=>{for(const ee of _)ee.status==="rejected"&&(0,v.onUnexpectedError)(ee.reason)})}}}}e.AsyncEmitter=l;class f extends E{constructor(c){super(c),this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=f;class r extends f{constructor(c){super(c),this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=r;class o extends E{constructor(c){super(c),this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){!this.hasListeners()||(this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const d={event:c,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const P=()=>{this.hasListeners&&this.unhook(d);const F=this.events.indexOf(d);this.events.splice(F,1)};return(0,D.toDisposable)((0,t.once)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(d=>this.emitter.fire(d))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.buffers=[]}wrapEvent(c){return(d,P,F)=>c($=>{const Z=this.buffers[this.buffers.length-1];Z?Z.push(()=>d.call(P,$)):d.call(P,$)},void 0,F)}bufferEvents(c){const d=[];this.buffers.push(d);const P=c();return this.buffers.pop(),d.forEach(F=>F()),P}}e.EventBufferer=i;class s{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=D.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(we[20],ye([1,0,7]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,p){const b=setTimeout(I.bind(p),0);return{dispose(){clearTimeout(b)}}});var D;(function(I){function p(b){return b===I.None||b===I.Cancelled||b instanceof C?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}I.isCancellationToken=p,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=T}),define(we[139],ye([1,0,20]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new v.CancellationTokenSource,p=this.task(I.token);return this.result={promise:p,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class D{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const p=JSON.stringify(I);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=D;class C{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const p=this.fn(I);return this._map.set(I,p),p}}e.CachedFunction=C}),define(we[85],ye([1,0,7,2]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=T=>({onDidChange:v.Event.None,value:T});e.staticObservableValue=D;class C extends t.Disposable{get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}constructor(I){super(),this._value=I,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=C}),define(we[45],ye([1,0,8,2]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(l){const f=l;return f?typeof f.read=="function":!1}e.isReadable=D;function C(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=C;function T(l){const f=l;return f?C(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=T;function I(l,f){return new p(l,f)}e.newWriteableStream=I;class p{constructor(f,r){this.reducer=f,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f<"u"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(r=>r(f))}emitError(f){this.listeners.error.length===0?(0,v.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(r=>r(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,r){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(f,r){if(this.state.destroyed)return;let o;switch(f){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(r);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(l,f){const r=[];let o;for(;(o=l.read())!==null;)r.push(o);return f(r)}e.consumeReadable=b;function R(l,f,r){const o=[];let n;for(;(n=l.read())!==null&&o.length<r;)o.push(n);return n===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return l.read()}}}e.peekReadable=R;function k(l,f){return new Promise((r,o)=>{const n=[];S(l,{onData:i=>{f&&n.push(i)},onError:i=>{f?o(i):r(void 0)},onEnd:()=>{r(f?f(n):void 0)}})})}e.consumeStream=k;function S(l,f){let r=!1;return l.on("error",o=>{r||f.onError(o)}),l.on("end",()=>{r||f.onEnd()}),l.on("data",o=>{r||f.onData(o)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=S;function y(l,f){return new Promise((r,o)=>{const n=new t.DisposableStore,i=[],s=d=>{if(i.push(d),i.length>f)return n.dispose(),l.pause(),r({stream:l,buffer:i,ended:!1})},a=d=>o(d),c=()=>r({stream:l,buffer:i,ended:!0});n.add((0,t.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),n.add((0,t.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),n.add((0,t.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=y;function h(l,f){const r=I(f);return r.end(l),r}e.toStream=h;function w(){const l=I(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=w;function E(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=E;function g(l,f,r){const o=I(r);return S(l,{onData:n=>o.write(f.data(n)),onError:n=>o.error(f.error?f.error(n):n),onEnd:()=>o.end()}),o}e.transform=g;function m(l,f,r){let o=!1;return{read:()=>{const n=f.read();return o?n:(o=!0,n!==null?r([l,n]):l)}}}e.prefixedReadable=m;function u(l,f,r){let o=!1;const n=I(r);return S(f,{onData:i=>o?n.write(i):(o=!0,n.write(r([l,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(l)),n.end()}}),n}e.prefixedStream=u}),define(we[16],ye([1,0,45]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let D,C;class T{static alloc(d){return t?new T(Buffer.allocUnsafe(d)):new T(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new T(d)}static fromString(d,P){return!(P?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(d)):(D||(D=new TextEncoder),new T(D.encode(d)))}static fromByteArray(d){const P=T.alloc(d.length);for(let F=0,$=d.length;F<$;F++)P.buffer[F]=d[F];return P}static concat(d,P){if(typeof P>"u"){P=0;for(let Z=0,J=d.length;Z<J;Z++)P+=d[Z].byteLength}const F=T.alloc(P);let $=0;for(let Z=0,J=d.length;Z<J;Z++){const _=d[Z];F.set(_,$),$+=_.byteLength}return F}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=T.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(d,P){return new T(this.buffer.subarray(d,P))}set(d,P){if(d instanceof T)this.buffer.set(d.buffer,P);else if(d instanceof Uint8Array)this.buffer.set(d,P);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),P);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return b(this.buffer,d)}writeUInt32BE(d,P){R(this.buffer,d,P)}readUInt32LE(d){return k(this.buffer,d)}writeUInt32LE(d,P){S(this.buffer,d,P)}readUInt8(d){return y(this.buffer,d)}writeUInt8(d,P){h(this.buffer,d,P)}}e.VSBuffer=T;function I(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0}e.readUInt16LE=I;function p(c,d,P){c[P+0]=d&255,d=d>>>8,c[P+1]=d&255}e.writeUInt16LE=p;function b(c,d){return c[d]*2**24+c[d+1]*2**16+c[d+2]*2**8+c[d+3]}e.readUInt32BE=b;function R(c,d,P){c[P+3]=d,d=d>>>8,c[P+2]=d,d=d>>>8,c[P+1]=d,d=d>>>8,c[P]=d}e.writeUInt32BE=R;function k(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0|c[d+2]<<16>>>0|c[d+3]<<24>>>0}e.readUInt32LE=k;function S(c,d,P){c[P+0]=d&255,d=d>>>8,c[P+1]=d&255,d=d>>>8,c[P+2]=d&255,d=d>>>8,c[P+3]=d&255}e.writeUInt32LE=S;function y(c,d){return c[d]}e.readUInt8=y;function h(c,d,P){c[P]=d}e.writeUInt8=h;function w(c){return v.consumeReadable(c,d=>T.concat(d))}e.readableToBuffer=w;function E(c){return v.toReadable(c)}e.bufferToReadable=E;function g(c){return v.consumeStream(c,d=>T.concat(d))}e.streamToBuffer=g;async function m(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await g(c.stream)])}e.bufferedStreamToBuffer=m;function u(c){return v.toStream(c,d=>T.concat(d))}e.bufferToStream=u;function l(c){return v.transform(c,{data:d=>typeof d=="string"?T.fromString(d):T.wrap(d)},d=>T.concat(d))}e.streamToBufferReadableStream=l;function f(c){return v.newWriteableStream(d=>T.concat(d),c)}e.newWriteableBufferStream=f;function r(c,d){return v.prefixedReadable(c,d,P=>T.concat(P))}e.prefixedBufferReadable=r;function o(c,d){return v.prefixedStream(c,d,P=>T.concat(P))}e.prefixedBufferStream=o;function n(c){let d=0,P=0,F=0;const $=new Uint8Array(Math.floor(c.length/4*3)),Z=_=>{switch(P){case 3:$[F++]=d|_,P=0;break;case 2:$[F++]=d|_>>>2,d=_<<6,P=3;break;case 1:$[F++]=d|_>>>4,d=_<<4,P=2;break;default:d=_<<2,P=1}};for(let _=0;_<c.length;_++){const ee=c.charCodeAt(_);if(ee>=65&&ee<=90)Z(ee-65);else if(ee>=97&&ee<=122)Z(ee-97+26);else if(ee>=48&&ee<=57)Z(ee-48+52);else if(ee===43||ee===45)Z(62);else if(ee===47||ee===95)Z(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${c[_]}`)}}const J=F;for(;P>0;)Z(0);return T.wrap($).slice(0,J)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},d=!0,P=!1){const F=P?s:i;let $="";const Z=c.byteLength%3;let J=0;for(;J<c.byteLength-Z;J+=3){const _=c[J+0],ee=c[J+1],ne=c[J+2];$+=F[_>>>2],$+=F[(_<<4|ee>>>4)&63],$+=F[(ee<<2|ne>>>6)&63],$+=F[ne&63]}if(Z===1){const _=c[J+0];$+=F[_>>>2],$+=F[_<<4&63],d&&($+="==")}else if(Z===2){const _=c[J+0],ee=c[J+1];$+=F[_>>>2],$+=F[(_<<4|ee>>>4)&63],$+=F[ee<<2&63],d&&($+="=")}return $}e.encodeBase64=a}),define(we[15],ye([1,0,139,134]),function(oe,e,v,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=C;const T=/{(\d+)}/g;function I(ce,...Ce){return Ce.length===0?ce:ce.replace(T,function(Ie,Ae){const Fe=parseInt(Ae,10);return isNaN(Fe)||Fe<0||Fe>=Ce.length?Ie:Ce[Fe]})}e.format=I;const p=/{([^}]+)}/g;function b(ce,Ce){return ce.replace(p,(Ie,Ae)=>Ce[Ae]??Ie)}e.format2=b;function R(ce){return ce.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=R;function k(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function S(ce,Ce){let Ie=0;const Ae=Ce.charCodeAt(0);for(let Fe=ce.length-1;Fe>=0;Fe--)ce.charCodeAt(Fe)===Ae&&Ie++;return Ie}e.count=S;function y(ce,Ce,Ie="\u2026"){return ce.length<=Ce?ce:`${ce.substr(0,Ce)}${Ie}`}e.truncate=y;function h(ce,Ce=" "){const Ie=w(ce,Ce);return E(Ie,Ce)}e.trim=h;function w(ce,Ce){if(!ce||!Ce)return ce;const Ie=Ce.length;if(Ie===0||ce.length===0)return ce;let Ae=0;for(;ce.indexOf(Ce,Ae)===Ae;)Ae=Ae+Ie;return ce.substring(Ae)}e.ltrim=w;function E(ce,Ce){if(!ce||!Ce)return ce;const Ie=Ce.length,Ae=ce.length;if(Ie===0||Ae===0)return ce;let Fe=Ae,$e=-1;for(;$e=ce.lastIndexOf(Ce,Fe-1),!($e===-1||$e+Ie!==Fe);){if($e===0)return"";Fe=$e}return ce.substring(0,Fe)}e.rtrim=E;function g(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function m(ce){return ce.replace(/\*/g,"")}e.stripWildcards=m;function u(ce,Ce,Ie={}){if(!ce)throw new Error("Cannot create regex from empty string");Ce||(ce=k(ce)),Ie.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Ae="";return Ie.global&&(Ae+="g"),Ie.matchCase||(Ae+="i"),Ie.multiline&&(Ae+="m"),Ie.unicode&&(Ae+="u"),new RegExp(ce,Ae)}e.createRegExp=u;function l(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function f(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function r(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=r;function o(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=o;function n(ce){for(let Ce=0,Ie=ce.length;Ce<Ie;Ce++){const Ae=ce.charCodeAt(Ce);if(Ae!==32&&Ae!==9)return Ce}return-1}e.firstNonWhitespaceIndex=n;function i(ce,Ce=0,Ie=ce.length){for(let Ae=Ce;Ae<Ie;Ae++){const Fe=ce.charCodeAt(Ae);if(Fe!==32&&Fe!==9)return ce.substring(Ce,Ae)}return ce.substring(Ce,Ie)}e.getLeadingWhitespace=i;function s(ce,Ce=ce.length-1){for(let Ie=Ce;Ie>=0;Ie--){const Ae=ce.charCodeAt(Ie);if(Ae!==32&&Ae!==9)return Ie}return-1}e.lastNonWhitespaceIndex=s;function a(ce,Ce,Ie){const Ae=[];let Fe=0;for(const $e of ce.matchAll(Ce)){if(Ae.push(ce.slice(Fe,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");Fe=$e.index+$e[0].length,Ae.push(Ie($e[0],...$e.slice(1),$e.index,ce,$e.groups))}return Ae.push(ce.slice(Fe)),Promise.all(Ae).then($e=>$e.join(""))}e.replaceAsync=a;function c(ce,Ce){return ce<Ce?-1:ce>Ce?1:0}e.compare=c;function d(ce,Ce,Ie=0,Ae=ce.length,Fe=0,$e=Ce.length){for(;Ie<Ae&&Fe<$e;Ie++,Fe++){const it=ce.charCodeAt(Ie),Ze=Ce.charCodeAt(Fe);if(it<Ze)return-1;if(it>Ze)return 1}const Qe=Ae-Ie,rt=$e-Fe;return Qe<rt?-1:Qe>rt?1:0}e.compareSubstring=d;function P(ce,Ce){return F(ce,Ce,0,ce.length,0,Ce.length)}e.compareIgnoreCase=P;function F(ce,Ce,Ie=0,Ae=ce.length,Fe=0,$e=Ce.length){for(;Ie<Ae&&Fe<$e;Ie++,Fe++){let it=ce.charCodeAt(Ie),Ze=Ce.charCodeAt(Fe);if(it===Ze)continue;if(it>=128||Ze>=128)return d(ce.toLowerCase(),Ce.toLowerCase(),Ie,Ae,Fe,$e);Z(it)&&(it-=32),Z(Ze)&&(Ze-=32);const at=it-Ze;if(at!==0)return at}const Qe=Ae-Ie,rt=$e-Fe;return Qe<rt?-1:Qe>rt?1:0}e.compareSubstringIgnoreCase=F;function $(ce){return ce>=48&&ce<=57}e.isAsciiDigit=$;function Z(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=Z;function J(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=J;function _(ce,Ce){return ce.length===Ce.length&&F(ce,Ce)===0}e.equalsIgnoreCase=_;function ee(ce,Ce){const Ie=Ce.length;return Ce.length>ce.length?!1:F(ce,Ce,0,Ie)===0}e.startsWithIgnoreCase=ee;function ne(ce,Ce){const Ie=Math.min(ce.length,Ce.length);let Ae;for(Ae=0;Ae<Ie;Ae++)if(ce.charCodeAt(Ae)!==Ce.charCodeAt(Ae))return Ae;return Ie}e.commonPrefixLength=ne;function B(ce,Ce){const Ie=Math.min(ce.length,Ce.length);let Ae;const Fe=ce.length-1,$e=Ce.length-1;for(Ae=0;Ae<Ie;Ae++)if(ce.charCodeAt(Fe-Ae)!==Ce.charCodeAt($e-Ae))return Ae;return Ie}e.commonSuffixLength=B;function ue(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=ue;function z(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=z;function X(ce,Ce){return(ce-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=X;function O(ce,Ce,Ie){const Ae=ce.charCodeAt(Ie);if(ue(Ae)&&Ie+1<Ce){const Fe=ce.charCodeAt(Ie+1);if(z(Fe))return X(Ae,Fe)}return Ae}e.getNextCodePoint=O;function U(ce,Ce){const Ie=ce.charCodeAt(Ce-1);if(z(Ie)&&Ce>1){const Ae=ce.charCodeAt(Ce-2);if(ue(Ae))return X(Ae,Ie)}return Ie}class x{get offset(){return this._offset}constructor(Ce,Ie=0){this._str=Ce,this._len=Ce.length,this._offset=Ie}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=U(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=O(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class ae{get offset(){return this._iterator.offset}constructor(Ce,Ie=0){this._iterator=new x(Ce,Ie)}nextGraphemeLength(){const Ce=Ve.getInstance(),Ie=this._iterator,Ae=Ie.offset;let Fe=Ce.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const $e=Ie.offset,Qe=Ce.getGraphemeBreakType(Ie.nextCodePoint());if(Me(Fe,Qe)){Ie.setOffset($e);break}Fe=Qe}return Ie.offset-Ae}prevGraphemeLength(){const Ce=Ve.getInstance(),Ie=this._iterator,Ae=Ie.offset;let Fe=Ce.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const $e=Ie.offset,Qe=Ce.getGraphemeBreakType(Ie.prevCodePoint());if(Me(Qe,Fe)){Ie.setOffset($e);break}Fe=Qe}return Ae-Ie.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ae;function fe(ce,Ce){return new ae(ce,Ce).nextGraphemeLength()}e.nextCharLength=fe;function K(ce,Ce){return new ae(ce,Ce).prevGraphemeLength()}e.prevCharLength=K;function ie(ce,Ce){Ce>0&&z(ce.charCodeAt(Ce))&&Ce--;const Ie=Ce+fe(ce,Ce);return[Ie-K(ce,Ie),Ie]}e.getCharContainingOffset=ie;function L(ce){const Ce=new ae(ce);let Ie=0;for(;!Ce.eol();)Ie++,Ce.nextGraphemeLength();return Ie}e.charCount=L;let M;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function re(ce){return M||(M=G()),M.test(ce)}e.containsRTL=re;const he=/^[\t\n\r\x20-\x7E]*$/;function ve(ce){return he.test(ce)}e.isBasicASCII=ve,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=H;function Y(ce){return ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=Y;function te(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129008||ce>=129280&&ce<=129535||ce>=129648&&ce<=129782}e.isEmojiImprecise=te;function W(ce,Ce){if(ce.length<Ce)return ce;const Ie=/\b/g;let Ae=0;for(;Ie.test(ce)&&!(ce.length-Ie.lastIndex<Ce);)Ae=Ie.lastIndex,Ie.lastIndex+=1;return ce.substring(Ae).replace(/^\s/,"")}e.lcut=W;const q=/\x1B\x5B[12]?K/g,j=/\x1b\[\d+m/g,Q=/\x1b\[0?m/g;function le(ce){return ce&&(ce=ce.replace(q,""),ce=ce.replace(j,""),ce=ce.replace(Q,"")),ce}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function ke(ce){return pe(ce)?ce.substr(1):ce}e.stripUTF8BOM=ke;function Te(ce,Ce){if(!ce||!Ce||ce.length<Ce.length)return!1;const Ie=Ce.length,Ae=ce.toLowerCase();let Fe=0,$e=-1;for(;Fe<Ie;){const Qe=Ae.indexOf(Ce[Fe],$e+1);if(Qe<0)return!1;$e=Qe,Fe++}return!0}e.fuzzyContains=Te;function Ne(ce,Ce=!1){return ce?(Ce&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=Ne;function Le(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Le;function me(ce,Ce=1){if(Ce===0)return"";let Ie=-1;do Ie=ce.indexOf(`
`,Ie+1),Ce--;while(Ce>0&&Ie>=0);return Ie===-1?ce:(ce[Ie-1]==="\r"&&Ie--,ce.substr(0,Ie))}e.getNLines=me;function be(ce){return ce=ce%(2*26),ce<26?String.fromCharCode(97+ce):String.fromCharCode(65+ce-26)}e.singleLetterHash=be;function Ee(ce){return Ve.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=Ee;function Me(ce,Ce){return ce===0?Ce!==5&&Ce!==7:ce===2&&Ce===3?!1:ce===4||ce===2||ce===3||Ce===4||Ce===2||Ce===3?!0:!(ce===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ce===11||ce===9)&&(Ce===9||Ce===10)||(ce===12||ce===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ce===1||ce===13&&Ce===14||ce===6&&Ce===6)}var Be;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(Be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Ie=this._data,Ae=Ie.length/3;let Fe=1;for(;Fe<=Ae;)if(Ce<Ie[3*Fe])Fe=2*Fe;else if(Ce>Ie[3*Fe+1])Fe=2*Fe+1;else return Ie[3*Fe+2];return 0}}Ve._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(ce,Ce){if(ce===0)return 0;const Ie=Ke(ce,Ce);if(Ie!==void 0)return Ie;const Ae=new x(Ce,ce);return Ae.prevCodePoint(),Ae.offset}e.getLeftDeleteOffset=Ye;function Ke(ce,Ce){const Ie=new x(Ce,ce);let Ae=Ie.prevCodePoint();for(;qe(Ae)||Ae===65039||Ae===8419;){if(Ie.offset===0)return;Ae=Ie.prevCodePoint()}if(!te(Ae))return;let Fe=Ie.offset;return Fe>0&&Ie.prevCodePoint()===8205&&(Fe=Ie.offset),Fe}function qe(ce){return 127995<=ce&&ce<=127999}var je;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class xe{static getInstance(Ce){return xe.cache.get(Array.from(Ce))}static getLocales(){return xe._locales.getValue()}constructor(Ce){this.confusableDictionary=Ce}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=xe,D=xe,xe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),xe.cache=new v.LRUCachedFunction(ce=>{function Ce(Ze){const at=new Map;for(let st=0;st<Ze.length;st+=2)at.set(Ze[st],Ze[st+1]);return at}function Ie(Ze,at){const st=new Map(Ze);for(const[dt,ft]of at)st.set(dt,ft);return st}function Ae(Ze,at){if(!Ze)return at;const st=new Map;for(const[dt,ft]of Ze)at.has(dt)&&st.set(dt,ft);return st}const Fe=D.ambiguousCharacterData.getValue();let $e=ce.filter(Ze=>!Ze.startsWith("_")&&Ze in Fe);$e.length===0&&($e=["_default"]);let Qe;for(const Ze of $e){const at=Ce(Fe[Ze]);Qe=Ae(Qe,at)}const rt=Ce(Fe._common),it=Ie(rt,Qe);return new xe(it)}),xe._locales=new t.Lazy(()=>Object.keys(xe.ambiguousCharacterData.getValue()).filter(ce=>!ce.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(Ce){return Ge.getData().has(Ce)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(we[86],ye([1,0,15]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(g){return D(g,0)}e.hash=t;function D(g,m){switch(typeof g){case"object":return g===null?C(349,m):Array.isArray(g)?p(g,m):b(g,m);case"string":return I(g,m);case"boolean":return T(g,m);case"number":return C(g,m);case"undefined":return C(937,m);default:return C(617,m)}}e.doHash=D;function C(g,m){return(m<<5)-m+g|0}e.numberHash=C;function T(g,m){return C(g?433:863,m)}function I(g,m){m=C(149417,m);for(let u=0,l=g.length;u<l;u++)m=C(g.charCodeAt(u),m);return m}e.stringHash=I;function p(g,m){return m=C(104579,m),g.reduce((u,l)=>D(l,u),m)}function b(g,m){return m=C(181387,m),Object.keys(g).sort().reduce((u,l)=>(u=I(l,u),D(g[l],u)),m)}class R{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=D(m,this._value),this._value}}e.Hasher=R;var k;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function S(g,m,u=32){const l=u-m,f=~((1<<l)-1);return(g<<m|(f&g)>>>l)>>>0}function y(g,m=0,u=g.byteLength,l=0){for(let f=0;f<u;f++)g[m+f]=l}function h(g,m,u="0"){for(;g.length<m;)g=u+g;return g}function w(g,m=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(u=>u.toString(16).padStart(2,"0")).join(""):h((g>>>0).toString(16),m/4)}e.toHexString=w;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const u=m.length;if(u===0)return;const l=this._buff;let f=this._buffLen,r=this._leftoverHighSurrogate,o,n;for(r!==0?(o=r,n=-1,r=0):(o=m.charCodeAt(0),n=0);;){let i=o;if(v.isHighSurrogate(o))if(n+1<u){const s=m.charCodeAt(n+1);v.isLowSurrogate(s)?(n++,i=v.computeCodePoint(o,s)):i=65533}else{r=o;break}else v.isLowSurrogate(o)&&(i=65533);if(f=this._push(l,f,i),n++,n<u)o=m.charCodeAt(n);else break}this._buffLen=f,this._leftoverHighSurrogate=r}_push(m,u,l){return l<128?m[u++]=l:l<2048?(m[u++]=192|(l&1984)>>>6,m[u++]=128|(l&63)>>>0):l<65536?(m[u++]=224|(l&61440)>>>12,m[u++]=128|(l&4032)>>>6,m[u++]=128|(l&63)>>>0):(m[u++]=240|(l&1835008)>>>18,m[u++]=128|(l&258048)>>>12,m[u++]=128|(l&4032)>>>6,m[u++]=128|(l&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=E._bigBlock32,u=this._buffDV;for(let c=0;c<64;c+=4)m.setUint32(c,u.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)m.setUint32(c,S(m.getUint32(c-12,!1)^m.getUint32(c-32,!1)^m.getUint32(c-56,!1)^m.getUint32(c-64,!1),1),!1);let l=this._h0,f=this._h1,r=this._h2,o=this._h3,n=this._h4,i,s,a;for(let c=0;c<80;c++)c<20?(i=f&r|~f&o,s=1518500249):c<40?(i=f^r^o,s=1859775393):c<60?(i=f&r|f&o|r&o,s=2400959708):(i=f^r^o,s=3395469782),a=S(l,5)+i+n+s+m.getUint32(c*4,!1)&4294967295,n=o,o=r,r=S(f,30),f=l,l=a;this._h0=this._h0+l&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[24],ye([1,0,18,15]),function(oe,e,v,t){"use strict";var D,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(n,i,s){let a=n.get(i);return a===void 0&&(a=s,n.set(i,a)),a}e.getOrSet=I;function p(n){const i=[];return n.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=p;function b(n){const i=[];return n.forEach(s=>{i.push(s)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=b;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=R;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class S{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var y;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(y||(y={}));class h{constructor(i,s){this._ignorePathCasing=i,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(E||(E={}));class g{static forUris(i=()=>!1,s=()=>!1){return new g(new h(i,s))}static forPaths(i=!1){return new g(new S(void 0,!i))}static forStrings(){return new g(new R)}static forConfigKeys(){return new g(new k)}constructor(i){this._iter=i}clear(){this._root=void 0}fill(i,s){if(s){const a=s.slice(0);(0,v.shuffle)(a);for(const c of a)this.set(c,i)}else{const a=i.slice(0);(0,v.shuffle)(a);for(const c of a)this.set(c[0],c[1])}}set(i,s){const a=this._iter.reset(i);let c;this._root||(this._root=new w,this._root.segment=a.value());const d=[];for(c=this._root;;){const F=a.cmp(c.segment);if(F>0)c.left||(c.left=new w,c.left.segment=a.value()),d.push([-1,c]),c=c.left;else if(F<0)c.right||(c.right=new w,c.right.segment=a.value()),d.push([1,c]),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new w,c.mid.segment=a.value()),d.push([0,c]),c=c.mid;else break}const P=c.value;c.value=s,c.key=i;for(let F=d.length-1;F>=0;F--){const $=d[F][1];$.updateHeight();const Z=$.balanceFactor();if(Z<-1||Z>1){const J=d[F][0],_=d[F+1][0];if(J===1&&_===1)d[F][1]=$.rotateLeft();else if(J===-1&&_===-1)d[F][1]=$.rotateRight();else if(J===1&&_===-1)$.right=d[F+1][1]=d[F+1][1].rotateRight(),d[F][1]=$.rotateLeft();else if(J===-1&&_===1)$.left=d[F+1][1]=d[F+1][1].rotateLeft(),d[F][1]=$.rotateRight();else throw new Error;if(F>0)switch(d[F-1][0]){case-1:d[F-1][1].left=d[F][1];break;case 1:d[F-1][1].right=d[F][1];break;case 0:d[F-1][1].mid=d[F][1];break}else this._root=d[0][1]}}return P}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const c=s.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),c=[];let d=this._root;for(;d;){const P=a.cmp(d.segment);if(P>0)c.push([-1,d]),d=d.left;else if(P<0)c.push([1,d]),d=d.right;else if(a.hasNext())a.next(),c.push([0,d]),d=d.mid;else break}if(!!d){if(s?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const P=this._min(d.right);if(P.key){const{key:F,value:$,segment:Z}=P;this._delete(P.key,!1),d.key=F,d.value=$,d.segment=Z}}else{const P=d.left??d.right;if(c.length>0){const[F,$]=c[c.length-1];switch(F){case-1:$.left=P;break;case 0:$.mid=P;break;case 1:$.right=P;break}}else this._root=P}for(let P=c.length-1;P>=0;P--){const F=c[P][1];F.updateHeight();const $=F.balanceFactor();if($>1?(F.right.balanceFactor()>=0||(F.right=F.right.rotateRight()),c[P][1]=F.rotateLeft()):$<-1&&(F.left.balanceFactor()<=0||(F.left=F.left.rotateLeft()),c[P][1]=F.rotateRight()),P>0)switch(c[P-1][0]){case-1:c[P-1][1].left=c[P][1];break;case 1:c[P-1][1].right=c[P][1];break;case 0:c[P-1][1].mid=c[P][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let a=this._root,c;for(;a;){const d=s.cmp(a.segment);if(d>0)a=a.left;else if(d<0)a=a.right;else if(s.hasNext())s.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const c=s.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const s=[];return this._dfsEntries(i,s),s[Symbol.iterator]()}_dfsEntries(i,s){!i||(i.left&&this._dfsEntries(i.left,s),i.value&&s.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,s),i.right&&this._dfsEntries(i.right,s))}_isBalanced(){const i=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=g;class m{constructor(i,s){this.uri=i,this.value=s}}class u{constructor(i,s){this[D]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=s??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new m(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[a,c]of this.map)i(c.value,c.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=n=>n.toString();class l{constructor(i,s){this[C]="ResourceSet",!i||typeof i=="function"?this._map=new u(i):(this._map=new u(s),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,s){this._map.forEach((a,c)=>i.call(s,c,c,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var f;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class r{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let c=this._map.get(i);if(c)c.value=s,a!==0&&this.touch(c,a);else{switch(c={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const a=this._state;let c=this._head;for(;c;){if(s?i.bind(s)(c.value,c.key,this):i(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:a.key,done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return c}values(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:a.value,done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return c}entries(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:[a.key,a.value],done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return c}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,c=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=r;class o extends r{constructor(i,s=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(we[140],ye([1,0,24,15]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...j){return function(Q,le){for(let pe=0,ke=j.length;pe<ke;pe++){const Te=j[pe](Q,le);if(Te)return Te}return null}}e.or=D,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(j,Q,le){if(!le||le.length<Q.length)return null;let pe;return j?pe=t.startsWithIgnoreCase(le,Q):pe=le.indexOf(Q)===0,pe?Q.length>0?[{start:0,end:Q.length}]:[]:null}function T(j,Q){const le=Q.toLowerCase().indexOf(j.toLowerCase());return le===-1?null:[{start:le,end:le+j.length}]}e.matchesContiguousSubString=T;function I(j,Q){return p(j.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=I;function p(j,Q,le,pe){if(le===j.length)return[];if(pe===Q.length)return null;if(j[le]===Q[pe]){let ke=null;return(ke=p(j,Q,le+1,pe+1))?g({start:pe,end:pe+1},ke):null}return p(j,Q,le,pe+1)}function b(j){return 97<=j&&j<=122}function R(j){return 65<=j&&j<=90}e.isUpper=R;function k(j){return 48<=j&&j<=57}function S(j){return j===32||j===9||j===10||j===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(j=>y.add(j.charCodeAt(0)));function h(j){return S(j)||y.has(j)}function w(j,Q){return j===Q||h(j)&&h(Q)}function E(j){return b(j)||R(j)||k(j)}function g(j,Q){return Q.length===0?Q=[j]:j.end===Q[0].start?Q[0].start=j.start:Q.unshift(j),Q}function m(j,Q){for(let le=Q;le<j.length;le++){const pe=j.charCodeAt(le);if(R(pe)||k(pe)||le>0&&!E(j.charCodeAt(le-1)))return le}return j.length}function u(j,Q,le,pe){if(le===j.length)return[];if(pe===Q.length)return null;if(j[le]!==Q[pe].toLowerCase())return null;{let ke=null,Te=pe+1;for(ke=u(j,Q,le+1,pe+1);!ke&&(Te=m(Q,Te))<Q.length;)ke=u(j,Q,le+1,Te),Te++;return ke===null?null:g({start:pe,end:pe+1},ke)}}function l(j){let Q=0,le=0,pe=0,ke=0,Te=0;for(let Ee=0;Ee<j.length;Ee++)Te=j.charCodeAt(Ee),R(Te)&&Q++,b(Te)&&le++,E(Te)&&pe++,k(Te)&&ke++;const Ne=Q/j.length,Le=le/j.length,me=pe/j.length,be=ke/j.length;return{upperPercent:Ne,lowerPercent:Le,alphaPercent:me,numericPercent:be}}function f(j){const{upperPercent:Q,lowerPercent:le}=j;return le===0&&Q>.6}function r(j){const{upperPercent:Q,lowerPercent:le,alphaPercent:pe,numericPercent:ke}=j;return le>.2&&Q<.8&&pe>.6&&ke<.2}function o(j){let Q=0,le=0,pe=0,ke=0;for(let Te=0;Te<j.length;Te++)pe=j.charCodeAt(Te),R(pe)&&Q++,b(pe)&&le++,S(pe)&&ke++;return(Q===0||le===0)&&ke===0?j.length<=30:Q<=5}function n(j,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!o(j)||Q.length>60)return null;const le=l(Q);if(!r(le)){if(!f(le))return null;Q=Q.toLowerCase()}let pe=null,ke=0;for(j=j.toLowerCase();ke<Q.length&&(pe=u(j,Q,0,ke))===null;)ke=m(Q,ke+1);return pe}e.matchesCamelCase=n;function i(j,Q,le=!1){if(!Q||Q.length===0)return null;let pe=null,ke=0;for(j=j.toLowerCase(),Q=Q.toLowerCase();ke<Q.length&&(pe=s(j,Q,0,ke,le))===null;)ke=a(Q,ke+1);return pe}e.matchesWords=i;function s(j,Q,le,pe,ke){if(le===j.length)return[];if(pe===Q.length)return null;if(w(j.charCodeAt(le),Q.charCodeAt(pe))){let Te=null,Ne=pe+1;if(Te=s(j,Q,le+1,pe+1,ke),!ke)for(;!Te&&(Ne=a(Q,Ne))<Q.length;)Te=s(j,Q,le+1,Ne,ke),Ne++;return Te?j.charCodeAt(le)!==Q.charCodeAt(pe)?Te:g({start:pe,end:pe+1},Te):null}else return null}function a(j,Q){for(let le=Q;le<j.length;le++)if(h(j.charCodeAt(le))||le>0&&h(j.charCodeAt(le-1)))return le;return j.length}const c=D(e.matchesPrefix,n,T),d=D(e.matchesPrefix,n,I),P=new v.LRUCache(1e4);function F(j,Q,le=!1){if(typeof j!="string"||typeof Q!="string")return null;let pe=P.get(j);pe||(pe=new RegExp(t.convertSimple2RegExpPattern(j),"i"),P.set(j,pe));const ke=pe.exec(Q);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:le?d(j,Q):c(j,Q)}e.matchesFuzzy=F;function $(j,Q){const le=he(j,j.toLowerCase(),0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return le?J(le):null}e.matchesFuzzy2=$;function Z(j,Q,le,pe,ke,Te){const Ne=Math.min(13,j.length);for(;le<Ne;le++){const Le=he(j,Q,le,pe,ke,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Le)return Le}return[0,Te]}e.anyScore=Z;function J(j){if(typeof j>"u")return[];const Q=[],le=j[1];for(let pe=j.length-1;pe>1;pe--){const ke=j[pe]+le,Te=Q[Q.length-1];Te&&Te.end===ke?Te.end=ke+1:Q.push({start:ke,end:ke+1})}return Q}e.createMatches=J;const _=128;function ee(){const j=[],Q=[];for(let le=0;le<=_;le++)Q[le]=0;for(let le=0;le<=_;le++)j.push(Q.slice(0));return j}function ne(j){const Q=[];for(let le=0;le<=j;le++)Q[le]=0;return Q}const B=ne(2*_),ue=ne(2*_),z=ee(),X=ee(),O=ee(),U=!1;function x(j,Q,le,pe,ke){function Te(Le,me,be=" "){for(;Le.length<me;)Le=be+Le;return Le}let Ne=` |   |${pe.split("").map(Le=>Te(Le,3)).join("|")}
`;for(let Le=0;Le<=le;Le++)Le===0?Ne+=" |":Ne+=`${Q[Le-1]}|`,Ne+=j[Le].slice(0,ke+1).map(me=>Te(me.toString(),3)).join("|")+`
`;return Ne}function ae(j,Q,le,pe){j=j.substr(Q),le=le.substr(pe),console.log(x(X,j,j.length,le,le.length)),console.log(x(O,j,j.length,le,le.length)),console.log(x(z,j,j.length,le,le.length))}function fe(j,Q){if(Q<0||Q>=j.length)return!1;const le=j.codePointAt(Q);switch(le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(le)}}function K(j,Q){if(Q<0||Q>=j.length)return!1;switch(j.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function ie(j,Q,le){return Q[j]!==le[j]}function L(j,Q,le,pe,ke,Te,Ne=!1){for(;Q<le&&ke<Te;)j[Q]===pe[ke]&&(Ne&&(B[Q]=ke),Q+=1),ke+=1;return Q===le}e.isPatternInWord=L;var M;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(M||(M={}));var G;(function(j){j.Default=[-100,0];function Q(le){return!le||le.length===2&&le[0]===-100&&le[1]===0}j.isDefault=Q})(G=e.FuzzyScore||(e.FuzzyScore={}));class re{constructor(Q,le){this.firstMatchCanBeWeak=Q,this.boostFullMatch=le}}e.FuzzyScoreOptions=re,re.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function he(j,Q,le,pe,ke,Te,Ne=re.default){const Le=j.length>_?_:j.length,me=pe.length>_?_:pe.length;if(le>=Le||Te>=me||Le-le>me-Te||!L(Q,le,Le,ke,Te,me,!0))return;ve(Le,me,le,Te,Q,ke);let be=1,Ee=1,Me=le,Be=Te;const Ve=[!1];for(be=1,Me=le;Me<Le;be++,Me++){const je=B[Me],xe=ue[Me],Ge=Me+1<Le?ue[Me+1]:me;for(Ee=je-Te+1,Be=je;Be<Ge;Ee++,Be++){let ce=Number.MIN_SAFE_INTEGER,Ce=!1;Be<=xe&&(ce=H(j,Q,Me,le,pe,ke,Be,me,Te,z[be-1][Ee-1]===0,Ve));let Ie=0;ce!==Number.MAX_SAFE_INTEGER&&(Ce=!0,Ie=ce+X[be-1][Ee-1]);const Ae=Be>je,Fe=Ae?X[be][Ee-1]+(z[be][Ee-1]>0?-5:0):0,$e=Be>je+1&&z[be][Ee-1]>0,Qe=$e?X[be][Ee-2]+(z[be][Ee-2]>0?-5:0):0;if($e&&(!Ae||Qe>=Fe)&&(!Ce||Qe>=Ie))X[be][Ee]=Qe,O[be][Ee]=3,z[be][Ee]=0;else if(Ae&&(!Ce||Fe>=Ie))X[be][Ee]=Fe,O[be][Ee]=2,z[be][Ee]=0;else if(Ce)X[be][Ee]=Ie,O[be][Ee]=1,z[be][Ee]=z[be-1][Ee-1]+1;else throw new Error("not possible")}}if(U&&ae(j,le,pe,Te),!Ve[0]&&!Ne.firstMatchCanBeWeak)return;be--,Ee--;const ze=[X[be][Ee],Te];let Ye=0,Ke=0;for(;be>=1;){let je=Ee;do{const xe=O[be][je];if(xe===3)je=je-2;else if(xe===2)je=je-1;else break}while(je>=1);Ye>1&&Q[le+be-1]===ke[Te+Ee-1]&&!ie(je+Te-1,pe,ke)&&Ye+1>z[be][je]&&(je=Ee),je===Ee?Ye++:Ye=1,Ke||(Ke=je),be--,Ee=je-1,ze.push(Ee)}me===Le&&Ne.boostFullMatch&&(ze[0]+=2);const qe=Ke-Le;return ze[0]-=qe,ze}e.fuzzyScore=he;function ve(j,Q,le,pe,ke,Te){let Ne=j-1,Le=Q-1;for(;Ne>=le&&Le>=pe;)ke[Ne]===Te[Le]&&(ue[Ne]=Le,Ne--),Le--}function H(j,Q,le,pe,ke,Te,Ne,Le,me,be,Ee){if(Q[le]!==Te[Ne])return Number.MIN_SAFE_INTEGER;let Me=1,Be=!1;return Ne===le-pe?Me=j[le]===ke[Ne]?7:5:ie(Ne,ke,Te)&&(Ne===0||!ie(Ne-1,ke,Te))?(Me=j[le]===ke[Ne]?7:5,Be=!0):fe(Te,Ne)&&(Ne===0||!fe(Te,Ne-1))?Me=5:(fe(Te,Ne-1)||K(Te,Ne-1))&&(Me=5,Be=!0),Me>1&&le===pe&&(Ee[0]=!0),Be||(Be=ie(Ne,ke,Te)||fe(Te,Ne-1)||K(Te,Ne-1)),le===pe?Ne>me&&(Me-=Be?3:5):be?Me+=Be?2:0:Me+=Be?0:1,Ne+1===Le&&(Me-=Be?3:5),Me}function Y(j,Q,le,pe,ke,Te,Ne){return W(j,Q,le,pe,ke,Te,!0,Ne)}e.fuzzyScoreGracefulAggressive=Y;function te(j,Q,le,pe,ke,Te,Ne){return W(j,Q,le,pe,ke,Te,!1,Ne)}e.fuzzyScoreGraceful=te;function W(j,Q,le,pe,ke,Te,Ne,Le){let me=he(j,Q,le,pe,ke,Te,Le);if(me&&!Ne)return me;if(j.length>=3){const be=Math.min(7,j.length-1);for(let Ee=le+1;Ee<be;Ee++){const Me=q(j,Ee);if(Me){const Be=he(Me,Me.toLowerCase(),le,pe,ke,Te,Le);Be&&(Be[0]-=3,(!me||Be[0]>me[0])&&(me=Be))}}}return me}function q(j,Q){if(Q+1>=j.length)return;const le=j[Q],pe=j[Q+1];if(le!==pe)return j.slice(0,Q)+pe+le+j.slice(Q+2)}}),define(we[141],ye([1,0,41,140,15]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(v.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${C.source}`,"g");function p(E){return E.replace(I,(g,m)=>m?g:`\\${g}`)}e.escapeIcons=p;const b=new RegExp(`\\\\${C.source}`,"g");function R(E){return E.replace(b,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=R;const k=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function S(E){return E.indexOf(e.iconStartMarker)===-1?E:E.replace(k,(g,m,u,l)=>u?g:m||l||"")}e.stripIcons=S;function y(E){const g=E.indexOf(e.iconStartMarker);return g===-1?{text:E}:h(E,g)}e.parseLabelWithIcons=y;function h(E,g){const m=[];let u="";function l(c){if(c){u+=c;for(const d of c)m.push(o)}}let f=-1,r="",o=0,n,i,s=g;const a=E.length;for(l(E.substr(0,g));s<a;)n=E[s],i=E[s+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(f=s,l(r),r=e.iconStartMarker,s++):n===")"&&f!==-1?(o+=s-f+1,f=-1,r=""):f!==-1?T.test(n)?r+=n:(l(r),f=-1,r=""):l(n),s++;return l(r),{text:u,iconOffsets:m}}function w(E,g,m=!1){const{text:u,iconOffsets:l}=g;if(!l||l.length===0)return(0,t.matchesFuzzy)(E,u,m);const f=(0,D.ltrim)(u," "),r=u.length-f.length,o=(0,t.matchesFuzzy)(E,f,m);if(o)for(const n of o){const i=l[n.start+r]+r;n.start+=i,n.end+=i}return o}e.matchesFuzzyIconAware=w}),define(we[87],ye([1,0,24]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function D(b){return p(b,"NFC",t)}e.normalizeNFC=D;const C=new v.LRUCache(1e4);function T(b){return p(b,"NFD",C)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function p(b,R,k){if(!b)return b;const S=k.get(b);if(S)return S;let y;return I.test(b)?y=b.normalize(R):y=b,k.set(b,y),y}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(R){return T(R).replace(b,"")}}()}),define(we[67],ye([1,0,15]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const C="error",T="warning",I="warn",p="info",b="ignore";function R(S){return S?v.equalsIgnoreCase(C,S)?D.Error:v.equalsIgnoreCase(T,S)||v.equalsIgnoreCase(I,S)?D.Warning:v.equalsIgnoreCase(p,S)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function k(S){switch(S){case D.Error:return C;case D.Warning:return T;case D.Info:return p;default:return b}}D.toString=k}(t||(t={})),e.default=t}),define(we[11],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(o){return typeof o=="string"}e.isString=v;function t(o){return Array.isArray(o)&&o.every(n=>v(n))}e.isStringArray=t;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function C(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=C;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function I(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=I;function p(o){return o===!0||o===!1}e.isBoolean=p;function b(o){return typeof o>"u"}e.isUndefined=b;function R(o){return!k(o)}e.isDefined=R;function k(o){return b(o)||o===null}e.isUndefinedOrNull=k;function S(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=S;function y(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=y;function h(...o){const n=[];for(let i=0;i<o.length;i++){const s=o[i];if(k(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(s)}return n}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function E(o){if(!D(o))return!1;for(const n in o)if(w.call(o,n))return!1;return!0}e.isEmptyObject=E;function g(o){return typeof o=="function"}e.isFunction=g;function m(...o){return o.length>0&&o.every(g)}e.areFunctions=m;function u(o,n){const i=Math.min(o.length,n.length);for(let s=0;s<i;s++)l(o[s],n[s])}e.validateConstraints=u;function l(o,n){if(v(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(g(n)){try{if(o instanceof n)return}catch{}if(!k(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function f(o){return o===null?void 0:o}e.withNullAsUndefined=f;function r(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=r}),define(we[36],ye([1,0,6,3,15,11]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function I(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=I;function p(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=p;function b(s,a=v.posix.sep){if(!s)return"";const c=s.length,d=s.charCodeAt(0);if(T(d)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let F=3;const $=F;for(;F<c&&!T(s.charCodeAt(F));F++);if($!==F&&!T(s.charCodeAt(F+1))){for(F+=1;F<c;F++)if(T(s.charCodeAt(F)))return s.slice(0,F+1).replace(/[\\/]/g,a)}}return a}else if(g(d)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let P=s.indexOf("://");if(P!==-1){for(P+=3;P<c;P++)if(T(s.charCodeAt(P)))return s.slice(0,P+1)}return""}e.getRoot=b;function R(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let c=2;const d=c;for(;c<s.length&&(a=s.charCodeAt(c),a!==92);c++);return!(d===c||(a=s.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=R;const k=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,a=t.isWindows){const c=a?k:S;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||a&&y.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function w(s,a,c){const d=s===a;return!c||d?d:!s||!a?!1:(0,D.equalsIgnoreCase)(s,a)}e.isEqual=w;function E(s,a,c,d=v.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let F=a.length;return a.charAt(a.length-1)===d&&F--,s.charAt(F)===d}return a.charAt(a.length-1)!==d&&(a+=d),s.indexOf(a)===0}e.isEqualOrParent=E;function g(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=g;function m(s,a){return t.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(a,s)),s=(0,v.normalize)(s),t.isWindows?(s=(0,D.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,D.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=m;function u(s){const a=(0,v.normalize)(s);return t.isWindows?s.length>3?!1:l(a)&&(s.length===2||a.charCodeAt(2)===92):a===v.posix.sep}e.isRootOrDriveLetter=u;function l(s,a=t.isWindows){return a?g(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function f(s){return l(s)?s[0]:void 0}e.getDriveLetter=f;function r(s,a,c){return a.length>s.length?-1:s===a?0:(c&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=r;function o(s){const a=s.split(":");let c,d,P;for(const F of a){const $=Number(F);(0,C.isNumber)($)?d===void 0?d=$:P===void 0&&(P=$):c=c?[c,F].join(":"):F}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:d!==void 0?d:void 0,column:P!==void 0?P:d!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,a,c=8){let d="";for(let F=0;F<c;F++)d+=n.charAt(Math.floor(Math.random()*n.length));let P;return a?P=`${a}-${d}`:P=d,s?(0,v.join)(s,P):P}e.randomPath=i}),define(we[22],ye([1,0,11]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const m=Array.isArray(g)?[]:{};return Object.keys(g).forEach(u=>{g[u]&&typeof g[u]=="object"?m[u]=t(g[u]):m[u]=g[u]}),m}e.deepClone=t;function D(g){if(!g||typeof g!="object")return g;const m=[g];for(;m.length>0;){const u=m.shift();Object.freeze(u);for(const l in u)if(C.call(u,l)){const f=u[l];typeof f=="object"&&!Object.isFrozen(f)&&!(0,v.isTypedArray)(f)&&m.push(f)}}return g}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function T(g,m){return I(g,m,new Set)}e.cloneAndChange=T;function I(g,m,u){if((0,v.isUndefinedOrNull)(g))return g;const l=m(g);if(typeof l<"u")return l;if(Array.isArray(g)){const f=[];for(const r of g)f.push(I(r,m,u));return f}if((0,v.isObject)(g)){if(u.has(g))throw new Error("Cannot clone recursive data-structure");u.add(g);const f={};for(const r in g)C.call(g,r)&&(f[r]=I(g[r],m,u));return u.delete(g),f}return g}function p(g,m,u=!0){return(0,v.isObject)(g)?((0,v.isObject)(m)&&Object.keys(m).forEach(l=>{l in g?u&&((0,v.isObject)(g[l])&&(0,v.isObject)(m[l])?p(g[l],m[l],u):g[l]=m[l]):g[l]=m[l]}),g):m}e.mixin=p;function b(g,m){if(g===m)return!0;if(g==null||m===null||m===void 0||typeof g!=typeof m||typeof g!="object"||Array.isArray(g)!==Array.isArray(m))return!1;let u,l;if(Array.isArray(g)){if(g.length!==m.length)return!1;for(u=0;u<g.length;u++)if(!b(g[u],m[u]))return!1}else{const f=[];for(l in g)f.push(l);f.sort();const r=[];for(l in m)r.push(l);if(r.sort(),!b(f,r))return!1;for(u=0;u<f.length;u++)if(!b(g[f[u]],m[f[u]]))return!1}return!0}e.equals=b;function R(g){const m=new Set;return JSON.stringify(g,(u,l)=>{if((0,v.isObject)(l)||Array.isArray(l)){if(m.has(l))return"[Circular]";m.add(l)}return l})}e.safeStringify=R;function k(g,m){const u=Object.create(null);return!g||!m||Object.keys(m).forEach(f=>{const r=g[f],o=m[f];b(r,o)||(u[f]=o)}),u}e.distinct=k;function S(g,m){const u=m.toLowerCase(),l=Object.keys(g).find(f=>f.toLowerCase()===u);return l?g[l]:g[m]}e.getCaseInsensitive=S;function y(g,m){const u=Object.create(null);for(const[l,f]of Object.entries(g))m(l,f)&&(u[l]=f);return u}e.filter=y;function h(g){let m=[],u=Object.getPrototypeOf(g);for(;Object.prototype!==u;)m=m.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return m}e.getAllPropertyNames=h;function w(g){const m=[];for(const u of h(g))typeof g[u]=="function"&&m.push(u);return m}e.getAllMethodNames=w;function E(g,m){const u=f=>function(){const r=Array.prototype.slice.call(arguments,0);return m(f,r)},l={};for(const f of g)l[f]=u(f);return l}e.createProxyObject=E}),define(we[4],ye([1,0,6,3]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,T=/^\/\//;function I(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(n,i){return!n&&!i?"file":n}function b(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const R="",k="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,s,a,c,d,P=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=p(i,P),this.authority=s||R,this.path=b(this.scheme,a||R),this.query=c||R,this.fragment=d||R,I(this,P))}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:a,path:c,query:d,fragment:P}=i;return s===void 0?s=this.scheme:s===null&&(s=R),a===void 0?a=this.authority:a===null&&(a=R),c===void 0?c=this.path:c===null&&(c=R),d===void 0?d=this.query:d===null&&(d=R),P===void 0?P=this.fragment:P===null&&(P=R),s===this.scheme&&a===this.authority&&c===this.path&&d===this.query&&P===this.fragment?this:new w(s,a,c,d,P)}static parse(i,s=!1){const a=S.exec(i);return a?new w(a[2]||R,o(a[4]||R),o(a[5]||R),o(a[7]||R),o(a[9]||R),s):new w(R,R,R,R,R)}static file(i){let s=R;if(t.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const a=i.indexOf(k,2);a===-1?(s=i.substring(2),i=k):(s=i.substring(2,a),i=i.substring(a)||k)}return new w("file",s,i,R,R)}static from(i){const s=new w(i.scheme,i.authority,i.path,i.query,i.fragment);return I(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&i.scheme==="file"?a=y.file(v.win32.join(u(i,!0),...s)).path:a=v.posix.join(i.path,...s),i.with({path:a})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const s=new w(i);return s._formatted=i.external,s._fsPath=i._sep===h?i.fsPath:null,s}}else return i}}e.URI=y;const h=t.isWindows?1:void 0;class w extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=h),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(n,i){let s,a=-1;for(let c=0;c<n.length;c++){const d=n.charCodeAt(c);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47)a!==-1&&(s+=encodeURIComponent(n.substring(a,c)),a=-1),s!==void 0&&(s+=n.charAt(c));else{s===void 0&&(s=n.substr(0,c));const P=E[d];P!==void 0?(a!==-1&&(s+=encodeURIComponent(n.substring(a,c)),a=-1),s+=P):a===-1&&(a=c)}}return a!==-1&&(s+=encodeURIComponent(n.substring(a))),s!==void 0?s:n}function m(n){let i;for(let s=0;s<n.length;s++){const a=n.charCodeAt(s);a===35||a===63?(i===void 0&&(i=n.substr(0,s)),i+=E[a]):i!==void 0&&(i+=n[s])}return i!==void 0?i:n}function u(n,i){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=u;function l(n,i){const s=i?m:g;let a="",{scheme:c,authority:d,path:P,query:F,fragment:$}=n;if(c&&(a+=c,a+=":"),(d||c==="file")&&(a+=k,a+=k),d){let Z=d.indexOf("@");if(Z!==-1){const J=d.substr(0,Z);d=d.substr(Z+1),Z=J.indexOf(":"),Z===-1?a+=s(J,!1):(a+=s(J.substr(0,Z),!1),a+=":",a+=s(J.substr(Z+1),!1)),a+="@"}d=d.toLowerCase(),Z=d.indexOf(":"),Z===-1?a+=s(d,!1):(a+=s(d.substr(0,Z),!1),a+=d.substr(Z))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const Z=P.charCodeAt(1);Z>=65&&Z<=90&&(P=`/${String.fromCharCode(Z+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const Z=P.charCodeAt(0);Z>=65&&Z<=90&&(P=`${String.fromCharCode(Z+32)}:${P.substr(2)}`)}a+=s(P,!0)}return F&&(a+="?",a+=s(F,!1)),$&&(a+="#",a+=i?$:g($,!1)),a}function f(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+f(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,i=>f(i)):n}}),define(we[142],ye([1,0,4]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=t;function D(b){const R=[];let k;try{const S=JSON.parse(b.arguments),y=S[S.length-1];y&&y.__$stack&&(S.pop(),k=y.__$stack),R.push(...S)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:k}}e.parse=D;function C(b){if(typeof b!="string")return C(D(b).stack);const R=b;if(R){const k=T(R),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(S&&S.length===4)return{uri:v.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=C;function T(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function I(b,R){const{args:k,stack:S}=D(b),y=typeof k[0]=="string"&&k.length===1;let h=T(S);h&&(h=`(${h.trim()})`);let w=[];if(typeof k[0]=="string"?h&&y?w=[`%c[${R}] %c${k[0]} %c${h}`,p("blue"),p(""),p("grey")]:w=[`%c[${R}] %c${k[0]}`,p("blue"),p(""),...k.slice(1)]:w=[`%c[${R}]%`,p("blue"),...k],h&&!y&&w.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,w)}e.log=I;function p(b){return`color: ${b}`}}),define(we[46],ye([1,0,16,15,4]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(b){return JSON.stringify(b,I)}e.stringify=C;function T(b){let R=JSON.parse(b);return R=p(R),R}e.parse=T;function I(b,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function p(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof v.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let k=0;k<b.length;++k)b[k]=p(b[k],R+1);else for(const k in b)Object.hasOwnProperty.call(b,k)&&(b[k]=p(b[k],R+1))}return b}e.revive=p}),define(we[12],ye([1,0,3,4]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebook="vscode-notebook",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractive="vscode-interactive",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${D.vscodeRemoteResource}`}set(b,R,k){this._hosts[b]=R,this._ports[b]=k}setConnectionToken(b,R){this._connectionTokens[b]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const R=b.authority;let k=this._hosts[R];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const S=this._ports[R],y=this._connectionTokens[R];let h=`path=${encodeURIComponent(b.path)}`;return typeof y=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${k}:${S}`,path:v.isWeb?(window.location.pathname+"/"+this._remoteResourcesPath).replace(/\/\/+/g,"/"):this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new C;class T{asBrowserUri(b,R){const k=this.toUri(b,R);return k.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===D.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${D.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?k.with({scheme:D.vscodeFileResource,authority:k.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(b,R){const k=this.toUri(b,R);return k.scheme===D.vscodeFileResource?k.with({scheme:D.file,authority:k.authority!==T.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(b,R){return t.URI.isUri(b)?b:t.URI.parse(R.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var I;(function(p){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(b.get("3"));const R="vscode-coi";function k(y){let h;typeof y=="string"?h=new URL(y).searchParams:y instanceof URL?h=y.searchParams:t.URI.isUri(y)&&(h=new URL(y.toString(!0)).searchParams);const w=h?.get(R);if(!!w)return b.get(w)}p.getHeadersFromQuery=k;function S(y,h,w){if(!globalThis.crossOriginIsolated)return;const E=h&&w?"3":w?"2":"1";y instanceof URLSearchParams?y.set(R,E):y[R]=E}p.addSearchParam=S})(I=e.COI||(e.COI={}))}),define(we[19],ye([1,0,36,12,6,3,15,4]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(y){return(0,I.uriToFsPath)(y,!0)}e.originalFSPath=p;class b{constructor(h){this._ignorePathCasing=h}compare(h,w,E=!1){return h===w?0:(0,T.compare)(this.getComparisonKey(h,E),this.getComparisonKey(w,E))}isEqual(h,w,E=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,E)===this.getComparisonKey(w,E)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,E=!1){if(h.scheme===w.scheme){if(h.scheme===t.Schemas.file)return v.isEqualOrParent(p(h),p(w),this._ignorePathCasing(h))&&h.query===w.query&&(E||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return v.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(E||h.fragment===w.fragment)}return!1}joinPath(h,...w){return I.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===t.Schemas.file?w=I.URI.file(D.dirname(p(h))).path:(w=D.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===t.Schemas.file?w=I.URI.file(D.normalize(p(h))).path:w=D.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===t.Schemas.file){const m=D.relative(p(h),p(w));return C.isWindows?v.toSlashes(m):m}let E=h.path||"/";const g=w.path||"/";if(this._ignorePathCasing(h)){let m=0;for(const u=Math.min(E.length,g.length);m<u&&!(E.charCodeAt(m)!==g.charCodeAt(m)&&E.charAt(m).toLowerCase()!==g.charAt(m).toLowerCase());m++);E=g.substr(0,m)+E.substr(m)}return D.posix.relative(E,g)}resolvePath(h,w){if(h.scheme===t.Schemas.file){const E=I.URI.file(D.resolve(p(h),w));return h.with({authority:E.authority,path:E.path})}return w=v.toPosixPath(w),h.with({path:D.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,T.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=D.sep){if(h.scheme===t.Schemas.file){const E=p(h);return E.length>v.getRoot(E).length&&E[E.length-1]===w}else{const E=h.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=D.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=D.sep){let E=!1;if(h.scheme===t.Schemas.file){const g=p(h);E=g!==void 0&&g.length===v.getRoot(g).length&&g[g.length-1]===w}else{w="/";const g=h.path;E=g.length===1&&g.charCodeAt(g.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(y=>y.scheme===t.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new b(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,h){const w=[];for(let E=0;E<y.length;E++){const g=h(y[E]);y.some((m,u)=>u===E?!1:(0,e.isEqualOrParent)(g,h(m)))||w.push(y[E])}return w}e.distinctParents=R;var k;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(w){const E=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(u=>{const[l,f]=u.split(":");l&&f&&E.set(l,f)});const m=w.path.substring(0,w.path.indexOf(";"));return m&&E.set(y.META_DATA_MIME,m),E}y.parseMetaData=h})(k=e.DataUri||(e.DataUri={}));function S(y,h,w){if(h){let E=y.path;return E&&E[0]!==D.posix.sep&&(E=D.posix.sep+E),y.with({scheme:w,authority:h,path:E})}return y.with({scheme:w})}e.toLocalResource=S}),define(we[14],ye([1,0,20,8,7,2,19,3]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(ie){return!!ie&&typeof ie.then=="function"}e.isThenable=p;function b(ie){const L=new v.CancellationTokenSource,M=ie(L.token),G=new Promise((re,he)=>{const ve=L.token.onCancellationRequested(()=>{ve.dispose(),L.dispose(),he(new t.CancellationError)});Promise.resolve(M).then(H=>{ve.dispose(),L.dispose(),re(H)},H=>{ve.dispose(),L.dispose(),he(H)})});return new class{cancel(){L.cancel()}then(re,he){return G.then(re,he)}catch(re){return this.then(void 0,re)}finally(re){return G.finally(re)}}}e.createCancelablePromise=b;function R(ie,L,M){return new Promise((G,re)=>{const he=L.onCancellationRequested(()=>{he.dispose(),G(M)});ie.then(G,re).finally(()=>he.dispose())})}e.raceCancellation=R;function k(ie,L){return new Promise((M,G)=>{const re=L.onCancellationRequested(()=>{re.dispose(),G(new t.CancellationError)});ie.then(M,G).finally(()=>re.dispose())})}e.raceCancellationError=k;async function S(ie){let L=-1;const M=ie.map((re,he)=>re.then(ve=>(L=he,ve))),G=await Promise.race(M);return ie.forEach((re,he)=>{he!==L&&re.cancel()}),G}e.raceCancellablePromises=S;function y(ie,L,M){let G;const re=setTimeout(()=>{G?.(void 0),M?.()},L);return Promise.race([ie.finally(()=>clearTimeout(re)),new Promise(he=>G=he)])}e.raceTimeout=y;function h(ie){return new Promise((L,M)=>{const G=ie();p(G)?G.then(L,M):L(G)})}e.asPromise=h;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(M,M).then(G)})}return new Promise((M,G)=>{this.queuedPromise.then(M,G)})}return this.activePromise=L(),new Promise((M,G)=>{this.activePromise.then(re=>{this.activePromise=null,M(re)},re=>{this.activePromise=null,G(re)})})}}e.Throttler=w;class E{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=E;class g{constructor(){this.promiseMap=new Map}queue(L,M){const re=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(L)===re&&this.promiseMap.delete(L)});return this.promiseMap.set(L,re),re}}e.SequencerByKey=g;const m=(ie,L)=>{let M=!0;const G=setTimeout(()=>{M=!1,L()},ie);return{isTriggered:()=>M,dispose:()=>{clearTimeout(G),M=!1}}},u=ie=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,ie())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,M=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((re,he)=>{this.doResolve=re,this.doReject=he}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const re=this.task;return this.task=null,re()}}));const G=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?u(G):m(M,G),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class f{constructor(L){this.delayer=new l(L),this.throttler=new w}trigger(L,M){return this.delayer.trigger(()=>this.throttler.queue(L),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class r{constructor(){this._isOpen=!1,this._promise=new Promise((L,M)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class o extends r{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function n(ie,L){return L?new Promise((M,G)=>{const re=setTimeout(()=>{he.dispose(),M()},ie),he=L.onCancellationRequested(()=>{clearTimeout(re),he.dispose(),G(new t.CancellationError)})}):b(M=>n(ie,M))}e.timeout=n;function i(ie,L=0){const M=setTimeout(ie,L);return(0,C.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=i;function s(ie){const L=[];let M=0;const G=ie.length;function re(){return M<G?ie[M++]():null}function he(ve){ve!=null&&L.push(ve);const H=re();return H?H.then(he):Promise.resolve(L)}return Promise.resolve(null).then(he)}e.sequence=s;function a(ie,L=G=>!!G,M=null){let G=0;const re=ie.length,he=()=>{if(G>=re)return Promise.resolve(M);const ve=ie[G++];return Promise.resolve(ve()).then(Y=>L(Y)?Promise.resolve(Y):he())};return he()}e.first=a;function c(ie,L=G=>!!G,M=null){if(ie.length===0)return Promise.resolve(M);let G=ie.length;const re=()=>{G=-1;for(const he of ie)he.cancel?.()};return new Promise((he,ve)=>{for(const H of ie)H.then(Y=>{--G>=0&&L(Y)?(re(),he(Y)):G===0&&he(M)}).catch(Y=>{--G>=0&&(re(),ve(Y))})})}e.firstParallel=c;class d{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((M,G)=>{this.outstandingPromises.push({factory:L,c:M,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const M=L.factory();M.then(L.c,L.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class P extends d{constructor(){super(1)}}e.Queue=P;class F{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new O;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,M=T.extUri){const G=M.getComparisonKey(L);let re=this.queues.get(G);return re||(re=new P,D.Event.once(re.onDrained)(()=>{re?.dispose(),this.queues.delete(G),this.onDidQueueDrain()}),this.queues.set(G,re)),re}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=F;class ${constructor(L,M){this._token=-1,typeof L=="function"&&typeof M=="number"&&this.setIfNotSet(L,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},M)}setIfNotSet(L,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},M))}}e.TimeoutTimer=$;class Z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,M){this.cancel(),this._token=setInterval(()=>{L()},M)}}e.IntervalTimer=Z;class J{constructor(L,M){this.timeoutToken=-1,this.runner=L,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=J;class _{constructor(L,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=_;class ee extends J{constructor(L,M){super(L,M),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ee;class ne extends C.Disposable{constructor(L,M){super(),this.options=L,this.handler=M,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new J(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ie=>{(0,I.setTimeout0)(()=>{if(L)return;const M=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(ie,L)=>{const M=requestIdleCallback(ie,typeof L=="number"?{timeout:L}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(M))}}}}();class B{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function ue(ie,L,M){let G;for(let re=0;re<M;re++)try{return await ie()}catch(he){G=he,await n(L)}throw G}e.retry=ue;class z{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,M,G){return this._pending={taskId:L,cancel:()=>G?.(),promise:M},M.then(()=>this.donePending(L),()=>this.donePending(L)),M}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let M,G;const re=new Promise((he,ve)=>{M=he,G=ve});this._next={run:L,promise:re,promiseResolve:M,promiseReject:G}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=z;class X{constructor(L,M=()=>Date.now()){this.interval=L,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=X;class O{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,M)=>{this.completeCallback=L,this.errorCallback=M})}complete(L){return new Promise(M=>{this.completeCallback(L),this.resolved=!0,M()})}error(L){return new Promise(M=>{this.errorCallback(L),this.rejected=!0,M()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=O;var U;(function(ie){async function L(G){let re;const he=await Promise.all(G.map(ve=>ve.then(H=>H,H=>{re||(re=H)})));if(typeof re<"u")throw re;return he}ie.settled=L;function M(G){return new Promise(async(re,he)=>{try{await G(re,he)}catch(ve){he(ve)}})}ie.withAsyncBody=M})(U=e.Promises||(e.Promises={}));var x;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(x||(x={}));class ae{static fromArray(L){return new ae(M=>{M.emitMany(L)})}static fromPromise(L){return new ae(async M=>{M.emitMany(await L)})}static fromPromises(L){return new ae(async M=>{await Promise.all(L.map(async G=>M.emitOne(await G)))})}static merge(L){return new ae(async M=>{await Promise.all(L.map(async G=>{for await(const re of G)M.emitOne(re)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const M={emitOne:G=>this.emitOne(G),emitMany:G=>this.emitMany(G),reject:G=>this.reject(G)};try{await Promise.resolve(L(M)),this.resolve()}catch(G){this.reject(G)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,M){return new ae(async G=>{for await(const re of L)G.emitOne(M(re))})}map(L){return ae.map(this,L)}static filter(L,M){return new ae(async G=>{for await(const re of L)M(re)&&G.emitOne(re)})}filter(L){return ae.filter(this,L)}static coalesce(L){return ae.filter(L,M=>!!M)}coalesce(){return ae.coalesce(this)}static async toPromise(L){const M=[];for await(const G of L)M.push(G);return M}toPromise(){return ae.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=ae,ae.EMPTY=ae.fromArray([]);class fe extends ae{constructor(L,M){super(M),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=fe;function K(ie){const L=new v.CancellationTokenSource,M=ie(L.token);return new fe(L,async G=>{const re=L.token.onCancellationRequested(()=>{re.dispose(),L.dispose(),G.reject(new t.CancellationError)});try{for await(const he of M){if(L.token.isCancellationRequested)return;G.emitOne(he)}re.dispose(),L.dispose()}catch(he){re.dispose(),L.dispose(),G.reject(he)}})}e.createCancelableAsyncIterable=K}),define(we[68],ye([1,0,18,14,36,24,6,3,15]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",k="[^/\\\\]",S=/\//g;function y(O,U){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${U?`|${R}${k}+`:""})*?`}}function h(O,U){if(!O)return[];const x=[];let ae=!1,fe=!1,K="";for(const ie of O){switch(ie){case U:if(!ae&&!fe){x.push(K),K="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}K+=ie}return K&&x.push(K),x}e.splitGlobAware=h;function w(O){if(!O)return"";let U="";const x=h(O,e.GLOB_SPLIT);if(x.every(ae=>ae===e.GLOBSTAR))U=".*";else{let ae=!1;x.forEach((fe,K)=>{if(fe===e.GLOBSTAR){if(ae)return;U+=y(2,K===x.length-1)}else{let ie=!1,L="",M=!1,G="";for(const re of fe){if(re!=="}"&&ie){L+=re;continue}if(M&&(re!=="]"||!G)){let he;re==="-"?he=re:(re==="^"||re==="!")&&!G?he="^":re===e.GLOB_SPLIT?he="":he=(0,p.escapeRegExpCharacters)(re),G+=he;continue}switch(re){case"{":ie=!0;continue;case"[":M=!0;continue;case"}":{U+=`(?:${h(L,",").map(H=>w(H)).join("|")})`,ie=!1,L="";break}case"]":{U+="["+G+"]",M=!1,G="";break}case"?":U+=k;continue;case"*":U+=y(1);continue;default:U+=(0,p.escapeRegExpCharacters)(re)}}K<x.length-1&&(x[K+1]!==e.GLOBSTAR||K+2<x.length)&&(U+=R)}ae=fe===e.GLOBSTAR})}return U}const E=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new C.LRUCache(1e4),o=function(){return!1},n=function(){return null};function i(O,U){if(!O)return n;let x;typeof O!="string"?x=O.pattern:x=O,x=x.trim();const ae=`${x}_${!!U.trimForExclusions}`;let fe=r.get(ae);if(fe)return s(fe,O);let K;return E.test(x)?fe=c(x.substr(4),x):(K=g.exec(a(x,U)))?fe=d(K[1],x):(U.trimForExclusions?u:m).test(x)?fe=P(x,U):(K=l.exec(a(x,U)))?fe=F(K[1].substr(1),x,!0):(K=f.exec(a(x,U)))?fe=F(K[1],x,!1):fe=$(x),r.set(ae,fe),s(fe,O)}function s(O,U){if(typeof U=="string")return O;const x=function(ae,fe){return(0,D.isEqualOrParent)(ae,U.base,!I.isLinux)?O(ae.substr(U.base.length+1),fe):null};return x.allBasenames=O.allBasenames,x.allPaths=O.allPaths,x.basenames=O.basenames,x.patterns=O.patterns,x}function a(O,U){return U.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,U){return function(x,ae){return typeof x=="string"&&x.endsWith(O)?U:null}}function d(O,U){const x=`/${O}`,ae=`\\${O}`,fe=function(ie,L){return typeof ie!="string"?null:L?L===O?U:null:ie===O||ie.endsWith(x)||ie.endsWith(ae)?U:null},K=[O];return fe.basenames=K,fe.patterns=[U],fe.allBasenames=K,fe}function P(O,U){const x=z(O.slice(1,-1).split(",").map(L=>i(L,U)).filter(L=>L!==n),O),ae=x.length;if(!ae)return n;if(ae===1)return x[0];const fe=function(L,M){for(let G=0,re=x.length;G<re;G++)if(x[G](L,M))return O;return null},K=x.find(L=>!!L.allBasenames);K&&(fe.allBasenames=K.allBasenames);const ie=x.reduce((L,M)=>M.allPaths?L.concat(M.allPaths):L,[]);return ie.length&&(fe.allPaths=ie),fe}function F(O,U,x){const ae=T.sep===T.posix.sep,fe=ae?O:O.replace(S,T.sep),K=T.sep+fe,ie=T.posix.sep+O;let L;return x?L=function(M,G){return typeof M=="string"&&(M===fe||M.endsWith(K)||!ae&&(M===O||M.endsWith(ie)))?U:null}:L=function(M,G){return typeof M=="string"&&(M===fe||!ae&&M===O)?U:null},L.allPaths=[(x?"*/":"./")+O],L}function $(O){try{const U=new RegExp(`^${w(O)}$`);return function(x){return U.lastIndex=0,typeof x=="string"&&U.test(x)?O:null}}catch{return n}}function Z(O,U,x){return!O||typeof U!="string"?!1:J(O)(U,void 0,x)}e.match=Z;function J(O,U={}){if(!O)return o;if(typeof O=="string"||_(O)){const x=i(O,U);if(x===n)return o;const ae=function(fe,K){return!!x(fe,K)};return x.allBasenames&&(ae.allBasenames=x.allBasenames),x.allPaths&&(ae.allPaths=x.allPaths),ae}return B(O,U)}e.parse=J;function _(O){const U=O;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.isRelativePattern=_;function ee(O){return O.allBasenames||[]}e.getBasenameTerms=ee;function ne(O){return O.allPaths||[]}e.getPathTerms=ne;function B(O,U){const x=z(Object.getOwnPropertyNames(O).map(L=>ue(L,O[L],U)).filter(L=>L!==n)),ae=x.length;if(!ae)return n;if(!x.some(L=>!!L.requiresSiblings)){if(ae===1)return x[0];const L=function(re,he){let ve;for(let H=0,Y=x.length;H<Y;H++){const te=x[H](re,he);if(typeof te=="string")return te;(0,t.isThenable)(te)&&(ve||(ve=[]),ve.push(te))}return ve?(async()=>{for(const H of ve){const Y=await H;if(typeof Y=="string")return Y}return null})():null},M=x.find(re=>!!re.allBasenames);M&&(L.allBasenames=M.allBasenames);const G=x.reduce((re,he)=>he.allPaths?re.concat(he.allPaths):re,[]);return G.length&&(L.allPaths=G),L}const fe=function(L,M,G){let re,he;for(let ve=0,H=x.length;ve<H;ve++){const Y=x[ve];Y.requiresSiblings&&G&&(M||(M=(0,T.basename)(L)),re||(re=M.substr(0,M.length-(0,T.extname)(L).length)));const te=Y(L,M,re,G);if(typeof te=="string")return te;(0,t.isThenable)(te)&&(he||(he=[]),he.push(te))}return he?(async()=>{for(const ve of he){const H=await ve;if(typeof H=="string")return H}return null})():null},K=x.find(L=>!!L.allBasenames);K&&(fe.allBasenames=K.allBasenames);const ie=x.reduce((L,M)=>M.allPaths?L.concat(M.allPaths):L,[]);return ie.length&&(fe.allPaths=ie),fe}function ue(O,U,x){if(U===!1)return n;const ae=i(O,x);if(ae===n)return n;if(typeof U=="boolean")return ae;if(U){const fe=U.when;if(typeof fe=="string"){const K=(ie,L,M,G)=>{if(!G||!ae(ie,L))return null;const re=fe.replace("$(basename)",M),he=G(re);return(0,t.isThenable)(he)?he.then(ve=>ve?O:null):he?O:null};return K.requiresSiblings=!0,K}}return ae}function z(O,U){const x=O.filter(L=>!!L.basenames);if(x.length<2)return O;const ae=x.reduce((L,M)=>{const G=M.basenames;return G?L.concat(G):L},[]);let fe;if(U){fe=[];for(let L=0,M=ae.length;L<M;L++)fe.push(U)}else fe=x.reduce((L,M)=>{const G=M.patterns;return G?L.concat(G):L},[]);const K=function(L,M){if(typeof L!="string")return null;if(!M){let re;for(re=L.length;re>0;re--){const he=L.charCodeAt(re-1);if(he===47||he===92)break}M=L.substr(re)}const G=ae.indexOf(M);return G!==-1?fe[G]:null};K.basenames=ae,K.patterns=fe,K.allBasenames=ae;const ie=O.filter(L=>!L.basenames);return ie.push(K),ie}function X(O,U){return(0,v.equals)(O,U,(x,ae)=>typeof x=="string"&&typeof ae=="string"?x===ae:typeof x!="string"&&typeof ae!="string"?x.base===ae.base&&x.pattern===ae.pattern:!1)}e.patternsEquals=X}),define(we[88],ye([1,0,8,141,19,15,4]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(E){E[E.Paragraph=0]="Paragraph",E[E.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class p{constructor(g="",m=!1){if(this.value=g,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(g,m=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(g):g).replace(/([ \t]+)/g,(u,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,m){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(g,m,u){return this.value+="[",this.value+=this._escape(m,"]"),this.value+="](",this.value+=this._escape(String(g),")"),u&&(this.value+=` "${this._escape(this._escape(u,'"'),")")}"`),this.value+=")",this}_escape(g,m){const u=new RegExp((0,C.escapeRegExpCharacters)(m),"g");return g.replace(u,(l,f)=>g.charAt(f-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=p;function b(E){return R(E)?!E.value:Array.isArray(E)?E.every(b):!0}e.isEmptyMarkdownString=b;function R(E){return E instanceof p?!0:E&&typeof E=="object"?typeof E.value=="string"&&(typeof E.isTrusted=="boolean"||E.isTrusted===void 0)&&(typeof E.supportThemeIcons=="boolean"||E.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function k(E,g){return E===g?!0:!E||!g?!1:E.value===g.value&&E.isTrusted===g.isTrusted&&E.supportThemeIcons===g.supportThemeIcons&&E.supportHtml===g.supportHtml&&(E.baseUri===g.baseUri||!!E.baseUri&&!!g.baseUri&&(0,D.isEqual)(T.URI.from(E.baseUri),T.URI.from(g.baseUri)))}e.markdownStringEqual=k;function S(E){return E.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function y(E){return E.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=y;function h(E){return E&&E.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function w(E){const g=[],m=E.split("|").map(l=>l.trim());E=m[0];const u=m[1];if(u){const l=/height=(\d+)/.exec(u),f=/width=(\d+)/.exec(u),r=l?l[1]:"",o=f?f[1]:"",n=isFinite(parseInt(o)),i=isFinite(parseInt(r));n&&g.push(`width="${o}"`),i&&g.push(`height="${r}"`)}return{href:E,dimensions:g}}e.parseHrefAndDimensions=w}),define(we[143],ye([1,0,18,36,6,3,19,15]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(n,i){const{os:s,tildify:a,relative:c}=i;if(c){const F=b(n,c,s);if(typeof F=="string")return F}let d=n.fsPath;if(s===1&&!C.isWindows?d=d.replace(/\//g,"\\"):s!==1&&C.isWindows&&(d=d.replace(/\\/g,"/")),s!==1&&a?.userHome){const F=a.userHome.fsPath;let $;n.scheme!==a.userHome.scheme&&n.path.startsWith(D.posix.sep)?$=a.userHome.with({path:n.path}).fsPath:$=n.fsPath,d=S($,F,s)}return(s===1?D.win32:D.posix).normalize(R(d,s===1))}e.getPathLabel=p;function b(n,i,s){const a=s===1?D.win32:D.posix,c=s===3?T.extUri:T.extUriIgnorePathCase,d=i.getWorkspace(),P=(0,v.firstOrDefault)(d.folders);if(!P)return;n.scheme!==P.uri.scheme&&n.path.startsWith(D.posix.sep)&&(n=P.uri.with({path:n.path}));const F=i.getWorkspaceFolder(n);if(!F)return;let $;if(c.isEqual(F.uri,n)?$="":$=c.relativePath(F.uri,n)??"",$&&($=a.normalize($)),d.folders.length>1&&!i.noPrefix){const Z=F.name?F.name:c.basenameOrAuthority(F.uri);$=$?`${Z} \u2022 ${$}`:Z}return $}function R(n,i=C.isWindows){return(0,t.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let k=Object.create(null);function S(n,i,s=C.OS){if(s===1||!n||!i)return n;let a=k.original===i?k.normalized:void 0;a||(a=i,C.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,I.rtrim)(a,D.posix.sep)}${D.posix.sep}`,k={original:i,normalized:a});let c=n;return C.isWindows&&(c=(0,t.toSlashes)(c)),(s===3?c.startsWith(a):(0,I.startsWithIgnoreCase)(c,a))?`~/${c.substr(a.length)}`:n}e.tildify=S;function y(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=y;const h="\u2026",w="\\\\",E="~";function g(n,i=D.sep){const s=new Array(n.length);let a=!1;for(let c=0;c<n.length;c++){const d=n[c];if(d===""){s[c]=`.${i}`;continue}if(!d){s[c]=d;continue}a=!0;let P="",F=d;F.indexOf(w)===0?(P=F.substr(0,F.indexOf(w)+w.length),F=F.substr(F.indexOf(w)+w.length)):F.indexOf(i)===0?(P=F.substr(0,F.indexOf(i)+i.length),F=F.substr(F.indexOf(i)+i.length)):F.indexOf(E)===0&&(P=F.substr(0,F.indexOf(E)+E.length),F=F.substr(F.indexOf(E)+E.length));const $=F.split(i);for(let Z=1;a&&Z<=$.length;Z++)for(let J=$.length-Z;a&&J>=0;J--){a=!1;let _=$.slice(J,J+Z).join(i);for(let ee=0;!a&&ee<n.length;ee++)if(ee!==c&&n[ee]&&n[ee].indexOf(_)>-1){const ne=J+Z===$.length,B=J>0&&n[ee].indexOf(i)>-1?i+_:_,ue=n[ee].endsWith(B);a=!ne||ue}if(!a){let ee="";($[0].endsWith(":")||P!=="")&&(J===1&&(J=0,Z++,_=$[0]+i+_),J>0&&(ee=$[0]+i),ee=P+ee),J>0&&(ee=ee+h+i),ee=ee+_,J+Z<$.length&&(ee=ee+i+h),s[c]=ee}}a&&(s[c]=d)}return s}e.shorten=g;var m;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function u(n,i=Object.create(null)){const s=[];let a=!1,c="";for(const d of n)if(d==="$"||a&&d==="{")c&&s.push({value:c,type:m.TEXT}),c="",a=!0;else if(d==="}"&&a){const P=i[c];if(typeof P=="string")P.length&&s.push({value:P,type:m.VARIABLE});else if(P){const F=s[s.length-1];(!F||F.type!==m.SEPARATOR)&&s.push({value:P.label,type:m.SEPARATOR})}c="",a=!1}else c+=d;return c&&!a&&s.push({value:c,type:m.TEXT}),s.filter((d,P)=>{if(d.type===m.SEPARATOR){const F=s[P-1],$=s[P+1];return[F,$].every(Z=>Z&&(Z.type===m.VARIABLE||Z.type===m.TEXT)&&Z.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=u;function l(n,i){return C.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function f(n,i){return C.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=f;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(n){const i=n.indexOf("/")!==-1?D.posix:D.win32,s=i.basename(n),a=i.dirname(n);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(we[69],ye([1,0,4]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const S=this._uriTransformer.transformIncoming(k);return S===k?k:t(v.URI.from(S))}transformOutgoing(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:t(v.URI.from(S))}transformOutgoingURI(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:v.URI.from(S)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function C(R,k,S){if(!R||S>200)return null;if(typeof R=="object"){if(R instanceof v.URI)return k.transformOutgoing(R);for(const y in R)if(Object.hasOwnProperty.call(R,y)){const h=C(R[y],k,S+1);h!==null&&(R[y]=h)}}return null}function T(R,k){const S=C(R,k,0);return S===null?R:S}e.transformOutgoingURIs=T;function I(R,k,S,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return S?v.URI.revive(k.transformIncoming(R)):k.transformIncoming(R);for(const h in R)if(Object.hasOwnProperty.call(R,h)){const w=I(R[h],k,S,y+1);w!==null&&(R[h]=w)}}return null}function p(R,k){const S=I(R,k,!1,0);return S===null?R:S}e.transformIncomingURIs=p;function b(R,k){const S=I(R,k,!0,0);return S===null?R:S}e.transformAndReviveIncomingURIs=b}),define(we[23],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return v.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(I){for(let p=0;p<I.length;p++)I[p]=Math.floor(Math.random()*256);return I};const C=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){D(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let p=0,b="";return b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+="-",b+=T[C[p++]],b+=T[C[p++]],b+="-",b+=T[C[p++]],b+=T[C[p++]],b+="-",b+=T[C[p++]],b+=T[C[p++]],b+="-",b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b}}()}),function(){"use strict";function oe(e,v,t){function D(y){return new Promise(h=>v.exists(y,h))}function C(y){return new Promise((h,w)=>{const E=new Date;v.utimes(y,E,E,g=>g?w(g):h())})}function T(y){return new Promise((h,w)=>v.mkdir(y,{recursive:!0},E=>E&&E.code!=="EEXIST"?w(E):h(y)))}function I(y){return new Promise((h,w)=>v.rm(y,{recursive:!0,force:!0,maxRetries:3},E=>E?w(E):h()))}function p(y){return new Promise((h,w)=>v.readFile(y,"utf8",(E,g)=>E?w(E):h(g)))}function b(y,h){return new Promise((w,E)=>v.writeFile(y,h,"utf8",g=>g?E(g):w()))}async function R(y){const h=e.join(y,"languagepacks.json");try{return JSON.parse(await p(h))}catch{}}function k(y,h){try{for(;h;){if(y[h])return h;{const w=h.lastIndexOf("-");if(w>0)h=h.substring(0,w);else return}}}catch(w){console.error("Resolving language pack configuration failed.",w)}}function S(y,h,w,E){if(E==="pseudo")return Promise.resolve({locale:E,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:E,availableLanguages:{}});if(E&&(E==="en"||E==="en-us"))return Promise.resolve({locale:E,availableLanguages:{}});const g=E;t.mark("code/willGenerateNls");const m=function(u){return t.mark("code/didGenerateNls"),Promise.resolve({locale:u,availableLanguages:{}})};try{return y?R(h).then(u=>{if(!u||(E=k(u,E),!E))return m(g);const l=u[E];let f;return!l||typeof l.hash!="string"||!l.translations||typeof(f=l.translations.vscode)!="string"?m(g):D(f).then(r=>{if(!r)return m(g);const o=l.hash+"."+E,n=e.join(h,"clp",o),i=e.join(n,y),s=e.join(n,"tcf.json"),a=e.join(n,"corrupted.info"),c={locale:g,availableLanguages:{"*":E},_languagePackId:o,_translationsConfigFile:s,_cacheRoot:n,_resolvedLanguagePackCoreLocation:i,_corruptedFile:a};return D(a).then(d=>{let P;return d?P=I(n):P=Promise.resolve(void 0),P.then(()=>D(i).then(F=>F?(C(i).catch(()=>{}),t.mark("code/didGenerateNls"),c):T(i).then(()=>Promise.all([p(w),p(f)])).then($=>{const Z=JSON.parse($[0]),J=JSON.parse($[1]).contents,_=Object.keys(Z.bundles),ee=[];for(const ne of _){const B=Z.bundles[ne],ue=Object.create(null);for(const z of B){const X=Z.keys[z],O=Z.messages[z],U=J[z];let x;if(U){x=[];for(let ae=0;ae<X.length;ae++){const fe=X[ae],K=typeof fe=="string"?fe:fe.key;let ie=U[K];ie===void 0&&(ie=O[ae]),x.push(ie)}}else x=O;ue[z]=x}ee.push(b(e.join(i,ne.replace(/\//g,"!")+".nls.json"),JSON.stringify(ue)))}return ee.push(b(s,JSON.stringify(l.translations))),Promise.all(ee)}).then(()=>(t.mark("code/didGenerateNls"),c)).catch($=>(console.error("Generating translation files failed.",$),m(E)))))})})}):m(g)}catch(u){return console.error("Generating translation files failed.",u),m(E)}}return{getNLSConfiguration:S}}if(typeof define=="function")define(we[144],ye([89,30,47]),function(e,v,t){return oe(e,v,t)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("fs"),t=require("../common/performance");module.exports=oe(e,v,t)}else throw new Error("Unknown context")}(),define(we[145],ye([1,0,28]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(T){const I=T.replace(/\-/g,":").toLowerCase();return!t.has(I)}function C(){const T=(0,v.networkInterfaces)();for(const I in T){const p=T[I];if(p){for(const{mac:b}of p)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(we[90],ye([1,0,28,8,24,23,145]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,k=0;const S=(0,v.networkInterfaces)();for(const y in S){const h=S[y];if(h)for(const{mac:w,internal:E}of h)E||(k+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(R+=1))}this._value=k>0?R/k:0}return this._value}};let I;async function p(){return I||(I=(async()=>await b()||C.generateUuid())()),I}e.getMachineId=p;async function b(){try{const R=await new Promise((S,y)=>{oe(["crypto"],S,y)}),k=(0,T.getMac)();return R.createHash("sha256").update(k,"utf8").digest("hex")}catch(R){t.onUnexpectedError(R);return}}}),define(we[21],ye([1,0,30,28,267,14,36,87,6,3,19,4]),function(oe,e,v,t,D,C,T,I,p,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function y(B,ue=S.UNLINK){if((0,T.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return ue===S.UNLINK?w(B):h(B)}async function h(B){try{const ue=(0,T.randomPath)((0,t.tmpdir)());try{await v.promises.rename(B,ue)}catch(z){return z.code==="ENOENT"?void 0:w(B)}w(ue).catch(z=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function w(B){return(0,D.promisify)(v.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function E(B){if((0,T.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=E;async function g(B,ue){return l(await(ue?m(B):(0,D.promisify)(v.readdir)(B)))}async function m(B){try{return await(0,D.promisify)(v.readdir)(B,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const ue=[],z=await g(B);for(const X of z){let O=!1,U=!1,x=!1;try{const ae=await e.Promises.lstat((0,p.join)(B,X));O=ae.isFile(),U=ae.isDirectory(),x=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}ue.push({name:X,isFile:()=>O,isDirectory:()=>U,isSymbolicLink:()=>x})}return ue}function u(B){return l(v.readdirSync(B))}e.readdirSync=u;function l(B){return B.map(ue=>typeof ue=="string"?b.isMacintosh?(0,I.normalizeNFC)(ue):ue:(ue.name=b.isMacintosh?(0,I.normalizeNFC)(ue.name):ue.name,ue))}async function f(B){const ue=await g(B),z=[];for(const X of ue)await o.existsDirectory((0,p.join)(B,X))&&z.push(X);return z}function r(B,ue=1e3){return new Promise(z=>{let X=!1;const O=setInterval(()=>{X||(X=!0,v.access(B,U=>{X=!1,U&&(clearInterval(O),z(void 0))}))},ue)})}e.whenDeleted=r;var o;(function(B){async function ue(O){let U;try{if(U=await e.Promises.lstat(O),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(O),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(b.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(O)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw ae}throw x}}B.stat=ue;async function z(O){try{const{stat:U,symbolicLink:x}=await B.stat(O);return U.isFile()&&x?.dangling!==!0}catch{}return!1}B.existsFile=z;async function X(O){try{const{stat:U,symbolicLink:x}=await B.stat(O);return U.isDirectory()&&x?.dangling!==!0}catch{}return!1}B.existsDirectory=X})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new C.ResourceQueue;function i(B,ue,z){return n.queueFor(k.URI.file(B),R.extUriBiasedIgnorePathCase).queue(()=>{const X=P(z);return new Promise((O,U)=>c(B,ue,X,x=>x?U(x):O()))})}let s=!0;function a(B){s=B}e.configureFlushOnWrite=a;function c(B,ue,z,X){if(!s)return v.writeFile(B,ue,{mode:z.mode,flag:z.flag},X);v.open(B,z.flag,z.mode,(O,U)=>{if(O)return X(O);v.writeFile(U,ue,x=>{if(x)return v.close(U,()=>X(x));v.fdatasync(U,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),a(!1)),v.close(U,fe=>X(fe))))})})}function d(B,ue,z){const X=P(z);if(!s)return v.writeFileSync(B,ue,{mode:X.mode,flag:X.flag});const O=v.openSync(B,X.flag,X.mode);try{v.writeFileSync(O,ue);try{v.fdatasyncSync(O)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),a(!1)}}finally{v.closeSync(O)}}e.writeFileSync=d;function P(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function F(B,ue){if(B!==ue)try{await e.Promises.rename(B,ue)}catch(z){if(B.toLowerCase()!==ue.toLowerCase()&&z.code==="EXDEV"||B.endsWith("."))await $(B,ue,{preserveSymlinks:!1}),await y(B,S.MOVE);else throw z}}async function $(B,ue,z){return J(B,ue,{root:{source:B,target:ue},options:z,handledSourcePaths:new Set})}const Z=511;async function J(B,ue,z){if(z.handledSourcePaths.has(B))return;z.handledSourcePaths.add(B);const{stat:X,symbolicLink:O}=await o.stat(B);if(O){if(z.options.preserveSymlinks)try{return await ne(B,ue,z)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(O.dangling)return}return X.isDirectory()?_(B,ue,X.mode&Z,z):ee(B,ue,X.mode&Z)}async function _(B,ue,z,X){await e.Promises.mkdir(ue,{recursive:!0,mode:z});const O=await g(B);for(const U of O)await J((0,p.join)(B,U),(0,p.join)(ue,U),X)}async function ee(B,ue,z){await e.Promises.copyFile(B,ue),await e.Promises.chmod(ue,z)}async function ne(B,ue,z){let X=await e.Promises.readlink(B);(0,T.isEqualOrParent)(X,z.root.source,!b.isLinux)&&(X=(0,p.join)(z.root.target,X.substr(z.root.source.length+1))),await e.Promises.symlink(X,ue)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(B,ue,z,X,O)=>new Promise((U,x)=>{v.read(B,ue,z,X,O,(ae,fe,K)=>ae?x(ae):U({bytesRead:fe,buffer:K}))})}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(B,ue,z,X,O)=>new Promise((U,x)=>{v.write(B,ue,z,X,O,(ae,fe,K)=>ae?x(ae):U({bytesWritten:fe,buffer:K}))})}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return f}get writeFile(){return i}get rm(){return y}get move(){return F}get copy(){return $}}}),define(we[146],ye([1,0,30,6,3,15,21]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(S){if(D.isLinux)return S;const y=(0,t.dirname)(S);if(S===y)return S;const h=((0,t.basename)(S)||S).toLowerCase();try{const E=(0,T.readdirSync)(y).filter(g=>g.toLowerCase()===h);if(E.length===1){const g=I(y);if(g)return(0,t.join)(g,E[0])}else if(E.length>1){const g=E.indexOf(h);if(g>=0){const m=I(y);if(m)return(0,t.join)(m,E[g])}}}catch{}return null}e.realcaseSync=I;async function p(S){if(D.isLinux)return S;const y=(0,t.dirname)(S);if(S===y)return S;const h=((0,t.basename)(S)||S).toLowerCase();try{const E=(await T.Promises.readdir(y)).filter(g=>g.toLowerCase()===h);if(E.length===1){const g=await p(y);if(g)return(0,t.join)(g,E[0])}else if(E.length>1){const g=E.indexOf(h);if(g>=0){const m=await p(y);if(m)return(0,t.join)(m,E[g])}}}catch{}return null}e.realcase=p;async function b(S){try{return await T.Promises.realpath(S)}catch{const h=k(S);return await T.Promises.access(h,v.constants.R_OK),h}}e.realpath=b;function R(S){try{return v.realpathSync(S)}catch{const h=k(S);return v.accessSync(h,v.constants.R_OK),h}}e.realpathSync=R;function k(S){return(0,C.rtrim)((0,t.normalize)(S),t.sep)}}),define(we[147],ye([1,0,91]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,p,b,R=1){let k=!1;return new Promise(S=>{const y=setTimeout(()=>{if(!k)return k=!0,S(0)},b);D(I,p,R,h=>{if(!k)return k=!0,clearTimeout(y),S(h)})})}e.findFreePort=t;function D(I,p,b,R){if(p===0)return R(0);const k=new v.Socket;k.once("connect",()=>(T(k),D(I+b,p-1,b,R))),k.once("data",()=>{}),k.once("error",S=>(T(k),S.code!=="ECONNREFUSED"?D(I+b,p-1,b,R):R(I))),k.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(I,p,b){let R=!1,k,S=1;const y=v.createServer({pauseOnConnect:!0});function h(w,E){R||(R=!0,y.removeAllListeners(),y.close(),k&&clearTimeout(k),E(w))}return new Promise(w=>{k=setTimeout(()=>{h(0,w)},b),y.on("listening",()=>{h(I,w)}),y.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&S<p?(I++,S++,y.listen(I,"127.0.0.1")):h(0,w)}),y.on("close",()=>{h(0,w)}),y.listen(I,"127.0.0.1")})}e.findFreePortFaster=C;function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(p){console.error(p)}}}),define(we[92],ye([1,0,28,6,21]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var p;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(p||(p={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class k{constructor(f,r,o){this.exePath=f,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:l=!1}={}){return l?b===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:l=!1,findPreview:f=!1}={}){const r=S({useAlternateBitness:l});if(!r)return null;const o=t.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let n=-1,i=null;for(const c of await D.Promises.readdir(o)){let d=-1;if(f){const F=c.indexOf("-");if(F<0)continue;const $=c.substring(0,F);if(!C.test($)||c.substring(F+1)!=="preview")continue;d=parseInt($,10)}else{if(!C.test(c))continue;d=parseInt(c,10)}if(d<=n)continue;const P=t.join(o,c,"pwsh.exe");!await D.SymlinkSupport.existsFile(P)||(i=P,n=d)}if(!i)return null;const s=r.includes("x86")?" (x86)":"",a=f?" Preview":"";return new k(i,`PowerShell${a}${s}`,!0)}async function h({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const f=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=l?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(f))if(r.test(n)){const i=t.join(f,n,"pwsh.exe");return new k(i,o)}return null}function w(){const l=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new k(l,".NET Core PowerShell Global Tool")}function E(){const l=t.join(process.env.windir,b===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(l,"Windows PowerShell",!0)}async function*g(){let l=await y();l&&(yield l),l=await y({useAlternateBitness:!0}),l&&(yield l),l=await h(),l&&(yield l),l=w(),l&&(yield l),l=await y({findPreview:!0}),l&&(yield l),l=await h({findPreview:!0}),l&&(yield l),l=await y({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=E(),l&&(yield l)}async function*m(){for await(const l of g())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=m;async function u(){for await(const l of m())return l;return null}e.getFirstAvailablePowerShellInstallation=u}),define(we[93],ye([1,0,6,3,27,56,11,21]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function p(k=D.env){return k.comspec||"cmd.exe"}e.getWindowsShell=p;function b(k){let S=[],y=!1;const h=function(w){if(y){S.push(w);return}(!k.send(w,g=>{if(g&&console.error(g),y=!1,S.length>0){const m=S.slice(0);S=[],m.forEach(u=>h(u))}})||t.isWindows)&&(y=!0)};return{send:h}}e.createQueuedSender=b;var R;(function(k){async function S(y,h,w){if(v.isAbsolute(y))return y;if(h===void 0&&(h=D.cwd()),v.dirname(y)!=="."||(w===void 0&&T.isString(D.env.PATH)&&(w=D.env.PATH.split(v.delimiter)),w===void 0||w.length===0))return v.join(h,y);async function g(m){if(await I.Promises.exists(m)){let u;try{u=await I.Promises.stat(m)}catch(l){l.message.startsWith("EACCES")&&(u=await I.Promises.lstat(m))}return u?!u.isDirectory():!1}return!1}for(const m of w){let u;if(v.isAbsolute(m)?u=v.join(m,y):u=v.join(h,m,y),await g(u))return u;let l=u+".com";if(await g(l)||(l=u+".exe",await g(l)))return l}return v.join(h,y)}k.findExecutable=S})(R=e.win32||(e.win32={}))}),define(we[94],ye([1,0,48,12]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(T){return new Promise((I,p)=>{let b;const R=new Map;function k(y,h,w,E,g){const m=R.get(h);if(y===T||m){const u={name:S(w),cmd:w,pid:y,ppid:h,load:E,mem:g};R.set(y,u),y===T&&(b=u),m&&(m.children||(m.children=[]),m.children.push(u),m.children.length>1&&(m.children=m.children.sort((l,f)=>l.pid-f.pid)))}}function S(y){const h=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,E=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,l=/\\pipe\\winpty-control/,f=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(u.exec(y))return"electron-crash-reporter";if(l.exec(y))return"winpty-process";if(f.exec(y))return"console-window-host (Windows internal process)";let o=r.exec(y);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(y)?"shared-process":w.exec(y)?"issue-reporter":E.exec(y)?"process-explorer":"window";if(o[1]==="utility"){if(g.exec(y))return"utility-network-service";if(m.exec(y))return"extension-host"}return o[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do o=n.exec(y),o&&(i+=o+" ");while(o);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,w)=>{oe(["windows-process-tree"],h,w)}).then(h=>{h.getProcessList(T,w=>{if(!w){p(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(w,E=>{const g=new Map;E.forEach(m=>{const u=y(m.commandLine||"");g.set(m.pid,{name:S(u),cmd:u,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),b=g.get(T),b?(g.forEach(m=>{const u=g.get(m.ppid);u&&(u.children||(u.children=[]),u.children.push(m))}),g.forEach(m=>{m.children&&(m.children=m.children.sort((u,l)=>u.pid-l.pid))}),I(b)):p(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[b];const w=[];for(;h.length;){const g=h.shift();g&&(w.push(g.pid),g.children&&(h=h.concat(g.children)))}let E=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",oe).fsPath);E+=" "+w.join(" "),(0,v.exec)(E,{},(g,m,u)=>{if(g||u)p(g||new Error(u.toString()));else{const l=m.toString().split(`
`);for(let f=0;f<w.length;f++){const r=R.get(w[f]);r.load=parseFloat(l[f])}if(!b){p(new Error(`Root process ${T} not found`));return}I(b)}})};(0,v.exec)("which ps",{},(h,w,E)=>{if(h||E)if(process.platform!=="linux")p(h||new Error(E.toString()));else{const g=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",oe).fsPath);(0,v.exec)(g,{},(m,u,l)=>{m||l?p(m||new Error(l.toString())):(C(u,k),y())})}else{const g=w.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${g} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,l,f)=>{u||f&&!f.includes("screen size is bogus")?p(u||new Error(f.toString())):(C(l,k),process.platform==="linux"?y():b?I(b):p(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=D;function C(T,I){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const R of b){const k=p.exec(R.trim());k&&k.length===6&&I(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(we[148],ye([1,0,28,3,92,93]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(y,h){return y===1?t.isWindows?k():C.getWindowsShell(h):b(y,h)}e.getSystemShell=T;function I(y,h){return y===1?t.isWindows?S(h):C.getWindowsShell(h):b(y,h)}e.getSystemShellSync=I;let p=null;function b(y,h){if(t.isLinux&&y===2||t.isMacintosh&&y===3)return"/bin/bash";if(!p){let w;if(t.isWindows)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,v.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}p=w}return p}let R=null;async function k(){return R||(R=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),R}function S(y){if(R)return R;const h=t.isWindows&&parseFloat((0,v.release)())>=10,w=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${y.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?E:C.getWindowsShell(y)}});var Re=this&&this.__decorate||function(oe,e,v,t){var D=arguments.length,C=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(oe,e,v,t);else for(var I=oe.length-1;I>=0;I--)(T=oe[I])&&(C=(D<3?T(C):D>3?T(e,v,C):T(e,v))||C);return D>3&&C&&Object.defineProperty(e,v,C),C};define(we[42],ye([1,0,18,14,16,20,83,8,7,2,46,15,11]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function h(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function E(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(g||(g={}));class m{constructor(U){this.buffer=U,this.pos=0}read(U){const x=this.buffer.slice(this.pos,this.pos+U);return this.pos+=x.byteLength,x}}class u{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var l;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(l||(l={}));function f(O){const U=D.VSBuffer.alloc(4);return U.writeUInt32BE(O,0),U}function r(O){return O.read(4).readUInt32BE(0)}function o(O){const U=D.VSBuffer.alloc(1);return U.writeUInt8(O,0),U}const n={Undefined:o(l.Undefined),String:o(l.String),Buffer:o(l.Buffer),VSBuffer:o(l.VSBuffer),Array:o(l.Array),Object:o(l.Object)},i=typeof Buffer<"u";function s(O,U){if(typeof U>"u")O.write(n.Undefined);else if(typeof U=="string"){const x=D.VSBuffer.fromString(U);O.write(n.String),O.write(f(x.byteLength)),O.write(x)}else if(i&&Buffer.isBuffer(U)){const x=D.VSBuffer.wrap(U);O.write(n.Buffer),O.write(f(x.byteLength)),O.write(x)}else if(U instanceof D.VSBuffer)O.write(n.VSBuffer),O.write(f(U.byteLength)),O.write(U);else if(Array.isArray(U)){O.write(n.Array),O.write(f(U.length));for(const x of U)s(O,x)}else{const x=D.VSBuffer.fromString(JSON.stringify(U));O.write(n.Object),O.write(f(x.byteLength)),O.write(x)}}function a(O){switch(O.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return O.read(r(O)).toString();case l.Buffer:return O.read(r(O)).buffer;case l.VSBuffer:return O.read(r(O));case l.Array:{const x=r(O),ae=[];for(let fe=0;fe<x;fe++)ae.push(a(O));return ae}case l.Object:return JSON.parse(O.read(r(O)).toString())}}class c{constructor(U,x,ae=null,fe=1e3){this.protocol=U,this.ctx=x,this.logger=ae,this.timeoutDelay=fe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(U,x){this.channels.set(U,x),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const x=this.send([U.type]);this.logger?.logOutgoing(x,0,1,E(U.type));return}case 201:case 202:case 204:case 203:{const x=this.send([U.type,U.id],U.data);this.logger?.logOutgoing(x,U.id,1,E(U.type),U.data);return}}}send(U,x=void 0){const ae=new u;return s(ae,U),s(ae,x),this.sendBuffer(ae.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const x=new m(U),ae=a(x),fe=a(x),K=ae[0];switch(K){case 100:return this.logger?.logIncoming(U.byteLength,ae[1],1,`${h(K)}: ${ae[2]}.${ae[3]}`,fe),this.onPromise({type:K,id:ae[1],channelName:ae[2],name:ae[3],arg:fe});case 102:return this.logger?.logIncoming(U.byteLength,ae[1],1,`${h(K)}: ${ae[2]}.${ae[3]}`,fe),this.onEventListen({type:K,id:ae[1],channelName:ae[2],name:ae[3],arg:fe});case 101:return this.logger?.logIncoming(U.byteLength,ae[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:ae[1]});case 103:return this.logger?.logIncoming(U.byteLength,ae[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:ae[1]})}}onPromise(U){const x=this.channels.get(U.channelName);if(!x){this.collectPendingRequest(U);return}const ae=new C.CancellationTokenSource;let fe;try{fe=x.call(this.ctx,U.name,U.arg,ae.token)}catch(L){fe=Promise.reject(L)}const K=U.id;fe.then(L=>{this.sendResponse({id:K,data:L,type:201}),this.activeRequests.delete(U.id)},L=>{L instanceof Error?this.sendResponse({id:K,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:K,data:L,type:203}),this.activeRequests.delete(U.id)});const ie=(0,b.toDisposable)(()=>ae.cancel());this.activeRequests.set(U.id,ie)}onEventListen(U){const x=this.channels.get(U.channelName);if(!x){this.collectPendingRequest(U);return}const ae=U.id,K=x.listen(this.ctx,U.name,U.arg)(ie=>this.sendResponse({id:ae,data:ie,type:204}));this.activeRequests.set(U.id,K)}disposeActiveRequest(U){const x=this.activeRequests.get(U.id);x&&(x.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let x=this.pendingRequests.get(U.channelName);x||(x=[],this.pendingRequests.set(U.channelName,x));const ae=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:U,timeoutTimer:ae})}flushPendingRequests(U){const x=this.pendingRequests.get(U);if(x){for(const ae of x)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.onPromise(ae.request);break;case 102:this.onEventListen(ae.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var d;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(U,x=null){this.protocol=U,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=x}getChannel(U){const x=this;return{call(ae,fe,K){return x.isDisposed?Promise.reject(new I.CancellationError):x.requestPromise(U,ae,fe,K)},listen(ae,fe){return x.isDisposed?p.Event.None:x.requestEvent(U,ae,fe)}}}requestPromise(U,x,ae,fe=C.CancellationToken.None){const K=this.lastRequestId++,L={id:K,type:100,channelName:U,name:x,arg:ae};if(fe.isCancellationRequested)return Promise.reject(new I.CancellationError);let M;return new Promise((re,he)=>{if(fe.isCancellationRequested)return he(new I.CancellationError);const ve=()=>{const W=q=>{switch(q.type){case 201:this.handlers.delete(K),re(q.data);break;case 202:{this.handlers.delete(K);const j=new Error(q.data.message);j.stack=q.data.stack,j.name=q.data.name,he(j);break}case 203:this.handlers.delete(K),he(q.data);break}};this.handlers.set(K,W),this.sendRequest(L)};let H=null;this.state===g.Idle?ve():(H=(0,t.createCancelablePromise)(W=>this.whenInitialized()),H.then(()=>{H=null,ve()}));const Y=()=>{H?(H.cancel(),H=null):this.sendRequest({id:K,type:101}),he(new I.CancellationError)},te=fe.onCancellationRequested(Y);M=(0,b.combinedDisposable)((0,b.toDisposable)(Y),te),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(U,x,ae){const fe=this.lastRequestId++,ie={id:fe,type:102,channelName:U,name:x,arg:ae};let L=null;const M=new p.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(re=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(M),this.sendRequest(ie)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(M),this.sendRequest({id:fe,type:103}))}}),G=re=>M.fire(re.data);return this.handlers.set(fe,G),M.event}sendRequest(U){switch(U.type){case 100:case 102:{const x=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger?.logOutgoing(x,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const x=this.send([U.type,U.id]);this.logger?.logOutgoing(x,U.id,0,h(U.type));return}}}send(U,x=void 0){const ae=new u;return s(ae,U),s(ae,x),this.sendBuffer(ae.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const x=new m(U),ae=a(x),fe=a(x),K=ae[0];switch(K){case 200:return this.logger?.logIncoming(U.byteLength,0,0,E(K)),this.onResponse({type:ae[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(U.byteLength,ae[1],0,E(K),fe),this.onResponse({type:ae[0],id:ae[1],data:fe})}}onResponse(U){if(U.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(U.id)?.(U)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Re([T.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class F{get connections(){const U=[];return this._connections.forEach(x=>U.push(x)),U}constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:x,onDidClientDisconnect:ae})=>{p.Event.once(x.onMessage)(K=>{const ie=new m(K),L=a(ie),M=new c(x,L),G=new P(x);this.channels.forEach((he,ve)=>M.registerChannel(ve,he));const re={channelServer:M,channelClient:G,ctx:L};this._connections.add(re),this._onDidAddConnection.fire(re),ae(()=>{M.dispose(),G.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}getChannel(U,x){const ae=this;return{call(fe,K,ie){let L;if((0,S.isFunction)(x)){const G=(0,v.getRandomElement)(ae.connections.filter(x));L=G?Promise.resolve(G):p.Event.toPromise(p.Event.filter(ae.onDidAddConnection,x))}else L=x.routeCall(ae,fe,K);const M=L.then(G=>G.channelClient.getChannel(U));return Z(M).call(fe,K,ie)},listen(fe,K){if((0,S.isFunction)(x))return ae.getMulticastEvent(U,x,fe,K);const ie=x.routeEvent(ae,fe,K).then(L=>L.channelClient.getChannel(U));return Z(ie).listen(fe,K)}}}getMulticastEvent(U,x,ae,fe){const K=this;let ie=new b.DisposableStore;const L=new p.Emitter({onFirstListenerAdd:()=>{ie=new b.DisposableStore;const M=new p.EventMultiplexer,G=new Map,re=ve=>{const Y=ve.channelClient.getChannel(U).listen(ae,fe),te=M.add(Y);G.set(ve,te)},he=ve=>{const H=G.get(ve);!H||(H.dispose(),G.delete(ve))};K.connections.filter(x).forEach(re),p.Event.filter(K.onDidAddConnection,x)(re,void 0,ie),K.onDidRemoveConnection(he,void 0,ie),M.event(L.fire,L,ie),ie.add(M)},onLastListenerRemove:()=>{ie.dispose()}});return L.event}registerChannel(U,x){this.channels.set(U,x),this._connections.forEach(ae=>{ae.channelServer.registerChannel(U,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class ${constructor(U,x,ae=null){const fe=new u;s(fe,x),U.send(fe.buffer),this.channelClient=new P(U,ae),this.channelServer=new c(U,x,ae)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,x){this.channelServer.registerChannel(U,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function Z(O){return{call(U,x,ae){return O.then(fe=>fe.call(U,x,ae))},listen(U,x){const ae=new p.Relay;return O.then(fe=>ae.input=fe.listen(U,x)),ae.event}}}e.getDelayedChannel=Z;function J(O){let U=!1;return{call(x,ae,fe){return U?O.call(x,ae,fe):(0,t.timeout)(0).then(()=>U=!0).then(()=>O.call(x,ae,fe))},listen(x,ae){if(U)return O.listen(x,ae);const fe=new p.Relay;return(0,t.timeout)(0).then(()=>U=!0).then(()=>fe.input=O.listen(x,ae)),fe.event}}}e.getNextTickChannel=J;class _{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const x of U.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await p.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=_;var ee;(function(O){function U(K,ie){const L=K,M=ie&&ie.disableMarshalling,G=new Map;for(const re in L)ae(re)&&G.set(re,p.Event.buffer(L[re],!0));return new class{listen(re,he,ve){const H=G.get(he);if(H)return H;if(fe(he)){const Y=L[he];if(typeof Y=="function")return Y.call(L,ve)}throw new Error(`Event not found: ${he}`)}call(re,he,ve){const H=L[he];if(typeof H=="function"){if(!M&&Array.isArray(ve))for(let Y=0;Y<ve.length;Y++)ve[Y]=(0,R.revive)(ve[Y]);return H.apply(L,ve)}throw new Error(`Method not found: ${he}`)}}}O.fromService=U;function x(K,ie){const L=ie&&ie.disableMarshalling;return new Proxy({},{get(M,G){if(typeof G=="string")return ie?.properties?.has(G)?ie.properties.get(G):fe(G)?function(re){return K.listen(G,re)}:ae(G)?K.listen(G):async function(...re){let he;ie&&!(0,S.isUndefinedOrNull)(ie.context)?he=[ie.context,...re]:he=re;const ve=await K.call(G,he);return L?ve:(0,R.revive)(ve)};throw new Error(`Property not found: ${String(G)}`)}})}O.toService=x;function ae(K){return K[0]==="o"&&K[1]==="n"&&k.isUpperAsciiLetter(K.charCodeAt(2))}function fe(K){return/^onDynamic/.test(K)&&k.isUpperAsciiLetter(K.charCodeAt(9))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){const U=O.toString();if(U!=="[object Object]")return U}return O}function ue(O){return Array.isArray(O)?O.map(B):B(O)}function z(O,U,x,ae,fe,K,ie){ie=ue(ie);const L=ne[fe],M=L[ae%L.length];let G=[`%c[${O}]%c[${String(U).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(K)?(G=G.concat(ie),G.push(")")):G.push(ie),console.log.apply(console,G)}e.logWithColors=z;class X{constructor(U,x){this._outgoingPrefix=U,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,x,ae,fe,K){this._totalOutgoing+=U,z(this._outgoingPrefix,this._totalOutgoing,U,x,ae,fe,K)}logIncoming(U,x,ae,fe,K){this._totalIncoming+=U,z(this._incomingPrefix,this._totalIncoming,U,x,ae,fe,K)}}e.IPCLogger=X}),define(we[95],ye([1,0,16,7,2,42]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let a=0;function c(P,F){if(!s.has(P)){const $=String(++a);s.set(P,$)}return s.get(P)}function d(P,F,$,Z){if(!i.enableDiagnostics)return;const J=c(P,F);if(Z instanceof v.VSBuffer||Z instanceof Uint8Array||Z instanceof ArrayBuffer||ArrayBuffer.isView(Z)){const _=v.VSBuffer.alloc(Z.byteLength);_.set(Z),i.records.push({timestamp:Date.now(),id:J,label:F,type:$,buff:_})}else i.records.push({timestamp:Date.now(),id:J,label:F,type:$,data:Z})}i.traceSocketEvent=d})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function R(){return b||(b=v.VSBuffer.alloc(0)),b}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return R();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const F=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),F}if(this._chunks[0].byteLength>s){const F=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),F}const c=v.VSBuffer.alloc(s);let d=0,P=0;for(;s>0;){const F=this._chunks[P];if(F.byteLength>s){const $=F.slice(0,s);c.set($,d),d+=s,a&&(this._chunks[P]=F.slice(s),this._totalLength-=s),s-=s}else c.set(F,d),d+=F.byteLength,a?(this._chunks.shift(),this._totalLength-=F.byteLength):P++,s-=F.byteLength}return c}}e.ChunkStream=k;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(s,a,c,d){this.type=s,this.id=a,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends D.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,d=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new w(c,d,P,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=v.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const c=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,c}_bufferTake(){const s=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class m extends D.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new w(1,0,0,s))}}e.Protocol=m;class u extends C.IPCClient{static fromSocket(s,a){return new u(new m(s),a)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,a,c=null){super(s,a,c),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=u;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class f{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let s=0,a=this._first;for(;a;)a=a.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let a=0,c=this._first;for(;c;)s[a++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new f(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<o._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=o._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),a=(1+o._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<o._HISTORY_LENGTH;d++)s-this.lastRuns[d]<=a&&c++;return 1-c/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,a=null,c=o.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new w(5,0,0,R());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new w(7,0,0,R());this._socketWriter.write(s)}sendResume(){const s=new w(8,0,0,R());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new w(3,0,this._incomingAckId,R());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let c=0,d=a.length;c<d;c++)this._socketWriter.write(a[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new w(6,0,0,R())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let c=0,d=a.length;c<d;c++)this._socketWriter.write(a[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new w(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const a=new w(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&c>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:c});return}const P=Math.max(2e4-a,2e4-c,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new w(3,0,this._incomingAckId,R());this._socketWriter.write(s)}_sendKeepAlive(){const s=new w(9,0,0,R());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(we[96],ye([1,0,48,14,16,20,142,8,7,2,22,93,56,42]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends y.ChannelServer{constructor(g){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=h;class w{constructor(g,m){this.modulePath=g,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(u),this.child=null,this._client=null}getChannel(g){const m=this;return{call(u,l,f){return m.requestPromise(g,u,l,f)},listen(u,l){return m.requestEvent(g,u,l)}}}requestPromise(g,m,u,l=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const f=this.getCachedChannel(g),r=(0,t.createCancelablePromise)(i=>f.call(m,u,i)),o=l.onCancellationRequested(()=>r.cancel()),n=(0,b.toDisposable)(()=>r.cancel());return this.activeRequests.add(n),r.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(g,m,u){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let l;const f=new p.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(g).listen(m,u)(f.fire,f),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return f.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,S.removeDangerousEnvVariables)(m.env),this.child=(0,v.fork)(this.modulePath,g,m);const u=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.options.serverName}`);return}u.fire(D.VSBuffer.wrap(Buffer.from(s,"base64")))});const f=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,r=s=>this.child&&this.child.connected&&f.send(s.buffer.toString("base64")),o=u.event,n={send:r,onMessage:o};this._client=new y.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(c=>(0,b.dispose)(c)),this.activeRequests.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:a})})}return this._client}getCachedChannel(g){let m=this.channels.get(g);return m||(m=this.client.getChannel(g),this.channels.set(g,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(we[57],ye([1,0,16,8,7,2,6,3,23,42,95]),function(oe,e,v,t,D,C,T,I,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:oe.__$__nodeRequire("crypto"),zlib:oe.__$__nodeRequire("zlib"),net:oe.__$__nodeRequire("net"),os:oe.__$__nodeRequire("os")}}class S{traceSocketEvent(c,d){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,d)}constructor(c,d=""){this._canWrite=!0,this.debugLabel=d,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener),this._closeListener=P=>{this.traceSocketEvent("close",{hadError:P}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(c){const d=P=>{this.traceSocketEvent("read",P),c(v.VSBuffer.wrap(P))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(c){const d=P=>{c({type:0,hadError:P,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(c){const d=()=>{c()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(c){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=S;var y;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var h;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(h||(h={}));class w extends C.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,d){this.socket.traceSocketEvent(c,d)}constructor(c,d,P,F){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:P?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new E(this,d,P,F,this._onData,($,Z)=>this._write($,Z))),this._register(this._flowManager.onError($=>{console.error($),(0,t.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._flowManager.writeMessage(c)}_write(c,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let P=2;c.byteLength<126?P+=0:c.byteLength<2**16?P+=2:P+=8;const F=v.VSBuffer.alloc(P);if(d?F.writeUInt8(194,0):F.writeUInt8(130,0),c.byteLength<126)F.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){F.writeUInt8(126,1);let $=1;F.writeUInt8(c.byteLength>>>8&255,++$),F.writeUInt8(c.byteLength>>>0&255,++$)}else{F.writeUInt8(127,1);let $=1;F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(c.byteLength>>>24&255,++$),F.writeUInt8(c.byteLength>>>16&255,++$),F.writeUInt8(c.byteLength>>>8&255,++$),F.writeUInt8(c.byteLength>>>0&255,++$)}this.socket.write(v.VSBuffer.concat([F,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),P=d.readUInt8(0),F=(P&128)>>>7,$=(P&64)>>>6,Z=d.readUInt8(1),J=(Z&128)>>>7,_=Z&127;this._state.state=2,this._state.readLen=2+(J?4:0)+(_===126?2:0)+(_===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),P=d.readUInt8(1),F=(P&128)>>>7;let $=P&127,Z=1;$===126?$=d.readUInt8(++Z)*2**8+d.readUInt8(++Z):$===127&&($=d.readUInt8(++Z)*0+d.readUInt8(++Z)*0+d.readUInt8(++Z)*0+d.readUInt8(++Z)*0+d.readUInt8(++Z)*2**24+d.readUInt8(++Z)*2**16+d.readUInt8(++Z)*2**8+d.readUInt8(++Z));let J=0;F&&(J=d.readUInt8(++Z)*2**24+d.readUInt8(++Z)*2**16+d.readUInt8(++Z)*2**8+d.readUInt8(++Z)),this._state.state=3,this._state.readLen=$,this._state.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),u(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class E extends C.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}constructor(c,d,P,F,$,Z){super(),this._tracer=c,this._onData=$,this._writeFn=Z,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new g(this._tracer,F,P,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(J=>this._onError.fire(J))),this._register(this._zlibDeflateStream.onError(J=>this._onError.fire(J)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(d,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,d){return new Promise((P,F)=>{c.write(d),c.flush($=>P($))})}acceptFrame(c,d,P){this._readQueue.push({data:c,isCompressed:d,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1}}_inflateFrame(c,d,P){return new Promise((F,$)=>{c.write(d),P&&c.write(v.VSBuffer.fromByteArray([0,0,255,255])),c.flush(Z=>F(Z))})}}class g extends C.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}constructor(c,d,P,F){super(),this._tracer=c,this._recordInflateBytes=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(F),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(v.VSBuffer.wrap($))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(d)})}}class m extends C.Disposable{constructor(c,d){super(),this._tracer=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(v.VSBuffer.wrap(P))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),c(d)})}}function u(a,c){if(c===0)return;const d=a.byteLength>>>2;for(let _=0;_<d;_++){const ee=a.readUInt32BE(_*4);a.writeUInt32BE(ee^c,_*4)}const P=d*4,F=a.byteLength-P,$=c>>>24&255,Z=c>>>16&255,J=c>>>8&255;F>=1&&a.writeUInt8(a.readUInt8(P)^$,P),F>=2&&a.writeUInt8(a.readUInt8(P+1)^Z,P+1),F>=3&&a.writeUInt8(a.readUInt8(P+2)^J,P+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const l={[2]:107,[1]:103};function f(){const a=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):c=(0,T.join)(k().os.tmpdir(),`vscode-ipc-${a}.sock`),o(c),c}e.createRandomIPCHandle=f;function r(a,c,d){const P=k().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${d}-${c}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${d}-${c}.sock`):F=(0,T.join)(a,`${d}-${c}.sock`),o(F),F}e.createStaticIPCHandle=r;function o(a){const c=l[I.platform];typeof c=="number"&&a.length>=c&&console.warn(`WARNING: IPC handle "${a}" is longer than ${c} chars, try a shorter --user-data-dir`)}class n extends b.IPCServer{static toClientConnectionEvent(c){const d=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(d,P=>({protocol:new R.Protocol(new S(P,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(P,"close"))}))}constructor(c){super(n.toClientConnectionEvent(c)),this.server=c}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function i(a){return new Promise((c,d)=>{const P=k().net.createServer();P.on("error",d),P.listen(a,()=>{P.removeListener("error",d),c(new n(P))})})}e.serve=i;function s(a,c){return new Promise((d,P)=>{const F=k().net.createConnection(a,()=>{F.removeListener("error",P),d(R.Client.fromSocket(new S(F,`ipc-client${c}`),c))});F.once("error",P)})}e.connect=s}),define(we[149],ye([1,0,14,7,2,11]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function I(k){const S=k;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var p;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class b extends D.Disposable{constructor(S,y=Object.create(null)){super(),this.database=S,this.options=y,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=p.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((y,h)=>this.accept(h,y)),S.deleted?.forEach(y=>this.accept(y,void 0))}accept(S,y){if(this.state===p.Closed)return;let h=!1;(0,C.isUndefinedOrNull)(y)?h=this.cache.delete(S):this.cache.get(S)!==y&&(this.cache.set(S,y),h=!0),h&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===p.None&&(this.state=p.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,y){const h=this.cache.get(S);return(0,C.isUndefinedOrNull)(h)?y:h}getBoolean(S,y){const h=this.get(S);return(0,C.isUndefinedOrNull)(h)?y:h==="true"}getNumber(S,y){const h=this.get(S);return(0,C.isUndefinedOrNull)(h)?y:parseInt(h,10)}async set(S,y){if(this.state===p.Closed)return;if((0,C.isUndefinedOrNull)(y))return this.delete(S);const h=String(y);if(this.cache.get(S)!==h)return this.cache.set(S,h),this.pendingInserts.set(S,h),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===p.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=p.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class R{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((y,h)=>this.items.set(h,y)),S.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=R}),define(we[97],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(D,C){this.lineNumber=D,this.column=C}with(D=this.lineNumber,C=this.column){return D===this.lineNumber&&C===this.column?this:new v(D,C)}delta(D=0,C=0){return this.with(this.lineNumber+D,this.column+C)}equals(D){return v.equals(this,D)}static equals(D,C){return!D&&!C?!0:!!D&&!!C&&D.lineNumber===C.lineNumber&&D.column===C.column}isBefore(D){return v.isBefore(this,D)}static isBefore(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<C.column}isBeforeOrEqual(D){return v.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<=C.column}static compare(D,C){const T=D.lineNumber|0,I=C.lineNumber|0;if(T===I){const p=D.column|0,b=C.column|0;return p-b}return T-I}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new v(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=v}),define(we[49],ye([1,0,97]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(C,T,I,p){C>I||C===I&&T>p?(this.startLineNumber=I,this.startColumn=p,this.endLineNumber=C,this.endColumn=T):(this.startLineNumber=C,this.startColumn=T,this.endLineNumber=I,this.endColumn=p)}isEmpty(){return t.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return t.containsPosition(this,C)}static containsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<C.startColumn||T.lineNumber===C.endLineNumber&&T.column>C.endColumn)}static strictContainsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<=C.startColumn||T.lineNumber===C.endLineNumber&&T.column>=C.endColumn)}containsRange(C){return t.containsRange(this,C)}static containsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>C.endColumn)}strictContainsRange(C){return t.strictContainsRange(this,C)}static strictContainsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<=C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>=C.endColumn)}plusRange(C){return t.plusRange(this,C)}static plusRange(C,T){let I,p,b,R;return T.startLineNumber<C.startLineNumber?(I=T.startLineNumber,p=T.startColumn):T.startLineNumber===C.startLineNumber?(I=T.startLineNumber,p=Math.min(T.startColumn,C.startColumn)):(I=C.startLineNumber,p=C.startColumn),T.endLineNumber>C.endLineNumber?(b=T.endLineNumber,R=T.endColumn):T.endLineNumber===C.endLineNumber?(b=T.endLineNumber,R=Math.max(T.endColumn,C.endColumn)):(b=C.endLineNumber,R=C.endColumn),new t(I,p,b,R)}intersectRanges(C){return t.intersectRanges(this,C)}static intersectRanges(C,T){let I=C.startLineNumber,p=C.startColumn,b=C.endLineNumber,R=C.endColumn;const k=T.startLineNumber,S=T.startColumn,y=T.endLineNumber,h=T.endColumn;return I<k?(I=k,p=S):I===k&&(p=Math.max(p,S)),b>y?(b=y,R=h):b===y&&(R=Math.min(R,h)),I>b||I===b&&p>R?null:new t(I,p,b,R)}equalsRange(C){return t.equalsRange(this,C)}static equalsRange(C,T){return!!C&&!!T&&C.startLineNumber===T.startLineNumber&&C.startColumn===T.startColumn&&C.endLineNumber===T.endLineNumber&&C.endColumn===T.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(C){return new v.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(C){return new v.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,T){return new t(this.startLineNumber,this.startColumn,C,T)}setStartPosition(C,T){return new t(C,T,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(C){return new t(this.startLineNumber+C,this.startColumn,this.endLineNumber+C,this.endColumn)}static collapseToStart(C){return new t(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,T=C){return new t(C.lineNumber,C.column,T.lineNumber,T.column)}static lift(C){return C?new t(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn)}static areIntersecting(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,T){if(C&&T){const b=C.startLineNumber|0,R=T.startLineNumber|0;if(b===R){const k=C.startColumn|0,S=T.startColumn|0;if(k===S){const y=C.endLineNumber|0,h=T.endLineNumber|0;if(y===h){const w=C.endColumn|0,E=T.endColumn|0;return w-E}return y-h}return k-S}return b-R}return(C?1:0)-(T?1:0)}static compareRangesUsingEnds(C,T){return C.endLineNumber===T.endLineNumber?C.endColumn===T.endColumn?C.startLineNumber===T.startLineNumber?C.startColumn-T.startColumn:C.startLineNumber-T.startLineNumber:C.endColumn-T.endColumn:C.endLineNumber-T.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[150],ye([1,0,7,2]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,p){return this._map.set(I,p),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===p&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,p){this._factories.get(I)?.dispose();const b=new C(this,I,p);return this._factories.set(I,b),(0,t.toDisposable)(()=>{const R=this._factories.get(I);!R||R!==b||(this._factories.delete(I),R.dispose())})}async getOrCreate(I){const p=this.get(I);if(p)return p;const b=this._factories.get(I);return!b||b.isResolved?null:(await b.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const b=this._factories.get(I);return!!(!b||b.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class C extends t.Disposable{get isResolved(){return this._isResolved}constructor(I,p,b){super(),this._registry=I,this._languageId=p,this._factory=b,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(we[151],ye([1,0,41,4,49,150]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class T{constructor(P,F,$){this._tokenBrand=void 0,this.offset=P,this.type=F,this.language=$}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=T;class I{constructor(P,F){this._tokenizationResultBrand=void 0,this.tokens=P,this.endState=F}}e.TokenizationResult=I;class p{constructor(P,F){this._encodedTokenizationResultBrand=void 0,this.tokens=P,this.endState=F}}e.EncodedTokenizationResult=p;var b;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(d){const P=new Map;P.set(0,v.Codicon.symbolMethod),P.set(1,v.Codicon.symbolFunction),P.set(2,v.Codicon.symbolConstructor),P.set(3,v.Codicon.symbolField),P.set(4,v.Codicon.symbolVariable),P.set(5,v.Codicon.symbolClass),P.set(6,v.Codicon.symbolStruct),P.set(7,v.Codicon.symbolInterface),P.set(8,v.Codicon.symbolModule),P.set(9,v.Codicon.symbolProperty),P.set(10,v.Codicon.symbolEvent),P.set(11,v.Codicon.symbolOperator),P.set(12,v.Codicon.symbolUnit),P.set(13,v.Codicon.symbolValue),P.set(15,v.Codicon.symbolEnum),P.set(14,v.Codicon.symbolConstant),P.set(15,v.Codicon.symbolEnum),P.set(16,v.Codicon.symbolEnumMember),P.set(17,v.Codicon.symbolKeyword),P.set(27,v.Codicon.symbolSnippet),P.set(18,v.Codicon.symbolText),P.set(19,v.Codicon.symbolColor),P.set(20,v.Codicon.symbolFile),P.set(21,v.Codicon.symbolReference),P.set(22,v.Codicon.symbolCustomColor),P.set(23,v.Codicon.symbolFolder),P.set(24,v.Codicon.symbolTypeParameter),P.set(25,v.Codicon.account),P.set(26,v.Codicon.issues);function F(J){let _=P.get(J);return _||(console.info("No codicon found for CompletionItemKind "+J),_=v.Codicon.symbolProperty),_}d.toIcon=F;const $=new Map;$.set("method",0),$.set("function",1),$.set("constructor",2),$.set("field",3),$.set("variable",4),$.set("class",5),$.set("struct",6),$.set("interface",7),$.set("module",8),$.set("property",9),$.set("event",10),$.set("operator",11),$.set("unit",12),$.set("value",13),$.set("constant",14),$.set("enum",15),$.set("enum-member",16),$.set("enumMember",16),$.set("keyword",17),$.set("snippet",27),$.set("text",18),$.set("color",19),$.set("file",20),$.set("reference",21),$.set("customcolor",22),$.set("folder",23),$.set("type-parameter",24),$.set("typeParameter",24),$.set("account",25),$.set("issue",26);function Z(J,_){let ee=$.get(J);return typeof ee>"u"&&!_&&(ee=9),ee}d.fromString=Z})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(d){d[d.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var h;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(h=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var E;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(E=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(d){return d&&t.URI.isUri(d.uri)&&D.Range.isIRange(d.range)&&(D.Range.isIRange(d.originSelectionRange)||D.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=m;var u;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var l;(function(d){d[d.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var f;(function(d){const P=new Map;P.set(0,v.Codicon.symbolFile),P.set(1,v.Codicon.symbolModule),P.set(2,v.Codicon.symbolNamespace),P.set(3,v.Codicon.symbolPackage),P.set(4,v.Codicon.symbolClass),P.set(5,v.Codicon.symbolMethod),P.set(6,v.Codicon.symbolProperty),P.set(7,v.Codicon.symbolField),P.set(8,v.Codicon.symbolConstructor),P.set(9,v.Codicon.symbolEnum),P.set(10,v.Codicon.symbolInterface),P.set(11,v.Codicon.symbolFunction),P.set(12,v.Codicon.symbolVariable),P.set(13,v.Codicon.symbolConstant),P.set(14,v.Codicon.symbolString),P.set(15,v.Codicon.symbolNumber),P.set(16,v.Codicon.symbolBoolean),P.set(17,v.Codicon.symbolArray),P.set(18,v.Codicon.symbolObject),P.set(19,v.Codicon.symbolKey),P.set(20,v.Codicon.symbolNull),P.set(21,v.Codicon.symbolEnumMember),P.set(22,v.Codicon.symbolStruct),P.set(23,v.Codicon.symbolEvent),P.set(24,v.Codicon.symbolOperator),P.set(25,v.Codicon.symbolTypeParameter);function F($){let Z=P.get($);return Z||(console.info("No codicon found for SymbolKind "+$),Z=v.Codicon.symbolProperty),Z}d.toIcon=F})(f=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(P){this.value=P}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var o;(function(d){function P(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}d.is=P})(o=e.Command||(e.Command={}));var n;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(d){d[d.Unresolved=0]="Unresolved",d[d.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var a;(function(d){d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new C.TokenizationRegistry;var c;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(c=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[152],ye([9,10]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(we[153],ye([1,0,152]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,C=D*24,T=C*7,I=C*30,p=C*365;function b(k,S,y){typeof k!="number"&&(k=k.getTime());const h=Math.round((new Date().getTime()-k)/1e3);if(h<-30)return(0,v.localize)(0,null,b(new Date().getTime()+h*1e3,!1));if(h<30)return(0,v.localize)(1,null);let w;return h<t?(w=h,S?w===1?y?(0,v.localize)(2,null,w):(0,v.localize)(3,null,w):y?(0,v.localize)(4,null,w):(0,v.localize)(5,null,w):w===1?y?(0,v.localize)(6,null,w):(0,v.localize)(7,null,w):y?(0,v.localize)(8,null,w):(0,v.localize)(9,null,w)):h<D?(w=Math.floor(h/t),S?w===1?y?(0,v.localize)(10,null,w):(0,v.localize)(11,null,w):y?(0,v.localize)(12,null,w):(0,v.localize)(13,null,w):w===1?y?(0,v.localize)(14,null,w):(0,v.localize)(15,null,w):y?(0,v.localize)(16,null,w):(0,v.localize)(17,null,w)):h<C?(w=Math.floor(h/D),S?w===1?y?(0,v.localize)(18,null,w):(0,v.localize)(19,null,w):y?(0,v.localize)(20,null,w):(0,v.localize)(21,null,w):w===1?y?(0,v.localize)(22,null,w):(0,v.localize)(23,null,w):y?(0,v.localize)(24,null,w):(0,v.localize)(25,null,w)):h<T?(w=Math.floor(h/C),S?w===1?(0,v.localize)(26,null,w):(0,v.localize)(27,null,w):w===1?(0,v.localize)(28,null,w):(0,v.localize)(29,null,w)):h<I?(w=Math.floor(h/T),S?w===1?y?(0,v.localize)(30,null,w):(0,v.localize)(31,null,w):y?(0,v.localize)(32,null,w):(0,v.localize)(33,null,w):w===1?y?(0,v.localize)(34,null,w):(0,v.localize)(35,null,w):y?(0,v.localize)(36,null,w):(0,v.localize)(37,null,w)):h<p?(w=Math.floor(h/I),S?w===1?y?(0,v.localize)(38,null,w):(0,v.localize)(39,null,w):y?(0,v.localize)(40,null,w):(0,v.localize)(41,null,w):w===1?y?(0,v.localize)(42,null,w):(0,v.localize)(43,null,w):y?(0,v.localize)(44,null,w):(0,v.localize)(45,null,w)):(w=Math.floor(h/p),S?w===1?y?(0,v.localize)(46,null,w):(0,v.localize)(47,null,w):y?(0,v.localize)(48,null,w):(0,v.localize)(49,null,w):w===1?y?(0,v.localize)(50,null,w):(0,v.localize)(51,null,w):y?(0,v.localize)(52,null,w):(0,v.localize)(53,null,w))}e.fromNow=b;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(we[154],ye([9,10]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(we[38],ye([1,0,18,11,154]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(k,S){return S&&(k.stack||k.stacktrace)?D.localize(0,null,I(k),T(k.stack)||T(k.stacktrace)):I(k)}function T(k){return Array.isArray(k)?k.join(`
`):k}function I(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function p(k=null,S=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const y=v.coalesce(k),h=p(y[0],S);return y.length>1?D.localize(4,null,h,y.length):h}if(t.isString(k))return k;if(k.detail){const y=k.detail;if(y.error)return C(y.error,S);if(y.exception)return C(y.exception,S)}return k.stack?C(k,S):k.message?k.message:D.localize(5,null)}e.toErrorMessage=p;function b(k){const S=k;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=b;function R(k,S){let y;return typeof k=="string"?y=new Error(k):y=k,y.actions=S,y}e.createErrorWithActions=R}),define(we[155],ye([9,10]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(we[156],ye([1,0,155]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(D){switch(D){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(we[157],ye([9,10]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(we[158],ye([9,10]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[159],ye([9,10]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(we[160],ye([9,10]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(we[161],ye([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[162],ye([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[163],ye([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(we[164],ye([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(we[165],ye([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[166],ye([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[167],ye([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[168],ye([9,10]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[169],ye([9,10]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(we[170],ye([9,10]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(we[171],ye([9,10]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(we[172],ye([9,10]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[173],ye([9,10]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[174],ye([9,10]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(we[175],ye([9,10]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(we[176],ye([9,10]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(we[177],ye([9,10]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[178],ye([9,10]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[179],ye([9,10]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[180],ye([9,10]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(we[181],ye([9,10]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(we[182],ye([9,10]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(we[183],ye([9,10]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(we[184],ye([9,10]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[185],ye([9,10]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(we[186],ye([1,0,7,2]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(I,p,b){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(I,p,b){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends t.Disposable{constructor(I){super(),this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,p,b){this.channel.call("attach",[I,p,b])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,p){this.channel.call("terminate",[I,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,p){return this.channel.call("openExtensionDevelopmentHostWindow",[I,p])}}e.ExtensionHostDebugChannelClient=C}),define(we[187],ye([1,0,4]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(T){this.service=T}listen(T,I,p){throw new Error("Invalid listen")}call(T,I,p){switch(I){case"download":return this.service.download(v.URI.revive(p[0]),v.URI.revive(p[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class D{constructor(T,I){this.channel=T,this.getUriTransformer=I}async download(T,I){const p=this.getUriTransformer();p&&(T=p.transformOutgoingURI(T),I=p.transformOutgoingURI(I)),await this.channel.call("download",[T,I])}}e.DownloadServiceChannelClient=D}),define(we[188],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(D){this.machineId=D}encryption(){return new Promise((D,C)=>oe(["vscode-encrypt"],D,C))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=v}),define(we[98],ye([1,0,153,83,12,6,27,19,4]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",oe).fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return p.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(p.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,C.join)(w,"argv.json")):(0,I.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,C.resolve)(w):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",oe).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=this.args["extensions-download-dir"];return w?(0,C.resolve)(w):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,C.resolve)(w);const E=T.env.VSCODE_EXTENSIONS;if(E)return E;const g=T.env.VSCODE_PORTABLE;return g?(0,C.join)(g,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(E=>/^[^:/?#]+?:\/\//.test(E)?p.URI.parse(E):p.URI.file((0,C.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,C.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return p.URI.file((0,C.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,C.join)(w,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this._args}constructor(w,E,g){this._args=w,this.paths=E,this.productService=g,this.editSessionId=this.args.editSessionId}}Re([t.memoize],b.prototype,"appRoot",null),Re([t.memoize],b.prototype,"userHome",null),Re([t.memoize],b.prototype,"userDataPath",null),Re([t.memoize],b.prototype,"appSettingsHome",null),Re([t.memoize],b.prototype,"tmpDir",null),Re([t.memoize],b.prototype,"cacheHome",null),Re([t.memoize],b.prototype,"stateResource",null),Re([t.memoize],b.prototype,"userRoamingDataHome",null),Re([t.memoize],b.prototype,"userDataSyncHome",null),Re([t.memoize],b.prototype,"userDataSyncLogResource",null),Re([t.memoize],b.prototype,"editSessionsLogResource",null),Re([t.memoize],b.prototype,"sync",null),Re([t.memoize],b.prototype,"machineSettingsResource",null),Re([t.memoize],b.prototype,"workspaceStorageHome",null),Re([t.memoize],b.prototype,"localHistoryHome",null),Re([t.memoize],b.prototype,"keyboardLayoutResource",null),Re([t.memoize],b.prototype,"argvResource",null),Re([t.memoize],b.prototype,"isExtensionDevelopment",null),Re([t.memoize],b.prototype,"untitledWorkspacesHome",null),Re([t.memoize],b.prototype,"installSourcePath",null),Re([t.memoize],b.prototype,"builtinExtensionsPath",null),Re([t.memoize],b.prototype,"extensionsPath",null),Re([t.memoize],b.prototype,"extensionDevelopmentLocationURI",null),Re([t.memoize],b.prototype,"extensionDevelopmentKind",null),Re([t.memoize],b.prototype,"extensionTestsLocationURI",null),Re([t.memoize],b.prototype,"debugExtensionHost",null),Re([t.memoize],b.prototype,"serviceMachineIdResource",null),Re([t.memoize],b.prototype,"telemetryLogResource",null),Re([t.memoize],b.prototype,"disableWorkspaceTrust",null),Re([t.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function R(h,w){return y(h["inspect-extensions"],h["inspect-brk-extensions"],5870,w,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=R;function k(h,w){return y(h["inspect-search"],h["inspect-brk-search"],5876,w,h.extensionEnvironment)}e.parseSearchPort=k;function S(h,w){return y(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,w,h.extensionEnvironment)}e.parsePtyHostPort=S;function y(h,w,E,g,m,u){const f=Number(w||h)||(g?null:E),r=f?Boolean(!!w):!1;let o;if(u)try{o=JSON.parse(u)}catch{}return{port:f,break:r,debugId:m,env:o}}}),define(we[58],ye([1,0,268,3,159]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,D.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},category:{type:"string",cat:"e",description:(0,D.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(h,w,E=T){const g={},m=["_"],u=[];for(const o in w){const n=w[o];n.alias&&(g[o]=n.alias),n.type==="string"||n.type==="string[]"?(m.push(o),n.deprecates&&m.push(...n.deprecates)):n.type==="boolean"&&(u.push(o),n.deprecates&&u.push(...n.deprecates))}const l=v(h,{string:m,boolean:u,alias:g}),f={},r=l;f._=l._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in w){const n=w[o];n.alias&&delete r[n.alias];let i=r[o];if(n.deprecates)for(const s of n.deprecates)r.hasOwnProperty(s)&&(i||(i=r[s],i&&E.onDeprecatedOption(s,n.deprecationMessage||(0,D.localize)(35,null,o))),delete r[s]);if(typeof i<"u"){if(n.type==="string[]"){if(Array.isArray(i)||(i=[i]),!n.allowEmptyValue){const s=i.filter(a=>a.length>0);s.length!==i.length&&(E.onEmptyValue(o),i=s.length>0?s:void 0)}}else n.type==="string"&&(Array.isArray(i)?(i=i.pop(),E.onMultipleValues(o,i)):!i&&!n.allowEmptyValue&&(E.onEmptyValue(o),i=void 0));f[o]=i,n.deprecationMessage&&E.onDeprecatedOption(o,n.deprecationMessage)}delete r[o]}for(const o in r)E.onUnknownOption(o);return f}e.parseArgs=I;function p(h,w){let E="";return w.args&&(Array.isArray(w.args)?E=` <${w.args.join("> <")}>`:E=` <${w.args}>`),w.alias?`-${w.alias} --${h}${E}`:`--${h}${E}`}function b(h,w){let E=0;const g=[];for(const f in h){const r=h[f],o=p(f,r);E=Math.max(E,o.length),g.push([o,r.description])}const m=E+2+1;if(w-m<25)return g.reduce((f,r)=>f.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const u=w-m-1,l=[];for(const f of g){const r=f[0],o=k(f[1],u),n=R(m-r.length-2);l.push("  "+r+n+o[0]);for(let i=1;i<o.length;i++)l.push(R(m)+o[i])}return l}e.formatOptions=b;function R(h){return" ".repeat(h)}function k(h,w){const E=[];for(;h.length;){const g=h.length<w?h.length:h.lastIndexOf(" ",w),m=h.slice(0,g).trim();h=h.slice(g),E.push(m)}return E}function S(h,w,E,g,m){const u=process.stdout.isTTY&&process.stdout.columns||80,l=m?.noInputFiles!==!0?`[${(0,D.localize)(36,null)}...]`:"",f=[`${h} ${E}`];f.push(""),f.push(`${(0,D.localize)(37,null)}: ${w} [${(0,D.localize)(38,null)}]${l}`),f.push(""),m?.noPipe!==!0&&(t.isWindows?f.push((0,D.localize)(39,null,w)):f.push((0,D.localize)(40,null,w)),f.push(""));const r={};for(const o in g){const n=g[o];if(n.description&&n.cat){let i=r[n.cat];i||(r[n.cat]=i={}),i[o]=n}}for(const o in r){const n=o,i=r[n];i&&(f.push(C[n]),f.push(...b(i,u)),f.push(""))}return f.join(`
`)}e.buildHelpMessage=S;function y(h,w){return`${h||(0,D.localize)(41,null)}
${w||(0,D.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=y}),define(we[189],ye([1,0,269,160,58]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function T(S,y){const h={onUnknownOption:E=>{console.warn((0,t.localize)(0,null,E))},onMultipleValues:(E,g)=>{console.warn((0,t.localize)(1,null,E,g))},onEmptyValue:E=>{console.warn((0,t.localize)(2,null,E))},onDeprecatedOption:(E,g)=>{console.warn((0,t.localize)(3,null,E,g))}},w=(0,D.parseArgs)(S,D.OPTIONS,y?h:void 0);return w.goto&&w._.forEach(E=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,t.localize)(4,null))),w["max-memory"]&&v(parseInt(w["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),w}function I(S){const y=S.findIndex(h=>!/^-/.test(h));if(y>-1)return[...S.slice(0,y),...S.slice(y+1)]}function p(S){let[,...y]=S;process.env.VSCODE_DEV&&(y=I(y)||[]);const h=!k(process.env);return T(y,h)}e.parseMainProcessArgv=p;function b(S){const[,,...y]=S;return T(y,!0)}e.parseCLIProcessArgv=b;function R(S,...y){const h=S.indexOf("--");return h===-1?S.push(...y):S.splice(h,0,...y),S}e.addArg=R;function k(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function oe(e,v,t){function D(T,I){const p=C(T,I),b=[p];return e.isAbsolute(p)||b.unshift(t),e.resolve(...b)}function C(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,I);const R=T["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(k,"AppData","Roaming")}break;case"darwin":b=e.join(v.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,I)}return{getUserDataPath:D}}if(typeof define=="function")define(we[190],ye([89,28,27]),function(e,v,t){return oe(e,v,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("os");module.exports=oe(e,v,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[191],ye([1,0,28,98,190]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends t.AbstractNativeEnvironmentService{constructor(I,p){super(I,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I,p.nameShort)},p)}}e.NativeEnvironmentService=C}),define(we[192],ye([1,0,11,164]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(T,I,p){try{C(T,I,p)}catch{}return T}e.localizeManifest=D;function C(T,I,p){const b=(R,k,S)=>{const y=R[k];if((0,v.isString)(y)){const h=y,w=h.length;if(w>1&&h[0]==="%"&&h[w-1]==="%"){const E=h.substr(1,w-2);let g=I[E];g===void 0&&p&&(g=p[E]);const m=typeof g=="string"?g:g.message;if(m!==void 0){const u=p?.[E],l=typeof u=="string"?u:u?.message;if(S&&(k==="title"||k==="category")&&l&&l!==m){const f={value:m,original:l};R[k]=f}else R[k]=m}else console.warn(`[${T.name}]: ${(0,t.localize)(0,null,E)}`)}}else if((0,v.isObject)(y))for(const h in y)y.hasOwnProperty(h)&&(h==="commands"?b(y,h,!0):b(y,h,S));else if(Array.isArray(y))for(let h=0;h<y.length;h++)b(y,h,S)};for(const R in T)T.hasOwnProperty(R)&&b(T,R)}}),define(we[70],ye([1,0,19,67,168,50]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function p(g){return g=g.trim(),g==="*"||T.test(g)}e.isValidVersionStr=p;function b(g){if(!p(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=g.match(T);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=b;function R(g){if(!g)return null;const m=g.majorBase,u=g.majorMustEqual,l=g.minorBase;let f=g.minorMustEqual;const r=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(m===0||(f=!1),o=!1);let n=0;if(g.preRelease){const i=I.exec(g.preRelease);if(i){const[,s,a,c]=i;n=Date.UTC(Number(s),Number(a)-1,Number(c))}}return{majorBase:m,majorMustEqual:u,minorBase:l,minorMustEqual:f,patchBase:r,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function k(g,m,u){let l;typeof g=="string"?l=R(b(g)):l=g;let f;m instanceof Date?f=m.getTime():typeof m=="string"&&(f=new Date(m).getTime());let r;if(typeof u=="string"?r=R(b(u)):r=u,!l||!r)return!1;const o=l.majorBase,n=l.minorBase,i=l.patchBase;let s=r.majorBase,a=r.minorBase,c=r.patchBase;const d=r.notBefore;let P=r.majorMustEqual,F=r.minorMustEqual,$=r.patchMustEqual;return r.isMinimum?o>s?!0:o<s?!1:n>a?!0:n<a||f&&f<d?!1:i>=c:(o===1&&s===0&&(!P||!F||!$)&&(s=1,a=0,c=0,P=!0,F=!1,$=!1),o<s?!1:o>s?!P:n<a?!1:n>a?!F:i<c?!1:i>c?!$:!(f&&f<d))}e.isValidVersion=k;function S(g,m,u,l,f){const r=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return r.push([t.default.Error,D.localize(0,null)]),r;if(typeof l.name!="string")return r.push([t.default.Error,D.localize(1,null,"name")]),r;if(typeof l.version!="string")return r.push([t.default.Error,D.localize(2,null,"version")]),r;if(!l.engines)return r.push([t.default.Error,D.localize(3,null,"engines")]),r;if(typeof l.engines.vscode!="string")return r.push([t.default.Error,D.localize(4,null,"engines.vscode")]),r;if(typeof l.extensionDependencies<"u"&&!E(l.extensionDependencies))return r.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),r;if(typeof l.activationEvents<"u"){if(!E(l.activationEvents))return r.push([t.default.Error,D.localize(6,null,"activationEvents")]),r;if(typeof l.main>"u"&&typeof l.browser>"u")return r.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),r}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&r.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return r.push([t.default.Error,D.localize(9,null,"main")]),r;{const i=(0,v.joinPath)(u,l.main);(0,v.isEqualOrParent)(i,u)||r.push([t.default.Warning,D.localize(10,null,i.path,u.path)])}if(typeof l.activationEvents>"u")return r.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),r}if(typeof l.browser<"u"){if(typeof l.browser!="string")return r.push([t.default.Error,D.localize(12,null,"browser")]),r;{const i=(0,v.joinPath)(u,l.browser);(0,v.isEqualOrParent)(i,u)||r.push([t.default.Warning,D.localize(13,null,i.path,u.path)])}if(typeof l.activationEvents>"u")return r.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),r}if(!C.valid(l.version))return r.push([t.default.Error,D.localize(15,null)]),r;const o=[];if(!y(g,m,l,f,o))for(const i of o)r.push([t.default.Error,i]);return r}e.validateExtensionManifest=S;function y(g,m,u,l,f){return l||typeof u.main>"u"&&typeof u.browser>"u"?!0:w(g,m,u.engines.vscode,f)}e.isValidExtensionVersion=y;function h(g,m,u){return g==="*"||w(m,u,g)}e.isEngineValid=h;function w(g,m,u,l=[]){const f=R(b(u));if(!f)return l.push(D.localize(16,null,u)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return l.push(D.localize(17,null,u)),!1}else if(!f.majorMustEqual)return l.push(D.localize(18,null,u)),!1;return k(g,m,f)?!0:(l.push(D.localize(19,null,g,u)),!1)}function E(g){if(!Array.isArray(g))return!1;for(let m=0,u=g.length;m<u;m++)if(typeof g[m]!="string")return!1;return!0}}),define(we[193],ye([1,0,16,23]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,T,I){let p=I&&I.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const R=(await T.readFile(C.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(R)?R:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await T.writeFile(C.serviceMachineIdResource,v.VSBuffer.fromString(p))}catch{}}return I?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=D}),define(we[59],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,C=[],T=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=v}),define(we[194],ye([1,0,59]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var D;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function C(I,p,b){p instanceof v.SyncDescriptor||(p=new v.SyncDescriptor(p,[],Boolean(b))),t.push([I,p])}e.registerSingleton=C;function T(){return t}e.getSingletonServiceDescriptors=T}),define(we[195],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(C,T){this.key=C,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=v;class t{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(const T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const I=this.lookupOrInsertNode(C),p=this.lookupOrInsertNode(T);I.outgoing.set(p.key,p),p.incoming.set(I.key,I)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(const I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let I=this._nodes.get(T);return I||(I=new v(T,C),this._nodes.set(T,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){const C=[];for(const[T,I]of this._nodes)C.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,T]of this._nodes){const I=new Set([C]),p=this._findCycle(T,I);if(p)return p}}_findCycle(C,T){for(const[I,p]of C.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const b=this._findCycle(p,T);if(b)return b;T.delete(I)}}}e.Graph=t}),define(we[5],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(T,I,p){I[v.DI_TARGET]===I?I[v.DI_DEPENDENCIES].push({id:T,index:p}):(I[v.DI_DEPENDENCIES]=[{id:T,index:p}],I[v.DI_TARGET]=I)}function D(T){if(v.serviceIds.has(T))return v.serviceIds.get(T);const I=function(p,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,p,R)};return I.toString=()=>T,v.serviceIds.set(T,I),I}e.createDecorator=D;function C(T){return T}e.refineServiceDecorator=C}),define(we[25],ye([1,0,11,4,5]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationOverrides=C;function T(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var I;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function b(g,m){const u=Object.create(null);for(const l in g)R(u,l,g[l],m);return u}e.toValuesTree=b;function R(g,m,u,l){const f=m.split("."),r=f.pop();let o=g;for(let n=0;n<f.length;n++){const i=f[n];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:l(`Ignoring ${m} as ${f.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[r]=u}catch{l(`Ignoring ${m} as ${f.join(".")} is ${JSON.stringify(o)}`)}else l(`Ignoring ${m} as ${f.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=R;function k(g,m){const u=m.split(".");S(g,u)}e.removeFromValueTree=k;function S(g,m){const u=m.shift();if(m.length===0){delete g[u];return}if(Object.keys(g).indexOf(u)!==-1){const l=g[u];typeof l=="object"&&!Array.isArray(l)&&(S(l,m),Object.keys(l).length===0&&delete g[u])}}function y(g,m,u){function l(o,n){let i=o;for(const s of n){if(typeof i!="object"||i===null)return;i=i[s]}return i}const f=m.split("."),r=l(g,f);return typeof r>"u"?u:r}e.getConfigurationValue=y;function h(g,m,u){Object.keys(m).forEach(l=>{l!=="__proto__"&&(l in g?v.isObject(g[l])&&v.isObject(m[l])?h(g[l],m[l],u):u&&(g[l]=m[l]):g[l]=m[l])})}e.merge=h;function w(g,m,u){const l=g.inspect(m),f=g.inspect(u);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:l.defaultValue}e.getMigratedSettingValue=w;function E(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(we[99],ye([1,0,3,15,5]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",v.isMacintosh),C.set("isLinux",v.isLinux),C.set("isWindows",v.isWindows),C.set("isWeb",v.isWeb),C.set("isMacNative",v.isMacintosh&&!v.isWeb),C.set("isEdge",v.isEdge),C.set("isFirefox",v.isFirefox),C.set("isChrome",v.isChrome),C.set("isSafari",v.isSafari);const T=Object.prototype.hasOwnProperty;var I;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class p{static false(){return k.INSTANCE}static true(){return S.INSTANCE}static has(_){return y.create(_)}static equals(_,ee){return h.create(_,ee)}static notEquals(_,ee){return g.create(_,ee)}static regex(_,ee){return n.create(_,ee)}static in(_,ee){return w.create(_,ee)}static notIn(_,ee){return E.create(_,ee)}static not(_){return m.create(_)}static and(..._){return a.create(_,null)}static or(..._){return c.create(_,null,!0)}static greater(_,ee){return l.create(_,ee)}static greaterEquals(_,ee){return f.create(_,ee)}static smaller(_,ee){return r.create(_,ee)}static smallerEquals(_,ee){return o.create(_,ee)}static deserialize(_,ee=!1){if(!!_)return this._deserializeOrExpression(_,ee)}static _deserializeOrExpression(_,ee){const ne=_.split("||");return c.create(ne.map(B=>this._deserializeAndExpression(B,ee)),null,!0)}static _deserializeAndExpression(_,ee){const ne=_.split("&&");return a.create(ne.map(B=>this._deserializeOne(B,ee)),null)}static _deserializeOne(_,ee){if(_=_.trim(),_.indexOf("!=")>=0){const ne=_.split("!=");return g.create(ne[0].trim(),this._deserializeValue(ne[1],ee))}if(_.indexOf("==")>=0){const ne=_.split("==");return h.create(ne[0].trim(),this._deserializeValue(ne[1],ee))}if(_.indexOf("=~")>=0){const ne=_.split("=~");return n.create(ne[0].trim(),this._deserializeRegexValue(ne[1],ee))}if(_.indexOf(" not in ")>=0){const ne=_.split(" not in ");return E.create(ne[0].trim(),ne[1].trim())}if(_.indexOf(" in ")>=0){const ne=_.split(" in ");return w.create(ne[0].trim(),ne[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const ne=_.split(">=");return f.create(ne[0].trim(),ne[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const ne=_.split(">");return l.create(ne[0].trim(),ne[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const ne=_.split("<=");return o.create(ne[0].trim(),ne[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const ne=_.split("<");return r.create(ne[0].trim(),ne[1].trim())}return/^\!\s*/.test(_)?m.create(_.substr(1).trim()):y.create(_)}static _deserializeValue(_,ee){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;const ne=/^'([^']*)'$/.exec(_);return ne?ne[1].trim():_}static _deserializeRegexValue(_,ee){if((0,t.isFalsyOrWhitespace)(_)){if(ee)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const ne=_.indexOf("/"),B=_.lastIndexOf("/");if(ne===B||ne<0){if(ee)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}const ue=_.slice(ne+1,B),z=_[B+1]==="i"?"i":"";try{return new RegExp(ue,z)}catch(X){if(ee)throw new Error(`bad regexp-value '${_}', parse error: ${X}`);return console.warn(`bad regexp-value '${_}', parse error: ${X}`),null}}}e.ContextKeyExpr=p;function b(J,_){const ee=J?J.substituteConstants():void 0,ne=_?_.substituteConstants():void 0;return!ee&&!ne?!0:!ee||!ne?!1:ee.equals(ne)}e.expressionsAreEqualWithConstantSubstitution=b;function R(J,_){return J.cmp(_)}class k{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class S{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class y{static create(_,ee=null){const ne=C.get(_);return typeof ne=="boolean"?ne?S.INSTANCE:k.INSTANCE:new y(_,ee)}constructor(_,ee){this.key=_,this.negated=ee,this.type=2}cmp(_){return _.type!==this.type?this.type-_.type:P(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=C.get(this.key);return typeof _=="boolean"?_?S.INSTANCE:k.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class h{static create(_,ee,ne=null){if(typeof ee=="boolean")return ee?y.create(_,ne):m.create(_,ne);const B=C.get(_);return typeof B=="boolean"?ee===(B?"true":"false")?S.INSTANCE:k.INSTANCE:new h(_,ee,ne)}constructor(_,ee,ne){this.key=_,this.value=ee,this.negated=ne,this.type=4}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=C.get(this.key);if(typeof _=="boolean"){const ee=_?"true":"false";return this.value===ee?S.INSTANCE:k.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class w{static create(_,ee){return new w(_,ee)}constructor(_,ee){this.key=_,this.valueKey=ee,this.type=10,this.negated=null}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const ee=_.getValue(this.valueKey),ne=_.getValue(this.key);return Array.isArray(ee)?ee.includes(ne):typeof ne=="string"&&typeof ee=="object"&&ee!==null?T.call(ee,ne):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=w;class E{static create(_,ee){return new E(_,ee)}constructor(_,ee){this.key=_,this.valueKey=ee,this.type=11,this._negated=w.create(_,ee)}cmp(_){return _.type!==this.type?this.type-_.type:this._negated.cmp(_._negated)}equals(_){return _.type===this.type?this._negated.equals(_._negated):!1}substituteConstants(){return this}evaluate(_){return!this._negated.evaluate(_)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(_){return _.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=E;class g{static create(_,ee,ne=null){if(typeof ee=="boolean")return ee?m.create(_,ne):y.create(_,ne);const B=C.get(_);return typeof B=="boolean"?ee===(B?"true":"false")?k.INSTANCE:S.INSTANCE:new g(_,ee,ne)}constructor(_,ee,ne){this.key=_,this.value=ee,this.negated=ne,this.type=5}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=C.get(this.key);if(typeof _=="boolean"){const ee=_?"true":"false";return this.value===ee?k.INSTANCE:S.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class m{static create(_,ee=null){const ne=C.get(_);return typeof ne=="boolean"?ne?k.INSTANCE:S.INSTANCE:new m(_,ee)}constructor(_,ee){this.key=_,this.negated=ee,this.type=3}cmp(_){return _.type!==this.type?this.type-_.type:P(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=C.get(this.key);return typeof _=="boolean"?_?k.INSTANCE:S.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function u(J,_){if(typeof J=="string"){const ee=parseFloat(J);isNaN(ee)||(J=ee)}return typeof J=="string"||typeof J=="number"?_(J):k.INSTANCE}class l{static create(_,ee,ne=null){return u(ee,B=>new l(_,B,ne))}constructor(_,ee,ne){this.key=_,this.value=ee,this.negated=ne,this.type=12}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class f{static create(_,ee,ne=null){return u(ee,B=>new f(_,B,ne))}constructor(_,ee,ne){this.key=_,this.value=ee,this.negated=ne,this.type=13}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=f;class r{static create(_,ee,ne=null){return u(ee,B=>new r(_,B,ne))}constructor(_,ee,ne){this.key=_,this.value=ee,this.negated=ne,this.type=14}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class o{static create(_,ee,ne=null){return u(ee,B=>new o(_,B,ne))}constructor(_,ee,ne){this.key=_,this.value=ee,this.negated=ne,this.type=15}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class n{static create(_,ee){return new n(_,ee)}constructor(_,ee){this.key=_,this.regexp=ee,this.type=7,this.negated=null}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const ee=this.regexp?this.regexp.source:"",ne=_.regexp?_.regexp.source:"";return ee<ne?-1:ee>ne?1:0}equals(_){if(_.type===this.type){const ee=this.regexp?this.regexp.source:"",ne=_.regexp?_.regexp.source:"";return this.key===_.key&&ee===ne}return!1}substituteConstants(){return this}evaluate(_){const ee=_.getValue(this.key);return this.regexp?this.regexp.test(ee):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{static create(_){return new i(_)}constructor(_){this._actual=_,this.type=8}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new i(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(J){let _=null;for(let ee=0,ne=J.length;ee<ne;ee++){const B=J[ee].substituteConstants();if(J[ee]!==B&&_===null){_=[];for(let ue=0;ue<ee;ue++)_[ue]=J[ue]}_!==null&&(_[ee]=B)}return _===null?J:_}class a{static create(_,ee){return a._normalizeArr(_,ee)}constructor(_,ee){this.expr=_,this.negated=ee,this.type=6}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let ee=0,ne=this.expr.length;ee<ne;ee++){const B=R(this.expr[ee],_.expr[ee]);if(B!==0)return B}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let ee=0,ne=this.expr.length;ee<ne;ee++)if(!this.expr[ee].equals(_.expr[ee]))return!1;return!0}return!1}substituteConstants(){const _=s(this.expr);return _===this.expr?this:a.create(_,this.negated)}evaluate(_){for(let ee=0,ne=this.expr.length;ee<ne;ee++)if(!this.expr[ee].evaluate(_))return!1;return!0}static _normalizeArr(_,ee){const ne=[];let B=!1;for(const ue of _)if(!!ue){if(ue.type===1){B=!0;continue}if(ue.type===0)return k.INSTANCE;if(ue.type===6){ne.push(...ue.expr);continue}ne.push(ue)}if(ne.length===0&&B)return S.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(R);for(let ue=1;ue<ne.length;ue++)ne[ue-1].equals(ne[ue])&&(ne.splice(ue,1),ue--);if(ne.length===1)return ne[0];for(;ne.length>1;){const ue=ne[ne.length-1];if(ue.type!==9)break;ne.pop();const z=ne.pop(),X=ne.length===0,O=c.create(ue.expr.map(U=>a.create([U,z],null)),null,X);O&&(ne.push(O),ne.sort(R))}return ne.length===1?ne[0]:new a(ne,ee)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(const ee of this.expr)_.push(...ee.keys());return _}map(_){return new a(this.expr.map(ee=>ee.map(_)),null)}negate(){if(!this.negated){const _=[];for(const ee of this.expr)_.push(ee.negate());this.negated=c.create(_,this,!0)}return this.negated}}class c{static create(_,ee,ne){return c._normalizeArr(_,ee,ne)}constructor(_,ee){this.expr=_,this.negated=ee,this.type=9}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let ee=0,ne=this.expr.length;ee<ne;ee++){const B=R(this.expr[ee],_.expr[ee]);if(B!==0)return B}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let ee=0,ne=this.expr.length;ee<ne;ee++)if(!this.expr[ee].equals(_.expr[ee]))return!1;return!0}return!1}substituteConstants(){const _=s(this.expr);return _===this.expr?this:c.create(_,this.negated,!1)}evaluate(_){for(let ee=0,ne=this.expr.length;ee<ne;ee++)if(this.expr[ee].evaluate(_))return!0;return!1}static _normalizeArr(_,ee,ne){let B=[],ue=!1;if(_){for(let z=0,X=_.length;z<X;z++){const O=_[z];if(!!O){if(O.type===0){ue=!0;continue}if(O.type===1)return S.INSTANCE;if(O.type===9){B=B.concat(O.expr);continue}B.push(O)}}if(B.length===0&&ue)return k.INSTANCE;B.sort(R)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(ne){for(let z=0;z<B.length;z++)for(let X=z+1;X<B.length;X++)$(B[z],B[X])&&(B.splice(X,1),X--);if(B.length===1)return B[0]}return new c(B,ee)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(const ee of this.expr)_.push(...ee.keys());return _}map(_){return new c(this.expr.map(ee=>ee.map(_)),null)}negate(){if(!this.negated){const _=[];for(const ee of this.expr)_.push(ee.negate());for(;_.length>1;){const ee=_.shift(),ne=_.shift(),B=[];for(const z of Z(ee))for(const X of Z(ne))B.push(a.create([z,X],null));const ue=_.length===0;_.unshift(c.create(B,null,ue))}this.negated=_[0]}return this.negated}}class d extends y{static all(){return d._info.values()}constructor(_,ee,ne){super(_,null),this._defaultValue=ee,typeof ne=="object"?d._info.push({...ne,key:_}):ne!==!0&&d._info.push({key:_,description:ne,type:ee!=null?typeof ee:void 0})}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return h.create(this.key,_)}notEqualsTo(_){return g.create(this.key,_)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(J,_){return J<_?-1:J>_?1:0}function F(J,_,ee,ne){return J<ee?-1:J>ee?1:_<ne?-1:_>ne?1:0}function $(J,_){if(_.type===6&&J.type!==9&&J.type!==6){for(const B of _.expr)if(J.equals(B))return!0}const ee=J.negate(),ne=Z(ee).concat(Z(_));ne.sort(R);for(let B=0;B<ne.length;B++){const z=ne[B].negate();for(let X=B+1;X<ne.length;X++){const O=ne[X];if(z.equals(O))return!0}}return!1}e.implies=$;function Z(J){return J.type===9?J.expr:[J]}}),define(we[71],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(C,T){return this.secretVault[C]?.[T]??null}async setPassword(C,T,I){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][T]=I}async deletePassword(C,T){return this.secretVault[C]?.[T]?(delete this.secretVault[C][T],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const T=[];for(const I of Object.keys(this.secretVault[C]||{}))T.push({account:I,password:this.secretVault[C][I]});return T}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(we[196],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=D}),define(we[72],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,v.createDecorator)("downloadService")}),define(we[197],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(we[29],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(we[31],ye([1,0,162,5]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function C(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function T(g,m){switch(g){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function I(g,m){return m==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function p(g,m,u){return I(m,u)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===u?!0:b(u).includes(g)}e.isTargetPlatformCompatible=p;function b(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function R(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=R;var k;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var S;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Install="install",g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var h;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var w;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(m,u){super(m),this.code=u,this.name=u}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(we[198],ye([1,0,7,2,46,22,4,69,31]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(E,g){return T.URI.revive(g?g.transformIncoming(E):E)}function R(E,g){return g?g.transformOutgoingURI(E):E}function k(E,g){g=g||I.DefaultURITransformer;const m=E.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...E,manifest:void 0},g),manifest:m}}function S(E,g){return g?(0,C.cloneAndChange)(E,m=>m instanceof T.URI?g.transformOutgoingURI(m):void 0):E}class y{constructor(g,m){this.service=g,this.getUriTransformer=m,this.onInstallExtension=v.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=v.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=v.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,m){const u=this.getUriTransformer(g);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return v.Event.map(this.onDidInstallExtensions,l=>l.map(f=>({...f,local:f.local?S(f.local,u):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,m,u){const l=this.getUriTransformer(g);switch(m){case"zip":return this.service.zip(k(u[0],l)).then(f=>R(f,l));case"unzip":return this.service.unzip(b(u[0],l));case"install":return this.service.install(b(u[0],l),(0,D.revive)(u[1]));case"getManifest":return this.service.getManifest(b(u[0],l));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],(0,D.revive)(u[1]));case"uninstall":return this.service.uninstall(k(u[0],l),(0,D.revive)(u[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(k(u[0],l));case"getInstalled":return this.service.getInstalled(u[0],T.URI.revive(u[1])).then(f=>f.map(r=>S(r,l)));case"getMetadata":return this.service.getMetadata(k(u[0],l));case"updateMetadata":return this.service.updateMetadata(k(u[0],l),u[1]).then(f=>S(f,l));case"updateExtensionScope":return this.service.updateExtensionScope(k(u[0],l),u[1]).then(f=>S(f,l));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class h extends t.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(g){super(),this.channel=g,this._onInstallExtension=this._register(new v.Emitter),this._onDidInstallExtensions=this._register(new v.Emitter),this._onUninstallExtension=this._register(new v.Emitter),this._onDidUninstallExtension=this._register(new v.Emitter),this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source,profileLocation:T.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(u=>({...u,local:u.local?k(u.local,null):u.local,source:this.isUriComponents(u.source)?T.URI.revive(u.source):u.source,profileLocation:T.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire({identifier:m.identifier,profileLocation:T.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire({...m,profileLocation:T.URI.revive(m.profileLocation)})))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const m=await this.getTargetPlatform();return g.allTargetPlatforms.some(u=>(0,p.isTargetPlatformCompatible)(u,g.allTargetPlatforms,m))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(m=>T.URI.revive(m)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,m){return Promise.resolve(this.channel.call("install",[g,m])).then(u=>k(u,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,m){return Promise.resolve(this.channel.call("installFromGallery",[g,m])).then(u=>k(u,null))}uninstall(g,m){return Promise.resolve(this.channel.call("uninstall",[g,m]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null,m){return Promise.resolve(this.channel.call("getInstalled",[g,m])).then(u=>u.map(l=>k(l,null)))}getMetadata(g){return Promise.resolve(this.channel.call("getMetadata",[g]))}updateMetadata(g,m){return Promise.resolve(this.channel.call("updateMetadata",[g,m])).then(u=>k(u,null))}updateExtensionScope(g,m){return Promise.resolve(this.channel.call("updateExtensionScope",[g,m])).then(u=>k(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class w{constructor(g){this.service=g}listen(g,m){throw new Error("Invalid listen")}call(g,m,u){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=w}),define(we[17],ye([1,0,24,6,15,11,4,170,5]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function b(z){return z.create===!0}e.isFileOpenForWriteOptions=b;var R;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var k;(function(z){z[z.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var S;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=y;function h(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=w;function E(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function g(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=g;function m(z){return y(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var u;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(X,O){super(X),this.code=O}}e.FileSystemProviderError=l;function f(z,X){const O=new l(z.toString(),X);return o(O,X),O}e.createFileSystemProviderError=f;function r(z){return z||f((0,I.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=r;function o(z,X){return z.name=X?`${X} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=o;function n(z){if(!z)return u.Unknown;if(z instanceof l)return z.code;const X=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!X)return u.Unknown;switch(X[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function i(z){if(z instanceof F)return z.fileOperationResult;switch(n(z)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(X,O,U){this.resource=X,this.operation=O,this.target=U}isOperation(X){return this.operation===X}}e.FileOperationEvent=a;var c;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class d{constructor(X,O){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=X;const U=new Map;for(const x of X){const ae=U.get(x.type);switch(ae?ae.push([x.resource,x]):U.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,ae]of U)switch(x){case 1:this.added=v.TernarySearchTree.forUris(()=>O),this.added.fill(ae);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>O),this.updated.fill(ae);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>O),this.deleted.fill(ae);break}}contains(X,...O){return this.doContains(X,{includeChildren:!1},...O)}affects(X,...O){return this.doContains(X,{includeChildren:!0},...O)}doContains(X,O,...U){if(!X)return!1;const x=U.length>0;return!!((!x||U.includes(1))&&(this.added?.get(X)||O.includeChildren&&this.added?.findSuperstr(X))||(!x||U.includes(0))&&(this.updated?.get(X)||O.includeChildren&&this.updated?.findSuperstr(X))||(!x||U.includes(2))&&(this.deleted?.findSubstr(X)||O.includeChildren&&this.deleted?.findSuperstr(X)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function P(z,X,O){return!z||!X||z===X||X.length>z.length?!1:(X.charAt(X.length-1)!==t.sep&&(X+=t.sep),O?(0,D.startsWithIgnoreCase)(z,X):z.indexOf(X)===0)}e.isParent=P;class F extends Error{constructor(X,O,U){super(X),this.fileOperationResult=O,this.options=U}}e.FileOperationError=F;class $ extends F{constructor(X,O,U){super(X,2,U),this.stat=O}}e.NotModifiedSinceFileOperationError=$;var Z;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Z=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=_;async function ee(z,X){if(!X.hasProvider(T.URI.from({scheme:z.scheme})))return new Promise(O=>{const U=X.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===z.scheme&&x.added&&(U.dispose(),O())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(X){return(0,C.isNumber)(X)||(X=0),X<ne.KB?(0,I.localize)(1,null,X.toFixed(0)):X<ne.MB?(0,I.localize)(2,null,(X/ne.KB).toFixed(2)):X<ne.GB?(0,I.localize)(3,null,(X/ne.MB).toFixed(2)):X<ne.TB?(0,I.localize)(4,null,(X/ne.GB).toFixed(2)):(0,I.localize)(5,null,(X/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var B;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function ue(z){return{maxFileSize:z===0?300*ne.MB:16*ne.GB,maxHeapSize:z===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=ue}),define(we[199],ye([1,0,16,38,8,7,2,45,4,23,17]),function(oe,e,v,t,D,C,T,I,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends T.Disposable{constructor(y,h){super(),this.channel=y,this.extraCapabilities=h,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,h){const{buffer:w}=await this.channel.call("readFile",[y,h]);return w}readFileStream(y,h,w){const E=(0,I.newWriteableStream)(m=>v.VSBuffer.concat(m.map(u=>v.VSBuffer.wrap(u))).buffer),g=this.channel.listen("readFileStream",[y,h])(m=>{if(m instanceof v.VSBuffer)E.write(m.buffer);else{if(m==="end")E.end();else{let u=m;u instanceof Error||(u=(0,R.createFileSystemProviderError)((0,t.toErrorMessage)(u),R.FileSystemProviderErrorCode.Unknown)),E.error(u),E.end()}g.dispose()}});return w.onCancellationRequested(()=>{E.error((0,D.canceled)()),E.end(),g.dispose()}),E}writeFile(y,h,w){return this.channel.call("writeFile",[y,v.VSBuffer.wrap(h),w])}open(y,h){return this.channel.call("open",[y,h])}close(y){return this.channel.call("close",[y])}async read(y,h,w,E,g){const[m,u]=await this.channel.call("read",[y,h,g]);return w.set(m.buffer.slice(0,u),E),u}write(y,h,w,E,g){return this.channel.call("write",[y,h,v.VSBuffer.wrap(w),E,g])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,h){return this.channel.call("delete",[y,h])}rename(y,h,w){return this.channel.call("rename",[y,h,w])}copy(y,h,w){return this.channel.call("copy",[y,h,w])}cloneFile(y,h){return this.channel.call("cloneFile",[y,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const h=y;this._onDidChange.fire(h.map(w=>({resource:p.URI.revive(w.resource),type:w.type})))}else{const h=y;this._onDidWatchError.fire(h)}}))}watch(y,h){const w=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,w,y,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,w]))}}e.DiskFileSystemProviderClient=k}),define(we[100],ye([1,0,16,8,171,17]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(R,k,S,y,h,w){let E;try{await I(R,k,S,y,h,w)}catch(g){E=g}finally{E&&h.errorTransformer&&(E=h.errorTransformer(E)),typeof E<"u"&&S.error(E),S.end()}}e.readFileIntoStream=T;async function I(R,k,S,y,h,w){p(w);const E=await R.open(k,{create:!1});try{p(w);let g=0,m=0,u=h&&typeof h.length=="number"?h.length:void 0,l=v.VSBuffer.alloc(Math.min(h.bufferSize,typeof u=="number"?u:h.bufferSize)),f=h&&typeof h.position=="number"?h.position:0,r=0;do m=await R.read(E,f,l.buffer,r,l.byteLength-r),f+=m,r+=m,g+=m,typeof u=="number"&&(u-=m),r===l.byteLength&&(await S.write(y(l)),l=v.VSBuffer.alloc(Math.min(h.bufferSize,typeof u=="number"?u:h.bufferSize)),r=0);while(m>0&&(typeof u!="number"||u>0)&&p(w)&&b(g,h));if(r>0){let o=r;typeof u=="number"&&(o=Math.min(r,u)),S.write(y(l.slice(0,o)))}}catch(g){throw(0,C.ensureFileSystemProviderError)(g)}finally{await R.close(E)}}function p(R){if(R.isCancellationRequested)throw(0,t.canceled)();return!0}function b(R,k){if(k?.limits){if(typeof k.limits.memory=="number"&&R>k.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&R>k.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(we[60],ye([1,0,68,2,6,3,4,17]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(g){return g.recursive===!0}e.isRecursiveWatchRequest=p;class b extends t.Disposable{constructor(m,u,l,f){super(),this.onFileChanges=m,this.onLogMessage=u,this.verboseLogging=l,this.options=f,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new t.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),m.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),m.add(this.watcher.onDidError(u=>this.onError(u)))}onError(m){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class R extends b{constructor(m,u,l){super(m,u,l,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class k extends b{constructor(m,u,l){super(m,u,l,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function S(g){return g.map(m=>({type:m.type,resource:T.URI.file(m.path)}))}e.toFileChanges=S;function y(g){const m=new E;for(const u of g)m.processEvent(u);return m.coalesce()}e.coalesceEvents=y;function h(g,m){return typeof m=="string"&&!m.startsWith(v.GLOBSTAR)&&!(0,D.isAbsolute)(m)?{base:g,pattern:m}:m}e.normalizeWatcherPattern=h;function w(g,m){const u=[];for(const l of m)u.push((0,v.parse)(h(g,l)));return u}e.parseWatcherPatterns=w;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return C.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const u=this.mapPathToChange.get(this.toKey(m));let l=!1;if(u){const f=u.type,r=m.type;u.path!==m.path&&(m.type===2||m.type===1)?l=!0:f===1&&r===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(u)):f===2&&r===1?u.type=0:f===1&&r===0||(u.type=r)}else l=!0;l&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],u=[];return Array.from(this.coalesced).filter(l=>l.type!==2?(m.push(l),!1):!0).sort((l,f)=>l.path.length-f.path.length).filter(l=>u.some(f=>(0,I.isParent)(l.path,f,!C.isLinux))?!1:(u.push(l.path),!0)).concat(m)}}}),define(we[200],ye([1,0,30,14,20,36,2,87,6,3,146,21,60]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends T.Disposable{constructor(E,g,m,u){super(),this.request=E,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=u,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const E=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await k.Promises.stat(E);this._register(await this.doWatch(E,g.isDirectory()))}catch(E){E.code!=="ENOENT"?this.error(E):this.trace(E)}}async normalizePath(E){let g=E.path;try{g=await k.Promises.realpath(E.path),E.path===g&&(g=await(0,R.realcase)(E.path)??E.path),E.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${E.path}, real: ${g})`)}catch{}return g}async doWatch(E,g){if(b.isMacintosh&&(0,C.isEqualOrParent)(E,"/Volumes/",!0))return this.error(`Refusing to watch ${E} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const m=new D.CancellationTokenSource(this.cts.token),u=new T.DisposableStore;try{const l=(0,p.basename)(E),f=(0,v.watch)(E);u.add((0,T.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.trace(`Started watching: '${E}'`);const r=new Set;if(g)try{for(const n of await k.Promises.readdir(E))r.add(n)}catch(n){this.error(n)}const o=new Map;u.add((0,T.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),f.on("error",(n,i)=>{this.error(`Failed to watch ${E} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),f.on("change",(n,i)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${i}`);let s="";if(i&&(s=i.toString(),b.isMacintosh&&(s=(0,I.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(g)if(n==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===l&&!await k.Promises.exists(E)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,p.join)(E,s));if(m.token.isCancellationRequested)return;let d;c?r.has(s)?d=0:(d=1,r.add(s)):(r.delete(s),d=2),this.onFileChange({path:(0,p.join)(this.request.path,s),type:d})},y.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,T.toDisposable)(()=>clearTimeout(a)))}else{let a;r.has(s)?a=0:(a=1,r.add(s)),this.onFileChange({path:(0,p.join)(this.request.path,s),type:a})}else if(n==="rename"||s!==l){const a=setTimeout(async()=>{const c=await k.Promises.exists(E);m.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(E,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,T.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await k.Promises.exists(E)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${E} for changes using fs.watch() (${l.toString()})`)}return(0,T.toDisposable)(()=>{m.dispose(!0),u.dispose()})}async onFileChange(E,g=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),!g&&this.excludes.some(m=>m(E.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${E.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(E.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${E.path}`):this.fileChangesBuffer.push(E);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,S.coalesceEvents)(m);if(u.length>0){if(this.verboseLogging)for(const f of u)this.trace(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(E){if(b.isLinux)return k.Promises.exists(E);try{const g=(0,p.basename)(E);return(await k.Promises.readdir((0,p.dirname)(E))).some(u=>u===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(E){this.verboseLogging=E}error(E){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${E}`})}warn(E){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${E}`})}trace(E){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function h(w,E,g,m,u=512){const l=await k.Promises.open(w,"r"),f=Buffer.allocUnsafe(u),r=new D.CancellationTokenSource(m);let o,n=!1;const i={path:w,excludes:[],recursive:!1},s=new y(i,a=>{(async()=>{for(const{type:c}of a)if(c===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:d}=await k.Promises.read(l,f,0,u,null);if(!d||r.token.isCancellationRequested)break;E(f.slice(0,d))}}catch(d){o=new Error(d),r.dispose(!0)}finally{n=!1}}})()});return await s.ready,g(),new Promise((a,c)=>{r.token.onCancellationRequested(async()=>{s.dispose();try{await k.Promises.close(l)}catch(d){o=new Error(d)}o?c(o):a()})})}e.watchFileContents=h}),define(we[201],ye([1,0,7,68,2,3,200]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const R=this.normalizeRequests(b),k=R.filter(y=>{const h=this.watchers.get(y.path);return h?!(0,t.patternsEquals)(h.request.excludes,y.excludes)||!(0,t.patternsEquals)(h.request.includes,y.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:y})=>!R.find(h=>h.path===y.path&&(0,t.patternsEquals)(h.excludes,y.excludes)&&(0,t.patternsEquals)(h.includes,y.includes))).map(({request:y})=>y.path);k.length&&this.trace(`Request to start watching: ${k.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const y of S)this.stopWatching(y);for(const y of k)this.startWatching(y)}startWatching(b){const R=new T.NodeJSFileWatcherLibrary(b,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),k={request:b,instance:R};this.watchers.set(b.path,k)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const R=this.watchers.get(b);R&&(this.watchers.delete(b),R.instance.dispose())}normalizeRequests(b){const R=new Map;for(const k of b){const S=C.isLinux?k.path:k.path.toLowerCase();R.set(S,k)}return Array.from(R.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,R]of this.watchers)R.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,R){return R?`[File Watcher (node.js)] ${b} (path: ${R.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=I}),define(we[202],ye([1,0,60,201]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends v.AbstractNonRecursiveWatcherClient{constructor(T,I,p){super(T,I,p),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(we[203],ye([1,0,12,42,96,60]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends C.AbstractUniversalWatcherClient{constructor(p,b,R){super(p,b,R),this.init()}createWatcher(p){const b=p.add(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(b.onDidProcessExit(({code:R,signal:k})=>this.onError(`terminated by itself with code ${R}, signal: ${k}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(we[73],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(const[C,T]of D)this.set(C,T)}set(D,C){const T=this._entries.get(D);return this._entries.set(D,C),T}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(we[101],ye([1,0,14,8,59,195,5,73]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class b extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class R{constructor(h=new I.ServiceCollection,w=!1,E,g=p){this._services=h,this._strict=w,this._parent=E,this._enableTracing=g,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=g?E?._globalGraph??new C.Graph(m=>m):void 0}createChild(h){return new R(h,this._strict,this,this._enableTracing)}invokeFunction(h,...w){const E=S.traceInvocation(this._enableTracing,h);let g=!1;try{return h({get:u=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(u,E);if(!l)throw new Error(`[invokeFunction] unknown service '${u}'`);return l}},...w)}finally{g=!0,E.stop()}}createInstance(h,...w){let E,g;return h instanceof D.SyncDescriptor?(E=S.traceCreation(this._enableTracing,h.ctor),g=this._createInstance(h.ctor,h.staticArguments.concat(w),E)):(E=S.traceCreation(this._enableTracing,h),g=this._createInstance(h,w,E)),E.stop(),g}_createInstance(h,w=[],E){const g=T._util.getServiceDependencies(h).sort((l,f)=>l.index-f.index),m=[];for(const l of g){const f=this._getOrCreateServiceInstance(l.id,E);f||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${l.id}.`,!1),m.push(f)}const u=g.length>0?g[0].index:w.length;if(w.length!==u){console.trace(`[createInstance] First service dependency of ${h.name} at position ${u+1} conflicts with ${w.length} static arguments`);const l=u-w.length;l>0?w=w.concat(new Array(l)):w=w.slice(0,u)}return new h(...w,...m)}_setServiceInstance(h,w){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const E=this._getServiceInstanceOrDescriptor(h);return E instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,E,w.branch(h,!0)):(w.branch(h,!1),E)}_safeCreateAndCacheServiceInstance(h,w,E){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,E)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,E){const g=new C.Graph(l=>l.id.toString());let m=0;const u=[{id:h,desc:w,_trace:E}];for(;u.length;){const l=u.pop();if(g.lookupOrInsertNode(l),m++>1e3)throw new b(g);for(const f of T._util.getServiceDependencies(l.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(f.id);if(r||this._throwIfStrict(`[createInstance] ${h} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(f.id)),r instanceof D.SyncDescriptor){const o={id:f.id,desc:r,_trace:l._trace.branch(f.id,!0)};g.insertEdge(l,o),u.push(o)}}}for(;;){const l=g.roots();if(l.length===0){if(!g.isEmpty())throw new b(g);break}for(const{data:f}of l){if(this._getServiceInstanceOrDescriptor(f.id)instanceof D.SyncDescriptor){const o=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,o)}g.removeNode(f)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,E=[],g,m){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(h,w,E,g,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,E,g,m);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w,E=[],g,m){if(g){const u=new R(void 0,this._strict,this,this._enableTracing);u._globalGraphImplicitDependency=String(h);const l=new v.IdleValue(()=>u._createInstance(w,E,m));return new Proxy(Object.create(null),{get(f,r){if(r in f)return f[r];const o=l.value;let n=o[r];return typeof n!="function"||(n=n.bind(o),f[r]=n),n},set(f,r,o){return l.value[r]=o,!0}})}else return this._createInstance(w,E,m)}_throwIfStrict(h,w){if(w&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=R;var k;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(k||(k={}));class S{static traceInvocation(h,w){return h?new S(1,w.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(h,w){return h?new S(0,w.name):S._None}constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}branch(h,w){const E=new S(2,h.toString());return this._dep.push([h,w,E]),E}stop(){const h=Date.now()-this._start;S._totals+=h;let w=!1;function E(m,u){const l=[],f=new Array(m+1).join("	");for(const[r,o,n]of u._dep)if(o&&n){w=!0,l.push(`${f}CREATES -> ${r}`);const i=E(m+1,n);i&&l.push(i)}else l.push(`${f}uses -> ${r}`);return l.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(h>2||w)&&S.all.add(g.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(we[204],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,v.createDecorator)("labelService")});var _e=this&&this.__param||function(oe,e){return function(v,t){e(v,t,oe)}};define(we[74],ye([1,0,20,2,3,173,31,5]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let p=class extends t.Disposable{constructor(R){super(),this.extensionGalleryService=R}async getAvailableLanguages(){const R=new v.CancellationTokenSource;setTimeout(()=>R.cancel(),1e3);let k;try{k=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},R.token)}catch{return[]}const y=k.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(w=>w.startsWith("lp-"))).map(h=>{const w=h.properties.localizedLanguages?.[0],E=this.getLocale(h);return{...this.createQuickPickItem(E,w,h),extensionId:h.identifier.id,galleryExtension:h}});return y.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),y}getLocale(R){return R.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(R,k,S){const y=k??R;let h;if(y!==R&&(h=`(${R})`),R.toLowerCase()===D.language.toLowerCase()&&(h??="",h+=(0,C.localize)(0,null)),S?.installCount){h??="";const w=S.installCount;let E;w>1e6?E=`${Math.floor(w/1e5)/10}M`:w>1e3?E=`${Math.floor(w/1e3)}K`:E=String(w),h+=` $(cloud-download) ${E}`}return{id:R,label:y,description:h}}};p=Re([_e(0,T.IExtensionGalleryService)],p),e.LanguagePackBaseService=p}),define(we[13],ye([1,0,38,7,2,3,5]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function I(){return new Date().toISOString()}var p;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function b(o,n,i){switch(n){case p.Trace:o.trace(i);break;case p.Debug:o.debug(i);break;case p.Info:o.info(i);break;case p.Warning:o.warn(i);break;case p.Error:o.error(i);break;case p.Critical:o.critical(i);break;default:throw new Error("Invalid log level")}}e.log=b;function R(o){let n="";for(let i=0;i<o.length;i++){let s=o[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(i>0?" ":"")+s}return n}e.format=R;class k extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class S extends k{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(p.Trace)&&this.log(p.Trace,R([n,...i]))}debug(n,...i){this.checkLogLevel(p.Debug)&&this.log(p.Debug,R([n,...i]))}info(n,...i){this.checkLogLevel(p.Info)&&this.log(p.Info,R([n,...i]))}warn(n,...i){this.checkLogLevel(p.Warning)&&this.log(p.Warning,R([n,...i]))}error(n,...i){if(this.checkLogLevel(p.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(p.Error,R(s))}else this.log(p.Error,R([n,...i]))}critical(n,...i){this.checkLogLevel(p.Critical)&&this.log(p.Critical,R([n,...i]))}flush(){}}e.AbstractMessageLogger=S;class y extends k{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!C.isWindows}trace(n,...i){this.getLevel()<=p.Trace&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}debug(n,...i){this.getLevel()<=p.Debug&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}info(n,...i){this.getLevel()<=p.Info&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}warn(n,...i){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,n,...i):console.warn(`[main ${I()}]`,n,...i))}error(n,...i){this.getLevel()<=p.Error&&(this.useColors?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,n,...i):console.error(`[main ${I()}]`,n,...i))}critical(n,...i){this.getLevel()<=p.Critical&&(this.useColors?console.error(`\x1B[90m[main ${I()}]\x1B[0m`,n,...i):console.error(`[main ${I()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class h extends k{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=h;class w extends k{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,v.toErrorMessage)(n,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class E extends k{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const s of this.logServices)s.trace(n,...i)}debug(n,...i){for(const s of this.logServices)s.debug(n,...i)}info(n,...i){for(const s of this.logServices)s.info(n,...i)}warn(n,...i){for(const s of this.logServices)s.warn(n,...i)}error(n,...i){for(const s of this.logServices)s.error(n,...i)}critical(n,...i){for(const s of this.logServices)s.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=E;class g extends D.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=g;class m extends D.Disposable{constructor(n,i){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,i?.always?p.Trace:this.logLevel,i),this.loggers.set(n.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class u{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return p.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=u;function l(o){if(o.verbose)return p.Trace;if(typeof o.logLevel=="string"){const n=f(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function f(o){switch(o){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=f;function r(o){switch(o){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=r}),define(we[205],ye([1,0,71,7,2,13,3,14]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let p=class $t extends D.Disposable{constructor(R){super(),this.logService=R,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(R,k){this.logService.trace("Getting password from keytar:",R,k);let S;try{S=await this.withKeytar()}catch{return null}const y=await(0,I.retry)(()=>S.getPassword(R,k),50,3);if(!y)return this.logService.trace("Did not get a password from keytar for account:",k),y;let h,w;try{const E=JSON.parse(y);h=E.content,w=E.hasNextChunk}catch{}if(!h||!w)return this.logService.trace("Got password from keytar for account:",k),y;try{let E=1;for(;w;){const g=await(0,I.retry)(()=>S.getPassword(R,`${k}-${E}`),50,3),m=JSON.parse(g);h+=m.content,w=m.hasNextChunk,E++}return this.logService.trace(`Got ${E}-chunked password from keytar for account:`,k),h}catch(E){return this.logService.error(E),y}}async setPassword(R,k,S){this.logService.trace("Setting password using keytar:",R,k);let y;try{y=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}if(T.isWindows&&S.length>$t.MAX_PASSWORD_LENGTH){let h=0,w=0,E=!0;for(;E;){const g=S.substring(h,h+$t.PASSWORD_CHUNK_SIZE);h+=$t.PASSWORD_CHUNK_SIZE,E=S.length-h>0;const m={content:g,hasNextChunk:E};await(0,I.retry)(()=>y.setPassword(R,w?`${k}-${w}`:k,JSON.stringify(m)),50,3),w++}this.logService.trace(`Got${w?` ${w}-chunked`:""} password from keytar for account:`,k)}else await(0,I.retry)(()=>y.setPassword(R,k,S),50,3),this.logService.trace("Got password from keytar for account:",k);this._onDidChangePassword.fire({service:R,account:k})}async deletePassword(R,k){this.logService.trace("Deleting password using keytar:",R,k);let S;try{S=await this.withKeytar()}catch(g){throw this.surfaceKeytarLoadError?.(g),g}const y=await S.getPassword(R,k);if(!y)return this.logService.trace("Did not get a password to delete from keytar for account:",k),!1;let h,w;try{const g=JSON.parse(y);h=g.content,w=g.hasNextChunk}catch{}let E=0;if(h&&w)try{for(E++;w;){const g=`${k}-${E}`,m=await S.getPassword(R,g);await S.deletePassword(R,g),w=JSON.parse(m).hasNextChunk,E++}}catch(g){this.logService.error(g)}return await S.deletePassword(R,k)?(this._onDidChangePassword.fire({service:R,account:k}),this.logService.trace(`Deleted${E?` ${E}-chunked`:""} password from keytar for account:`,k),!0):(this.logService.trace(`Keytar failed to delete${E?` ${E}-chunked`:""} password for account:`,k),!1)}async findPassword(R){let k;try{k=await this.withKeytar()}catch{return null}return await k.findPassword(R)}async findCredentials(R){let k;try{k=await this.withKeytar()}catch{return[]}return await k.findCredentials(R)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};p.MAX_PASSWORD_LENGTH=2500,p.PASSWORD_CHUNK_SIZE=p.MAX_PASSWORD_LENGTH-100,p=Re([_e(0,C.ILogService)],p),e.BaseCredentialsMainService=p}),define(we[206],ye([1,0,18,14,8,7,2,6,60,13]),function(oe,e,v,t,D,C,T,I,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends T.Disposable{constructor(S,y){super(),this.logService=S,this.options=y,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,y):this.watchNonRecursive(S,y)}watchUniversal(S,y){const h={path:this.toFilePath(S),excludes:y.excludes,includes:y.includes,recursive:y.recursive},w=(0,v.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,p.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const y of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const y of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(y)&&S.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,y){const h={path:this.toFilePath(S),excludes:y.excludes,includes:y.includes,recursive:!1},w=(0,v.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,p.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,I.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(we[102],ye([1,0,18,14,16,20,7,86,44,2,24,12,47,19,45,169,17,100,13]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends b.Disposable{constructor(f){super(),this.logService=f,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(f,r){if(this.provider.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${f}`);const o=new b.DisposableStore;return this.provider.set(f,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:f,provider:r}),o.add(r.onDidChangeFile(n=>this._onDidFilesChange.fire(new E.FileChangesEvent(n,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&o.add(r.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),o.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:f}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:f,provider:r}),this.provider.delete(f),(0,b.dispose)(o)})}getProvider(f){return this.provider.get(f)}async activateProvider(f){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:f,join(o){r.push(o)}}),!this.provider.has(f)&&await t.Promises.settled(r)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.provider.has(f.scheme)}hasCapability(f,r){const o=this.provider.get(f.scheme);return!!(o&&o.capabilities&r)}listCapabilities(){return p.Iterable.map(this.provider,([f,r])=>({scheme:f,capabilities:r.capabilities}))}async withProvider(f){if(!(0,y.isAbsolutePath)(f))throw new E.FileOperationError((0,w.localize)(0,null,this.resourceForError(f)),8);await this.activateProvider(f.scheme);const r=this.provider.get(f.scheme);if(!r){const o=new Error;throw o.name="ENOPRO",o.message=(0,w.localize)(1,null,f.toString()),o}return r}async withReadProvider(f){const r=await this.withProvider(f);if((0,E.hasOpenReadWriteCloseCapability)(r)||(0,E.hasReadWriteCapability)(r)||(0,E.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(f){const r=await this.withProvider(f);if((0,E.hasOpenReadWriteCloseCapability)(r)||(0,E.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,r){try{return await this.doResolveFile(f,r)}catch(o){throw(0,E.toFileSystemProviderErrorCode)(o)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,w.localize)(2,null,this.resourceForError(f)),1):(0,E.ensureFileSystemProviderError)(o)}}async doResolveFile(f,r){const o=await this.withProvider(f),n=this.isPathCaseSensitive(o),i=r?.resolveTo,s=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,c=await o.stat(f);let d;return this.toFileStat(o,f,c,void 0,!!a,(P,F)=>(d||(d=R.TernarySearchTree.forUris(()=>!n),d.set(f,!0),i&&d.fill(!0,i)),d.get(P.resource)||d.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&s?F===1:!1))}async toFileStat(f,r,o,n,i,s){const{providerExtUri:a}=this.getExtUri(f),c={resource:r,name:a.basename(r),isFile:(o.type&E.FileType.File)!==0,isDirectory:(o.type&E.FileType.Directory)!==0,isSymbolicLink:(o.type&E.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&E.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,E.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(c.isDirectory&&s(c,n)){try{const d=await f.readdir(r),P=await t.Promises.settled(d.map(async([F,$])=>{try{const Z=a.joinPath(r,F),J=i?await f.stat(Z):{type:$};return await this.toFileStat(f,Z,J,d.length,i,s)}catch(Z){return this.logService.trace(Z),null}}));c.children=(0,v.coalesce)(P)}catch(d){this.logService.trace(d),c.children=[]}return c}return c}async resolveAll(f){return t.Promises.settled(f.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(f){const r=await this.withProvider(f),o=await r.stat(f);return this.toFileStat(r,f,o,void 0,!0,()=>!1)}async exists(f){const r=await this.withProvider(f);try{return!!await r.stat(f)}catch{return!1}}async canCreateFile(f,r){try{await this.doValidateCreateFile(f,r)}catch(o){return o}return!0}async doValidateCreateFile(f,r){if(!r?.overwrite&&await this.exists(f))throw new E.FileOperationError((0,w.localize)(3,null,this.resourceForError(f)),3,r)}async createFile(f,r=D.VSBuffer.fromString(""),o){await this.doValidateCreateFile(f,o);const n=await this.writeFile(f,r);return this._onDidRunOperation.fire(new E.FileOperationEvent(f,0,n)),n}async writeFile(f,r,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,f,o)||await this.mkdirp(n,i.dirname(f));let a;if((0,E.hasReadWriteCapability)(n)&&!(r instanceof D.VSBuffer))if((0,h.isReadableStream)(r)){const c=await(0,h.peekStream)(r,3);c.ended?a=D.VSBuffer.concat(c.buffer):a=c}else a=(0,h.peekReadable)(r,c=>D.VSBuffer.concat(c),3);else a=r;!(0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(n,f,o,a):await this.doWriteBuffered(n,f,o,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this._onDidRunOperation.fire(new E.FileOperationEvent(f,4))}catch(s){throw new E.FileOperationError((0,w.localize)(4,null,this.resourceForError(f),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),o)}return this.resolve(f,{resolveMetadata:!0})}async validateWriteFile(f,r,o){if(!!o?.unlock&&!(f.capabilities&8192))throw new Error((0,w.localize)(5,null,this.resourceForError(r)));let i;try{i=await f.stat(r)}catch{return}if((i.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,w.localize)(6,null,this.resourceForError(r)),0,o);if(this.throwIfFileIsReadonly(r,i),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==E.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&o.mtime<i.mtime&&o.etag!==(0,E.etag)({mtime:o.mtime,size:i.size}))throw new E.FileOperationError((0,w.localize)(7,null),3,o);return i}async readFile(f,r,o){const n=await this.withReadProvider(f);return r?.atomic?this.doReadFileAtomic(n,f,r,o):this.doReadFile(n,f,r,o)}async doReadFileAtomic(f,r,o,n){return new Promise((i,s)=>{this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(f,r,o,n);i(a)}catch(a){s(a)}})})}async doReadFile(f,r,o,n){const i=await this.doReadFileStream(f,r,{...o,preferUnbuffered:!0},n);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(f,r,o){const n=await this.withReadProvider(f);return this.doReadFileStream(n,f,r,o)}async doReadFileStream(f,r,o,n){const i=new C.CancellationTokenSource(n),s=this.validateReadFile(r,o).then(c=>c,c=>{throw i.cancel(),c});let a;try{return typeof o?.etag=="string"&&o.etag!==E.ETAG_DISABLED&&await s,o?.atomic&&(0,E.hasFileAtomicReadCapability)(f)||!((0,E.hasOpenReadWriteCloseCapability)(f)||(0,E.hasFileReadStreamCapability)(f))||(0,E.hasReadWriteCapability)(f)&&o?.preferUnbuffered?a=this.readFileUnbuffered(f,r,o):(0,E.hasFileReadStreamCapability)(f)?a=this.readFileStreamed(f,r,i.token,o):a=this.readFileBuffered(f,r,i.token,o),{...await s,value:a}}catch(c){a&&await(0,h.consumeStream)(a);const d=(0,w.localize)(8,null,this.resourceForError(r),(0,E.ensureFileSystemProviderError)(c).toString());throw c instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(d,c.stat,o):new E.FileOperationError(d,(0,E.toFileOperationResult)(c),o)}}readFileStreamed(f,r,o,n=Object.create(null)){const i=f.readFileStream(r,n,o);return(0,h.transform)(i,{data:s=>s instanceof D.VSBuffer?s:D.VSBuffer.wrap(s),error:s=>new E.FileOperationError((0,w.localize)(9,null,this.resourceForError(r),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),n)},s=>D.VSBuffer.concat(s))}readFileBuffered(f,r,o,n=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,g.readFileIntoStream)(f,r,i,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new E.FileOperationError((0,w.localize)(10,null,this.resourceForError(r),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),n)},o),i}readFileUnbuffered(f,r,o){const n=(0,h.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;o?.atomic&&(0,E.hasFileAtomicReadCapability)(f)?i=await f.readFile(r,{atomic:!0}):i=await f.readFile(r),typeof o?.position=="number"&&(i=i.slice(o.position)),typeof o?.length=="number"&&(i=i.slice(0,o.length)),this.validateReadFileLimits(r,i.byteLength,o),n.end(D.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(f,r){const o=await this.resolve(f,{resolveMetadata:!0});if(o.isDirectory)throw new E.FileOperationError((0,w.localize)(11,null,this.resourceForError(f)),0,r);if(typeof r?.etag=="string"&&r.etag!==E.ETAG_DISABLED&&r.etag===o.etag)throw new E.NotModifiedSinceFileOperationError((0,w.localize)(12,null),o,r);return this.validateReadFileLimits(f,o.size,r),o}validateReadFileLimits(f,r,o){if(o?.limits){let n;if(typeof o.limits.memory=="number"&&r>o.limits.memory&&(n=9),typeof o.limits.size=="number"&&r>o.limits.size&&(n=7),typeof n=="number")throw new E.FileOperationError((0,w.localize)(13,null,this.resourceForError(f)),n)}}async canMove(f,r,o){return this.doCanMoveCopy(f,r,"move",o)}async canCopy(f,r,o){return this.doCanMoveCopy(f,r,"copy",o)}async doCanMoveCopy(f,r,o,n){if(f.toString()!==r.toString())try{const i=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f):await this.withReadProvider(f),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(i,f,s,r,o,n)}catch(i){return i}return!0}async move(f,r,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,f,i,r,"move",!!o),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(f,s==="move"?2:3,a)),a}async copy(f,r,o){const n=await this.withReadProvider(f),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,f,i,r,"copy",!!o),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(f,s==="copy"?3:2,a)),a}async doMoveCopy(f,r,o,n,i,s){if(r.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(f,r,o,n,i,s);if(a&&!c&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(n)),i==="copy"){if(f===o&&(0,E.hasFileFolderCopyCapability)(f))await f.copy(r,n,{overwrite:s});else{const d=await this.resolve(r);d.isDirectory?await this.doCopyFolder(f,d,o,n):await this.doCopyFile(f,r,o,n)}return i}else return f===o?(await f.rename(r,n,{overwrite:s}),i):(await this.doMoveCopy(f,r,o,n,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(f,r,o,n){if((0,E.hasOpenReadWriteCloseCapability)(f)&&(0,E.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(f,r,o,n);if((0,E.hasOpenReadWriteCloseCapability)(f)&&(0,E.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(f,r,o,n);if((0,E.hasReadWriteCapability)(f)&&(0,E.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(f,r,o,n);if((0,E.hasReadWriteCapability)(f)&&(0,E.hasReadWriteCapability)(o))return this.doPipeUnbuffered(f,r,o,n)}async doCopyFolder(f,r,o,n){await o.mkdir(n),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async i=>{const s=this.getExtUri(o).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(f,await this.resolve(i.resource),o,s):this.doCopyFile(f,i.resource,o,s)}))}async doValidateMoveCopy(f,r,o,n,i,s){let a=!1;if(f===o){const{providerExtUri:d,isPathCaseSensitive:P}=this.getExtUri(f);if(P||(a=d.isEqual(r,n)),a&&i==="copy")throw new Error((0,w.localize)(14,null,this.resourceForError(r),this.resourceForError(n)));if(!a&&d.isEqualOrParent(n,r))throw new Error((0,w.localize)(15,null,this.resourceForError(r),this.resourceForError(n)))}const c=await this.exists(n);if(c&&!a){if(!s)throw new E.FileOperationError((0,w.localize)(16,null,this.resourceForError(r),this.resourceForError(n)),4);if(f===o){const{providerExtUri:d}=this.getExtUri(f);if(d.isEqualOrParent(r,n))throw new Error((0,w.localize)(17,null,this.resourceForError(r),this.resourceForError(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(f){const r=this.isPathCaseSensitive(f);return{providerExtUri:r?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(f){return!!(f.capabilities&1024)}async createFolder(f){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);await this.mkdirp(r,f);const o=await this.resolve(f,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(f,0,o)),o}async mkdirp(f,r){const o=[],{providerExtUri:n}=this.getExtUri(f);for(;!n.isEqual(r,n.dirname(r));)try{if(((await f.stat(r)).type&E.FileType.Directory)===0)throw new Error((0,w.localize)(18,null,this.resourceForError(r)));break}catch(i){if((0,E.toFileSystemProviderErrorCode)(i)!==E.FileSystemProviderErrorCode.FileNotFound)throw i;o.push(n.basename(r)),r=n.dirname(r)}for(let i=o.length-1;i>=0;i--){r=n.joinPath(r,o[i]);try{await f.mkdir(r)}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(f,r){try{await this.doValidateDelete(f,r)}catch(o){return o}return!0}async doValidateDelete(f,r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);if(!!r?.useTrash&&!(o.capabilities&4096))throw new Error((0,w.localize)(19,null,this.resourceForError(f)));let i;try{i=await o.stat(f)}catch{}if(i)this.throwIfFileIsReadonly(f,i);else throw new E.FileOperationError((0,w.localize)(20,null,this.resourceForError(f)),1);if(!!!r?.recursive){const a=await this.resolve(f);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,w.localize)(21,null,this.resourceForError(f)))}return o}async del(f,r){const o=await this.doValidateDelete(f,r),n=!!r?.useTrash,i=!!r?.recursive;await o.delete(f,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new E.FileOperationEvent(f,1))}async cloneFile(f,r){const o=await this.withProvider(f),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(o===n&&this.getExtUri(o).providerExtUri.isEqual(f,r))return;if(o===n&&(0,E.hasFileCloneCapability)(o))return o.cloneFile(f,r);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r));const i=this.writeQueue.queueFor(f,this.getExtUri(o).providerExtUri);return o===n&&(0,E.hasFileFolderCopyCapability)(o)?i.queue(()=>o.copy(f,r,{overwrite:!0})):i.queue(()=>this.doCopyFile(o,f,n,r))}watch(f,r={recursive:!1,excludes:[]}){const o=new b.DisposableStore;let n=!1,i=()=>{n=!0};return o.add((0,b.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(f,r);n?(0,b.dispose)(s):i=()=>(0,b.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(f,r){const o=await this.withProvider(f),n=(0,I.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(f),r]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:o.watch(f,r)},this.activeWatchers.set(n,i)),i.count+=1,(0,b.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,b.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,f]of this.activeWatchers)(0,b.dispose)(f.disposable);this.activeWatchers.clear()}async doWriteBuffered(f,r,o,n){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(async()=>{const i=await f.open(r,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(n)||(0,h.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(f,i,n):await this.doWriteReadableBufferedQueued(f,i,n)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await f.close(i)}})}async doWriteStreamBufferedQueued(f,r,o){let n=0,i;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=D.VSBuffer.concat(o.buffer);await this.doWriteBuffer(f,r,s,s.byteLength,n,0),n+=s.byteLength}if(o.ended)return;i=o.stream}else i=o;return new Promise((s,a)=>{(0,h.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(f,r,c,c.byteLength,n,0)}catch(d){return a(d)}n+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>a(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(f,r,o){let n=0,i;for(;(i=o.read())!==null;)await this.doWriteBuffer(f,r,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(f,r,o,n,i,s){let a=0;for(;a<n;)a+=await f.write(r,i+a,o.buffer,s+a,n-a)}async doWriteUnbuffered(f,r,o,n){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(f,r,o,n))}async doWriteUnbufferedQueued(f,r,o,n){let i;n instanceof D.VSBuffer?i=n:(0,h.isReadableStream)(n)?i=await(0,D.streamToBuffer)(n):(0,h.isReadableBufferedStream)(n)?i=await(0,D.bufferedStreamToBuffer)(n):i=(0,D.readableToBuffer)(n),await f.writeFile(r,i.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(f,r,o,n))}async doPipeBufferedQueued(f,r,o,n){let i,s;try{i=await f.open(r,{create:!1}),s=await o.open(n,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,d=0,P=0;do P=await f.read(i,c,a.buffer,d,a.byteLength-d),await this.doWriteBuffer(o,s,a,P,c,d),c+=P,d+=P,d===a.byteLength&&(d=0);while(P>0)}catch(a){throw(0,E.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof i=="number"?f.close(i):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(f,r,o,n))}async doPipeUnbufferedQueued(f,r,o,n){return o.writeFile(n,await f.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(f,r,o,n))}async doPipeUnbufferedToBufferedQueued(f,r,o,n){const i=await o.open(n,{create:!0,unlock:!1});try{const s=await f.readFile(r);await this.doWriteBuffer(o,i,D.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await o.close(i)}}async doPipeBufferedToUnbuffered(f,r,o,n){const i=await(0,D.streamToBuffer)(this.readFileBuffered(f,r,C.CancellationToken.None));await this.doWriteUnbuffered(o,n,void 0,i)}throwIfFileSystemIsReadonly(f,r){if(f.capabilities&2048)throw new E.FileOperationError((0,w.localize)(22,null,this.resourceForError(r)),6);return f}throwIfFileIsReadonly(f,r){if((r.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,w.localize)(23,null,this.resourceForError(f)),6)}resourceForError(f){return f.scheme===k.Schemas.file?f.fsPath:f.toString(!0)}};u=Re([_e(0,m.ILogService)],u),e.FileService=u}),define(we[61],ye([1,0,30,270,14,24,16,7,36,2,6,3,19,45,21,172,17,100,206,38,203,202]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(o){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(o)}`)}})();class r extends m.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new C.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,S.joinPath)(n,a.name))).type:c=this.toType(a),s.push([a.name,c])}catch(c){this.logService.trace(c)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let s;return i?.dangling?s=E.FileType.Unknown:n.isFile()?s=E.FileType.File:n.isDirectory()?s=E.FileType.Directory:s=E.FileType.Unknown,i&&(s|=E.FileType.SymbolicLink),s}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const a=new D.Barrier;return this.resourceLocks.set(n,a),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===a&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(n,i){let s;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const a=this.toFilePath(n);return await h.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}traceLock(n){r.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,s){const a=(0,y.newWriteableStream)(c=>T.VSBuffer.concat(c.map(d=>T.VSBuffer.wrap(d))).buffer);return(0,g.readFileIntoStream)(this,n,a,c=>c.buffer,{...i,bufferSize:256*1024},s),a}async writeFile(n,i,s){let a;try{const c=this.toFilePath(n);if(!s.create||!s.overwrite){if(await h.Promises.exists(c)){if(!s.overwrite)throw(0,E.createFileSystemProviderError)((0,w.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,E.createFileSystemProviderError)((0,w.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(n,c)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){r.canFlush=n}async open(n,i){const s=this.toFilePath(n);let a;(0,E.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(n));let c;try{if((0,E.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:P}=await h.SymlinkSupport.stat(s);P.mode&128||await h.Promises.chmod(s,P.mode|128)}catch(P){this.logService.trace(P)}let d;if((0,E.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await h.Promises.truncate(s,0),d="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}d||(d="w")}else d="r";c=await h.Promises.open(s,d)}catch(d){throw a?.dispose(),(0,E.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(c,0),(0,E.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(c,n),a){const d=this.mapHandleToLock.get(c);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.mapHandleToLock.set(c,a),d&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),d.dispose())}return c}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&r.canFlush)try{await h.Promises.fdatasync(n)}catch(s){r.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,s,a,c){const d=this.normalizePos(n,i);let P=null;try{P=(await h.Promises.read(n,s,a,c,d)).bytesRead}catch(F){throw this.toFileSystemProviderError(F)}finally{this.updatePos(n,d,P)}return P}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,s){const a=this.mapHandleToPos.get(n);typeof a=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,a+s):this.mapHandleToPos.delete(n)))}async write(n,i,s,a,c){return(0,D.retry)(()=>this.doWrite(n,i,s,a,c),100,3)}async doWrite(n,i,s,a,c){const d=this.normalizePos(n,i);let P=null;try{P=(await h.Promises.write(n,s,a,c,d)).bytesWritten}catch(F){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),F)}finally{this.updatePos(n,d,P)}return P}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const s=this.toFilePath(n);i.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,i,s){const a=this.toFilePath(n),c=this.toFilePath(i);if(a!==c)try{await this.validateTargetDeleted(n,i,"move",s.overwrite),await h.Promises.move(a,c)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,w.localize)(2,null,(0,R.basename)(a),(0,R.basename)((0,R.dirname)(c)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(n,i,s){const a=this.toFilePath(n),c=this.toFilePath(i);if(a!==c)try{await this.validateTargetDeleted(n,i,"copy",s.overwrite),await h.Promises.copy(a,c,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,w.localize)(3,null,(0,R.basename)(a),(0,R.basename)((0,R.dirname)(c)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(n,i,s,a){const c=this.toFilePath(n),d=this.toFilePath(i);let P=!1;if(!!(this.capabilities&1024)||(P=(0,p.isEqual)(c,d,!0)),P&&s==="copy")throw(0,E.createFileSystemProviderError)((0,w.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!P&&await h.Promises.exists(d)){if(!a)throw(0,E.createFileSystemProviderError)((0,w.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,s){const a=this.toFilePath(n),c=this.toFilePath(i),d=!!(this.capabilities&1024);if((0,p.isEqual)(a,c,!d))return;const P=new b.DisposableStore;try{const[F,$]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);P.add(F),P.add($),s&&await h.Promises.mkdir((0,R.dirname)(c),{recursive:!0}),await h.Promises.copyFile(a,c)}catch(F){if(F.code==="ENOENT"&&!s)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(F)}finally{P.dispose()}}createUniversalWatcher(n,i,s){return new l.UniversalWatcherClient(a=>n(a),a=>i(a),s)}createNonRecursiveWatcher(n,i,s){return new f.NodeJSWatcherClient(a=>n(a),a=>i(a),s)}toFileSystemProviderError(n){if(n instanceof E.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=E.FileSystemProviderErrorCode.NoPermissions;break;default:i=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(n,i){let s=this.toFileSystemProviderError(i);if(n&&s.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await h.SymlinkSupport.stat(this.toFilePath(n));a.mode&128||(s=(0,E.createFileSystemProviderError)(i,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=r,r.TRACE_LOG_RESOURCE_LOCKS=!1,r.canFlush=!0}),define(we[207],ye([1,0,7,61,2,16,45,20]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends D.Disposable{constructor(k,S){super(),this.provider=k,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,S,y){const h=this.getUriTransformer(k);switch(S){case"stat":return this.stat(h,y[0]);case"readdir":return this.readdir(h,y[0]);case"open":return this.open(h,y[0],y[1]);case"close":return this.close(y[0]);case"read":return this.read(y[0],y[1],y[2]);case"readFile":return this.readFile(h,y[0],y[1]);case"write":return this.write(y[0],y[1],y[2],y[3],y[4]);case"writeFile":return this.writeFile(h,y[0],y[1],y[2]);case"rename":return this.rename(h,y[0],y[1],y[2]);case"copy":return this.copy(h,y[0],y[1],y[2]);case"cloneFile":return this.cloneFile(h,y[0],y[1]);case"mkdir":return this.mkdir(h,y[0]);case"delete":return this.delete(h,y[0],y[1]);case"watch":return this.watch(h,y[0],y[1],y[2],y[3]);case"unwatch":return this.unwatch(y[0],y[1])}throw new Error(`IPC Command ${S} not found`)}listen(k,S,y){const h=this.getUriTransformer(k);switch(S){case"fileChange":return this.onFileChange(h,y[0]);case"readFileStream":return this.onReadFileStream(h,y[0],y[1])}throw new Error(`Unknown event ${S}`)}stat(k,S){const y=this.transformIncoming(k,S,!0);return this.provider.stat(y)}readdir(k,S){const y=this.transformIncoming(k,S);return this.provider.readdir(y)}async readFile(k,S,y){const h=this.transformIncoming(k,S,!0),w=await this.provider.readFile(h,y);return C.VSBuffer.wrap(w)}onReadFileStream(k,S,y){const h=this.transformIncoming(k,S,!0),w=new I.CancellationTokenSource,E=new v.Emitter({onLastListenerRemove:()=>{w.cancel()}}),g=this.provider.readFileStream(h,y,w.token);return(0,T.listenStream)(g,{onData:m=>E.fire(C.VSBuffer.wrap(m)),onError:m=>E.fire(m),onEnd:()=>{E.fire("end"),E.dispose(),w.dispose()}}),E.event}writeFile(k,S,y,h){const w=this.transformIncoming(k,S);return this.provider.writeFile(w,y.buffer,h)}open(k,S,y){const h=this.transformIncoming(k,S,!0);return this.provider.open(h,y)}close(k){return this.provider.close(k)}async read(k,S,y){const h=C.VSBuffer.alloc(y),w=0,E=await this.provider.read(k,S,h.buffer,w,y);return[h,E]}write(k,S,y,h,w){return this.provider.write(k,S,y.buffer,h,w)}mkdir(k,S){const y=this.transformIncoming(k,S);return this.provider.mkdir(y)}delete(k,S,y){const h=this.transformIncoming(k,S);return this.provider.delete(h,y)}rename(k,S,y,h){const w=this.transformIncoming(k,S),E=this.transformIncoming(k,y);return this.provider.rename(w,E,h)}copy(k,S,y,h){const w=this.transformIncoming(k,S),E=this.transformIncoming(k,y);return this.provider.copy(w,E,h)}cloneFile(k,S,y){const h=this.transformIncoming(k,S),w=this.transformIncoming(k,y);return this.provider.cloneFile(h,w)}onFileChange(k,S){const y=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(k,y))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return y.event}async watch(k,S,y,h,w){const E=this.sessionToWatcher.get(S);if(E){const g=this.transformIncoming(k,h),m=E.watch(y,g,w);this.watchRequests.set(S+y,m)}}async unwatch(k,S){const y=k+S,h=this.watchRequests.get(y);h&&((0,D.dispose)(h),this.watchRequests.delete(y))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class b extends D.Disposable{constructor(k,S,y,h){super(),this.uriTransformer=k,this.logService=y,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(k){const S=this._register(new v.Emitter);this._register(S.event(y=>{k.fire(y.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type})))})),this._register(this.fileWatcher.onDidChangeFile(y=>S.fire(y))),this._register(this.fileWatcher.onDidWatchError(y=>k.fire(y)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,S,y){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(y.excludes=[...y.excludes,...h]),this.watcherRequests.set(k,this.fileWatcher.watch(S,y)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=b}),define(we[103],ye([1,0,7,4,13]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(S){this.service=S,this.onDidChangeLogLevel=v.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(S,y,h){switch(y){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=C;class T{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){T.setLevel(this.channel,S)}static setLevel(S,y){return S.call("setLevel",y)}}e.LogLevelChannelClient=T;class I{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,y){throw new Error(`Event not found: ${y}`)}async call(S,y,h){switch(y){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${y}`)}createLogger(S,y){this.loggers.set(S.toString(),this.loggerService.createLogger(S,y))}consoleLog(S,y){let h=console.log;switch(S){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...y)}log(S,y){const h=this.loggers.get(S.toString());if(!h)throw new Error("Create the logger before logging");for(const[w,E]of y)(0,D.log)(h,w,E)}}e.LoggerChannel=I;class p extends D.AbstractLoggerService{constructor(S,y,h){super(S,y),this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,y)=>{this.channel.call("consoleLog",[S,y])}})}doCreateLogger(S,y,h){return new b(this.channel,S,y,h)}}e.LoggerChannelClient=p;class b extends D.AbstractMessageLogger{constructor(S,y,h,w){super(w?.always),this.channel=S,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[y,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,y){const h=[[S,y]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(S){this.channel.call("log",[this.file,S])}}class R extends D.LogService{constructor(S,y){super(y),this.parent=S,this._register(S.onDidChangeLogLevel(h=>y.setLevel(h)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=R}),define(we[104],ye([1,0,17,13]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(I,p,b,R,k){try{const S=await new Promise((h,w)=>{oe(["spdlog"],h,w)});S.setFlushOn(t.LogLevel.Trace);const y=await S.createAsyncRotatingLogger(I,p,b,R);return k&&y.clearFormatters(),y}catch(S){console.error(S)}return null}function C(I,p,b){switch(p){case t.LogLevel.Trace:I.trace(b);break;case t.LogLevel.Debug:I.debug(b);break;case t.LogLevel.Info:I.info(b);break;case t.LogLevel.Warning:I.warn(b);break;case t.LogLevel.Error:I.error(b);break;case t.LogLevel.Critical:I.critical(b);break;default:throw new Error("Invalid log level")}}class T extends t.AbstractMessageLogger{constructor(p,b,R,k,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(p,b,R,k),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}async _createSpdLogLogger(p,b,R,k){const S=R?6:1,y=30/S*v.ByteSize.MB,h=await D(p,b,y,S,k);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:w,message:E}of this.buffer)C(this._logger,w,E);this.buffer=[]}}log(p,b){this._logger?C(this._logger,p,b):this.getLevel()<=p&&this.buffer.push({level:p,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(we[208],ye([1,0,67,174,5]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var T;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(p){function b(h,w){return w-h}p.compare=b;const R=Object.create(null);R[p.Error]=(0,t.localize)(0,null),R[p.Warning]=(0,t.localize)(1,null),R[p.Info]=(0,t.localize)(2,null);function k(h){return R[h]||""}p.toString=k;function S(h){switch(h){case v.default.Error:return p.Error;case v.default.Warning:return p.Warning;case v.default.Info:return p.Info;case v.default.Ignore:return p.Hint}}p.fromSeverity=S;function y(h){switch(h){case p.Error:return v.default.Error;case p.Warning:return v.default.Warning;case p.Info:return v.default.Info;case p.Hint:return v.default.Ignore}}p.toSeverity=y}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(p){const b="";function R(S){return k(S,!0)}p.makeKey=R;function k(S,y){const h=[b];return S.source?h.push(S.source.replace("\xA6","\\\xA6")):h.push(b),S.code?typeof S.code=="string"?h.push(S.code.replace("\xA6","\\\xA6")):h.push(S.code.value.replace("\xA6","\\\xA6")):h.push(b),S.severity!==void 0&&S.severity!==null?h.push(T.toString(S.severity)):h.push(b),S.message&&y?h.push(S.message.replace("\xA6","\\\xA6")):h.push(b),S.startLineNumber!==void 0&&S.startLineNumber!==null?h.push(S.startLineNumber.toString()):h.push(b),S.startColumn!==void 0&&S.startColumn!==null?h.push(S.startColumn.toString()):h.push(b),S.endLineNumber!==void 0&&S.endLineNumber!==null?h.push(S.endLineNumber.toString()):h.push(b),S.endColumn!==void 0&&S.endColumn!==null?h.push(S.endColumn.toString()):h.push(b),h.push(b),h.join("\xA6")}p.makeKeyOptionalMessage=k})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(we[62],ye([1,0,7,44,2,5]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class T extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(b){const R=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...b,...this.policyDefinitions},R!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(b),t.Iterable.reduce(this.policies.entries(),(k,[S,y])=>({...k,[S]:y}),{})}getPolicyValue(b){return this.policies.get(b)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(b,[R,k])=>({...b,[R]:{definition:k,value:this.policies.get(R)}}),{})}}e.AbstractPolicyService=T;class I{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(we[51],ye([1,0,12,3,27,19]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const I=t.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof oe?.__$__nodeRequire=="function"){const I=(0,C.dirname)(v.FileAccess.asFileUri("",oe));if(T=oe.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath),D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const p=oe.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);Object.assign(T,{version:p.version})}Object.assign(T,{extensionsGallery:D.env.EXTENSIONS_GALLERY?JSON.parse(D.env.EXTENSIONS_GALLERY):T.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else T={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.72.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"4.8.2",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.72.1",commit:"129500ee4c8ab7263461ffe327268ba56b9f210d",date:"2022-11-04T15:54:04.096Z"},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(we[26],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(we[34],ye([1,0,84,11]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(T,I){v.ok(t.isString(T)),v.ok(t.isObject(I)),v.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new D}),define(we[209],ye([1,0,7,34]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,b){this.schemasById[D(p)]=b,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;t.Registry.add(e.Extensions.JSONContribution,T)}),define(we[52],ye([1,0,18,7,11,158,25,209,34]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=p.Registry.as(I.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const n=this.doRegisterConfigurations(r,o);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(r){const o=this.doDeregisterConfigurations(r);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:r,remove:o}){const n=[];n.push(...this.doDeregisterConfigurations(o)),n.push(...this.doRegisterConfigurations(r,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(n)})}registerDefaultConfigurations(r){const o=[],n=[];for(const{overrides:i,source:s}of r)for(const a in i)if(o.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c=this.configurationDefaultsOverrides.get(a),d=c?.valuesSources??new Map;if(s)for(const Z of Object.keys(i[a]))d.set(Z,s);const P={...c?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:P,valuesSources:d});const F=(0,T.getLanguageTagSettingPlainKey)(a),$={type:"object",default:P,description:C.localize(1,null,F),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:D.isString(s)?void 0:s,defaultValueSource:s};n.push(...w(a)),this.configurationProperties[a]=$,this.defaultLanguageConfigurationOverridesNode.properties[a]=$}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:s});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const o=[];for(const{overrides:n,source:i}of r)for(const s in n){const a=this.configurationDefaultsOverrides.get(s),c=D.isString(i)?i:i?.id,d=D.isString(a?.source)?a?.source:a?.source?.id;if(c===d)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const P=this.configurationProperties[s];P&&(this.updatePropertyDefaultValue(s,P),this.updateSchema(s,P))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const o of r)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,o){const n=[];return r.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(r){const o=[],n=i=>{if(i.properties)for(const s in i.properties){o.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s])}i.allOf?.forEach(s=>n(s))};for(const i of r){n(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(r,o=!0,n,i,s=3){s=D.isUndefinedOrNull(r.scope)?s:r.scope;const a=[],c=r.properties;if(c)for(const P in c){const F=c[P];if(o&&u(P,F)){delete c[P];continue}if(F.source=n,F.defaultDefaultValue=c[P].default,this.updatePropertyDefaultValue(P,F),e.OVERRIDE_PROPERTY_REGEX.test(P)?F.scope=void 0:(F.scope=D.isUndefinedOrNull(F.scope)?s:F.scope,F.restricted=D.isUndefinedOrNull(F.restricted)?!!i?.includes(P):F.restricted),c[P].hasOwnProperty("included")&&!c[P].included){this.excludedConfigurationProperties[P]=c[P],delete c[P];continue}else this.configurationProperties[P]=c[P],c[P].policy?.name&&this.policyConfigurations.set(c[P].policy.name,P);!c[P].deprecationMessage&&c[P].markdownDeprecationMessage&&(c[P].deprecationMessage=c[P].markdownDeprecationMessage),a.push(P)}const d=r.allOf;if(d)for(const P of d)a.push(...this.validateAndRegisterProperties(P,o,n,i,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const o=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(o)};o(r)}updateSchema(r,o){switch(e.allSettings.properties[r]=o,o.scope){case 1:e.applicationSettings.properties[r]=o;break;case 2:e.machineSettings.properties[r]=o;break;case 6:e.machineOverridableSettings.properties[r]=o;break;case 3:e.windowSettings.properties[r]=o;break;case 4:e.resourceSettings.properties[r]=o;break;case 5:e.resourceSettings.properties[r]=o,this.resourceLanguageSettingsSchema.properties[r]=o;break}}removeFromSchema(r,o){switch(delete e.allSettings.properties[r],o.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const o=`[${r}]`,n={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,o){const n=this.configurationDefaultsOverrides.get(r);let i=n?.value,s=n?.source;D.isUndefined(i)&&(i=o.defaultDefaultValue,s=void 0),D.isUndefined(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",h=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(f){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let o=h.exec(f);for(;o?.length;){const n=o[1].trim();n&&r.push(n),o=h.exec(f)}}return(0,v.distinct)(r)}e.overrideIdentifiersFromKey=w;function E(f){return f.reduce((r,o)=>`${r}[${o}]`,"")}e.keyFromOverrideIdentifiers=E;function g(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const m=new S;p.Registry.add(e.Extensions.Configuration,m);function u(f,r){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?C.localize(7,null,f):m.getConfigurationProperties()[f]!==void 0?C.localize(8,null,f):r.policy?.name&&m.getPolicyConfigurations().get(r.policy?.name)!==void 0?C.localize(9,null,f,r.policy?.name,m.getPolicyConfigurations().get(r.policy?.name)):null:C.localize(6,null)}e.validateProperty=u;function l(){const f=[],r=m.getConfigurationProperties();for(const o of Object.keys(r))f.push([o,r[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=l}),define(we[105],ye([1,0,18,7,65,2,24,22,11,4,25,52,34]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},o=[],n=[],i){this._contents=r,this._keys=o,this._overrides=n,this.raw=i,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof y)return o;const n=new h("");return n.parseRaw(o),n.configurationModel});this._rawConfiguration=r.reduce((o,n)=>n===o?n:o.merge(n),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}inspect(r,o){const n=this.rawConfiguration.getValue(r),i=o?this.rawConfiguration.getOverrideValue(r,o):void 0,s=o?this.rawConfiguration.override(o).getValue(r):n;return{value:n,override:i,merged:s}}getOverrideValue(r,o){const n=this.getContentsForOverrideIdentifer(o);return n?r?(0,R.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const n of this.overrides)n.identifiers.includes(r)&&o.push(...n.keys);return v.distinct(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return v.distinct(r)}override(r){let o=this.overrideConfigurations.get(r);return o||(o=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,o)),o}merge(...r){const o=I.deepClone(this.contents),n=I.deepClone(this.overrides),i=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const a of r)if(s.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(o,a.contents);for(const c of a.overrides){const[d]=n.filter(P=>v.equals(P.identifiers,c.identifiers));d?(this.mergeContents(d.contents,c.contents),d.keys.push(...c.keys),d.keys=v.distinct(d.keys)):n.push(I.deepClone(c))}for(const c of a.keys)i.indexOf(c)===-1&&i.push(c)}return new y(o,i,n,s.every(a=>a instanceof y)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new y(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(r){const o=this.getContentsForOverrideIdentifer(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const n={};for(const i of v.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[i];const a=o[i];a&&(typeof s=="object"&&typeof a=="object"?(s=I.deepClone(s),this.mergeContents(s,a)):s=a),n[i]=s}return new y(n,this.keys,this.overrides)}mergeContents(r,o){for(const n of Object.keys(o)){if(n in r&&p.isObject(r[n])&&p.isObject(o[n])){this.mergeContents(r[n],o[n]);continue}r[n]=I.deepClone(o[n])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let o=null,n=null;const i=s=>{s&&(n?this.mergeContents(n,s):n=I.deepClone(s))};for(const s of this.overrides)v.equals(s.identifiers,[r])?o=s.contents:s.identifiers.includes(r)&&i(s.contents);return i(o),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,o){this.addKey(r),(0,R.addToValueTree)(this.contents,r,o,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let o=this.keys.length;for(let n=0;n<o;n++)r.indexOf(this.keys[n])===0&&(o=n);this.keys.splice(o,1,r)}removeKey(r){const o=this.keys.indexOf(r);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=y;class h{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,o){if(!p.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,o)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,o){this._raw=r;const{contents:n,keys:i,overrides:s,restricted:a,hasExcludedProperties:c}=this.doParseRaw(r,o);this._configurationModel=new y(n,i,s,c?[r]:void 0),this._restrictedConfigurations=a||[]}doParseContent(r){let o={},n=null,i=[];const s=[],a=[];function c(P){Array.isArray(i)?i.push(P):n!==null&&(i[n]=P)}const d={onObjectBegin:()=>{const P={};c(P),s.push(i),i=P,n=null},onObjectProperty:P=>{n=P},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const P=[];c(P),s.push(i),i=P,n=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:c,onError:(P,F,$)=>{a.push({error:P,offset:F,length:$})}};if(r)try{D.visit(r,d),o=i[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return o}doParseRaw(r,o){const n=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),i=this.filter(r,n,!0,o);r=i.raw;const s=(0,R.toValuesTree)(r,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),a=Object.keys(r),c=this.toOverrides(r,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:s,keys:a,overrides:c,restricted:i.restricted,hasExcludedProperties:i.hasExcludedProperties}}filter(r,o,n,i){let s=!1;if(!i?.scopes&&!i?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const a={},c=[];for(const d in r)if(k.OVERRIDE_PROPERTY_REGEX.test(d)&&n){const P=this.filter(r[d],o,!1,i);a[d]=P.raw,s=s||P.hasExcludedProperties,c.push(...P.restricted)}else{const P=o[d],F=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&c.push(d),(F===void 0||i.scopes===void 0||i.scopes.includes(F))&&!(i.skipRestricted&&P?.restricted)?a[d]=r[d]:s=!0}return{raw:a,restricted:c,hasExcludedProperties:s}}toOverrides(r,o){const n=[];for(const i of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(i)){const s={};for(const a in r[i])s[a]=r[i][a];n.push({identifiers:(0,k.overrideIdentifiersFromKey)(i),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,o)})}return n}}e.ConfigurationModelParser=h;class w extends C.Disposable{constructor(r,o,n,i){super(),this.userSettingsResource=r,this.scopes=o,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class E{constructor(r,o,n,i,s=new y,a=new y,c=new T.ResourceMap,d=new y,P=new T.ResourceMap,F=!0){this._defaultConfiguration=r,this._policyConfiguration=o,this._applicationConfiguration=n,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=d,this._memoryConfigurationByResource=P,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,o,n){return this.getConsolidatedConfigurationModel(r,o,n).getValue(r)}updateValue(r,o,n={}){let i;n.resource?(i=this._memoryConfigurationByResource.get(n.resource),i||(i=new y,this._memoryConfigurationByResource.set(n.resource,i))):i=this._memoryConfiguration,o===void 0?i.removeValue(r):i.setValue(r,o),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,o,n){const i=this.getConsolidatedConfigurationModel(r,o,n),s=this.getFolderConfigurationModelForResource(o.resource,n),a=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,c=this._defaultConfiguration.inspect(r,o.overrideIdentifier),d=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(r),P=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(r),F=this.userConfiguration.freeze().inspect(r,o.overrideIdentifier),$=this.localUserConfiguration.freeze().inspect(r,o.overrideIdentifier),Z=this.remoteUserConfiguration.freeze().inspect(r,o.overrideIdentifier),J=n?this._workspaceConfiguration.freeze().inspect(r,o.overrideIdentifier):void 0,_=s?s.freeze().inspect(r,o.overrideIdentifier):void 0,ee=a.inspect(r,o.overrideIdentifier),ne=i.getValue(r),B=v.distinct(i.overrides.map(ue=>ue.identifiers).flat()).filter(ue=>i.getOverrideValue(r,ue)!==void 0);return{defaultValue:c?c.merged:void 0,policyValue:d?d.merged:void 0,applicationValue:P?P.merged:void 0,userValue:F?F.merged:void 0,userLocalValue:$?$.merged:void 0,userRemoteValue:Z?Z.merged:void 0,workspaceValue:J?J.merged:void 0,workspaceFolderValue:_?_.merged:void 0,memoryValue:ee?ee.merged:void 0,value:ne,default:c.value!==void 0||c.override!==void 0?{value:c.value,override:c.override}:void 0,policy:d?.value!==void 0?{value:d.value}:void 0,application:P?.value!==void 0||P?.override!==void 0?{value:P.value,override:P.override}:void 0,user:F.value!==void 0||F.override!==void 0?{value:F.value,override:F.override}:void 0,userLocal:$.value!==void 0||$.override!==void 0?{value:$.value,override:$.override}:void 0,userRemote:Z.value!==void 0||Z.override!==void 0?{value:Z.value,override:Z.override}:void 0,workspace:J?.value!==void 0||J?.override!==void 0?{value:J.value,override:J.override}:void 0,workspaceFolder:_?.value!==void 0||_?.override!==void 0?{value:_.value,override:_.override}:void 0,memory:ee.value!==void 0||ee.override!==void 0?{value:ee.value,override:ee.override}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(r){const o=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,o){this._folderConfigurations.set(r,o),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const n=[];if(!o){const{added:i,updated:s,removed:a}=u(this._defaultConfiguration,r);o=[...i,...s,...a]}for(const i of o)for(const s of(0,k.overrideIdentifiersFromKey)(i)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),c=r.getKeysForOverrideIdentifier(s),d=[...c.filter(P=>a.indexOf(P)===-1),...a.filter(P=>c.indexOf(P)===-1),...a.filter(P=>!I.equals(this._defaultConfiguration.override(s).getValue(P),r.override(s).getValue(P)))];n.push([s,d])}return this.updateDefaultConfiguration(r),{keys:o,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:n,removed:i}=u(this._policyConfiguration,r),s=[...o,...n,...i];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:n,removed:i,overrides:s}=u(this.applicationConfiguration,r),a=[...o,...n,...i];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:n,removed:i,overrides:s}=u(this.localUserConfiguration,r),a=[...o,...n,...i];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:n,removed:i,overrides:s}=u(this.remoteUserConfiguration,r),a=[...o,...n,...i];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:n,removed:i,overrides:s}=u(this.workspaceConfiguration,r),a=[...o,...n,...i];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(r,o){const n=this.folderConfigurations.get(r),{added:i,updated:s,removed:a,overrides:c}=u(n,o),d=[...i,...s,...a];return(d.length||!n)&&this.updateFolderConfiguration(r,o),{keys:d,overrides:c}}compareAndDeleteFolderConfiguration(r){const o=this.folderConfigurations.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:i,removed:s,overrides:a}=u(o,void 0);return{keys:[...n,...i,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,o,n){let i=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier&&(i=i.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:r},o){let n=this.getWorkspaceConsolidatedConfiguration();if(o&&r){const i=o.getFolder(r);i&&(n=this.getFolderConsolidatedConfiguration(i.uri)||n);const s=this._memoryConfigurationByResource.get(r);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let o=this._foldersConsolidatedConfigurations.get(r);if(!o){const n=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(r);i?(o=n.merge(i),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(r,o)):o=n}return o}getFolderConfigurationModelForResource(r,o){if(o&&r){const n=o.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,o)=>{const{contents:n,overrides:i,keys:s}=this._folderConfigurations.get(o);return r.push([o,{contents:n,overrides:i,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>r.add(o)),this.userConfiguration.freeze().keys.forEach(o=>r.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(i=>o.add(i))),[...o.values()]}static parse(r){const o=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.policy),i=this.parseConfigurationModel(r.application),s=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((d,P)=>(d.set(b.URI.revive(P[0]),this.parseConfigurationModel(P[1])),d),new T.ResourceMap);return new E(o,n,i,s,new y,a,c,new y,new T.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=E;function g(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const r=new Set,o=new Map;for(const i of f)i.keys.forEach(s=>r.add(s)),i.overrides.forEach(([s,a])=>{const c=(0,T.getOrSet)(o,s,new Set);a.forEach(d=>c.add(d))});const n=[];return o.forEach((i,s)=>n.push([s,[...i.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=g;class m{constructor(r,o,n,i){this.change=r,this.previous=o,this.currentConfiguraiton=n,this.currentWorkspace=i,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(c=>s.add(c)),r.overrides.forEach(([,c])=>c.forEach(d=>s.add(d))),this.affectedKeys=[...s.values()];const a=new y;this.affectedKeys.forEach(c=>a.setValue(c,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(o){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(r,o,this.currentWorkspace);return!I.equals(n,i)}return!0}return!1}doesAffectedKeysTreeContains(r,o){let n=(0,R.toValuesTree)({[o]:!0},()=>{}),i;for(;typeof n=="object"&&(i=Object.keys(n)[0]);){if(r=r[i],!r)return!1;n=n[i]}return!0}}e.ConfigurationChangeEvent=m;function u(f,r){const{added:o,removed:n,updated:i}=l(r,f),s=[],a=f?.getAllOverrideIdentifiers()||[],c=r?.getAllOverrideIdentifiers()||[];if(r){const d=c.filter(P=>!a.includes(P));for(const P of d)s.push([P,r.getKeysForOverrideIdentifier(P)])}if(f){const d=a.filter(P=>!c.includes(P));for(const P of d)s.push([P,f.getKeysForOverrideIdentifier(P)])}if(r&&f){for(const d of a)if(c.includes(d)){const P=l({contents:f.getOverrideValue(void 0,d)||{},keys:f.getKeysForOverrideIdentifier(d)},{contents:r.getOverrideValue(void 0,d)||{},keys:r.getKeysForOverrideIdentifier(d)});s.push([d,[...P.added,...P.removed,...P.updated]])}}return{added:o,removed:n,updated:i,overrides:s}}function l(f,r){const o=f?r?f.keys.filter(s=>r.keys.indexOf(s)===-1):[...f.keys]:[],n=r?f?r.keys.filter(s=>f.keys.indexOf(s)===-1):[...r.keys]:[],i=[];if(f&&r){for(const s of r.keys)if(f.keys.indexOf(s)!==-1){const a=(0,R.getConfigurationValue)(r.contents,s),c=(0,R.getConfigurationValue)(f.contents,s);I.equals(a,c)||i.push(s)}}return{added:o,removed:n,updated:i}}}),define(we[210],ye([1,0,18,7,2,22,11,25,105,52,13,62,34]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.onDidUpdateConfiguration(m,u))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(m,u){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class h extends p.ConfigurationModel{constructor(m={}){const u=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(u),f=Object.create(null),r=[];for(const o in u){const n=m[o],i=n!==void 0?n:u[o].default;(0,I.addToValueTree)(f,o,i,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(f))b.OVERRIDE_PROPERTY_REGEX.test(o)&&r.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(f[o]),contents:(0,I.toValuesTree)(f[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(f,l,r)}}e.DefaultConfigurationModel=h;class w{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=w;let E=class extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(m,u,l){super(),this.defaultConfiguration=m,this.policyService=u,this.logService=l,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new p.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.registerPolicyDefinitions(m),!0))),this._configurationModel}async registerPolicyDefinitions(m){const u={},l=[],f=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const r of m){const o=f[r];if(!o){l.push(r);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}l.push(r),u[o.policy.name]={type:o.type}}}return(0,T.isEmptyObject)(u)||await this.policyService.registerPolicyDefinitions(u),l}onDidChangePolicies(m){const u=S.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),l=(0,v.coalesce)(m.map(f=>u.get(f)));this.update(l,!0)}update(m,u){const l=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),f=[],r=this._configurationModel.isEmpty();for(const o of m){const n=l[o]?.policy?.name;if(n){const i=this.policyService.getPolicyValue(n);(r?i!==void 0:!(0,C.equals)(this._configurationModel.getValue(o),i))&&f.push([o,i])}else this._configurationModel.getValue(o)!==void 0&&f.push([o,void 0])}if(f.length){const o=this._configurationModel;this._configurationModel=new p.ConfigurationModel;for(const n of o.keys)this._configurationModel.setValue(n,o.getValue(n));for(const[n,i]of f)i===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,i);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};E=Re([_e(1,k.IPolicyService),_e(2,R.ILogService)],E),e.PolicyConfiguration=E}),define(we[106],ye([1,0,14,7,2,19,25,105,210,62]),function(oe,e,v,t,D,C,T,I,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends D.Disposable{constructor(S,y,h,w){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration),this.policyConfiguration=h instanceof b.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,h,w)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,y)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:E,properties:g})=>this.onDidDefaultConfigurationChange(E,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(E=>this.onDidPolicyConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,y,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(S,y,new I.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(S,y){const h=typeof S=="string"?S:void 0,w=(0,T.isConfigurationOverrides)(S)?S:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(h,w,void 0)}updateValue(S,y,h,w){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(h,y,2)}onDidDefaultConfigurationChange(S,y){const h=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(S,y);this.trigger(w,h,7)}onDidPolicyConfigurationChange(S){const y=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(h,y,7)}trigger(S,y,h){const w=new I.ConfigurationChangeEvent(S,{data:y},this.configuration);w.source=h,w.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(we[107],ye([1,0,8,5]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends v.ErrorNoTelemetry{static isTemporarilyNotAvailable(I){return I instanceof C&&I._code===D.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof C&&I._code===D.NoResolverFound}static isHandled(I){return I instanceof C&&I.isHandled}constructor(I,p=D.Unknown,b){super(I),this._message=I,this._code=p,this._detail=b,this.isHandled=p===D.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}}e.RemoteAuthorityResolverError=C}),define(we[75],ye([1,0,12]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(b){return b.scheme===v.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=t;function D(b){if(!b)return;const R=b.indexOf("+");return R<0?b:b.substr(0,R)}e.getRemoteName=D;function C(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=C;function T(b){const{host:R,port:k}=p(b);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.parseAuthorityWithPort=T;function I(b,R){let{host:k,port:S}=p(b);return typeof S>"u"&&(S=R),{host:k,port:S}}e.parseAuthorityWithOptionalPort=I;function p(b){const R=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=b.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const S=b.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:b,port:void 0}}}),define(we[35],ye([1,0,15,5,75]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=C;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var p;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,E){if(typeof w>"u"||w===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof w=="string"||typeof E=="string"){const g=typeof w=="string"?w:w.value,m=typeof E=="string"?E:E.value;return v.equalsIgnoreCase(g,m)}return w._lower===E._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=b;function R(h){return k(h)}e.isApplicationScopedExtension=R;function k(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function S(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function y(h,w){if(w){const E=`onResolveRemoteAuthority:${(0,D.getRemoteName)(w)}`;return h.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[32],ye([1,0,15,31,35,3,4,8,27]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,v.compareIgnoreCase)(o.id,n.id)===0}e.areSameExtensions=b;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(n){const i=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new k(n.identifier,i,s)}static parse(n){const i=R.exec(n);return i&&i[1]&&i[2]?new k({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,s="undefined"){this.version=i,this.targetPlatform=s,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof k?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=k;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(o){const n=S.exec(o);return n&&n[1]?[w(n[1]),n[2]]:[w(o),void 0]}e.getIdAndVersion=y;function h(o,n){return`${o}.${n}`}e.getExtensionId=h;function w(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=w;function E(o,n){return w(h(o,n))}e.getGalleryExtensionId=E;function g(o,n){const i=[],s=a=>{for(const c of i)if(c.some(d=>b(n(d),n(a))))return c;return null};for(const a of o){const c=s(a);c?c.push(a):i.push([a])}return i}e.groupByExtension=g;function m(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function u(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function l(o,n){const i=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&i.every(c=>!b(c.identifier,{id:a}))){const c=o.filter(d=>b(d.identifier,{id:a}));c.length===1&&(i.push(c[0]),s.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=l;async function f(o,n){if(!C.isLinux)return!1;let i;try{i=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=f;async function r(o,n){const i=await f(o,n),s=(0,t.getTargetPlatform)(i?"alpine":C.platform,p.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=r}),define(we[108],ye([1,0,20,8,12,19,50,4,163,31,32,35]),function(oe,e,v,t,D,C,T,I,p,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const S=E=>(0,p.localize)(0,null,E),y=(0,p.localize)(1,null,"ms-dotnettools.csharp");function h(E,g){return g?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let w=class{constructor(g,m){this.extensionManagementService=g,this.extensionGalleryService=m}get location(){}async listExtensions(g,m,u,l=console){let f=await this.extensionManagementService.getInstalled(1,u);const r=k.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(m&&m!==""){if(r.indexOf(m.toLowerCase())<0){l.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}f=f.filter(n=>n.manifest.categories?n.manifest.categories.map(s=>s.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){l.log("Possible Categories: "),r.forEach(n=>{l.log(n)});return}this.location&&l.log((0,p.localize)(2,null,this.location)),f=f.sort((n,i)=>n.identifier.id.localeCompare(i.identifier.id));let o;for(const n of f)o!==n.identifier.id&&(o=n.identifier.id,l.log(h(n.manifest,g)))}async installExtensions(g,m,u,l,f=console){const r=[],o=[];g.length&&f.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const n=await this.extensionManagementService.getInstalled(1,u.profileLocation),i=(d,P)=>{const F=n.find($=>(0,R.areSameExtensions)($.identifier,{id:d}));if(F){if(!l&&(!P||P==="prerelease"&&F.preRelease))return f.log((0,p.localize)(5,null,d,F.manifest.version,d)),!1;if(P&&F.manifest.version===P)return f.log((0,p.localize)(6,null,`${d}@${P}`)),!1}return!0},s=(d,P,F)=>{c.push({id:d,version:P!=="prerelease"?P:void 0,installOptions:{...u,isBuiltin:F,installPreReleaseVersion:P==="prerelease"||u.installPreReleaseVersion}})},a=[],c=[];for(const d of g)if(d instanceof I.URI)a.push(d);else{const[P,F]=(0,R.getIdAndVersion)(d);i(P,F)&&s(P,F,!1)}for(const d of m){const[P,F]=(0,R.getIdAndVersion)(d);i(P,F)&&s(P,F,!0)}if(a.length&&await Promise.all(a.map(async d=>{try{const P=await this.installVSIX(d,{...u,isBuiltin:!1},l,f);P&&o.push(P)}catch(P){f.error(P.message||P.stack||P),r.push(d.toString())}})),c.length){const d=await this.getGalleryExtensions(c);await Promise.all(c.map(async P=>{const F=d.get(P.id.toLowerCase());if(F)try{const $=await this.installFromGallery(P,F,n,l,f);$&&o.push($)}catch($){f.error($.message||$.stack||$),r.push(P.id)}else f.error(`${S(P.version?`${P.id}@${P.version}`:P.id)}
${y}`),r.push(P.id)}))}if(r.length)throw new Error((0,p.localize)(7,null,r.join(", ")))}async installVSIX(g,m,u,l){const f=await this.extensionManagementService.getManifest(g);if(!f)throw new Error("Invalid vsix");if(await this.validateVSIX(f,u,m.profileLocation,l))try{return await this.extensionManagementService.install(g,m),l.log((0,p.localize)(8,null,(0,C.basename)(g))),f}catch(o){if((0,t.isCancellationError)(o))return l.log((0,p.localize)(9,null,(0,C.basename)(g))),null;throw o}return null}async getGalleryExtensions(g){const m=new Map,u=g.some(f=>f.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(g.map(f=>({...f,preRelease:u})),v.CancellationToken.None);for(const f of l)m.set(f.identifier.id.toLowerCase(),f);return m}async installFromGallery({id:g,version:m,installOptions:u},l,f,r,o){const n=await this.extensionGalleryService.getManifest(l,v.CancellationToken.None);if(n&&!this.validateExtensionKind(n,o))return null;const i=f.find(s=>(0,R.areSameExtensions)(s.identifier,l.identifier));if(i){if(l.version===i.manifest.version)return o.log((0,p.localize)(10,null,m?`${g}@${m}`:g)),null;o.log((0,p.localize)(11,null,g,l.version))}try{u.isBuiltin?o.log(m?(0,p.localize)(12,null,g,m):(0,p.localize)(13,null,g)):o.log(m?(0,p.localize)(14,null,g,m):(0,p.localize)(15,null,g));const s=await this.extensionManagementService.installFromGallery(l,{...u,installGivenVersion:!!m});return o.log((0,p.localize)(16,null,g,s.manifest.version)),n}catch(s){if((0,t.isCancellationError)(s))return o.log((0,p.localize)(17,null,g)),null;throw s}}validateExtensionKind(g,m){return!0}async validateVSIX(g,m,u,l){const f={id:(0,R.getGalleryExtensionId)(g.publisher,g.name)},o=(await this.extensionManagementService.getInstalled(1,u)).find(n=>(0,R.areSameExtensions)(f,n.identifier)&&(0,T.gt)(n.manifest.version,g.version));return o&&!m?(l.log((0,p.localize)(18,null,o.identifier.id,o.manifest.version,g.version)),!1):this.validateExtensionKind(g,l)}async uninstallExtensions(g,m,u,l=console){const f=async o=>{if(o instanceof I.URI){const n=await this.extensionManagementService.getManifest(o);return h(n)}return o},r=[];for(const o of g){const n=await f(o),s=(await this.extensionManagementService.getInstalled(void 0,u)).filter(a=>(0,R.areSameExtensions)(a.identifier,{id:n}));if(!s.length)throw new Error(`${this.notInstalled(n)}
${y}`);if(s.some(a=>a.type===0)){l.log((0,p.localize)(19,null,n));return}if(!m&&s.some(a=>a.isBuiltin)){l.log((0,p.localize)(20,null,n));return}l.log((0,p.localize)(21,null,n));for(const a of s)await this.extensionManagementService.uninstall(a,{profileLocation:u}),r.push(a);this.location?l.log((0,p.localize)(22,null,n,this.location)):l.log((0,p.localize)(23,null,n))}}async locateExtension(g,m=console){const u=await this.extensionManagementService.getInstalled();g.forEach(l=>{u.forEach(f=>{if(f.identifier.id===l&&f.location.scheme===D.Schemas.file){m.log(f.location.fsPath);return}})})}notInstalled(g){return this.location?(0,p.localize)(24,null,g,this.location):(0,p.localize)(25,null,g)}};w=Re([_e(0,b.IExtensionManagementService),_e(1,b.IExtensionGalleryService)],w),e.ExtensionManagementCLI=w}),define(we[53],ye([1,0,14,16,2,24,4,32,17,5,13]),function(oe,e,v,t,D,C,T,I,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let k=class extends D.Disposable{constructor(y,h){super(),this.fileService=y,this.logService=h,this.resourcesAccessQueueMap=new C.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,h){return this.withProfileExtensions(h,w=>(w=w.filter(E=>y.some(([g])=>!(0,I.areSameExtensions)(E.identifier,g.identifier))),w.push(...y.map(([E,g])=>({identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:g}))),w))}removeExtensionFromProfile(y,h){return this.withProfileExtensions(h,w=>w.filter(E=>!(0,I.areSameExtensions)(E.identifier,y)))}async withProfileExtensions(y,h){return this.getResourceAccessQueue(y).queue(async()=>{let w=[];try{const E=await this.fileService.readFile(y),g=JSON.parse(E.value.toString());for(const m of g){if(!m.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",m);continue}if(!m.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",m);continue}if(!m.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",m);continue}w.push({identifier:m.identifier,location:T.URI.revive(m.location),version:m.version,metadata:m.metadata})}}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}if(h){w=h(w);const E=w.map(g=>({identifier:g.identifier,version:g.version,location:g.location.toJSON(),metadata:g.metadata}));await this.fileService.writeFile(y,t.VSBuffer.fromString(JSON.stringify(E)))}return w})}getResourceAccessQueue(y){let h=this.resourcesAccessQueueMap.get(y);return h||(h=new v.Queue,this.resourcesAccessQueueMap.set(y,h)),h}};k=Re([_e(0,p.IFileService),_e(1,R.ILogService)],k),e.ExtensionsProfileScannerService=k}),define(we[211],ye([1,0,14,8,2,3,19,50,4,23,21,29,31,32,17,13]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let E=class extends D.Disposable{constructor(m,u,l,f){super(),this.fileService=u,this.extensionGalleryService=l,this.logService=f,this.extensionsDownloadDir=p.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,u){await this.cleanUpPromise;const l=this.getName(m),f=(0,T.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(f)){const r=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(m,r,u);try{await this.rename(r,f,Date.now()+2*60*1e3)}catch(o){try{await this.fileService.del(r)}catch{}if(o.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(o)}. Deleted the vsix from downloaded location`,r.path),o}}return f}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,u,l){try{await R.Promises.rename(m.fsPath,u.fsPath)}catch(f){if(C.isWindows&&f&&f.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${m} to ${u} with 'EPERM' error. Trying again...`),this.rename(m,u,l);throw f}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const u=[],l=[];for(const o of m.children){const n=y.ExtensionKey.parse(o.name);n&&l.push([n,o])}const f=(0,y.groupByExtension)(l,([o])=>o),r=[];for(const o of f)o.sort((n,i)=>I.rcompare(n[0].version,i[0].version)),u.push(...o.slice(1).map(n=>n[1].resource)),r.push(o[0][1]);r.sort((o,n)=>o.mtime-n.mtime),u.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),await v.Promises.settled(u.map(o=>(this.logService.trace("Deleting vsix from cache",o.path),this.fileService.del(o))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?y.ExtensionKey.create(m).toString().toLowerCase():(0,b.generateUuid)()}};E=Re([_e(0,k.INativeEnvironmentService),_e(1,h.IFileService),_e(2,S.IExtensionGalleryService),_e(3,w.ILogService)],E),e.ExtensionsDownloader=E}),define(we[212],ye([1,0,2,6,21,35]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends v.Disposable{constructor(p,b){super(),this.environmentService=p,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(R=>this.onDidInstallExtensions(R))),this._register(b.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtensions(p){p.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(we[109],ye([1,0,110,18,14,2,12,6,21,29,31,32,13,74]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends y.LanguagePackBaseService{constructor(m,u,l,f){super(l),this.extensionManagementService=m,this.logService=f,this.cache=this._register(new w(u,f)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getInstalledLanguages(){const m=await this.cache.getLanguagePacks(),u=Object.keys(m).map(l=>{const f=m[l];return{...this.createQuickPickItem(l,f.label),extensionId:f.extensions[0].extensionIdentifier.id}});return u.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),u.sort((l,f)=>l.label.localeCompare(f.label)),u}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const u=await this.cache.getLanguagePacks();Object.keys(u).some(l=>u[l]&&u[l].extensions.some(f=>(0,k.areSameExtensions)(f.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(u);return!(0,t.equals)(Object.keys(m),Object.keys(l))}};h=Re([_e(0,R.IExtensionManagementService),_e(1,b.INativeEnvironmentService),_e(2,R.IExtensionGalleryService),_e(3,S.ILogService)],h),e.NativeLanguagePackService=h;let w=class extends C.Disposable{constructor(m,u){super(),this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(u=>{Object.keys(u).forEach(l=>delete u[l]),this.createLanguagePacksFromExtensions(u,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...u){for(const l of u)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,l);Object.keys(m).forEach(l=>this.updateHash(m[l]))}createLanguagePacksFromExtension(m,u){const l=u.identifier,f=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const r of f)if(u.location.scheme===T.Schemas.file&&E(r)){let o=m[r.languageId];o||(o={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=o);const n=o.extensions.filter(i=>(0,k.areSameExtensions)(i.extensionIdentifier,l))[0];n?n.version=u.manifest.version:o.extensions.push({extensionIdentifier:l,version:u.manifest.version});for(const i of r.translations)o.translations[i.id]=(0,I.join)(u.location.fsPath,i.path)}}updateHash(m){if(m){const u=(0,v.createHash)("md5");for(const l of m.extensions)u.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);m.hash=u.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(u=m(l),l)).then(l=>{for(const r of Object.keys(l))l[r]||delete l[r];this.languagePacks=l,this.initializedCache=!0;const f=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",f),p.Promises.writeFile(this.languagePacksFilePath,f)}).then(()=>u,l=>this.logService.error(l))})}};w=Re([_e(0,b.INativeEnvironmentService),_e(1,S.ILogService)],w);function E(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const m of g.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(we[54],ye([1,0,16,175,52,5,34]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function I(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=I;function p(w){return w.res.statusCode===204}async function b(w){return p(w)?null:(await(0,v.streamToBuffer)(w.stream)).toString()}e.asText=b;async function R(w){if(!I(w))throw new Error("Server returned "+w.res.statusCode);return b(w)}e.asTextOrError=R;async function k(w){if(!I(w))throw new Error("Server returned "+w.res.statusCode);if(p(w))return null;const g=(await(0,v.streamToBuffer)(w.stream)).toString();try{return JSON.parse(g)}catch(m){throw m.message+=`:
`+g,m}}e.asJson=k;function S(w){h(w)}e.updateProxyConfigurationsScope=S;let y;function h(w){const E=T.Registry.as(D.Extensions.Configuration),g=y;y={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[y],remove:g?[g]:[]})}h(2)}),define(we[213],ye([1,0,20,12,17,54]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(p,b){this.requestService=p,this.fileService=b}async download(p,b,R=v.CancellationToken.None){if(p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(p,b);return}const k={type:"GET",url:p.toString(!0)},S=await this.requestService.request(k,R);if(S.res.statusCode===200)await this.fileService.writeFile(b,S.stream);else{const y=await(0,C.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${y}`)}}};T=Re([_e(0,C.IRequestService),_e(1,D.IFileService)],T),e.DownloadService=T}),define(we[214],ye([1,0,16,20]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(I){this.service=I}listen(I,p){throw new Error("Invalid listen")}call(I,p,b,R=t.CancellationToken.None){switch(p){case"request":return this.service.request(b[0],R).then(async({res:k,stream:S})=>{const y=await(0,v.streamToBuffer)(S);return[{statusCode:k.statusCode,headers:k.headers},y]});case"resolveProxy":return this.service.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class C{constructor(I){this.channel=I}async request(I,p){const[b,R]=await this.channel.call("request",[I],p);return{res:b,stream:(0,v.bufferToStream)(R)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=C}),define(we[215],ye([1,0,76,11]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(T,I){return T.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:T.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(T,I,p={}){const b=(0,v.parse)(T),R=p.proxyUrl||D(b,I);if(!R)return null;const k=(0,v.parse)(R);if(!/^https?:$/.test(k.protocol||""))return null;const S={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((y,h)=>{oe(["http-proxy-agent"],y,h)}))(S):new(await new Promise((y,h)=>{oe(["https-proxy-agent"],y,h)}))(S)}e.getProxyAgent=C}),define(we[77],ye([1,0,48,6,176,20,38,8,3,23,148,189,14]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let h;async function w(g,m,u){return m["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(u)&&!m["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(u)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=S.Promises.withAsyncBody(async(l,f)=>{const r=new C.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),f(new Error((0,D.localize)(0,null)))},y);try{l(await E(g,r.token))}catch(n){!(0,I.isCancellationError)(n)&&!r.token.isCancellationRequested?f(new Error((0,D.localize)(1,null,(0,T.toErrorMessage)(n)))):l({})}finally{clearTimeout(o),r.dispose()}})),h)}e.getResolvedShellEnv=w;async function E(g,m){const u=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",u);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",l);const f=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(f+"(.*)"+f),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",o);const n=await(0,R.getSystemShell)(p.OS,o);return g.trace("getUnixShellEnvironment#shell",n),new Promise((i,s)=>{if(m.isCancellationRequested)return s((0,I.canceled)());const a=(0,t.basename)(n);let c,d;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${P} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,d=["-Login","-Command"]):(c=`'${process.execPath}' ${P} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,a==="tcsh"?d=["-ic"]:d=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),c);const F=(0,v.spawn)(n,[...d,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});m.onCancellationRequested(()=>(F.kill(),s((0,I.canceled)()))),F.on("error",J=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(J)),s(J)});const $=[];F.stdout.on("data",J=>$.push(J));const Z=[];F.stderr.on("data",J=>Z.push(J)),F.on("close",(J,_)=>{const ee=Buffer.concat($).toString("utf8");g.trace("getUnixShellEnvironment#raw",ee);const ne=Buffer.concat(Z).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),J||_)return s(new Error((0,D.localize)(2,null,J,_)));const B=r.exec(ee),ue=B?B[1]:"{}";try{const z=JSON.parse(ue);u?z.ELECTRON_RUN_AS_NODE=u:delete z.ELECTRON_RUN_AS_NODE,l?z.ELECTRON_NO_ATTACH_CONSOLE=l:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",z),i(z)}catch(z){g.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(z)),s(z)}})})}}),define(we[111],ye([1,0,3,27,4,23]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(v.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function I(b,R,k,S,y,h,w,E,g,m){const u=Object.create(null);u["common.machineId"]=w,u.sessionID=(0,C.generateUuid)()+Date.now(),u.commitHash=y,u.version=h,u["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,v.PlatformToString)(v.platform),u["common.nodePlatform"]=t.platform,u["common.nodeArch"]=S,u["common.product"]=m||"desktop",E&&(u["common.msftInternal"]=E);let l=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(u["common.snap"]="true");const r=T(k);r&&(u["common.platformDetail"]=r);try{const o=await b.readFile(D.URI.file(g));u["common.source"]=o.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=I;function p(b){const R=t.env.USERDNSDOMAIN;if(!R)return!1;const k=R.toLowerCase();return b.some(S=>k===S)}e.verifyMicrosoftInternalDomain=p}),define(we[216],ye([1,0,18,8,2,22,17]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var I;(function(b){function R(k,S){return k.callstack<S.callstack?-1:k.callstack>S.callstack?1:0}b.compare=R})(I=e.ErrorEvent||(e.ErrorEvent={}));class p{constructor(R,k=p.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new D.DisposableStore,this._telemetryService=R,this._flushDelay=k;const S=t.errorHandler.addListener(y=>this._onErrorEvent(y));this._disposables.add((0,D.toDisposable)(S)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(R){if(!R||(R.detail&&R.detail.stack&&(R=R.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(R)||R instanceof T.FileOperationError))return;const k=Array.isArray(R.stack)?R.stack.join(`
`):R.stack,S=R.message?R.message:(0,C.safeStringify)(R);!k||this._enqueue({msg:S,callstack:k})}_enqueue(R){const k=(0,v.binarySearch)(this._buffer,R,I.compare);k<0?(R.count=1,this._buffer.splice(~k,0,R)):(this._buffer[k].count||(this._buffer[k].count=0),this._buffer[k].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(const R of this._buffer)this._telemetryService.publicLogError2("UnhandledError",R);this._buffer.length=0}}e.default=p,p.ERROR_FLUSH_TIMEOUT=5*1e3}),define(we[217],ye([1,0,2]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends v.Disposable{constructor(C,T){super(),this.telemetryService=C,this.telemetryAppender=T}async call(C,T,I){switch(T){case"updateTelemetryLevel":{const{telemetryLevel:p}=I;return this.telemetryService.updateInjectedTelemetryLevel(p)}case"logTelemetry":{const{eventName:p,data:b}=I;return this.telemetryAppender?this.telemetryAppender.log(p,b):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${T} not found`)}listen(C,T,I){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(we[33],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(we[218],ye([1,0,28,44,14,65,12,6,3,4,90,21,94,196,17,26,33]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const g=new Map;async function m(o,n){const i=`${o}::${n.join(":")}`,s=g.get(i);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,d=new Map,P=2e4;function F(Z,J,_,ee){const ne=J.substring(Z.length+1);return D.Promises.withAsyncBody(async B=>{let ue;try{ue=await k.Promises.readdir(J,{withFileTypes:!0})}catch{B();return}if(ee.count>=P){ee.count+=ue.length,ee.maxReached=!0,B();return}let z=ue.length;if(z===0){B();return}let X=ue;ee.count+ue.length>P&&(ee.maxReached=!0,z=P-ee.count,X=ue.slice(0,z)),ee.count+=ue.length;for(const O of X)if(O.isDirectory()){if(_.includes(O.name)||await F(Z,(0,I.join)(J,O.name),_,ee),--z===0){B();return}}else{const U=O.name.lastIndexOf(".");if(U>=0){const x=O.name.substring(U+1);x&&c.set(x,(c.get(x)??0)+1)}for(const x of a)x.relativePathPattern?.test(ne)!==!1&&x.filePattern.test(O.name)&&d.set(x.tag,(d.get(x.tag)??0)+1);if(--z===0){B();return}}})}const $=D.Promises.withAsyncBody(async Z=>{const J={count:0,maxReached:!1};await F(o,o,n,J);const _=await f(o);Z({configFiles:u(d),fileTypes:u(c),fileCount:J.count,maxFilesReached:J.maxReached,launchConfigFiles:_})});return g.set(i,$),$}e.collectWorkspaceStats=m;function u(o){return[...t.Iterable.map(o.entries(),([n,i])=>({name:n,count:i}))].sort((n,i)=>i.count-n.count)}function l(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},n=v.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}e.getMachineInfo=l;async function f(o){try{const n=new Map,i=(0,I.join)(o,".vscode","launch.json"),s=await k.Promises.readFile(i),a=[],c=(0,C.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(c)==="object"&&c.configurations)for(const d of c.configurations){const P=d.type;P&&(n.has(P)?n.set(P,n.get(P)+1):n.set(P,1))}return u(n)}catch{return[]}}e.collectLaunchConfigs=f;let r=class{constructor(n,i){this.telemetryService=n,this.productService=i}formatMachineInfo(n){const i=[];return i.push(`OS Version:       ${n.os}`),i.push(`CPUs:             ${n.cpus}`),i.push(`Memory (System):  ${n.memory}`),i.push(`VM:               ${n.vmHint}`),i.join(`
`)}formatEnvironment(n){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const s=v.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(v.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),p.isWindows||i.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${n.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(n,i){return Promise.all([(0,S.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[a,c]=s,d=this.formatProcessList(n,a);return i.forEach(P=>{if((0,y.isRemoteDiagnosticError)(P))d+=`
${P.errorMessage}`,c+=`
${P.errorMessage}`;else if(d+=`

Remote: ${P.hostName}`,P.processes&&(d+=`
${this.formatProcessList(n,P.processes)}`),P.workspaceMetadata){c+=`
|  Remote: ${P.hostName}`;for(const F of Object.keys(P.workspaceMetadata)){const $=P.workspaceMetadata[F];let Z=`${$.fileCount} files`;$.maxFilesReached&&(Z=`more than ${Z}`),c+=`|    Folder (${F}): ${Z}`,c+=this.formatWorkspaceStats($)}}}),{processInfo:d,workspaceInfo:c}})}async getSystemInfo(n,i){const{memory:s,vmHint:a,os:c,cpus:d}=l(),P={os:c,memory:s,cpus:d,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:i};return p.isWindows||(P.load=`${v.loadavg().map(F=>Math.round(F)).join(", ")}`),p.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(n,i){const s=[];return(0,S.listProcesses)(n.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,a)),n.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),i.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))s.push(`
${c.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${c.hostName}`),s.push(this.formatMachineInfo(c.machineInfo)),c.processes&&s.push(this.formatProcessList(n,c.processes)),c.workspaceMetadata)for(const d of Object.keys(c.workspaceMetadata)){const P=c.workspaceMetadata[d];let F=`${P.fileCount} files`;P.maxFilesReached&&(F=`more than ${F}`),s.push(`Folder (${d}): ${F}`),s.push(this.formatWorkspaceStats(P))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const i=[];let a=0;const c=($,Z)=>{const J=` ${$}(${Z})`;a+J.length>60?(i.push(d),d="|                 ",a=d.length):a+=J.length,d+=J};let d="|      File types:";const P=10,F=n.fileTypes.length>P?P:n.fileTypes.length;for(let $=0;$<F;$++){const Z=n.fileTypes[$];c(Z.name,Z.count)}if(i.push(d),n.configFiles.length>=0&&(d="|      Conf files:",a=0,n.configFiles.forEach($=>{c($.name,$.count)}),i.push(d)),n.launchConfigFiles.length>0){let $="|      Launch Configs:";n.launchConfigFiles.forEach(Z=>{$+=Z.count>1?` ${Z.name}(${Z.count})`:` ${Z.name}`}),i.push($)}return i.join(`
`)}expandGPUFeatures(n){const i=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const i=[],s=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const d=b.URI.revive(c);if(d.scheme===T.Schemas.file){const P=d.fsPath;s.push(m(P,["node_modules",".git"]).then(F=>{let $=`${F.fileCount} files`;F.maxFilesReached&&($=`more than ${$}`),i.push(`|    Folder (${(0,I.basename)(P)}): ${$}`),i.push(this.formatWorkspaceStats(F))}).catch(F=>{i.push(`|      Error: Unable to collect workspace stats for folder ${P} (${F.toString()})`)}))}else i.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(n,i){const s=new Map;n.windows.forEach(c=>s.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(n.mainPID,s,a,i,0),a.join(`
`)}formatProcessItem(n,i,s,a,c){const d=c===0;let P;d?P=a.pid===n?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(P=`${P} (${i.get(a.pid)})`));const F=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(F/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(a.children)&&a.children.forEach($=>this.formatProcessItem(n,i,s,$,c+1))}async getWorkspaceFileExtensions(n){const i=new Set;for(const{uri:s}of n.folders){const a=b.URI.revive(s);if(a.scheme!==T.Schemas.file)continue;const c=a.fsPath;try{(await m(c,["node_modules",".git"])).fileTypes.forEach(P=>i.add(P.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(n){for(const{uri:i}of n.folders){const s=b.URI.revive(i);if(s.scheme!==T.Schemas.file)continue;const a=s.fsPath;try{const c=await m(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),c.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})}),c.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})}),c.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};r=Re([_e(0,E.ITelemetryService),_e(1,w.IProductService)],r),e.DiagnosticsService=r}),define(we[43],ye([1,0,22,85,11,25,111,33]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class b{async publicLog(r,o,n){}async publicLogError(r,o,n){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(f,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&f.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(o.source),configurationKeys:g(o.sourceConfig)})})}e.configurationTelemetry=R;function k(f,r){return!(r.disableTelemetry||!f.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=k;function S(f){const r=f.getValue(I.TELEMETRY_SETTING_ID),o=f.getValue("telemetry.enableCrashReporter");if(f.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function y(f){const r={},o={},n={};E(f,n);for(let i in n){i=i.length>150?i.substr(i.length-149):i;const s=n[i];typeof s=="number"?o[i]=s:typeof s=="boolean"?o[i]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${s.length}`),r[i]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(r[i]=s)}return{properties:r,measurements:o}}e.validateTelemetryData=y;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function w(f){if(!f)return"none";for(const r of h)if(f.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=w;function E(f,r,o=0,n){if(!!f)for(const i of Object.getOwnPropertyNames(f)){const s=f[i],a=n?n+i:i;Array.isArray(s)?r[a]=(0,v.safeStringify)(s):s instanceof Date?r[a]=s.toISOString():(0,D.isObject)(s)?o<2?E(s,r,o+1,a+"."):r[a]=(0,v.safeStringify)(s):r[a]=s}}function g(f){if(!f)return[];const r=[];return m(r,"",f),r}function m(f,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>m(f,r?`${r}.${n}`:n,o[n])):f.push(r)}function u(f,r){const o=f.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=u;function l(f){return[f.appRoot,f.extensionsPath,f.userHome.fsPath,f.tmpDir.fsPath,f.userDataPath]}e.getPiiPathsFromEnvironment=l}),define(we[219],ye([1,0,193,43]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(C,T,I,p,b,R,k){const S={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${T.nameShort})`};if((0,t.supportsTelemetry)(T,I)&&(0,t.getTelemetryLevel)(p)===3){const y=await(0,v.getServiceMachineId)(I,b,R),{sessionId:h}=await k.getTelemetryInfo();S["X-Market-User-Id"]=y,S["VSCode-SessionId"]=h}return S}e.resolveMarketplaceHeaders=D}),define(we[220],ye([1,0,8,22,43]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(p,b,R){const k=await new Promise((E,g)=>{oe(["@microsoft/1ds-core-js"],E,g)}),S=await new Promise((E,g)=>{oe(["@microsoft/1ds-post-js"],E,g)}),y=new k.AppInsightsCore,h=new S.PostChannel,w={instrumentationKey:p,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(R){w.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:R};w.extensionConfig[h.identifier]=E}return y.initialize(w,[]),y.addTelemetryInitializer(E=>{b&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),y}class I{constructor(b,R,k,S,y){this._isInternalTelemetry=b,this._eventPrefix=R,this._defaultData=k,this._xhrOverride=y,this.endPointUrl=C,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(b){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(R=>{b(R)},R=>{(0,v.onUnexpectedError)(R),console.error(R)})}}log(b,R){if(!this._aiCoreOrKey)return;R=(0,t.mixin)(R,this._defaultData),R=(0,D.validateTelemetryData)(R);const k=this._eventPrefix+"/"+b;try{this._withAIClient(S=>{S.pluginVersionString=R?.properties.version??"Unknown",S.track({name:k,baseData:{name:k,properties:R?.properties,measurements:R?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(R=>{R.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(we[221],ye([1,0,2,22,85,3,15,177,25,52,51,26,34,33,43]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(m,u,l){this._configurationService=u,this._productService=l,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(f),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,u){this._experimentProperties[m]=u}_updateTelemetryLevel(){let m=(0,h.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const l=u.usage?3:u.error?2:0;m=Math.min(m,l)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const m=await this._commonProperties,u=m.sessionID,l=m["common.machineId"],f=m["common.firstSessionDate"],r=m["common.msftInternal"];return{sessionId:u,machineId:l,firstSessionDate:f,msftInternal:r}}dispose(){this._disposables.dispose()}_log(m,u,l,f){return this.telemetryLevel.value<u?Promise.resolve(void 0):this._commonProperties.then(r=>{l=(0,t.mixin)(l,r),l=(0,t.mixin)(l,this._experimentProperties),l=(0,t.cloneAndChange)(l,o=>{if(typeof o=="string")return this._cleanupInfo(o,f)}),this._appenders.forEach(o=>o.log(m,l))},r=>{console.error(r)})}publicLog(m,u,l){return this._log(m,3,u,l)}publicLog2(m,u,l){return this.publicLog(m,u,l)}publicLogError(m,u){return this._sendErrorTelemetry?this._log(m,2,u,!0):Promise.resolve(void 0)}publicLogError2(m,u){return this.publicLogError(m,u)}_anonymizeFilePaths(m){let u=m;const l=[];for(const n of this._cleanupPatterns)for(;;){const i=n.exec(m);if(!i)break;l.push([i.index,n.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(u="";;){const n=r.exec(m);if(!n)break;!f.test(n[0])&&l.every(([i,s])=>n.index<i||n.index>=s)&&(u+=m.substring(o,n.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<m.length&&(u+=m.substr(o)),u}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const u=m.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const f of l)if(f.regex.test(u))return`<REDACTED: ${f.label}>`;return m}_cleanupInfo(m,u){let l=m;u&&(l=this._anonymizeFilePaths(l));for(const f of this._cleanupPatterns)l=l.replace(f,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=Re([_e(1,p.IConfigurationService),_e(2,k.IProductService)],w),e.TelemetryService=w;function E(){const g=(0,I.localize)(0,null,R.default.nameLong),m=R.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",R.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=C.isWeb?"":(0,I.localize)(3,null),l=(0,I.localize)(4,null),f=(0,I.localize)(5,null),r=(0,I.localize)(6,null),o=(0,I.localize)(7,null),n=`
|       | ${l} | ${f} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,I.localize)(8,null);return`
${g} ${m} ${u}

&nbsp;

${o}
${n}

&nbsp;

${i}
`}S.Registry.as(b.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(b.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:R.default.privacyStatementUrl?(0,I.localize)(16,null,R.default.nameLong,R.default.privacyStatementUrl):(0,I.localize)(15,null,R.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[222],ye([1,0,25,5,26,33,221,43]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let p=class extends T.TelemetryService{constructor(R,k,S,y){super(R,S,y),this._injectedTelemetryLevel=k}publicLog(R,k,S){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(R,k,S)}publicLog2(R,k,S){return this.publicLog(R,k,S)}publicLogError(R,k){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(R,k)}publicLogError2(R,k){return this.publicLogError(R,k)}async updateInjectedTelemetryLevel(R){if(R===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,R):R,this._injectedTelemetryLevel===0&&this.dispose()}};p=Re([_e(2,v.IConfigurationService),_e(3,D.IProductService)],p),e.ServerTelemetryService=p,e.ServerNullTelemetryService=new class extends I.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(C.ITelemetryService)}),define(we[223],ye([1,0,224,220]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends t.AbstractOneDataSystemAppender{constructor(T,I,p,b){const R={sendPOST:(k,S)=>{const y={method:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data)}};try{const h=v.request(k.urlString,y,w=>{w.on("data",function(E){S(w.statusCode??200,w.headers,E.toString())}),w.on("error",function(E){S(0,{})})});h.write(k.data),h.end()}catch{S(0,{})}}};super(T,I,p,b,R)}}e.OneDataSystemAppender=D}),define(we[225],ye([1,0,8,216]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class D extends t.default{installErrorListeners(){(0,v.setUnexpectedErrorHandler)(I=>console.error(I));const T=[];process.on("unhandledRejection",(I,p)=>{T.push(p),setTimeout(()=>{const b=T.indexOf(p);b>=0&&p.catch(R=>{T.splice(b,1),(0,v.isCancellationError)(R)||(console.warn(`rejected promise not handled within 1 second: ${R}`),R.stack&&console.warn(`stack trace: ${R.stack}`),I&&(0,v.onUnexpectedError)(I))})},1e3)}),process.on("rejectionHandled",I=>{const p=T.indexOf(I);p>=0&&T.splice(p,1)}),process.on("uncaughtException",I=>{(0,v.onUnexpectedError)(I)})}}e.default=D}),define(we[226],ye([1,0,14,20,7,2,13]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends C.Disposable{constructor(b,R){super(),this._logService=R,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((R,k)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,R),this._onCreateRequest.fire({requestId:S,...b});const y=new t.CancellationTokenSource;(0,v.timeout)(this._timeout,y.token).then(()=>k(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,C.toDisposable)(()=>y.cancel())])})}acceptReply(b,R){const k=this._pendingRequests.get(b);k?(this._pendingRequests.delete(b),(0,C.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),k(R)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};I=Re([_e(1,T.ILogService)],I),e.RequestStore=I}),define(we[112],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(u){u.FileName="ptyhost"})(C=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var I;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var p;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(p=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,v.createDecorator)("ptyService");var R;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(R=e.ProcessPropertyType||(e.ProcessPropertyType={}));var k;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(S=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var w;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(w=e.FlowControlConstants||(e.FlowControlConstants={}));var E;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(E=e.ProfileSource||(e.ProfileSource={}));var g;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(g=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(we[227],ye([1,0,28,12,22,6,3,27,15,11,21]),function(oe,e,v,t,D,C,T,I,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function k(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let f=0;return l&&l.length===4&&(f=parseInt(l[3])),f}e.getWindowsBuildNumber=k;async function S(l,f,r,o=I.env,n=R.Promises.exists){if(C.isAbsolute(l))return await n(l)?l:void 0;if(f===void 0&&(f=I.cwd()),C.dirname(l)!=="."){const c=C.join(f,l);return await n(c)?c:void 0}const s=(0,D.getCaseInsensitive)(o,"PATH");if(r===void 0&&(0,b.isString)(s)&&(r=s.split(C.delimiter)),r===void 0||r.length===0){const c=C.join(f,l);return await n(c)?c:void 0}for(const c of r){let d;if(C.isAbsolute(c)?d=C.join(c,l):d=C.join(f,c,l),await n(d))return d;if(T.isWindows){let P=d+".com";if(await n(P)||(P=d+".exe",await n(P)))return P}}const a=C.join(f,l);return await n(a)?a:void 0}e.findExecutable=S;function y(l,f,r,o,n){if(!f.shellIntegration.enabled||!l.executable||l.isFeatureTerminal||l.hideFromUser||l.ignoreShellIntegration||T.isWindows&&!f.windowsEnableConpty)return;const i=l.args,s=I.platform==="win32"?C.basename(l.executable).toLowerCase():C.basename(l.executable),a=C.dirname(t.FileAccess.asFileUri("",oe).fsPath);let c;const d={VSCODE_INJECTION:"1"};if(T.isWindows){if(s==="pwsh.exe")return!i||m(i)?c=e.shellIntegrationArgs.get(h.WindowsPwsh):g(i)&&(c=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),c?(c=[...c],c[c.length-1]=(0,p.format)(c[c.length-1],a,""),{newArgs:c,envMixin:d}):void 0;o.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(s){case"bash":return!i||i.length===0?c=e.shellIntegrationArgs.get(h.Bash):u(i)&&(d.VSCODE_SHELL_LOGIN="1",c=e.shellIntegrationArgs.get(h.Bash)),c?(c=[...c],c[c.length-1]=(0,p.format)(c[c.length-1],a),{newArgs:c,envMixin:d}):void 0;case"pwsh":return!i||m(i)?c=e.shellIntegrationArgs.get(h.Pwsh):g(i)&&(c=e.shellIntegrationArgs.get(h.PwshLogin)),c?(c=[...c],c[c.length-1]=(0,p.format)(c[c.length-1],a,""),{newArgs:c,envMixin:d}):void 0;case"zsh":{if(!i||i.length===0?c=e.shellIntegrationArgs.get(h.Zsh):u(i)?c=e.shellIntegrationArgs.get(h.ZshLogin):(i===e.shellIntegrationArgs.get(h.Zsh)||i===e.shellIntegrationArgs.get(h.ZshLogin))&&(c=i),!c)return;c=[...c],c[c.length-1]=(0,p.format)(c[c.length-1],a);const P=C.join(v.tmpdir(),`${v.userInfo().username}-${n.applicationName}-zsh`);d.ZDOTDIR=P;const F=r?.ZDOTDIR??v.homedir()??"~";d.USER_ZDOTDIR=F;const $=[];return $.push({source:C.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:C.join(P,".zshrc")}),$.push({source:C.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:C.join(P,".zprofile")}),$.push({source:C.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:C.join(P,".zshenv")}),$.push({source:C.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:C.join(P,".zlogin")}),{newArgs:c,envMixin:d,filesToCopy:$}}}o.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}e.getShellIntegrationInjection=y;var h;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],E=["-nol","-nologo"];function g(l){return typeof l=="string"?w.includes(l.toLowerCase()):l.length===1&&w.includes(l[0].toLowerCase())||l.length===2&&(w.includes(l[0].toLowerCase())||w.includes(l[1].toLowerCase()))&&(E.includes(l[0].toLowerCase())||E.includes(l[1].toLowerCase()))}function m(l){return typeof l=="string"?E.includes(l.toLowerCase()):l.length===0||l?.length===1&&E.includes(l[0].toLowerCase())}function u(l){return l==="string"&&w.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&w.includes(l[0].toLowerCase())}}),define(we[228],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(C){C.DARK="dark",C.LIGHT="light",C.HIGH_CONTRAST_DARK="hcDark",C.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(C){return C===v.HIGH_CONTRAST_DARK||C===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(C){return C===v.DARK||C===v.HIGH_CONTRAST_DARK}e.isDark=D}),define(we[113],ye([1,0,41,7,2,5,34,228]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var p;(function(E){function g(m){return m&&typeof m=="object"&&typeof m.id=="string"}E.isThemeColor=g})(p=e.ThemeColor||(e.ThemeColor={}));function b(E){return{id:E}}e.themeColorFromId=b;var R;(function(E){function g(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||p.isThemeColor(i.color))}E.isThemeIcon=g;const m=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const s=m.exec(i);if(!s)return;const[,a]=s;return{id:a}}E.fromString=u;function l(i){return{id:i}}E.fromId=l;function f(i,s){let a=i.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),s&&(a=`${a}~${s}`),{id:a}}E.modify=f;function r(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}E.getModifier=r;function o(i,s){return i.id===s.id&&i.color?.id===s.color?.id}E.isEqual=o;function n(i,s){return{id:i.id,color:s?b(s):void 0}}E.asThemeIcon=n,E.asClassNameArray=v.CSSIcon.asClassNameArray,E.asClassName=v.CSSIcon.asClassName,E.asCSSSelector=v.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function k(E){switch(E){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,D.toDisposable)(()=>{const m=this.themingParticipants.indexOf(g);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const y=new S;T.Registry.add(e.Extensions.ThemingContribution,y);function h(E){return y.onColorThemeChange(E)}e.registerThemingParticipant=h;class w extends D.Disposable{constructor(g){super(),this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,m){let u=this.theme.getColor(g);return u&&m&&(u=m(u,this.theme)),u?u.toString():null}}e.Themable=w}),define(we[229],ye([1,0,41,4,179,113]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(S,y){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...S.map(w=>({name:w.profileName,description:I(w)}))),y&&h.push(...y.map(w=>({name:w.title,description:p(w)}))),{values:h.map(w=>w.name),markdownDescriptions:h.map(w=>w.description)}}e.createProfileSchemaEnums=T;function I(S){let y=`$(${C.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:v.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?y+=`
- args: "${S.args}"`:y+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(y+=`
- overrideName: ${S.overrideName}`),S.color&&(y+=`
- color: ${S.color}`),S.env&&(y+=`
- env: ${JSON.stringify(S.env)}`),y}function p(S){return`$(${C.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:v.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function b(S,y){if(!S&&!y)return!0;if(typeof S=="string"&&typeof y=="string")return S===y;if(Array.isArray(S)&&Array.isArray(y)){if(S.length!==y.length)return!1;for(let h=0;h<S.length;h++)if(S[h]!==y[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function R(S,y){if(!S&&!y)return!0;if(!S||!y)return!1;if(C.ThemeIcon.isThemeIcon(S)&&C.ThemeIcon.isThemeIcon(y))return S.id===y.id&&S.color===y.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof y=="object"&&"light"in y&&"dark"in y){const h=S,w=y;if((t.URI.isUri(h.light)||k(h.light))&&(t.URI.isUri(h.dark)||k(h.dark))&&(t.URI.isUri(w.light)||k(w.light))&&(t.URI.isUri(w.dark)||k(w.dark)))return h.light.path===w.light.path&&h.dark.path===w.dark.path}if(t.URI.isUri(S)&&t.URI.isUri(y)||k(S)||k(y)){const h=S,w=y;return h.path===w.path&&h.scheme===w.scheme}return!1}e.terminalIconsEqual=R;function k(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=k}),define(we[230],ye([1,0,41,178,52,34,229]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(v.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(v.Codicon.getAll(),l=>`$(${l.id})`)};const I={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...I}},R=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),k=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),S=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),w=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),E={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:k},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:k},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:S},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...I}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...I}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...I}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){C.Registry.as(D.Extensions.Configuration).registerConfiguration(E),u()}e.registerTerminalPlatformConfiguration=g;let m;function u(l,f){const r=C.Registry.as(D.Extensions.Configuration);let o;l&&(o=(0,T.createProfileSchemaEnums)(l?.profiles,f));const n=m;m={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?o?.values:void 0,markdownEnumDescriptions:l?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?o?.values:void 0,markdownEnumDescriptions:l?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?o?.values:void 0,markdownEnumDescriptions:l?.os===1?o?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[m],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(we[231],ye([1,0,48,41,6,3,21,92,227,113]),function(oe,e,v,t,D,C,T,I,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R,k=!0;function S(o,n,i,s,a=process.env,c,d,P,F){return c=c||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},C.isWindows?y(i,c,a,d,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),F,P):l(c,d,i,o&&typeof o=="object"?{...o}:s.getValue(C.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(C.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,P,a)}e.detectAvailableProfiles=S;async function y(o,n,i,s,a,c,d,P,F){const $=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Z=`${process.env.windir}\\${$?"Sysnative":"System32"}`;let J=!1;(0,p.getWindowsBuildNumber)()>=16299&&(J=!0),await E(P);const _=new Map;o&&(_.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${Z}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Command Prompt",{path:`${Z}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),f(c,_);const ee=await h(_.entries(),d,n,i,s,F);if(o||a)try{const ne=await m(`${Z}\\${J?"wsl":"bash"}.exe`,d);for(const B of ne)(!c||!(B.profileName in c))&&ee.push(B)}catch{k&&(s?.info("WSL is not installed, so could not detect WSL profiles"),k=!1)}return ee}async function h(o,n,i,s=process.env,a,c){const d=[];for(const[P,F]of o){if(F===null)continue;let $,Z,J;if("source"in F){const ne=R?.get(F.source);if(!ne)continue;$=ne.paths,Z=F.args||ne.args,F.icon?J=w(F.icon):ne.icon&&(J=ne.icon)}else $=Array.isArray(F.path)?F.path:[F.path],Z=C.isWindows||Array.isArray(F.args)?F.args:void 0,J=w(F.icon);const _=await c?.($)||$.slice(),ee=await r(P,n,_,i,s,Z,F.env,F.overrideName,F.isAutoDetected,a);ee?(ee.isAutoDetected=F.isAutoDetected,ee.icon=J,ee.color=F.color,d.push(ee)):a?.debug("Terminal profile not validated",P,$)}return a?.debug("Validated terminal profiles",d),d}function w(o){return typeof o=="string"?{id:o}:o}async function E(o){R&&!o||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:o||await g(),icon:b.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function g(){const o=[];for await(const n of(0,I.enumeratePowerShellInstallations)())o.push(n.exePath);return o}async function m(o,n){const i=[],s=await new Promise((d,P)=>{v.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,$)=>{if(F)return P("Problem occurred when getting wsl distros");d($)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),c=s.split(a).filter(d=>d.trim().length>0&&d!=="");for(const d of c){if(d===""||d.startsWith("docker-desktop"))continue;const P=`${d} (WSL)`,F={profileName:P,path:o,args:["-d",`${d}`],isDefault:P===n,icon:u(d),isAutoDetected:!1};i.push(F)}return i}function u(o){return o.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):o.includes("Debian")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function l(o,n,i,s,a,c,d,P){const F=new Map;if(i){const $=(await o.readFile("/etc/shells")).toString(),Z=c||$.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),J=new Map;for(const _ of Z){let ee=(0,D.basename)(_),ne=J.get(ee)||0;ne++,ne>1&&(ee=`${ee} (${ne})`),J.set(ee,ne),F.set(ee,{path:_,isAutoDetected:!0})}}return f(s,F),await h(F.entries(),a,o,P,n,d)}function f(o,n){if(!!o)for(const[i,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?n.delete(i):(s.icon=s.icon||n.get(i)?.icon,n.set(i,s))}async function r(o,n,i,s,a,c,d,P,F,$){if(i.length===0)return Promise.resolve(void 0);const Z=i.shift();if(Z==="")return r(o,n,i,s,a,c,d,P,F);const J={profileName:o,path:Z,args:c,env:d,overrideName:P,isAutoDetected:F,isDefault:o===n};if((0,D.basename)(Z)===Z){const ee=a.PATH?a.PATH.split(D.delimiter):void 0,ne=await(0,p.findExecutable)(Z,void 0,ee,void 0,s.existsFile);return ne?(J.path=ne,J.isFromPath=!0,J):r(o,n,i,s,a,c)}return await s.existsFile((0,D.normalize)(Z))?J:r(o,n,i,s,a,c,d,P,F)}}),define(we[232],ye([1,0,7,2,12,3,42,96,25,29,98,77,13,103,226,112,230,231]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let u=0,l=class extends t.Disposable{constructor(r,o,n,i){super(),this._reconnectConstants=r,this._configurationService=o,this._environmentService=n,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new v.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new v.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new v.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new v.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new v.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new v.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new v.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new v.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new v.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new v.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new v.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new v.Emitter),this.onProcessExit=this._onProcessExit.event,(0,E.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(C.isWindows)return process.env;try{return await(0,k.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,R.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?r.debugBrk=o.port:!o.break&&o.port&&(r.debug=o.port));const n=new I.Client(D.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,r);this._onPtyHostStart.fire(),T.ProxyChannel.toService(n.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(c=>{this._onPtyHostExit.fire(c.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const s=n.getChannel(w.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const a=T.ProxyChannel.toService(n.getChannel(w.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(c=>this._onProcessData.fire(c))),this._register(a.onProcessReady(c=>this._onProcessReady.fire(c))),this._register(a.onProcessExit(c=>this._onProcessExit.fire(c))),this._register(a.onDidChangeProperty(c=>this._onDidChangeProperty.fire(c))),this._register(a.onProcessReplay(c=>this._onProcessReplay.fire(c))),this._register(a.onProcessOrphanQuestion(c=>this._onProcessOrphanQuestion.fire(c))),this._register(a.onDidRequestDetach(c=>this._onDidRequestDetach.fire(c))),[n,a]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,o,n,i,s,a,c,d,P,F,$){const Z=setTimeout(()=>this._handleUnresponsiveCreateProcess(),w.HeartbeatConstants.CreateProcessTimeout),J=await this._proxy.createProcess(r,o,n,i,s,a,c,d,P,F,$);return clearTimeout(Z),u=Math.max(u,J),J}updateTitle(r,o,n){return this._proxy.updateTitle(r,o,n)}updateIcon(r,o,n,i){return this._proxy.updateIcon(r,o,n,i)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r,o){return this._proxy.detachFromProcess(r,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,o){return this._proxy.shutdown(r,o)}input(r,o){return this._proxy.input(r,o)}processBinary(r,o){return this._proxy.processBinary(r,o)}resize(r,o,n){return this._proxy.resize(r,o,n)}acknowledgeDataEvent(r,o){return this._proxy.acknowledgeDataEvent(r,o)}setUnicodeVersion(r,o){return this._proxy.setUnicodeVersion(r,o)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,o){return this._proxy.installAutoReply(r,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,o,n,i=!1){const s=await this._shellEnv;return(0,g.detectAvailableProfiles)(o,n,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}getRevivedPtyNewId(r){return this._proxy.getRevivedPtyNewId(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,o){return this._proxy.requestDetachInstance(r,o)}async acceptDetachInstanceReply(r,o){return this._proxy.acceptDetachInstanceReply(r,o)}async freePortKillProcess(r,o){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(r,o)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,o){return this._proxy.reviveTerminalProcesses(r,o)}async refreshProperty(r,o){return this._proxy.refreshProperty(r,o)}async updateProperty(r,o,n){return this._proxy.updateProperty(r,o,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:o})}async acceptPtyHostResolvedVariables(r,o){this._resolveVariablesRequestStore.acceptReply(r,o)}};l=Re([_e(1,p.IConfigurationService),_e(2,b.IEnvironmentService),_e(3,S.ILogService)],l),e.PtyHostService=l}),define(we[39],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(we[233],ye([1,0,7,2,4,29,32,17,13,39]),function(oe,e,v,t,D,C,T,I,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends t.Disposable{constructor(S,y,h,w,E){super(),this.extensionsManagementService=S,this.logService=w,this.uriIdentityService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new v.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(m=>{this.installedExtensions=m.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(S.onInstallExtension(m=>this.onInstallExtension(m))),this._register(S.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(S.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const g=D.URI.file(h.extensionsPath);this._register(y.watch(g)),this._register(v.Event.filter(y.onDidFilesChange,m=>m.rawChanges.some(u=>this.doesChangeAffects(u,g)))(()=>this.onDidChange()))}doesChangeAffects(S,y){return S.type!==1&&S.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(S.resource),y)?!1:this.uriIdentityService.extUri.isEqual(S.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(S.resource).startsWith(".")}onInstallExtension(S){this.addInstallingExtension(S.identifier)}onDidInstallExtensions(S){for(const y of S)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(S){S.error||this.removeInstalledExtension(S.identifier)}addInstallingExtension(S){this.removeInstallingExtension(S),this.installingExtensions.push(S)}removeInstallingExtension(S){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,S))}addInstalledExtension(S){this.installedExtensions&&(this.removeInstalledExtension(S),this.installedExtensions.push(S))}removeInstalledExtension(S){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,S)))}async onDidChange(){if(this.installedExtensions){const S=await this.extensionsManagementService.getInstalled(),y=S.filter(w=>[...this.installingExtensions,...this.installedExtensions].some(E=>(0,T.areSameExtensions)(E,w.identifier))?!1:w.installedTimestamp&&w.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",w.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",w.identifier.id),!1)),h=this.installedExtensions.filter(w=>this.installingExtensions.some(E=>(0,T.areSameExtensions)(E,w))?!1:S.every(E=>!(0,T.areSameExtensions)(E.identifier,w))?(this.logService.info("Detected extension removed from another source",w.id),!0):!1);this.installedExtensions=S.map(w=>w.identifier),(y.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:h})}}};R=Re([_e(1,I.IFileService),_e(2,C.INativeEnvironmentService),_e(3,p.ILogService),_e(4,b.IUriIdentityService)],R),e.ExtensionsWatcher=R}),define(we[114],ye([1,0,39,194,17,19,137,7,2]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(S){this.uri=S,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let R=class{constructor(S){this._fileService=S,this._dispooables=new p.DisposableStore,this._limit=2**16;const y=new Map,h=w=>{let E=y.get(w.scheme);return E===void 0&&(E=S.hasProvider(w)&&!this._fileService.hasCapability(w,1024),y.set(w.scheme,E)),E};this._dispooables.add(I.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(w=>{y.delete(w.scheme)})),this.extUri=new C.ExtUri(h),this._canonicalUris=new T.SkipList((w,E)=>this.extUri.compare(w,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,C.normalizePath)(S));const y=this._canonicalUris.get(S);return y?y.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new b(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((h,w)=>h[1].touch<w[1].touch?1:h[1].touch>w[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let h=0;h<y;h++)this._canonicalUris.set(S[h][0],S[h][1].touch())}};R=Re([_e(0,D.IFileService)],R),e.UriIdentityService=R,(0,t.registerSingleton)(v.IUriIdentityService,R,!0)}),define(we[78],ye([1,0,181,6,24,19,4,5,12]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function b(o){const n=o;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(o,n){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=o;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=R;function k(o){const n=o;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=k;function S(o){const n=o;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const i=o;if(i?.configPath)return{id:i.id,configPath:T.URI.revive(i.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=S;var y;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function h(o){const n=o;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=h;function w(o){const n=o;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=w;class E{constructor(n,i,s,a,c){this._id=n,this._transient=s,this._configuration=a,this._ignorePathCasing=c,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class g{constructor(n,i){this.raw=i,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,C.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function m(o){return new g({uri:o,index:0,name:(0,C.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(o,n){return C.extUriBiasedIgnorePathCase.isEqualOrParent(o,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function l(o){let n;return T.URI.isUri(o)?n=o:n=o.configuration,n?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=l;function f(o,n){return!u(o,n)&&!l(o)}e.isSavedWorkspace=f;function r(o){return(typeof o=="string"?(0,t.extname)(o):(0,C.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(we[37],ye([1,0,86,7,2,19,11,4,180,29,17,5,13,78,24,39,14,23,15]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function u(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&I.URI.isUri(i.location)&&I.URI.isUri(i.globalStorageHome)&&I.URI.isUri(i.settingsResource)&&I.URI.isUri(i.keybindingsResource)&&I.URI.isUri(i.tasksResource)&&I.URI.isUri(i.snippetsHome)&&((0,T.isUndefined)(i.extensionsResource)||I.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=u,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,k.createDecorator)("IUserDataProfilesService");function l(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:I.URI.revive(n.location).with({scheme:i}),globalStorageHome:I.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:I.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:I.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:I.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:I.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:I.URI.revive(n.extensionsResource)?.with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=l,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function f(n,i,s,a){return{id:n,name:i,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,C.joinPath)(s,"globalStorage"),settingsResource:(0,C.joinPath)(s,"settings.json"),keybindingsResource:(0,C.joinPath)(s,"keybindings.json"),tasksResource:(0,C.joinPath)(s,"tasks.json"),snippetsHome:(0,C.joinPath)(s,"snippets"),extensionsResource:(0,C.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=f;let r=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,s,a,c){super(),this.environmentService=i,this.fileService=s,this.uriIdentityService=a,this.logService=c,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,C.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(d=>f((0,C.basename)(d.location),d.name,d.location,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags})):[];let s;const a=new h.ResourceMap,c=f((0,v.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,p.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...c,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?c.extensionsResource:void 0}),i.length){const d=this.getStoredProfileAssociations();if(d.workspaces)for(const[P,F]of Object.entries(d.workspaces)){const $=I.URI.parse(P),Z=I.URI.parse(F),J=i.find(_=>this.uriIdentityService.extUri.isEqual(_.location,Z));J&&a.set($,J)}if(d.emptyWindow){const P=I.URI.parse(d.emptyWindow);s=i.find(F=>this.uriIdentityService.extUri.isEqual(F.location,P))}}this._profilesObject={profiles:i,workspaces:a,emptyWindow:s}}return this._profilesObject}async createTransientProfile(i){const s="Temp",a=new RegExp(`${(0,m.escapeRegExpCharacters)(s)}\\s(\\d+)`);let c=0;for(const P of this.profiles){const F=a.exec(P.name),$=F?parseInt(F[1]):0;c=$>c?$:c}const d=`${s} ${c+1}`;return this.createProfile((0,v.hash)((0,g.generateUuid)()).toString(16),d,{transient:!0},i)}async createNamedProfile(i,s,a){return this.createProfile((0,v.hash)((0,g.generateUuid)()).toString(16),i,s,a)}async createProfile(i,s,a,c){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const d=await this.doCreateProfile(i,s,a);return c&&await this.setProfileForWorkspace(c,d),d}async doCreateProfile(i,s,a){let c=this.profileCreationPromises.get(s);return c||(c=(async()=>{try{const d=this.profiles.find($=>$.name===s||$.id===i);if(d)return d;const P=f(i,s,(0,C.joinPath)(this.profilesHome,i),a);await this.fileService.createFolder(P.location);const F=[];return this._onWillCreateProfile.fire({profile:P,join($){F.push($)}}),await E.Promises.settled(F),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,c)),c}async updateProfile(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(c=>c.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=f(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(c=>c.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:s,join(c){a.push(c)}});try{await Promise.allSettled(a)}catch(c){this.logService.error(c)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const c of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(c){this.logService.error(c)}}getOrSetProfileForWorkspace(i,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let a=this.getProfileForWorkspace(i);return a||(a=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,a)),a}async setProfileForWorkspace(i,s){this.setProfileForWorkspaceSync(i,s)}setProfileForWorkspaceSync(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=this.profiles.find(c=>c.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(i,a)}unsetWorkspace(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.getWorkspace(i);return I.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,y.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,y.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location)))}updateProfiles(i,s,a){const c=[...this.profiles,...i],d=[];this.transientProfilesObject.profiles=[];for(let P of c)P.isDefault||s.some(F=>P.id===F.id)||(P=a.find(F=>P.id===F.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):d.push({location:P.location,name:P.name,shortName:P.shortName,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(d),this._profilesObject=void 0,this.triggerProfilesChanges(i,s,a)}triggerProfilesChanges(i,s,a){this._onDidChangeProfiles.fire({added:i,removed:s,updated:a,all:this.profiles})}updateWorkspaceAssociation(i,s,a){a=s?.isTransient?!0:a,a||this.updateWorkspaceAssociation(i,void 0,!0);const c=this.getWorkspace(i),d=a?this.transientProfilesObject:this.profilesObject;I.URI.isUri(c)?(d.workspaces.delete(c),s&&d.workspaces.set(c,s)):d.emptyWindow=s,a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[a,c]of this.profilesObject.workspaces.entries())i[a.toString()]=c.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};r.PROFILES_KEY="userDataProfiles",r.PROFILE_ASSOCIATIONS_KEY="profileAssociations",r=Re([_e(0,b.IEnvironmentService),_e(1,R.IFileService),_e(2,w.IUriIdentityService),_e(3,S.ILogService)],r),e.UserDataProfilesService=r;class o extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=o}),define(we[234],ye([1,0,18,14,20,8,7,2,3,4,161,31,32,35,13,26,33,37]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends I.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,i,s,a,c){super(),this.galleryService=n,this.telemetryService=i,this.logService=s,this.productService=a,this.userDataProfilesService=c,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:d})=>d.cancel()),this.uninstallingExtensions.forEach(d=>d.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const i=await this.getTargetPlatform();return n.allTargetPlatforms.some(s=>(0,k.isTargetPlatformCompatible)(s,n.allTargetPlatforms,i))}async installFromGallery(n,i={}){try{if(!this.galleryService.isEnabled())throw new k.ExtensionManagementError(R.localize(0,null),k.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(n,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,i)}catch(s){throw f(this.telemetryService,"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(n),error:s}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(s),l(s)}}async uninstall(n,i={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,i)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const i=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:i,compatible:!0},D.CancellationToken.None);if(!s)throw new Error(R.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,i,s){const a=Z=>`${S.ExtensionKey.create(Z).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!b.URI.isUri(i)){const Z=this.installingExtensions.get(a(i));if(Z){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:J}=await Z.task.waitUntilTaskIsFinished();return J}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const c=[],d=[],P=[],F=this.createInstallExtensionTask(n,i,s);b.URI.isUri(i)||this.installingExtensions.set(a(i),{task:F,waitingTasks:[]}),this._onInstallExtension.fire({identifier:F.identifier,source:i,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",F.identifier.id),c.push({task:F,manifest:n});let $=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const J=await this.getAllDepsAndPackExtensions(F.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),_=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:ee,manifest:ne}of J){$=$||!!ne.extensionDependencies?.some(z=>(0,S.areSameExtensions)({id:z},F.identifier));const B=a(ee),ue=this.installingExtensions.get(B);if(ue){if(this.canWaitForTask(F,ue.task)){this.logService.info("Waiting for already requested installing extension",ee.identifier.id,F.identifier.id),ue.waitingTasks.push(F);const z=ue.task.identifier;d.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,X=>X.some(O=>(0,S.areSameExtensions)(O.identifier,z)))).then(X=>{if(!X.find(U=>(0,S.areSameExtensions)(U.identifier,z))?.local)throw new Error(`Extension ${z.id} is not installed`)}))}}else if(!_.some(({identifier:z})=>(0,S.areSameExtensions)(z,ee.identifier))){const z=this.createInstallExtensionTask(ne,ee,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(B,{task:z,waitingTasks:[F]}),this._onInstallExtension.fire({identifier:z.identifier,source:ee,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",z.identifier.id,F.identifier.id),c.push({task:z,manifest:ne})}}}catch(J){if(b.URI.isUri(F.source))(0,v.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",F.identifier.id,J.message),(0,v.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",F.identifier.id,J.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),J}const Z=c.reduce((J,{task:_,manifest:ee})=>(J.set(_.identifier.id.toLowerCase(),{task:_,manifest:ee}),J),new Map);for(;Z.size;){let J;const _=[...Z.values()].filter(({manifest:ee})=>!ee.extensionDependencies?.some(ne=>Z.has(ne.toLowerCase())));_.length?J=Z.size===1?_:_.filter(({task:ee})=>!(ee===F&&!$)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:ee})=>ee.identifier.id)),J=[...Z.values()]),await this.joinAllSettled(J.map(async({task:ee})=>{const ne=new Date().getTime();try{const{local:B}=await ee.run();if(await this.joinAllSettled(this.participants.map(ue=>ue.postInstall(B,ee.source,s,D.CancellationToken.None))),!b.URI.isUri(ee.source)){const ue=ee.operation===3,z=ue?void 0:(new Date().getTime()-ee.source.lastUpdated)/1e3;if(f(this.telemetryService,ue?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(ee.source),duration:new Date().getTime()-ne,durationSinceUpdate:z}),p.isWeb&&ee.operation!==3)try{await this.galleryService.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}P.push({local:B,identifier:ee.identifier,operation:ee.operation,source:ee.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:B.isApplicationScoped})}catch(B){throw b.URI.isUri(ee.source)||f(this.telemetryService,ee.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(ee.source),duration:new Date().getTime()-ne,error:B}),this.logService.error("Error while installing the extension:",ee.identifier.id),B}finally{Z.delete(ee.identifier.id.toLowerCase())}}))}return d.length&&await this.joinAllSettled(d),P.forEach(({identifier:J})=>this.logService.info("Extension installed successfully:",J.id)),this._onDidInstallExtensions.fire(P),P.filter(({identifier:J})=>(0,S.areSameExtensions)(J,F.identifier))[0].local}catch(Z){if(c.forEach(({task:J})=>J.cancel()),P.length)try{const J=await Promise.allSettled(P.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let _=0;_<J.length;_++){const ee=J[_],{identifier:ne}=P[_];ee.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ne.id):this.logService.warn("Rollback: Error while uninstalling extension",ne.id,(0,C.getErrorMessage)(ee.reason))}}catch(J){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(J),P.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(c.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:s.context,profileLocation:s.profileLocation}))),Z}finally{for(const[Z,{task:J,waitingTasks:_}]of this.installingExtensions.entries()){const ee=_.indexOf(F);ee!==-1&&_.splice(ee,1),_.length===0&&(J===F||ee!==-1)&&this.installingExtensions.delete(Z)}}}canWaitForTask(n,i){for(const[,{task:s,waitingTasks:a}]of this.installingExtensions.entries())if(s===n&&(a.includes(i)||a.some(c=>this.canWaitForTask(c,i)))||s===i&&a[0]&&!this.canWaitForTask(n,a[0]))return!1;return!0}async joinAllSettled(n){const i=[],s=[],a=await Promise.allSettled(n);for(const c of a)c.status==="fulfilled"?i.push(c.value):s.push(c.reason);if(s.length)throw u(s);return i}async getAllDepsAndPackExtensions(n,i,s,a,c){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,c),P=[n],F=[],$=async(Z,J)=>{const _=J.extensionDependencies||[],ee=[..._];if(J.extensionPack){const ne=s?d.find(B=>(0,S.areSameExtensions)(B.identifier,Z)):void 0;for(const B of J.extensionPack)ne&&ne.manifest.extensionPack&&ne.manifest.extensionPack.some(ue=>(0,S.areSameExtensions)({id:ue},{id:B}))||ee.every(ue=>!(0,S.areSameExtensions)({id:ue},{id:B}))&&ee.push(B)}if(ee.length){const ne=[...P,...F.map(ue=>ue.gallery.identifier)],B=ee.filter(ue=>ne.every(z=>!(0,S.areSameExtensions)(z,{id:ue})));if(B.length){const ue=await this.galleryService.getExtensions(B.map(z=>({id:z,preRelease:a})),D.CancellationToken.None);for(const z of ue){if(ne.find(U=>(0,S.areSameExtensions)(U,z.identifier)))continue;const X=_.some(U=>(0,S.areSameExtensions)({id:U},z.identifier));let O;try{O=await this.checkAndGetCompatibleVersion(z,!1,a)}catch(U){if(U instanceof k.ExtensionManagementError&&U.code===k.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.logService.info("Skipping the packed extension as it cannot be installed",z.identifier.id);continue}else throw U}F.push({gallery:O.extension,manifest:O.manifest}),await $(O.extension.identifier,O.manifest)}}}};return await $(n,i),F}async checkAndGetCompatibleVersion(n,i,s){if((await this.getExtensionsControlManifest()).malicious.some(P=>(0,S.areSameExtensions)(n.identifier,P)))throw new k.ExtensionManagementError(R.localize(3,null,n.identifier.id),k.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const P=await this.getTargetPlatform();throw new k.ExtensionManagementError(R.localize(4,null,n.identifier.id,this.productService.nameLong,(0,k.TargetPlatformToString)(P)),k.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(n,i,s);if(c){if(s&&!i&&n.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new k.ExtensionManagementError(R.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),k.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],D.CancellationToken.None))[0]?new k.ExtensionManagementError(R.localize(6,null,n.identifier.id),k.ExtensionManagementErrorCode.ReleaseVersionNotFound):new k.ExtensionManagementError(R.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),k.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const d=await this.galleryService.getManifest(c,D.CancellationToken.None);if(d===null)throw new k.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,k.ExtensionManagementErrorCode.Invalid);if(d.version!==c.version)throw new k.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,k.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:d}}async getCompatibleVersion(n,i,s){const a=await this.getTargetPlatform();let c=null;return!i&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==s&&(c=(await this.galleryService.getExtensions([{...n.identifier,preRelease:s}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null),!c&&await this.galleryService.isExtensionCompatible(n,s,a)&&(c=n),c||(i?c=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null:c=await this.galleryService.getCompatibleExtension(n,s,a)),c}async uninstallExtension(n,i){const s=$=>`${$.id.toLowerCase()}${i.versionOnly?`-${n.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(s(n.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),a.waitUntilTaskIsFinished();const c=($,Z)=>{const J=this.createUninstallExtensionTask($,Z);return this.uninstallingExtensions.set(s(J.extension.identifier),J),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this._onUninstallExtension.fire({identifier:$.identifier,profileLocation:i.profileLocation,applicationScoped:$.isApplicationScoped}),J},d=($,Z)=>{Z?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString(),Z.message):this.logService.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,Z.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),f(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)($),error:Z}),this._onDidUninstallExtension.fire({identifier:$.identifier,version:$.manifest.version,error:Z?.code,profileLocation:i.profileLocation,applicationScoped:$.isApplicationScoped})},P=[],F=[];try{P.push(c(n,i));const $=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const Z=this.getAllPackExtensionsToUninstall(n,$);for(const J of Z)this.uninstallingExtensions.has(s(J.identifier))?this.logService.info("Extensions is already requested to uninstall",J.identifier.id):P.push(c(J,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(P.map(Z=>Z.extension),$,n),await this.joinAllSettled(P.map(async Z=>{try{if(await Z.run(),await this.joinAllSettled(this.participants.map(J=>J.postUninstall(Z.extension,i,D.CancellationToken.None))),Z.extension.identifier.uuid)try{await this.galleryService.reportStatistic(Z.extension.manifest.publisher,Z.extension.manifest.name,Z.extension.manifest.version,"uninstall")}catch{}d(Z.extension)}catch(J){const _=J instanceof k.ExtensionManagementError?J:new k.ExtensionManagementError((0,C.getErrorMessage)(J),k.ExtensionManagementErrorCode.Internal);throw d(Z.extension,_),_}finally{F.push(Z)}}))}catch($){const Z=$ instanceof k.ExtensionManagementError?$:new k.ExtensionManagementError((0,C.getErrorMessage)($),k.ExtensionManagementErrorCode.Internal);for(const J of P){try{J.cancel()}catch{}F.includes(J)||d(J.extension,Z)}throw Z}finally{for(const $ of P)this.uninstallingExtensions.delete(s($.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}checkForDependents(n,i,s){for(const a of n){const c=this.getDependents(a,i);if(c.length){const d=c.filter(P=>!n.some(F=>(0,S.areSameExtensions)(F.identifier,P.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(a,d,s))}}}getDependentsErrorMessage(n,i,s){return s===n?i.length===1?R.localize(8,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?R.localize(9,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):R.localize(10,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?R.localize(11,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?R.localize(12,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):R.localize(13,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(n,i,s=[]){if(s.indexOf(n)!==-1)return[];s.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const c=i.filter(P=>!P.isBuiltin&&a.some(F=>(0,S.areSameExtensions)({id:F},P.identifier))),d=[];for(const P of c)d.push(...this.getAllPackExtensionsToUninstall(P,i,s));return[...c,...d]}return[]}getDependents(n,i){return i.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(a=>(0,S.areSameExtensions)({id:a},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(n,i,s){return s.profileLocation&&(0,y.isApplicationScopedExtension)(n)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(n,i,s)}createUninstallExtensionTask(n,i){return i.profileLocation&&n.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(n,i)}};m=Re([_e(0,k.IExtensionGalleryService),_e(1,E.ITelemetryService),_e(2,h.ILogService),_e(3,w.IProductService),_e(4,g.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function u(o){const n=Array.isArray(o)?o:[o];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((i,s)=>new Error(`${i.message}${i.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=u;function l(o){if(o instanceof k.ExtensionManagementError)return o;const n=new k.ExtensionManagementError(o.message,k.ExtensionManagementErrorCode.Internal);return n.stack=o.stack,n}function f(o,n,{extensionData:i,duration:s,error:a,durationSinceUpdate:c}){const d=a?a instanceof k.ExtensionManagementError?a.code:k.ExtensionManagementErrorCode.Internal:void 0;o.publicLog(n,{...i,success:!a,duration:s,errorcode:d,durationSinceUpdate:c})}e.reportTelemetry=f;class r{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((i,s)=>{const a=n.onCancellationRequested(()=>{a.dispose(),s(new C.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(we[55],ye([1,0,18,14,22,16,8,65,156,2,12,6,3,19,50,67,11,4,165,29,32,35,70,17,5,13,26,7,46,53,37,39,192]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l,f,r,o,n,i,s,a,c,d,P,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Z;(function(z){function X(O,U){if(O===U)return!0;const x=Object.keys(O),ae=new Set;for(const fe of Object.keys(U))ae.add(fe);if(x.length!==ae.size)return!1;for(const fe of x){if(O[fe]!==U[fe])return!1;ae.delete(fe)}return ae.size===0}z.equals=X})(Z=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let J=class extends b.Disposable{constructor(X,O,U,x,ae,fe,K,ie,L,M,G){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=O,this.extensionsControlLocation=U,this.cacheLocation=x,this.userDataProfilesService=ae,this.extensionsProfileScannerService=fe,this.fileService=K,this.logService=ie,this.environmentService=L,this.productService=M,this.instantiationService=G,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,(0,y.joinPath)(this.cacheLocation,f.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,(0,y.joinPath)(this.cacheLocation,f.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ee,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(X,O,U){const[x,ae]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(O)]),fe=U?await this.scanExtensionsUnderDevelopment(X,[...x,...ae]):[];return this.dedupExtensions(x,ae,fe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const O=[];O.push(this.scanDefaultSystemExtensions(!!X.useCache,X.language)),O.push(this.scanDevSystemExtensions(X.language,!!X.checkControlFile));const[U,x]=await Promise.all(O);return this.applyScanOptions([...U,...x],0,X,!1)}async scanUserExtensions(X){this.logService.trace("Started scanning user extensions");const O=await this.createExtensionScannerInput(X.profileLocation??this.userExtensionsLocation,!!X.profileLocation,1,!X.includeUninstalled,X.language);let x=await(X.useCache&&!O.devMode&&O.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(O);return x=await this.applyScanOptions(x,1,X,!0),this.logService.trace("Scanned user extensions:",x.length),x}async scanExtensionsUnderDevelopment(X,O){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const U=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(x=>x.scheme===R.Schemas.file).map(async x=>{const ae=await this.createExtensionScannerInput(x,!1,1,!0,X.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ae)).map(K=>(K.type=O.find(ie=>(0,l.areSameExtensions)(ie.identifier,K.identifier))?.type??K.type,this.extensionsScanner.validate(K,ae)))}))).flat();return this.applyScanOptions(U,"development",X,!0)}return[]}async scanExistingExtension(X,O,U){const x=await this.createExtensionScannerInput(X,!1,O,!0,U.language),ae=await this.extensionsScanner.scanExtension(x);return!ae||!U.includeInvalid&&!ae.isValid?null:ae}async scanOneOrMultipleExtensions(X,O,U){const x=await this.createExtensionScannerInput(X,!1,O,!0,U.language),ae=await this.extensionsScanner.scanOneOrMultipleExtensions(x);return this.applyScanOptions(ae,O,U,!0)}async scanMetadata(X){const O=(0,y.joinPath)(X,"package.json"),U=(await this.fileService.readFile(O)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(X,O){const U=(0,y.joinPath)(X,"package.json"),x=(await this.fileService.readFile(U)).value.toString(),ae=JSON.parse(x);O.isMachineScoped=O.isMachineScoped||void 0,O.isBuiltin=O.isBuiltin||void 0,O.installedTimestamp=O.installedTimestamp||void 0,ae.__metadata={...ae.__metadata,...O},await this.fileService.writeFile((0,y.joinPath)(X,"package.json"),C.VSBuffer.fromString(JSON.stringify(ae,null,"	")))}async applyScanOptions(X,O,U,x){return U.includeAllVersions||(X=this.dedupExtensions(O===0?X:void 0,O===1?X:void 0,O==="development"?X:void 0,await this.getTargetPlatform(),x)),U.includeInvalid||(X=X.filter(ae=>ae.isValid)),X.sort((ae,fe)=>{const K=k.basename(ae.location.fsPath),ie=k.basename(fe.location.fsPath);return K<ie?-1:K>ie?1:0})}dedupExtensions(X,O,U,x,ae){const fe=(ie,L,M)=>{if(ie.isValid&&!L.isValid)return!1;if(ie.isValid===L.isValid){if(ae&&h.gt(ie.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(h.eq(ie.manifest.version,L.manifest.version)){if(ie.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===x)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${ie.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${ie.location.path} with ${L.location.path}.`),!0},K=new Map;return X?.forEach(ie=>{const L=f.ExtensionIdentifier.toKey(ie.identifier.id),M=K.get(L);(!M||fe(M,ie,!1))&&K.set(L,ie)}),O?.forEach(ie=>{const L=f.ExtensionIdentifier.toKey(ie.identifier.id),M=K.get(L);if(!M&&X&&ie.type===0){this.logService.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!M||fe(M,ie,!1))&&K.set(L,ie)}),U?.forEach(ie=>{const L=f.ExtensionIdentifier.toKey(ie.identifier.id),M=K.get(L);(!M||fe(M,ie,!0))&&K.set(L,ie),K.set(L,ie)}),[...K.values()]}async scanDefaultSystemExtensions(X,O){this.logService.trace("Started scanning system extensions");const U=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,O),ae=await(X&&!U.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(U);return this.logService.trace("Scanned system extensions:",ae.length),ae}async scanDevSystemExtensions(X,O){const U=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!U?.length)return[];this.logService.trace("Started scanning dev system extensions");const x=O?await this.getBuiltInExtensionControl():{},ae=[],fe=g.URI.file(k.normalize(k.join(R.FileAccess.asFileUri("",oe).fsPath,"..",".build","builtInExtensions")));for(const ie of U){const L=x[ie.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":ae.push((0,y.joinPath)(fe,ie.name));break;default:ae.push(g.URI.file(L));break}}const K=await Promise.all(ae.map(async ie=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ie,!1,0,!0,X))));return this.logService.trace("Scanned dev system extensions:",K.length),(0,v.coalesce)(K)}async getBuiltInExtensionControl(){try{const X=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(X.value.toString())}catch{return{}}}async createExtensionScannerInput(X,O,U,x,ae,fe=!0){const K=await this.getTranslations(ae??S.language),ie=await this.getMtime(X),L=O?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=L?await this.getMtime(L):void 0;return new _(X,ie,L,M,O,U,x,fe,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ae,K)}async getMtime(X){try{const O=await this.fileService.stat(X);if(typeof O.mtime=="number")return O.mtime}catch{}}};J=Re([_e(4,P.IUserDataProfilesService),_e(5,d.IExtensionsProfileScannerService),_e(6,o.IFileService),_e(7,i.ILogService),_e(8,u.IEnvironmentService),_e(9,s.IProductService),_e(10,n.IInstantiationService)],J),e.AbstractExtensionsScannerService=J;class _{constructor(X,O,U,x,ae,fe,K,ie,L,M,G,re,he,ve){this.location=X,this.mtime=O,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=x,this.profile=ae,this.type=fe,this.excludeObsolete=K,this.validate=ie,this.productVersion=L,this.productDate=M,this.productCommit=G,this.devMode=re,this.language=he,this.translations=ve}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,O){return(0,y.isEqual)(X.location,O.location)&&X.mtime===O.mtime&&(0,y.isEqual)(X.applicationExtensionslocation,O.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===O.applicationExtensionslocationMtime&&X.profile===O.profile&&X.type===O.type&&X.excludeObsolete===O.excludeObsolete&&X.validate===O.validate&&X.productVersion===O.productVersion&&X.productDate===O.productDate&&X.productCommit===O.productCommit&&X.devMode===O.devMode&&X.language===O.language&&Z.equals(X.translations,O.translations)}}let ee=class extends b.Disposable{constructor(X,O,U,x,ae){super(),this.obsoleteFile=X,this.extensionsProfileScannerService=O,this.uriIdentityService=U,this.fileService=x,this.logService=ae}async scanExtensions(X){const O=X.profile?await this.scanExtensionsFromProfile(X):await this.scanExtensionsFromLocation(X);let U={};if(X.excludeObsolete&&X.type===1)try{const x=(await this.fileService.readFile(this.obsoleteFile)).value.toString();U=JSON.parse(x)}catch{}return(0,E.isEmptyObject)(U)?O:O.filter(x=>!U[l.ExtensionKey.create(x).toString()])}async scanExtensionsFromLocation(X){const O=await this.fileService.resolve(X.location);if(!O.children?.length)return[];const U=await Promise.all(O.children.map(async x=>{if(!x.isDirectory||X.type===1&&(0,y.basename)(x.resource).indexOf(".")===0)return null;const ae=new _(x.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(ae)}));return(0,v.coalesce)(U).sort((x,ae)=>x.location.path<ae.location.path?-1:1)}async scanExtensionsFromProfile(X){let O=await this.scanExtensionsFromProfileResource(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(X.location,X.applicationExtensionslocation)){O=O.filter(x=>!x.metadata?.isApplicationScoped);const U=await this.scanExtensionsFromProfileResource(X.applicationExtensionslocation,x=>!!x.metadata?.isApplicationScoped,X);O.push(...U)}return O}async scanExtensionsFromProfileResource(X,O,U){const x=await this.extensionsProfileScannerService.scanProfileExtensions(X);if(!x.length)return[];const ae=await Promise.all(x.map(async fe=>{if(O(fe)){const K=new _(fe.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(K,fe.metadata)}return null}));return(0,v.coalesce)(ae)}async scanOneOrMultipleExtensions(X){try{if(await this.fileService.exists((0,y.joinPath)(X.location,"package.json"))){const O=await this.scanExtension(X);return O?[O]:[]}else return await this.scanExtensions(X)}catch(O){return this.logService.error(`Error scanning extensions at ${X.location.path}:`,(0,T.getErrorMessage)(O)),[]}}async scanExtension(X,O){try{let U=await this.scanExtensionManifest(X.location);if(U){U.publisher||(U.publisher=f.UNDEFINED_PUBLISHER),O=O??U.__metadata,delete U.__metadata;const x=(0,l.getGalleryExtensionId)(U.publisher,U.name),ae=O?.id?{id:x,uuid:O.id}:{id:x},fe=O?.isSystem?0:X.type,K=fe===0||!!O?.isBuiltin;U=await this.translateManifest(X.location,U,_.createNlsConfiguration(X));const ie={type:fe,identifier:ae,manifest:U,location:X.location,isBuiltin:K,targetPlatform:O?.targetPlatform??"undefined",metadata:O,isValid:!0,validations:[]};return X.validate?this.validate(ie,X):ie}}catch(U){X.type!==0&&this.logService.error(U)}return null}validate(X,O){let U=!0;const x=(0,r.validateExtensionManifest)(O.productVersion,O.productDate,O.location,X.manifest,X.isBuiltin);for(const[ae,fe]of x)ae===w.default.Error&&(U=!1,this.logService.error(this.formatMessage(O.location,fe)));return X.isValid=U,X.validations=x,X}async scanExtensionManifest(X){const O=(0,y.joinPath)(X,"package.json");let U;try{U=(await this.fileService.readFile(O)).value.toString()}catch(ae){return(0,o.toFileOperationResult)(ae)!==1&&this.logService.error(this.formatMessage(X,(0,m.localize)(0,null,O.path,ae.message))),null}let x;try{x=JSON.parse(U)}catch{const fe=[];(0,I.parse)(U,fe);for(const K of fe)this.logService.error(this.formatMessage(X,(0,m.localize)(1,null,O.path,K.offset,K.length,(0,p.getParseErrorMessage)(K.error))));return null}return(0,I.getNodeType)(x)!=="object"?(this.logService.error(this.formatMessage(X,(0,m.localize)(2,null,O.path))),null):x}async translateManifest(X,O,U){const x=await this.getLocalizedMessages(X,O,U);if(x)try{const ae=[],fe=await this.resolveOriginalMessageBundle(x.default,ae);if(ae.length>0)return ae.forEach(ie=>{this.logService.error(this.formatMessage(X,(0,m.localize)(3,null,x.default?.path,(0,p.getParseErrorMessage)(ie.error))))}),O;if((0,I.getNodeType)(x)!=="object")return this.logService.error(this.formatMessage(X,(0,m.localize)(4,null,x.default?.path))),O;const K=x.values||Object.create(null);return(0,$.localizeManifest)(O,K,fe)}catch{}return O}async getLocalizedMessages(X,O,U){const x=(0,y.joinPath)(X,"package.nls.json"),ae=(L,M)=>{M.forEach(G=>{this.logService.error(this.formatMessage(X,(0,m.localize)(5,null,L?.path,(0,p.getParseErrorMessage)(G.error))))})},fe=L=>{this.logService.error(this.formatMessage(X,(0,m.localize)(6,null,L?.path)))},K=`${O.publisher}.${O.name}`,ie=U.translations[K];if(ie)try{const L=g.URI.file(ie),M=(await this.fileService.readFile(L)).value.toString(),G=[],re=(0,I.parse)(M,G);return G.length>0?(ae(L,G),{values:void 0,default:x}):(0,I.getNodeType)(re)!=="object"?(fe(L),{values:void 0,default:x}):{values:re.contents?re.contents.package:void 0,default:x}}catch{return{values:void 0,default:x}}else{if(!await this.fileService.exists(x))return;let M;try{M=await this.findMessageBundles(X,U)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const G=(await this.fileService.readFile(M.localized)).value.toString(),re=[],he=(0,I.parse)(G,re);return re.length>0?(ae(M.localized,re),{values:void 0,default:M.original}):(0,I.getNodeType)(he)!=="object"?(fe(M.localized),{values:void 0,default:M.original}):{values:he,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(X,O){if(X)try{const U=(await this.fileService.readFile(X)).value.toString();return(0,I.parse)(U,O)}catch{}}findMessageBundles(X,O){return new Promise((U,x)=>{const ae=fe=>{const K=(0,y.joinPath)(X,`package.nls.${fe}.json`);this.fileService.exists(K).then(ie=>{ie&&U({localized:K,original:(0,y.joinPath)(X,"package.nls.json")});const L=fe.lastIndexOf("-");L===-1?U({localized:(0,y.joinPath)(X,"package.nls.json"),original:null}):(fe=fe.substring(0,L),ae(fe))})};if(O.devMode||O.pseudo||!O.language)return U({localized:(0,y.joinPath)(X,"package.nls.json"),original:null});ae(O.language)})}formatMessage(X,O){return`[${X.path}]: ${O}`}};ee=Re([_e(1,d.IExtensionsProfileScannerService),_e(2,F.IUriIdentityService),_e(3,o.IFileService),_e(4,i.ILogService)],ee);let ne=class extends ee{constructor(X,O,U,x,ae,fe){super(O,U,x,ae,fe),this.cacheFile=X,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(X){const O=await this.readExtensionCache();if(this.input=X,O&&O.input&&_.equals(O.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),O.result.map(x=>(x.location=g.URI.revive(x.location),x));const U=await super.scanExtensions(X);return await this.writeExtensionCache({input:X,result:U}),U}async readExtensionCache(){try{const X=await this.fileService.readFile(this.cacheFile),O=JSON.parse(X.value.toString());return{result:O.result,input:(0,c.revive)(O.input)}}catch(X){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(X))}return null}async writeExtensionCache(X){try{await this.fileService.writeFile(this.cacheFile,C.VSBuffer.fromString(JSON.stringify(X)))}catch(O){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(O))}}async validateCache(){if(!this.input)return;const X=await this.readExtensionCache();if(!X)return;const O=X.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(U,O))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(x){this.logService.error(x)}}};ne=Re([_e(2,d.IExtensionsProfileScannerService),_e(3,F.IUriIdentityService),_e(4,o.IFileService),_e(5,i.ILogService)],ne);function B(z,X){const O=(0,l.getExtensionId)(z.manifest.publisher,z.manifest.name);return{id:O,identifier:new f.ExtensionIdentifier(O),isBuiltin:z.type===0,isUserBuiltin:z.type===1&&z.isBuiltin,isUnderDevelopment:X,extensionLocation:z.location,uuid:z.identifier.uuid,targetPlatform:z.targetPlatform,...z.manifest}}e.toExtensionDescription=B;class ue extends J{constructor(X,O,U,x,ae,fe,K,ie,L,M,G){super(X,O,(0,y.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(x,f.MANIFEST_CACHE_FOLDER),ae,fe,K,ie,L,M,G),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const re=await this.fileService.readFile(g.URI.file(S.translationsConfigFile));return JSON.parse(re.value.toString())}catch{}return Object.create(null)})()}getTranslations(X){return this.translationsPromise}}e.NativeExtensionsScannerService=ue}),define(we[235],ye([1,0,48,14,38,7,2,12,6,21,13,37]),function(oe,e,v,t,D,C,T,I,p,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends T.Disposable{constructor(h,w){super(),this.userDataProfilesService=h,this.logService=w,this.processesLimiter=new t.Limiter(5)}async postUninstall(h){const w=this.parseScript(h,"uninstall");return w&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${E}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(h,w){const E=`vscode:${w}`;if(h.location.scheme===I.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[E]=="string"){const g=h.manifest.scripts[E].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${E} should be a node script`),null):{script:(0,p.join)(h.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(h,w,E,g,m){return new Promise((u,l)=>{const f=this.start(h,w,E,m);let r;const o=n=>{r&&(clearTimeout(r),r=null),n?l(n):u(void 0)};f.on("error",n=>{o((0,D.toErrorMessage)(n)||"Unknown")}),f.on("exit",(n,i)=>{o(n?`post-${w} process exited with code ${n}`:void 0)}),g&&(r=setTimeout(()=>{r=null,f.kill(),l("timed out")},5e3))})}start(h,w,E,g){const m={silent:!0,execArgv:void 0},u=(0,v.fork)(h,[`--type=extension-post-${w}`,...E],m);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const l=C.Event.fromNodeEventEmitter(u.stdout,"data"),f=C.Event.fromNodeEventEmitter(u.stderr,"data");l(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${w}`,n)),f(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${w}`,n));const r=C.Event.any(C.Event.map(l,n=>({data:`%c${n}`,format:[""]})),C.Event.map(f,n=>({data:`%c${n}`,format:["color: red"]})));return C.Event.debounce(r,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}getExtensionStoragePath(h){return(0,p.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};S=Re([_e(0,k.IUserDataProfilesService),_e(1,R.ILogService)],S),e.ExtensionsLifecycle=S}),define(we[236],ye([1,0,14,7,2,47,11,149,5,37]),function(oe,e,v,t,D,C,T,I,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var R;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var S;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function y(m){const u=m.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=y;class h extends D.Disposable{constructor(u={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=u,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,l){if(l===e.TARGET_KEY){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:l,target:this.getKeyTargets(u)[l]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,l,f){return this.getStorage(l)?.get(u,f)}getBoolean(u,l,f){return this.getStorage(l)?.getBoolean(u,f)}getNumber(u,l,f){return this.getStorage(l)?.getNumber(u,f)}store(u,l,f,r){if((0,T.isUndefinedOrNull)(l)){this.remove(u,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,f,r),this.getStorage(f)?.set(u,l)})}remove(u,l){this.withPausedEmitters(()=>{this.updateKeyTarget(u,l,void 0),this.getStorage(l)?.delete(u)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,l){const f=[],r=this.getKeyTargets(u);for(const o of Object.keys(r))r[o]===l&&f.push(o);return f}updateKeyTarget(u,l,f){const r=this.getKeyTargets(l);typeof f=="number"?r[u]!==f&&(r[u]=f,this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(r))):typeof r[u]=="number"&&(delete r[u],this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const l=this.getStorage(u);return l?y(l):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=R.NONE){this._onWillSaveState.fire({reason:u});const l=this.getStorage(-1),f=this.getStorage(0),r=this.getStorage(1);switch(u){case R.NONE:await v.Promises.settled([l?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await v.Promises.settled([l?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return g(u,l,f,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(u,l){return this.emitWillSaveState(R.NONE),(0,b.isUserDataProfile)(u)?this.switchToProfile(u,l):this.switchToWorkspace(u,l)}canSwitchProfile(u,l){return!(u.id===l.id||w(l)&&w(u))}switchData(u,l,f,r){this.withPausedEmitters(()=>{if(r)for(const[o,n]of u)l.set(o,n);else{const o=new Set;for(const[n,i]of u)o.add(n),l.get(n)!==i&&this.emitDidChangeValue(f,n);for(const[n]of l.items)o.has(n)||this.emitDidChangeValue(f,n)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function w(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class E extends h{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(u){return!1}}e.InMemoryStorageService=E;async function g(m,u,l,f,r,o){const n=Z=>{try{return JSON.parse(Z)}catch{return Z}},i=new Map,s=new Map;m.forEach((Z,J)=>{i.set(J,Z),s.set(J,n(Z))});const a=new Map,c=new Map;u.forEach((Z,J)=>{a.set(J,Z),c.set(J,n(Z))});const d=new Map,P=new Map;l.forEach((Z,J)=>{d.set(J,Z),P.set(J,n(Z))}),console.group(f!==r?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const F=[];if(i.forEach((Z,J)=>{F.push({key:J,value:Z})}),console.table(F),console.groupEnd(),console.log(s),f!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const Z=[];a.forEach((J,_)=>{Z.push({key:_,value:J})}),console.table(Z),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${o})`);const $=[];d.forEach((Z,J)=>{$.push({key:J,value:Z})}),console.table($),console.groupEnd(),console.log(P)}e.logStorage=g}),define(we[115],ye([1,0,18,20,8,3,27,11,4,25,29,31,32,70,17,13,26,54,219,236,33]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=C.isWeb?"web":(0,k.getTargetPlatform)(C.platform,T.arch);var r;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function o(...L){return String(L.reduce((M,G)=>M|G,0))}var n;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class d{constructor(M=c){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(M,G=this.state.pageSize){return new d({...this.state,pageNumber:M,pageSize:G})}withFilter(M,...G){const re=[...this.state.criteria,...G.length?G.map(he=>({filterType:M,value:he})):[{filterType:M}]];return new d({...this.state,criteria:re})}withSortBy(M){return new d({...this.state,sortBy:M})}withSortOrder(M){return new d({...this.state,sortOrder:M})}withFlags(...M){return new d({...this.state,flags:M.reduce((G,re)=>G|re,0)})}withAssetTypes(...M){return new d({...this.state,assetTypes:M})}withSource(M){return new d({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:G,pageSize:re,sortBy:he,sortOrder:ve,flags:H,assetTypes:Y}=this.state;return{filters:[{criteria:M,pageNumber:G,pageSize:re,sortBy:he,sortOrder:ve}],assetTypes:Y,flags:H}}get searchText(){const M=this.state.criteria.filter(G=>G.filterType===n.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function P(L,M){const G=(L||[]).filter(re=>re.statisticName===M)[0];return G?G.value:0}function F(L){const M="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(re=>re.assetType.indexOf(M)===0).reduce((re,he)=>{const ve=J(L,he.assetType);return ve&&re.push([he.assetType.substring(M.length),ve]),re},[])}function $(L){if(L.properties){const M=L.properties.filter(he=>he.key===i.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=M.filter(he=>G.test(he.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return J(L,i.Repository)}function Z(L){return{uri:`${L.fallbackAssetUri}/${i.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${i.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function J(L,M){return L.files.filter(re=>re.assetType===M)[0]?{uri:`${L.assetUri}/${M}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${M}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function _(L,M){const G=L.properties?L.properties.filter(he=>he.key===M):[],re=G.length>0&&G[0].value;return re?re.split(",").map(he=>(0,S.adoptToGalleryExtensionId)(he)):[]}function ee(L){const M=L.properties?L.properties.filter(G=>G.key===s.Engine):[];return M.length>0&&M[0].value||""}function ne(L){const M=L.properties?L.properties.filter(G=>G.key===s.PreRelease):[];return M.length>0&&M[0].value==="true"}function B(L){const M=L.properties?L.properties.filter(re=>re.key===s.LocalizedLanguages):[],G=M.length>0&&M[0].value||"";return G?G.split(","):[]}function ue(L){return L.properties?.find(M=>M.key===s.SponsorLink)?.value}function z(L){return L.indexOf("preview")!==-1}function X(L){return L.targetPlatform?(0,k.toTargetPlatform)(L.targetPlatform):"undefined"}function O(L){const M=(0,v.distinct)(L.versions.map(X)),G=!!L.tags?.includes(k.WEB_EXTENSION_TAG),re=M.indexOf("web");return G?re===-1&&M.push("web"):re!==-1&&M.splice(re,1),M}function U(L,M){const G=(0,k.getFallbackTargetPlarforms)(M);for(let re=0;re<L.length;re++){const he=L[re];if(he.version===L[re-1]?.version){let ve=re;const H=X(he);if(H===M)for(;ve>0&&L[ve-1].version===he.version;)ve--;else if(G.includes(H))for(;ve>0&&L[ve-1].version===he.version&&X(L[ve-1])!==M;)ve--;ve!==re&&(L.splice(re,1),L.splice(ve,0,he))}}return L}e.sortExtensionVersions=U;function x(L,M,G){L.telemetryData={index:M,querySource:G}}function ae(L,M,G){const re=L.versions[0],he={manifest:J(M,i.Manifest),readme:J(M,i.Details),changelog:J(M,i.Changelog),license:J(M,i.License),repository:$(M),download:Z(M),icon:J(M,i.Icon),coreTranslations:F(M)};return{identifier:{id:(0,S.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:M.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:ue(re),description:L.shortDescription||"",installCount:P(L.statistics,"install"),rating:P(L.statistics,"averagerating"),ratingCount:P(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:G,assets:he,properties:{dependencies:_(M,s.Dependency),extensionPack:_(M,s.ExtensionPack),engine:ee(M),localizedLanguages:B(M),targetPlatform:X(M),isPreReleaseVersion:ne(M)},hasPreReleaseVersion:ne(re),hasReleaseVersion:!0,preview:z(L.flags)}}let fe=class{constructor(M,G,re,he,ve,H,Y,te){this.requestService=G,this.logService=re,this.environmentService=he,this.telemetryService=ve,this.fileService=H,this.productService=Y,this.configurationService=te;const W=Y.extensionsGallery;this.extensionsGalleryUrl=W?.serviceUrl,this.extensionsGallerySearchUrl=W?.searchUrl,this.extensionsControlUrl=W?.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(Y.version,Y,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,G,re){const he=t.CancellationToken.isCancellationToken(G)?{}:G,ve=t.CancellationToken.isCancellationToken(G)?G:re,H=[],Y=[],te=[],W=[];let q=!0;for(const le of M){le.uuid?Y.push(le.uuid):H.push(le.id);const pe=!!(le.version||le.preRelease);te.push({id:le.id,uuid:le.uuid,includePreRelease:pe}),le.version&&W.push({id:le.id,uuid:le.uuid,version:le.version}),q=q&&!!le.hasPreRelease&&!pe}if(!Y.length&&!H.length)return[];let j=new d().withPage(1,M.length);Y.length&&(j=j.withFilter(n.ExtensionId,...Y)),H.length&&(j=j.withFilter(n.ExtensionName,...H)),(he.queryAllVersions||q)&&(j=j.withFlags(j.flags,r.IncludeVersions)),he.source&&(j=j.withSource(he.source));const{extensions:Q}=await this.queryGalleryExtensions(j,{targetPlatform:he.targetPlatform??f,includePreRelease:te,versions:W,compatible:!!he.compatible},ve);return he.source&&Q.forEach((le,pe)=>x(le,pe,he.source)),Q}async getCompatibleExtension(M,G,re){if((0,k.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(M,G,re))return M;const he=new d().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,M.identifier.uuid),{extensions:ve}=await this.queryGalleryExtensions(he,{targetPlatform:re,compatible:!0,includePreRelease:G},t.CancellationToken.None);return ve[0]||null}async isExtensionCompatible(M,G,re){if(!(0,k.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,re)||!G&&M.properties.isPreReleaseVersion)return!1;let he=M.properties.engine;if(!he){const ve=await this.getManifest(M,t.CancellationToken.None);if(!ve)throw new Error("Manifest was not found");he=ve.engines.vscode}return(0,y.isEngineValid)(he,this.productService.version,this.productService.date)}async isValidVersion(M,G,re,he,ve){if(!(0,k.isTargetPlatformCompatible)(X(M),he,ve)||G!=="any"&&ne(M)!==(G==="prerelease"))return!1;if(re)try{const H=await this.getEngine(M);if(!(0,y.isEngineValid)(H,this.productService.version,this.productService.date))return!1}catch(H){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,D.getErrorMessage)(H)),!1}return!0}async query(M,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let re=M.text||"";const he=M.pageSize??50;let ve=new d().withPage(1,he);re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(q,j,Q)=>(ve=ve.withFilter(n.Category,Q||j),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(q,j,Q)=>(ve=ve.withFilter(n.Tag,Q||j),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(ve=ve.withFilter(n.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),ve=ve.withFilter(n.SearchText,re)),ve=ve.withSortBy(0)):M.ids?ve=ve.withFilter(n.ExtensionId,...M.ids):M.names?ve=ve.withFilter(n.ExtensionName,...M.names):ve=ve.withSortBy(4),typeof M.sortBy=="number"&&(ve=ve.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(ve=ve.withSortOrder(M.sortOrder)),M.source&&(ve=ve.withSource(M.source));const H=async(q,j)=>{const{extensions:Q,total:le}=await this.queryGalleryExtensions(q,{targetPlatform:f,compatible:!1,includePreRelease:!!M.includePreRelease},j);return Q.forEach((pe,ke)=>x(pe,(q.pageNumber-1)*q.pageSize+ke,M.source)),{extensions:Q,total:le}},{extensions:Y,total:te}=await H(ve,G),W=async(q,j)=>{if(j.isCancellationRequested)throw new D.CancellationError;const{extensions:Q}=await H(ve.withPage(q+1),j);return Q};return{firstPage:Y,total:te,pageSize:ve.pageSize,getPage:W}}async queryGalleryExtensions(M,G,re){const he=M.flags;!!(M.flags&r.IncludeLatestVersionOnly)&&!!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(M.flags&r.IncludeLatestVersionOnly)&&!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags,r.IncludeLatestVersionOnly)),G.versions?.length&&(M=M.withFlags(M.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),M=M.withFlags(M.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:ve,total:H}=await this.queryRawGalleryExtensions(M,re);if(!(M.flags&r.IncludeLatestVersionOnly)){const q=[];for(const j of ve){const Q=await this.toGalleryExtensionWithCriteria(j,G);Q&&q.push(Q)}return{extensions:q,total:H}}const te=[],W=new Map;for(let q=0;q<ve.length;q++){const j=ve[q],Q={id:(0,S.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},le=(0,I.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(ke=>(0,S.areSameExtensions)(ke,Q))?.includePreRelease;if(G.compatible&&(0,k.isNotWebExtensionInWebTargetPlatform)(O(j),G.targetPlatform))continue;const pe=await this.toGalleryExtensionWithCriteria(j,G);!pe||pe.properties.isPreReleaseVersion&&(!le||!pe.hasReleaseVersion)||!pe.properties.isPreReleaseVersion&&pe.properties.targetPlatform!==G.targetPlatform&&pe.hasPreReleaseVersion?W.set(j.extensionId,q):te.push([q,pe])}if(W.size){const q=new Date().getTime(),j=new d().withFlags(he&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,W.size).withFilter(n.ExtensionId,...W.keys()),{extensions:Q}=await this.queryGalleryExtensions(j,G,re);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-q,count:W.size});for(const le of Q){const pe=W.get(le.identifier.uuid);te.push([pe,le])}}return{extensions:te.sort((q,j)=>q[0]-j[0]).map(([,q])=>q),total:H}}async toGalleryExtensionWithCriteria(M,G){const re={id:(0,S.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},he=G.versions?.find(te=>(0,S.areSameExtensions)(te,re))?.version,ve=(0,I.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(te=>(0,S.areSameExtensions)(te,re))?.includePreRelease,H=O(M),Y=U(M.versions,G.targetPlatform);if(G.compatible&&(0,k.isNotWebExtensionInWebTargetPlatform)(H,G.targetPlatform))return null;for(let te=0;te<Y.length;te++){const W=Y[te];if(!(he&&W.version!==he)){if(await this.isValidVersion(W,ve?"any":"release",G.compatible,H,G.targetPlatform))return ae(M,W,H);if(he&&W.version===he)return null}}return he||G.compatible?null:ae(M,M.versions[0],H)}async queryRawGalleryExtensions(M,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,o(r.Unpublished));const re=await this.commonHeadersPromise,he=JSON.stringify(M.raw),ve={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},H=new Date().getTime();let Y,te,W=0;try{if(Y=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&M.criteria.some(j=>j.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:he,headers:ve},G),Y.res.statusCode&&Y.res.statusCode>=400&&Y.res.statusCode<500)return{galleryExtensions:[],total:W};const q=await(0,g.asJson)(Y);if(q){const j=q.results[0],Q=j.extensions,le=j.resultMetadata&&j.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return W=le&&le.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:Q,total:W}}return{galleryExtensions:[],total:W}}catch(q){throw te=q,q}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-H,success:!!Y&&(0,g.isSuccess)(Y),responseBodySize:Y?.res.headers["Content-Length"],statusCode:Y?String(Y.res.statusCode):void 0,errorCode:te?(0,D.isCancellationError)(te)?"canceled":(0,D.getErrorMessage)(te).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(W)})}}async reportStatistic(M,G,re,he){if(!this.isEnabled())return;const ve=C.isWeb?this.api(`/itemName/${M}.${G}/version/${re}/statType/${he==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${G}/${re}/stats?statType=${he}`),H=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",te={...await this.commonHeadersPromise,Accept:H};try{await this.requestService.request({type:"POST",url:ve,headers:te},t.CancellationToken.None)}catch{}}async download(M,G,re){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const he=(0,S.getGalleryExtensionTelemetryData)(M),ve=new Date().getTime(),H=q=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...he,duration:q}),Y=re===2?"install":re===3?"update":"",te=Y?{uri:`${M.assets.download.uri}${p.URI.parse(M.assets.download.uri).query?"&":"?"}${Y}=true`,fallbackUri:`${M.assets.download.fallbackUri}${p.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${Y}=true`}:M.assets.download,W=await this.getAsset(te);await this.fileService.writeFile(G,W.stream),H(new Date().getTime()-ve)}async getReadme(M,G){if(M.assets.readme){const re=await this.getAsset(M.assets.readme,{},G);return await(0,g.asTextOrError)(re)||""}return""}async getManifest(M,G){if(M.assets.manifest){const re=await this.getAsset(M.assets.manifest,{},G),he=await(0,g.asTextOrError)(re);return he?JSON.parse(he):null}return null}async getManifestFromRawExtensionVersion(M,G){const re=J(M,i.Manifest);if(!re)throw new Error("Manifest was not found");const he={"Accept-Encoding":"gzip"},ve=await this.getAsset(re,{headers:he});return await(0,g.asJson)(ve)}async getCoreTranslation(M,G){const re=M.assets.coreTranslations.filter(he=>he[0]===G.toUpperCase())[0];if(re){const he=await this.getAsset(re[1]),ve=await(0,g.asTextOrError)(he);return ve?JSON.parse(ve):null}return null}async getChangelog(M,G){if(M.assets.changelog){const re=await this.getAsset(M.assets.changelog,{},G);return await(0,g.asTextOrError)(re)||""}return""}async getAllCompatibleVersions(M,G,re){let he=new d().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?he=he.withFilter(n.ExtensionId,M.identifier.uuid):he=he.withFilter(n.ExtensionName,M.identifier.id);const{galleryExtensions:ve}=await this.queryRawGalleryExtensions(he,t.CancellationToken.None);if(!ve.length)return[];const H=O(ve[0]);if((0,k.isNotWebExtensionInWebTargetPlatform)(H,re))return[];const Y=[];await Promise.all(ve[0].versions.map(async q=>{try{await this.isValidVersion(q,G?"any":"release",!0,H,re)&&Y.push(q)}catch{}}));const te=[],W=new Set;for(const q of U(Y,re))W.has(q.version)||(W.add(q.version),te.push({version:q.version,date:q.lastUpdated,isPreReleaseVersion:ne(q)}));return te}async getAsset(M,G={},re=t.CancellationToken.None){const he=await this.commonHeadersPromise,ve={type:"GET"},H={...he,...G.headers||{}};G={...G,...ve,headers:H};const Y=M.uri,te=M.fallbackUri,W={...G,url:Y};try{const q=await this.requestService.request(W,re);if(q.res.statusCode===200)return q;const j=await(0,g.asTextOrError)(q);throw new Error(`Expected 200, got back ${q.res.statusCode} instead.

${j}`)}catch(q){if((0,D.isCancellationError)(q))throw q;const j=(0,D.getErrorMessage)(q);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Y,message:j});const Q={...G,url:te};return this.requestService.request(Q,re)}}async getEngine(M){let G=ee(M);if(!G){const re=await this.getManifestFromRawExtensionVersion(M,t.CancellationToken.None);if(!re)throw new Error("Manifest was not found");G=re.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,g.asJson)(M),re=[],he={};if(G){for(const ve of G.malicious)re.push({id:ve});if(G.migrateToPreRelease)for(const[ve,H]of Object.entries(G.migrateToPreRelease))(!H.engine||(0,y.isEngineValid)(H.engine,this.productService.version,this.productService.date))&&(he[ve.toLowerCase()]={disallowInstall:!0,extension:{id:H.id,displayName:H.displayName,autoMigrate:{storage:!!H.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[ve,H]of Object.entries(G.deprecated))H&&(he[ve.toLowerCase()]=(0,I.isBoolean)(H)?{}:H)}return{malicious:re,deprecated:he}}};fe=Re([_e(1,g.IRequestService),_e(2,w.ILogService),_e(3,R.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,h.IFileService),_e(6,E.IProductService),_e(7,b.IConfigurationService)],fe);let K=class extends fe{constructor(M,G,re,he,ve,H,Y,te){super(M,G,re,he,ve,H,Y,te)}};K=Re([_e(0,u.IStorageService),_e(1,g.IRequestService),_e(2,w.ILogService),_e(3,R.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,h.IFileService),_e(6,E.IProductService),_e(7,b.IConfigurationService)],K),e.ExtensionGalleryService=K;let ie=class extends fe{constructor(M,G,re,he,ve,H,Y){super(void 0,M,G,re,he,ve,H,Y)}};ie=Re([_e(0,g.IRequestService),_e(1,w.ILogService),_e(2,R.IEnvironmentService),_e(3,l.ITelemetryService),_e(4,h.IFileService),_e(5,E.IProductService),_e(6,b.IConfigurationService)],ie),e.ExtensionGalleryServiceWithNoStorageService=ie}),define(we[116],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,v.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(C,T){this._exitInfo.set(C,T)}getExitInfo(C){return this._exitInfo.get(C)||null}}e.ExtensionHostStatusService=t}),define(we[237],ye([1,0,7,14]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function D(T){let I=0,p=0,b=0;T>=1e3&&(b=Math.floor(T/1e3),T-=b*1e3),b>=60&&(p=Math.floor(b/60),b-=p*60),p>=60&&(I=Math.floor(p/60),p-=I*60);const R=I?`${I}h`:"",k=p?`${p}m`:"",S=b?`${b}s`:"",y=T?`${T}ms`:"";return`${R}${k}${S}${y}`}e.printTime=D;class C{constructor(I,p,b,R){this._logService=I,this._reconnectionToken=p,this._onClose=new v.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=b,this.protocol=R,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${D(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${D(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${D(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(I){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${I}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${D(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const I=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),I.end(),this._onClose.fire(void 0)}acceptReconnection(I,p,b){this._remoteAddress=I,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(p,b),this.protocol.endAcceptReconnection()}}e.ManagementConnection=C}),define(we[79],ye([1,0,30,12,6,144,51]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const I=D.join(t.FileAccess.asFileUri("",oe).fsPath,"nls.metadata.json"),p=new Map;function b(h){return new Promise(w=>v.exists(h,w))}function R(h,w){return b(I).then(E=>{if(!E||!T.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const g=`${h}||${w}`;let m=p.get(g);return m||(m=C.getNLSConfiguration(T.default.commit,w,I,h).then(u=>(k.is(u)&&(u._languagePackSupport=!0),u.locale!=="en"&&u.locale!=="en-us"&&Object.keys(u.availableLanguages).length===0&&p.delete(g),u)),p.set(g,m)),m})}e.getNLSConfiguration=R;var k;(function(h){function w(E){const g=E;return g&&typeof g._languagePackId=="string"}h.is=w})(k=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const S=async h=>{try{const w=y(await v.promises.readFile(h,"utf8"));return JSON.parse(w).locale}catch(w){return w.code!=="ENOENT"&&console.warn(w),"en"}};e.getLocaleFromConfig=S;const y=h=>{const w=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return h.replace(w,(E,g,m,u,l)=>{if(u)return"";if(l){const f=l.length;return f>2&&l[f-1]===`
`?l[f-2]==="\r"?`\r
`:`
`:""}else return E})}}),define(we[117],ye([1,0,19,4,29,53,55,35,17,5,13,26,37,79]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let h=class extends T.AbstractExtensionsScannerService{constructor(E,g,m,u,l,f,r){super(t.URI.file(l.builtinExtensionsPath),t.URI.file(l.extensionsPath),(0,v.joinPath)(l.userHome,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(t.URI.file(l.userDataPath),I.MANIFEST_CACHE_FOLDER),E,g,m,u,l,f,r),this.nativeEnvironmentService=l}async getTranslations(E){const g=await(0,y.getNLSConfiguration)(E,this.nativeEnvironmentService.userDataPath);if(y.InternalNLSConfiguration.is(g))try{const m=await this.fileService.readFile(t.URI.file(g._translationsConfigFile));return JSON.parse(m.value.toString())}catch{}return Object.create(null)}};h=Re([_e(0,S.IUserDataProfilesService),_e(1,C.IExtensionsProfileScannerService),_e(2,p.IFileService),_e(3,R.ILogService),_e(4,D.INativeEnvironmentService),_e(5,k.IProductService),_e(6,b.IInstantiationService)],h),e.ExtensionsScannerService=h}),define(we[238],ye([1,0,239,30,6,23,12,21]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const p=/^[0-9A-Za-z-]+$/;var b;(function(g){g[g.None=0]="None",g[g.Optional=1]="Optional",g[g.Mandatory=2]="Mandatory"})(b=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class R{constructor(){this.type=0}validate(m){return!0}}e.NoneServerConnectionToken=R;class k{constructor(m){this.value=m,this.type=1}validate(m){return m===this.value}}e.OptionalServerConnectionToken=k;class S{constructor(m){this.value=m,this.type=2}validate(m){return m===this.value}}e.MandatoryServerConnectionToken=S;class y{constructor(m){this.message=m}}e.ServerConnectionTokenParseError=y;async function h(g,m){const u=g["without-connection-token"],l=g["connection-token"],f=g["connection-token-file"],r=g.compatibility==="1.63";if(u)return typeof l<"u"||typeof f<"u"?new y("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new R;if(typeof f<"u"){if(typeof l<"u")return new y("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let o;try{o=t.readFileSync(f).toString().replace(/\r?\n$/,"")}catch{return new y(`Unable to read the connection token file at '${f}'.`)}return p.test(o)?new S(o):new y(`The connection token defined in '${f} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof l<"u"?p.test(l)?r?new k(l):new S(l):new y(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):r?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new k(await m())):new S(await m())}e.parseServerConnectionToken=h;async function w(g){return h(g,async()=>{if(!g["user-data-dir"])return(0,C.generateUuid)();const u=D.join(g["user-data-dir"],"token");try{const r=(await I.Promises.readFile(u)).toString().replace(/\r?\n$/,"");if(p.test(r))return r}catch{}const l=(0,C.generateUuid)();try{await I.Promises.writeFile(u,l,{mode:384})}catch{}return l})}e.determineServerConnectionToken=w;function E(g,m,u){if(g.validate(u.query[T.connectionTokenQueryName]))return!0;const l=v.parse(m.headers.cookie||"");return g.validate(l[T.connectionTokenCookieName])}e.requestHasValidConnectionToken=E}),define(we[40],ye([1,0,182,191,58,5,29]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:v.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:v.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:v.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:v.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:v.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:v.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:v.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:v.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:v.localize(8,null)},"user-data-dir":D.OPTIONS["user-data-dir"],"enable-smoke-test-driver":D.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":D.OPTIONS["disable-telemetry"],"disable-workspace-trust":D.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:D.OPTIONS.log,logsPath:D.OPTIONS.logsPath,"force-disable-user-env":D.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:v.localize(9,null)},"default-workspace":{type:"string",description:v.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":D.OPTIONS["extensions-dir"],"extensions-download-dir":D.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":D.OPTIONS["builtin-extensions-dir"],"install-extension":D.OPTIONS["install-extension"],"install-builtin-extension":D.OPTIONS["install-builtin-extension"],"uninstall-extension":D.OPTIONS["uninstall-extension"],"list-extensions":D.OPTIONS["list-extensions"],"locate-extension":D.OPTIONS["locate-extension"],"show-versions":D.OPTIONS["show-versions"],category:D.OPTIONS.category,force:D.OPTIONS.force,"do-not-sync":D.OPTIONS["do-not-sync"],"pre-release":D.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:v.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:D.OPTIONS.help,version:D.OPTIONS.version,"locate-shell-integration-path":D.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:D.OPTIONS._},e.IServerEnvironmentService=(0,C.refineServiceDecorator)(T.IEnvironmentService);class I extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=I}),define(we[240],ye([1,0,71,13,40,26,205,23,18]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let b=class extends T.BaseCredentialsMainService{constructor(k,S,y){super(k),this.environmentMainService=S,this.productService=y,this.environmentMainService.args["github-auth"]&&this.storeGitHubToken(this.environmentMainService.args["github-auth"]).catch(h=>{this.logService.error("Failed to store provided GitHub token",h)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((k,S)=>{oe(["keytar"],k,S)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(k){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${k.message??k}`),this._keytarCache=new v.InMemoryCredentialsProvider}return this._keytarCache}async storeGitHubToken(k){const S="vscode.github-authentication",y=`${await this.getSecretStoragePrefix()}${S}`,h="github.auth",E=[["read:user","user:email","repo"]].map(u=>({id:(0,I.generateUuid)(),scopes:u.sort(),accessToken:k})),g=await this.getPassword(y,h);let m;if(g)try{const u=JSON.parse(g);u.content=JSON.parse(u.content),m=u}catch(u){this.logService.error("Failed to parse existing GitHub credentials",u)}return m?.content&&(m.content=m.content.filter(u=>{const l=u.scopes.sort();return!E.find(f=>(0,p.equals)(l,f.scopes)&&f.account?.label===u.account?.label)})),this.setPassword(y,h,JSON.stringify({extensionId:S,...m||{},content:JSON.stringify([...E,...m?.content||[]])}))}};b=Re([_e(0,t.ILogService),_e(1,D.IServerEnvironmentService),_e(2,C.IProductService)],b),e.CredentialsWebMainService=b}),define(we[241],ye([1,0,271,224,242,28]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class T extends v.AppInsightsCore{constructor(p){super(),this.endpoint=p}track(p){const b=p.baseData||{};b.properties||(b.properties={}),b.measurements||(b.measurements={});try{const R=C.cpus();b.measurements.cores=R.length,b.properties["common.cpuModel"]=R[0].model}catch{}try{b.measurements.memoryFree=C.freemem(),b.measurements.memoryTotal=C.totalmem()}catch{}try{b.properties["common.shell"]=C.userInfo().shell,b.properties["common.release"]=C.release(),b.properties["common.arch"]=C.arch()}catch{}try{const R=(/^http:/.test(this.endpoint)?D:t).request(this.endpoint,{method:"POST",headers:{"Content-Type":"application/json"}});R.on("error",()=>{}),R.write(JSON.stringify(b)),R.end()}catch{}}}e.TelemetryClient=T}),define(we[243],ye([1,0,30,89,76,239,110,36,66,3,13,40,6,12,23,26,54,20,4,16,11,79,75]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(Z,J,_,ee){J.writeHead(_,{"Content-Type":"text/plain"}),J.end(ee)}e.serveError=n;var i;(function(Z){Z[Z.NO_CACHING=0]="NO_CACHING",Z[Z.ETAG=1]="ETAG",Z[Z.NO_EXPIRY=2]="NO_EXPIRY"})(i=e.CacheControl||(e.CacheControl={}));async function s(Z,J,_,ee,ne,B){try{const ue=await v.promises.stat(Z);if(J===1){const z=`W/"${[ue.ino,ue.size,ue.mtime.getTime()].join("-")}"`;if(ee.headers["if-none-match"]===z)return ne.writeHead(304),ne.end();B.Etag=z}else J===2?B["Cache-Control"]="public, max-age=31536000":J===0&&(B["Cache-Control"]="no-store");B["Content-Type"]=o[(0,S.extname)(Z)]||(0,p.getMediaMime)(Z)||"text/plain",ne.writeHead(200,B),(0,v.createReadStream)(Z).pipe(ne)}catch(ue){return ue.code!=="ENOENT"?(_.error(ue),console.error(ue.toString())):console.error(`File not found: ${Z}`),ne.writeHead(404,{"Content-Type":"text/plain"}),ne.end("Not found")}}e.serveFile=s;const a=(0,S.dirname)(y.FileAccess.asFileUri("",oe).fsPath);let c=class{constructor(J,_,ee,ne,B){this._connectionToken=J,this._environmentService=_,this._logService=ee,this._requestService=ne,this._productService=B,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?m.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const ue=(0,r.getRemoteServerRootPath)(B);this._staticRoute=`${ue}/static`,this._callbackRoute=`${ue}/callback`,this._webExtensionRoute="/web-extension-resource"}async handle(J,_,ee){try{const ne=ee.pathname;return ne.startsWith(this._staticRoute)&&ne.charCodeAt(this._staticRoute.length)===47?this._handleStatic(J,_,ee):ne==="/"?this._handleRoot(J,_,ee):ne===this._callbackRoute?this._handleCallback(_):ne.startsWith(this._webExtensionRoute)&&ne.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(J,_,ee):n(J,_,404,"Not found.")}catch(ne){return this._logService.error(ne),console.error(ne.toString()),n(J,_,500,"Internal Server Error.")}}async _handleStatic(J,_,ee){const ne=Object.create(null),ue=decodeURIComponent(ee.pathname).substring(this._staticRoute.length+1),z=(0,S.join)(a,ue);return(0,I.isEqualOrParent)(z,a,!b.isLinux)?s(z,this._environmentService.isBuilt?2:1,this._logService,J,_,ne):n(J,_,400,"Bad request.")}_getResourceURLTemplateAuthority(J){const _=J.authority.indexOf(".");return _!==-1?J.authority.substring(_+1):void 0}async _handleWebExtensionResource(J,_,ee){if(!this._webExtensionResourceUrlTemplate)return n(J,_,500,"No extension gallery service configured.");const ne=decodeURIComponent(ee.pathname),B=(0,S.normalize)(ne.substring(this._webExtensionRoute.length+1)),ue=m.URI.parse(B).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:B.substring(0,B.indexOf("/")),path:B.substring(B.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(ue))return n(J,_,403,"Request Forbidden");const z={},X=K=>{const ie=J.headers[K];ie&&((0,l.isString)(ie)||ie[0])?z[K]=(0,l.isString)(ie)?ie:ie[0]:K!==K.toLowerCase()&&X(K.toLowerCase())};X("X-Client-Name"),X("X-Client-Version"),X("X-Machine-Id"),X("X-Client-Commit");const O=await this._requestService.request({type:"GET",url:ue.toString(!0),headers:z},g.CancellationToken.None),U=O.res.statusCode||500;if(U!==200){let K=null;try{K=await(0,E.asTextOrError)(O)}catch{}return n(J,_,U,K||`Request failed with status ${U}`)}const x=Object.create(null),ae=K=>{const ie=O.res.headers[K];ie?x[K]=ie:K!==K.toLowerCase()&&ae(K.toLowerCase())};ae("Cache-Control"),ae("Content-Type"),_.writeHead(200,x);const fe=await(0,u.streamToBuffer)(O.stream);return _.end(fe.buffer)}async _handleRoot(J,_,ee){const ne=ee.query[y.connectionTokenQueryName];if(typeof ne=="string"){const ve=Object.create(null);ve["Set-Cookie"]=C.serialize(y.connectionTokenCookieName,ne,{sameSite:"lax",maxAge:60*60*24*7});const H=Object.create(null);for(const te in ee.query)te!==y.connectionTokenQueryName&&(H[te]=ee.query[te]);const Y=D.format({pathname:"/",query:H});return ve.Location=Y,_.writeHead(302,ve),_.end()}const B="remote";if(!B)return n(J,_,400,"Bad request.");function ue(ve){return JSON.stringify(ve).replace(/"/g,"&quot;")}let z;this._environmentService.args["enable-smoke-test-driver"]&&(z=!1);const X=ve=>ve&&m.URI.file(t.resolve(ve)).with({scheme:y.Schemas.vscodeRemote,authority:B}),O=y.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",oe).fsPath,U=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,h.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,x=(0,e.relativeRoot)((0,e.getOriginalUrl)(J)),ae=(0,e.relativePath)((0,e.getOriginalUrl)(J)),fe=this._environmentService.args.locale||await(0,f.getLocaleFromConfig)(this._environmentService.argvResource.fsPath),K=await(0,f.getNLSConfiguration)(fe,this._environmentService.userDataPath),ie={remoteAuthority:B,webviewEndpoint:ae+this._staticRoute+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this._environmentService.userDataPath,isEnabledFileDownloads:!this._environmentService.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this._environmentService.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:z,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this._logService.getLevel()},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:X(this._environmentService.args["default-folder"]),workspaceUri:X(this._environmentService.args["default-workspace"]),productConfiguration:{codeServerVersion:this._productService.codeServerVersion,rootEndpoint:x,updateEndpoint:this._environmentService.args["disable-update-check"]?void 0:x+"/update/check",logoutEndpoint:this._environmentService.args.auth&&this._environmentService.args.auth!=="none"?x+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??x+"/proxy/{{port}}/",serviceWorker:{scope:ae+"/",path:x+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this._productService.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this._productService.extensionsGallery},callbackRoute:this._callbackRoute},L=this._productService.extensionsGallery?.nlsBaseUrl,M={WORKBENCH_WEB_CONFIGURATION:ue(ie),WORKBENCH_AUTH_SESSION:U?ue(U):"",WORKBENCH_WEB_BASE_URL:ae+this._staticRoute,WORKBENCH_NLS_BASE_URL:ae+(L?`${L}${L.endsWith("/")?"":"/"}${this._productService.commit}/${this._productService.version}/`:""),BASE:x,VS_BASE:ae,NLS_CONFIGURATION:ue(K)};let G;try{G=(await v.promises.readFile(O)).toString().replace(/\{\{([^}]+)\}\}/g,(H,Y)=>M[Y]??"undefined")}catch{return _.writeHead(404,{"Content-Type":"text/plain"}),_.end("Not found")}const re=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(G).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),he={"Content-Type":"text/html","Content-Security-Policy":re};return this._connectionToken.type!==0&&(he["Set-Cookie"]=C.serialize(y.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),_.writeHead(200,he),_.end(G)}_getScriptCspHashes(J){const _=/<script>([\s\S]+?)<\/script>/img,ee=[];let ne;for(;ne=_.exec(J);){const B=T.createHash("sha256"),ue=ne[1].replace(/\r\n/g,`
`),z=B.update(Buffer.from(ue)).digest().toString("base64");ee.push(`'sha256-${z}'`)}return ee}async _handleCallback(J){const _=y.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",oe).fsPath,ee=(await v.promises.readFile(_)).toString(),ne=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(ee).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return J.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ne}),J.end(ee)}};c=Re([_e(1,k.IServerEnvironmentService),_e(2,R.ILogService),_e(3,E.IRequestService),_e(4,w.IProductService)],c),e.WebClientServer=c;const d=(Z,J=!1)=>Z.replace(/\/\/+/g,"/").replace(/\/+$/,J?"/":"");e.normalizeUrlPath=d;const P=Z=>{const J=(Z.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(J>1?"../".repeat(J-1):""))};e.relativeRoot=P;const F=Z=>{const J=Z.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+J[J.length-1])};e.relativePath=F;const $=Z=>Z.originalUrl||Z.url;e.getOriginalUrl=$}),define(we[244],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class t{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.dispose=C.dispose.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=t}),define(we[63],ye([1,0,69]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(C){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:C,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function D(C){return new v.URITransformer(t(C))}e.createURITransformer=D}),define(we[245],ye([1,0,4,63,61,6,207]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class I extends T.AbstractDiskFileSystemProviderChannel{constructor(R,k){super(new D.DiskFileSystemProvider(R),R),this.environmentService=k,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(R){let k=this.uriTransformerCache.get(R.remoteAuthority);return k||(k=(0,t.createURITransformer)(R.remoteAuthority),this.uriTransformerCache.set(R.remoteAuthority,k)),k}transformIncoming(R,k,S=!1){if(S&&k.path==="/vscode-resource"&&k.query){const y=JSON.parse(k.query).requestResourcePath;return v.URI.from({scheme:"file",path:y})}return v.URI.revive(R.transformIncoming(k))}createSessionFileWatcher(R,k){return new p(R,k,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=I;class p extends T.AbstractSessionFileWatcher{constructor(R,k,S,y){super(R,k,S,y)}getRecursiveWatcherOptions(R){const k=R.args["file-watcher-polling"];if(k){const S=k.split(C.delimiter),y=Number(S[0]);if(y>0)return{usePolling:S.length>1?S.slice(1):!0,pollingInterval:y}}}getExtraExcludes(R){if(R.extensionsPath)return[C.posix.join(R.extensionsPath,"**")]}}}),define(we[80],ye([1,0,183,11,4,2,5,34,17,12]),function(oe,e,v,t,D,C,T,I,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(O){O[O.PROGRAMMATIC=1]="PROGRAMMATIC",O[O.USER=2]="USER",O[O.EDIT=3]="EDIT",O[O.NAVIGATION=4]="NAVIGATION",O[O.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var k;(function(O){O[O.IDENTICAL=1]="IDENTICAL",O[O.SIMILAR=2]="SIMILAR",O[O.DIFFERENT=3]="DIFFERENT"})(k=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function S(O){const U=O;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}e.isEditorPaneWithSelection=S;function y(O,U,x){for(const ae of x.visibleEditorPanes)if(ae.group.id===U&&O.matches(ae.input))return ae.getViewState()}e.findViewStateForEditor=y;function h(O){if(s(O))return!1;const U=O;return D.URI.isUri(U?.resource)}e.isResourceEditorInput=h;function w(O){if(s(O))return!1;const U=O;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=w;function E(O){if(s(O)||w(O))return!1;const U=O;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function g(O){if(s(O))return!1;const U=O;return U?U.resource===void 0||U.resource.scheme===b.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;const m=/Untitled-\d+/;function u(O){return O.scheme===b.Schemas.untitled&&O.path.length>1&&!m.test(O.path)}e.isUntitledWithAssociatedResource=u;function l(O){if(s(O))return!1;const U=O;return D.URI.isUri(U?.base?.resource)&&D.URI.isUri(U?.input1?.resource)&&D.URI.isUri(U?.input2?.resource)&&D.URI.isUri(U?.result?.resource)}e.isResourceMergeEditorInput=l;var f;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var r;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.mapIdToSaveSource=new Map}registerSource(U,x){let ae=this.mapIdToSaveSource.get(U);return ae||(ae={source:U,label:x},this.mapIdToSaveSource.set(U,ae)),ae.source}getSourceLabel(U){return this.mapIdToSaveSource.get(U)?.label??U}}e.SaveSourceRegistry=new o;var n;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription",O[O.CanDropIntoEditor=128]="CanDropIntoEditor",O[O.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends C.Disposable{}e.AbstractEditorInput=i;function s(O){return O instanceof i}e.isEditorInput=s;function a(O){const U=O;return D.URI.isUri(U?.preferredResource)}function c(O){const U=O;return s(U?.primary)&&s(U?.secondary)}e.isSideBySideEditorInput=c;function d(O){const U=O;return s(U?.modified)&&s(U?.original)}e.isDiffEditorInput=d;function P(O){return s(O?.editor)}e.isEditorInputWithOptions=P;function F(O){const U=O;return P(O)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=F;function $(O){const U=O;return typeof U?.groupId=="number"&&s(U.editor)}e.isEditorIdentifier=$;var Z;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(Z=e.EditorCloseContext||(e.EditorCloseContext={}));var J;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(J=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var _;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(_=e.SideBySideEditor||(e.SideBySideEditor={}));class ee{getOriginalUri(U,x){if(!U)return;if(l(U))return e.EditorResourceAccessor.getOriginalUri(U.result,x);if(x?.supportSideBySide){const{primary:fe,secondary:K}=this.getSideEditors(U);if(fe&&K){if(x?.supportSideBySide===_.BOTH)return{primary:this.getOriginalUri(fe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===_.ANY)return this.getOriginalUri(fe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(K,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===_.PRIMARY?fe:K}}if(w(U)||E(U)||l(U))return;const ae=a(U)?U.preferredResource:U.resource;return!ae||!x||!x.filterByScheme?ae:this.filterUri(ae,x.filterByScheme)}getSideEditors(U){return c(U)||E(U)?{primary:U.primary,secondary:U.secondary}:d(U)||w(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,x){if(!U)return;if(l(U))return e.EditorResourceAccessor.getCanonicalUri(U.result,x);if(x?.supportSideBySide){const{primary:fe,secondary:K}=this.getSideEditors(U);if(fe&&K){if(x?.supportSideBySide===_.BOTH)return{primary:this.getCanonicalUri(fe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===_.ANY)return this.getCanonicalUri(fe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===_.PRIMARY?fe:K}}if(w(U)||E(U)||l(U))return;const ae=U.resource;return!ae||!x||!x.filterByScheme?ae:this.filterUri(ae,x.filterByScheme)}filterUri(U,x){if(Array.isArray(x)){if(x.some(ae=>U.scheme===ae))return U}else if(x===U.scheme)return U}}e.EditorResourceAccessor=new ee;var ne;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(ne=e.CloseDirection||(e.CloseDirection={}));class B{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const x=this.instantiationService=U.get(T.IInstantiationService);for(const[ae,fe]of this.editorSerializerConstructors)this.createEditorSerializer(ae,fe,x);this.editorSerializerConstructors.clear()}createEditorSerializer(U,x,ae){const fe=ae.createInstance(x);this.editorSerializerInstances.set(U,fe)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,x){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,x,this.instantiationService):this.editorSerializerConstructors.set(U,x),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}I.Registry.add(e.EditorExtensions.EditorFactory,new B);async function ue(O,U){return!O||!O.length?[]:await Promise.all(O.map(async x=>{const ae=D.URI.revive(x.fileUri);if(!ae||!await U.canHandleResource(ae))return;let K=x.exists,ie=x.type;if(typeof K!="boolean"||typeof ie!="number")try{ie=(await U.stat(ae)).isDirectory?p.FileType.Directory:p.FileType.Unknown,K=!0}catch{K=!1}if(!K&&x.openOnlyIfExists||ie===p.FileType.Directory)return;const L={...x.options,pinned:!0};return K?{resource:ae,options:L}:{resource:ae,options:L,forceUntitled:!0}}))}e.pathsToEditors=ue;var z;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function X(O){const U=O;if(!U)return!1;const x=U;if(x.modified)return X(x.modified);const ae=U;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}e.isTextEditorViewState=X}),define(we[118],ye([1,0,16,68,44,66,12,6,3,99]),function(oe,e,v,t,D,C,T,I,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(c){c[c.Markup=1]="Markup",c[c.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",C.Mimes.latex,C.Mimes.markdown,"image/png","image/jpeg",C.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[C.Mimes.latex,C.Mimes.markdown,"application/json",C.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(c){c[c.Running=1]="Running",c[c.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(c){c[c.Unconfirmed=1]="Unconfirmed",c[c.Pending=2]="Pending",c[c.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(c){c[c.WithHardKernelDependency=0]="WithHardKernelDependency",c[c.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",c[c.Pure=2]="Pure",c[c.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function(c){c.Always="always",c.Never="never",c.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var w;(function(c){c[c.ModelChange=1]="ModelChange",c[c.Move=2]="Move",c[c.ChangeCellLanguage=5]="ChangeCellLanguage",c[c.Initialize=6]="Initialize",c[c.ChangeCellMetadata=7]="ChangeCellMetadata",c[c.Output=8]="Output",c[c.OutputItem=9]="OutputItem",c[c.ChangeCellContent=10]="ChangeCellContent",c[c.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",c[c.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",c[c.ChangeCellMime=13]="ChangeCellMime",c[c.Unknown=100]="Unknown"})(w=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var E;(function(c){c[c.Handle=0]="Handle",c[c.Index=1]="Index"})(E=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(c){c[c.Replace=1]="Replace",c[c.Output=2]="Output",c[c.Metadata=3]="Metadata",c[c.CellLanguage=4]="CellLanguage",c[c.DocumentMetadata=5]="DocumentMetadata",c[c.Move=6]="Move",c[c.OutputItems=7]="OutputItems",c[c.PartialMetadata=8]="PartialMetadata",c[c.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var m;(function(c){c.scheme=T.Schemas.vscodeNotebookCell;const d=["W","X","Y","Z","a","b","c","d","e","f"],P=new RegExp(`^[${d.join("")}]+`),F=7;function $(B,ue){const z=ue.toString(F),O=`${z.length<d.length?d[z.length-1]:"z"}${z}s${(0,v.encodeBase64)(v.VSBuffer.fromString(B.scheme),!0,!0)}`;return B.with({scheme:c.scheme,fragment:O})}c.generate=$;function Z(B){if(B.scheme!==c.scheme)return;const ue=B.fragment.indexOf("s");if(ue<0)return;const z=parseInt(B.fragment.substring(0,ue).replace(P,""),F),X=(0,v.decodeBase64)(B.fragment.substring(ue+1)).toString();if(!isNaN(z))return{handle:z,notebook:B.with({scheme:X,fragment:null})}}c.parse=Z;function J(B,ue){return B.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${B.scheme!==T.Schemas.file?B.scheme:""}`})}c.generateCellOutputUri=J;function _(B){if(B.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!ue)return;const z=ue[1]&&ue[1]!==""?ue[1]:void 0,X=ue[2];return{outputId:z,notebook:B.with({scheme:X||T.Schemas.file,fragment:null})}}c.parseCellOutputUri=_;function ee(B,ue,z){return c.generate(B,ue).with({scheme:z})}c.generateCellPropertyUri=ee;function ne(B,ue){if(B.scheme===ue)return c.parse(B.with({scheme:c.scheme}))}c.parseCellPropertyUri=ne})(m=e.CellUri||(e.CellUri={}));const u=c=>p.isWindows?c.replace(/\//g,"\\"):c;class l{constructor(d=[],P=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=P,this.order=[...new Set(d)].map(F=>({pattern:F,matches:t.parse(u(F))}))}sort(d){const P=new Map(D.Iterable.map(d,$=>[$,u($)]));let F=[];for(const{matches:$}of this.order)for(const[Z,J]of P)if($(J)){F.push(Z),P.delete(Z);break}return P.size&&(F=F.concat([...P.keys()].sort(($,Z)=>this.defaultOrder.indexOf($)-this.defaultOrder.indexOf(Z)))),F}prioritize(d,P){const F=this.findIndex(d);if(F===-1){this.order.unshift({pattern:d,matches:t.parse(u(d))});return}const $=new Set(P.map(J=>this.findIndex(J,F)));$.delete(-1);const Z=Array.from($).sort();this.order.splice(F+1,0,...Z.map(J=>this.order[J]));for(let J=Z.length-1;J>=0;J--)this.order.splice(Z[J],1)}toArray(){return this.order.map(d=>d.pattern)}findIndex(d,P=this.order.length){const F=u(d);for(let $=0;$<P;$++)if(this.order[$].matches(F))return $;return-1}}e.MimeTypeDisplayOrder=l;function f(c,d,P,F=($,Z)=>$===Z){const $=[];function Z(ee,ne,B){if(ne===0&&B.length===0)return;const ue=$[$.length-1];ue&&ue.start+ue.deleteCount===ee?(ue.deleteCount+=ne,ue.toInsert.push(...B)):$.push({start:ee,deleteCount:ne,toInsert:B})}let J=0,_=0;for(;;){if(J===c.length){Z(J,0,d.slice(_));break}if(_===d.length){Z(J,c.length-J,[]);break}const ee=c[J],ne=d[_];if(F(ee,ne)){J+=1,_+=1;continue}P(ne)?(Z(J,1,[]),J+=1):(Z(J,0,[ne]),_+=1)}return $}e.diff=f,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(c){c.default="default",c.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(c){const d=c;return!!((typeof d.include=="string"||t.isRelativePattern(d.include))&&(typeof d.exclude=="string"||t.isRelativePattern(d.exclude)))}e.isDocumentExcludePattern=o;function n(c,d,P){if(Array.isArray(c.viewType)&&c.viewType.indexOf(d)>=0||c.viewType===d)return!0;if(c.filenamePattern){const F=o(c.filenamePattern)?c.filenamePattern.include:c.filenamePattern,$=o(c.filenamePattern)?c.filenamePattern.exclude:void 0;if(t.match(F,(0,I.basename)(P.fsPath).toLowerCase()))return!($&&t.match($,(0,I.basename)(P.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(c){c[c.Left=1]="Left",c[c.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(d){return`${s._prefix}${d}`}static parse(d){if(d.startsWith(s._prefix))return d.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/";function a(c){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(c)}e.isTextStreamMime=a}),define(we[119],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,v.createDecorator)("environmentVariableService");var t;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(we[246],ye([1,0,3,119]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class D{constructor(p){this.collections=p,this.map=new Map,p.forEach((b,R)=>{const k=b.map.entries();let S=k.next();for(;!S.done;){const y=S.value[0];let h=this.map.get(y);if(h||(h=[],this.map.set(y,h)),h.length>0&&h[0].type===t.EnvironmentVariableMutatorType.Replace){S=k.next();continue}const w=S.value[1];h.unshift({extensionIdentifier:R,value:w.value,type:w.type}),S=k.next()}})}async applyToProcessEnvironment(p,b){let R;v.isWindows&&(R={},Object.keys(p).forEach(k=>R[k.toLowerCase()]=k));for(const[k,S]of this.map){const y=v.isWindows&&R[k.toLowerCase()]||k;for(const h of S){const w=b?await b(h.value):h.value;switch(h.type){case t.EnvironmentVariableMutatorType.Append:p[y]=(p[y]||"")+w;break;case t.EnvironmentVariableMutatorType.Prepend:p[y]=w+(p[y]||"");break;case t.EnvironmentVariableMutatorType.Replace:p[y]=w;break}}}}diff(p){const b=new Map,R=new Map,k=new Map;if(p.map.forEach((S,y)=>{const h=this.map.get(y),w=C(S,h);w&&b.set(y,w)}),this.map.forEach((S,y)=>{const h=p.map.get(y),w=C(S,h);w&&k.set(y,w)}),this.map.forEach((S,y)=>{const h=p.map.get(y),w=T(S,h);w&&R.set(y,w)}),!(b.size===0&&R.size===0&&k.size===0))return{added:b,changed:R,removed:k}}}e.MergedEnvironmentVariableCollection=D;function C(I,p){if(!p)return I;const b=new Set;p.forEach(k=>b.add(k.extensionIdentifier));const R=[];return I.forEach(k=>{b.has(k.extensionIdentifier)||R.push(k)}),R.length===0?void 0:R}function T(I,p){if(!p)return;const b=new Map;p.forEach(k=>b.set(k.extensionIdentifier,k));const R=[];return I.forEach(k=>{const S=b.get(k.extensionIdentifier);S&&(k.type!==S.type||k.value!==S.value)&&R.push(S)}),R.length===0?void 0:R}}),define(we[120],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=v;function t(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=t;function D(T){return Array.from(T.entries()).map(I=>[I[0],v(I[1].map)])}e.serializeEnvironmentVariableCollections=D;function C(T){return new Map(T.map(I=>[I[0],{map:t(I[1])}]))}e.deserializeEnvironmentVariableCollections=C}),define(we[247],ye([1,0,6,56,3]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function C(l,f){if(!!f)if(D.isWindows)for(const r in f){let o=r;for(const i in l)if(r.toLowerCase()===i.toLowerCase()){o=i;break}const n=f[r];n!==void 0&&T(l,o,n)}else Object.keys(f).forEach(r=>{const o=f[r];o!==void 0&&T(l,r,o)})}e.mergeEnvironments=C;function T(l,f,r){typeof r=="string"?l[f]=r:delete l[f]}function I(l,f,r,o){l.TERM_PROGRAM="vscode",f&&(l.TERM_PROGRAM_VERSION=f),R(l,o)&&(l.LANG=k(r)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=I;function p(l,f){if(!!f)for(const r of Object.keys(f)){const o=f[r];o&&(l[r]=o)}}async function b(l,f){return await Promise.all(Object.entries(f).map(async([r,o])=>{if(typeof o=="string")try{f[r]=await l(o)}catch{f[r]=o}})),f}function R(l,f){if(f==="on")return!0;if(f==="auto"){const r=l.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function k(l){const f=l?l.split("-"):[],r=f.length;if(r===0)return"en_US.UTF-8";if(r===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};f[0]in o&&f.push(o[f[0]])}else f[1]=f[1].toUpperCase();return f.join("_")+".UTF-8"}e.getLangEnvVariable=k;async function S(l,f,r,o,n,i){if(l.cwd){const a=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,c=await y(a,r);return h(c||a)}let s;return!l.ignoreConfigurationCwd&&n&&(r&&(n=await y(n,r,i)),n&&(v.isAbsolute(n)?s=n:o&&(s=v.join(o.fsPath,n)))),s||(s=o?o.fsPath:f||""),h(s)}e.getCwd=S;async function y(l,f,r){if(f)try{return await f(l)}catch(o){r?.error("Could not resolve terminal cwd",o);return}return l}function h(l){return l.match(/$['"].*['"]^/)&&(l=l.substring(1,l.length-1)),D.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function w(l,f,r){if(!!r)return o=>r.resolveWithEnvironment(f,l,o)}e.createVariableResolver=w;async function E(l,f,r,o,n,i,s,a=D.platform){let c;s&&(c=m(l,"automationShell",a)),c||(c=m(l,"shell",a));let d=c||f;if(a===3&&!r&&o){const P=v.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();d&&d.toLowerCase().indexOf(P)===0&&(d=v.join(o,"System32",d.substr(P.length+1)))}if(d&&a===3&&(d=d.replace(/\//g,"\\")),n)try{d=await n(d)}catch(P){i.error("Could not resolve shell",P)}return d}e.getDefaultShell=E;async function g(l,f,r,o,n=D.platform){if(f&&m(l,"automationShell",n))return[];const i=n===3?"windows":n===1?"osx":"linux";let s=l(`terminal.integrated.shellArgs.${i}`);if(!s)return[];if(typeof s=="string"&&n===3)return r?await r(s):s;if(r){const a=[];for(const c of s)try{a.push(await r(c))}catch(d){o.error(`Could not resolve terminal.integrated.shellArgs.${i}`,d),a.push(c)}s=a}return s}e.getDefaultShellArgs=g;function m(l,f,r=D.platform){return l(`terminal.integrated.${f}.${r===3?"windows":r===1?"osx":"linux"}`)}async function u(l,f,r,o,n,i){const s={};if(l.strictEnv)p(s,l.env);else{p(s,i);const a={...f};r&&(a&&await b(r,a),l.env&&await b(r,l.env)),(0,t.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),C(s,a),C(s,l.env),I(s,o,D.locale,n)}return s}e.createTerminalEnvironment=u}),define(we[81],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(C){C.Delimiter="\0"})(v=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(T,I,p=T.parent){if(T.id===I)return new D([I]);const b=[T.id];for(let R=p;R&&R.id!==I;R=R.parent)b.push(R.id);return b.push(I),new D(b.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const I=T.indexOf("\0");return I===-1?T:T.slice(0,I)}static fromString(T){return new D(T.split("\0"))}static join(T,I){return new D([...T.path,I])}static joinToString(T,I){return T.toString()+"\0"+I}static compare(T,I){return T===I?0:I.startsWith(T+"\0")?2:T.startsWith(I+"\0")?3:1}constructor(T,I=T.length){if(this.path=T,this.viewEnd=I,T.length===0||I<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new D(this.path,T)}compare(T){if(typeof T=="string")return D.compare(this.toString(),T);for(let I=0;I<T.viewEnd&&I<this.viewEnd;I++)if(T.path[I]!==this.path[I])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=D}),define(we[82],ye([1,0,4,49]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var C;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(s){s.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),s.deserialize=a=>({range:t.Range.lift(a.range),uri:v.URI.revive(a.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var I;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var p;(function(s){s.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&T.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&T.deserialize(a.location)})})(p=e.ITestErrorMessage||(e.ITestErrorMessage={}));var b;(function(s){s.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&T.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&T.deserialize(a.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(s){s.serialize=a=>a.type===0?p.serialize(a):b.serialize(a),s.deserialize=a=>a.type===0?p.deserialize(a):b.deserialize(a)})(R=e.ITestMessage||(e.ITestMessage={}));var k;(function(s){s.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),s.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(R.serialize)}),s.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(R.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",y=(s,a)=>s+S+a;e.namespaceTestTag=y;const h=s=>{const a=s.indexOf(S);return{ctrlId:s.slice(0,a),tagId:s.slice(a+1)}};e.denamespaceTestTag=h;var w;(function(s){s.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),s.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?v.URI.revive(a.uri):void 0,range:a.range?t.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(w=e.ITestItem||(e.ITestItem={}));var E;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(s){s.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:w.serialize(a.item)}),s.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:w.deserialize(a.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var m;(function(s){s.serialize=a=>{let c;return a.item&&(c={},a.item.label!==void 0&&(c.label=a.item.label),a.item.tags!==void 0&&(c.tags=a.item.tags),a.item.busy!==void 0&&(c.busy=a.item.busy),a.item.uri!==void 0&&(c.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(c.range=a.item.range?.toJSON()),a.item.description!==void 0&&(c.description=a.item.description),a.item.error!==void 0&&(c.error=a.item.error),a.item.sortText!==void 0&&(c.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:c}},s.deserialize=a=>{let c;return a.item&&(c={},a.item.label!==void 0&&(c.label=a.item.label),a.item.tags!==void 0&&(c.tags=a.item.tags),a.item.busy!==void 0&&(c.busy=a.item.busy),a.item.range!==void 0&&(c.range=a.item.range?t.Range.lift(a.item.range):null),a.item.description!==void 0&&(c.description=a.item.description),a.item.error!==void 0&&(c.error=a.item.error),a.item.sortText!==void 0&&(c.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:c}}})(m=e.ITestItemUpdate||(e.ITestItemUpdate={}));const u=(s,a)=>{a.expand!==void 0&&(s.expand=a.expand),a.item!==void 0&&(s.item=s.item?Object.assign(s.item,a.item):a.item)};e.applyTestItemUpdate=u;var l;(function(s){s.serializeWithoutMessages=a=>({...g.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(k.serializeWithoutMessages),retired:a.retired}),s.serialize=a=>({...g.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(k.serialize),retired:a.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var f;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(f=e.DetailType||(e.DetailType={}));var r;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(s){s.deserialize=a=>a.op===0?{op:a.op,item:g.deserialize(a.item)}:a.op===1?{op:a.op,item:m.deserialize(a.item)}:a.op===2?{op:a.op,uri:v.URI.revive(a.uri),docv:a.docv}:a,s.serialize=a=>a.op===0?{op:a.op,item:g.serialize(a.item)}:a.op===1?{op:a.op,item:m.serialize(a.item)}:a})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(a){}update(a){}remove(a,c){}complete(){}}e.IncrementalChangeCollector=n;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const c=this.createChangeCollector();for(const d of a)switch(d.op){case 0:{const P=g.deserialize(d.item);if(P.parent){if(this.items.has(P.parent)){const F=this.items.get(P.parent);F.children.add(P.item.extId);const $=this.createItem(P,F);this.items.set(P.item.extId,$),c.add($)}}else{const F=this.createItem(P);this.roots.add(F),this.items.set(P.item.extId,F),c.add(F)}P.expand===2&&this.busyControllerCount++;break}case 1:{const P=m.deserialize(d.item),F=this.items.get(P.extId);if(!F)break;P.expand!==void 0&&(F.expand===2&&this.busyControllerCount--,P.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(F,P),c.update(F);break}case 3:{const P=this.items.get(d.itemId);if(!P)break;P.parent?this.items.get(P.parent).children.delete(P.item.extId):this.roots.delete(P);const F=[[d.itemId]];for(;F.length;)for(const $ of F.pop()){const Z=this.items.get($);Z&&(F.push(Z.children),this.items.delete($),c.remove(Z,Z!==P),Z.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(d.itemId);break;case 4:this.updatePendingRoots(d.amount);break;case 6:this._tags.set(d.tag.id,d.tag);break;case 7:this._tags.delete(d.id);break}c.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=i}),define(we[121],ye([1,0,14,7,2,84,82,81]),function(oe,e,v,t,D,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(p=e.TestItemEventOp||(e.TestItemEventOp={}));const b=(g,m)=>g===m,R={range:(g,m)=>g===m?!0:!g||!m?!1:g.equalsRange(m),busy:b,label:b,description:b,error:b,tags:(g,m)=>!(g.length!==m.length||g.some(u=>!m.includes(u)))},k=(g,m)=>{let u;for(const[l,f]of Object.entries(R))f(g[l],m[l])||(u?u[l]=m[l]:u={[l]:m[l]});return u};class S extends D.Disposable{get root(){return this.options.root}constructor(m){super(),this.options=m,this.debounceSendDiff=this._register(new v.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(m){this._resolveHandler=m;for(const u of this.tree.values())this.updateExpandability(u)}collectDiff(){const m=this.diff;return this.diff=[],m}pushDiff(m){switch(m.op){case 2:{for(const u of this.diff)if(u.op===2&&u.uri===m.uri){u.docv=m.docv;return}break}case 1:{const u=this.diff[this.diff.length-1];if(u){if(u.op===1&&u.item.extId===m.item.extId){(0,T.applyTestItemUpdate)(u.item,m.item);return}if(u.op===0&&u.item.item.extId===m.item.extId){(0,T.applyTestItemUpdate)(u.item,m.item);return}}break}}this.diff.push(m),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(m,u){const l=this.tree.get(m);if(!!l){if((l.expandLevels===void 0||u>l.expandLevels)&&(l.expandLevels=u),l.expand===1){const f=this.resolveChildren(l);return f.isOpen()?this.expandChildren(l,u-1):f.wait().then(()=>this.expandChildren(l,u-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,u-1)):this.expandChildren(l,u-1)}}dispose(){for(const m of this.tree.values())this.options.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(m,u){switch(u.op){case 3:this.removeItem(I.TestId.joinToString(m.fullId,u.id));break;case 0:this.upsertItem(u.item,m);break;case 5:for(const l of u.ops)this.onTestItemEvent(m,l);break;case 1:this.diffTagRefs(u.new,u.old,m.fullId.toString());break;case 2:this.updateExpandability(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:u.update}});break;case 6:this.documentSynced(m.actual.uri);break;default:(0,C.assertNever)(u)}}documentSynced(m){m&&this.pushDiff({op:2,uri:m,docv:this.options.getDocumentVersion(m)})}upsertItem(m,u){const l=I.TestId.fromExtHostTestItem(m,this.root.id,u?.actual),f=this.options.getApiFor(m);f.parent&&f.parent!==u?.actual&&this.options.getChildren(f.parent).delete(m.id);let r=this.tree.get(l.toString());if(!r){r={fullId:l,actual:m,parent:u?l.parentId:null,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},m.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(m,u),this.pushDiff({op:0,item:{parent:r.parent&&r.parent.toString(),controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(m)}}),this.connectItemAndChildren(m,r,u);return}if(r.actual===m){this.connectItem(m,r,u);return}const o=this.options.getChildren(r.actual),n=r.actual,i=k(this.options.toITestItem(n),this.options.toITestItem(m));this.options.getApiFor(n).listener=void 0,r.actual=m,r.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(m.tags,n.tags,l.toString()),delete i.tags),this.onTestItemEvent(r,{op:4,update:i})),this.connectItemAndChildren(m,r,u);for(const[s,a]of o)this.options.getChildren(m).get(a.id)||this.removeItem(I.TestId.joinToString(l,a.id));this.documentSynced(r.actual.uri)}diffTagRefs(m,u,l){const f=new Set(u.map(r=>r.id));for(const r of m)f.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:l,item:{tags:m.map(r=>(0,T.namespaceTestTag)(this.options.controllerId,r.id))}}}),f.forEach(this.decrementTagRefs,this)}incrementTagRefs(m){const u=this.tags.get(m.id);u?u.refCount++:(this.tags.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,m.id)}}))}decrementTagRefs(m){const u=this.tags.get(m);u&&!--u.refCount&&(this.tags.delete(m),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,m)}))}setItemParent(m,u){this.options.getApiFor(m).parent=u&&u.actual!==this.root?u.actual:void 0}connectItem(m,u,l){this.setItemParent(m,l);const f=this.options.getApiFor(m);f.parent=l?.actual,f.listener=r=>this.onTestItemEvent(u,r),this.updateExpandability(u)}connectItemAndChildren(m,u,l){this.connectItem(m,u,l);for(const[f,r]of this.options.getChildren(m))this.upsertItem(r,u)}updateExpandability(m){let u;this._resolveHandler?m.resolveBarrier?u=m.resolveBarrier.isOpen()?3:2:u=m.actual.canResolveChildren?1:0:u=0,u!==m.expand&&(m.expand=u,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:u}}),u===1&&m.expandLevels!==void 0&&this.resolveChildren(m))}expandChildren(m,u){if(u<0)return;const l=[];for(const[f,r]of this.options.getChildren(m.actual)){const o=this.expand(I.TestId.joinToString(m.fullId,r.id),u);(0,v.isThenable)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this._resolveHandler){const r=new v.Barrier;return r.open(),r}m.expand=2,this.pushExpandStateUpdate(m);const u=m.resolveBarrier=new v.Barrier,l=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let f;try{f=this._resolveHandler(m.actual===this.root?void 0:m.actual)}catch(r){l(r)}return(0,v.isThenable)(f)?f.catch(l).then(()=>{u.open(),this.updateExpandability(m)}):(u.open(),this.updateExpandability(m)),m.resolveBarrier}pushExpandStateUpdate(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}removeItem(m){const u=this.tree.get(m);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const l=[u];for(;l.length;){const f=l.pop();if(!!f){this.options.getApiFor(f.actual).listener=void 0;for(const r of f.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(f.fullId.toString());for(const[r,o]of this.options.getChildren(f.actual))l.push(this.tree.get(I.TestId.joinToString(f.fullId,o.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.diffOpEmitter.fire(m)}}e.TestItemCollection=S;class y extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=y;class h extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class w extends Error{constructor(m,u,l){super(`TestItem with ID "${m}" is from controller "${u}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=w;const E=(g,m,u)=>{let l=new Map;return{get size(){return l.size},forEach(f,r){for(const o of l.values())f.call(r,o,this)},[Symbol.iterator](){return l.entries()},replace(f){const r=new Map,o=new Set(l.keys()),n={op:5,ops:[]};for(const i of f){if(!(i instanceof u))throw new h(i.id);const s=m(i).controllerId;if(s!==g.controllerId)throw new w(i.id,s,g.controllerId);if(r.has(i.id))throw new y(i.id);r.set(i.id,i),o.delete(i.id),n.ops.push({op:0,item:i})}for(const i of o.keys())n.ops.push({op:3,id:i});g.listener?.(n),l=r},add(f){if(!(f instanceof u))throw new h(f.id);l.set(f.id,f),g.listener?.({op:0,item:f})},delete(f){l.delete(f)&&g.listener?.({op:3,id:f})},get(f){return l.get(f)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=E}),define(we[122],ye([1,0,121]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(T,I)=>{const p={controllerId:I};return t.set(T,p),p};e.createPrivateApiFor=D;const C=T=>{const I=t.get(T);if(!I)throw new v.InvalidTestItemError(T?.id||"<unknown>");return I};e.getPrivateApiFor=C}),define(we[248],ye([1,0,25,5]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(v.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(we[123],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,v.createDecorator)("configurationResolverService");var t;(function(C){C.Unknown="unknown",C.Env="env",C.Config="config",C.Command="command",C.Input="input",C.ExtensionInstallFolder="extensionInstallFolder",C.WorkspaceFolder="workspaceFolder",C.Cwd="cwd",C.WorkspaceFolderBasename="workspaceFolderBasename",C.UserHome="userHome",C.LineNumber="lineNumber",C.SelectedText="selectedText",C.File="file",C.FileWorkspaceFolder="fileWorkspaceFolder",C.RelativeFile="relativeFile",C.RelativeFileDirname="relativeFileDirname",C.FileDirname="fileDirname",C.FileExtname="fileExtname",C.FileBasename="fileBasename",C.FileBasenameNoExtension="fileBasenameNoExtension",C.FileDirnameBasename="fileDirnameBasename",C.ExecPath="execPath",C.ExecInstallFolder="execInstallFolder",C.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(T,I){super(I),this.variable=T}}e.VariableError=D}),define(we[249],ye([1,0,6,27,11,22,3,143,184,123,15]),function(oe,e,v,t,D,C,T,I,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(y,h,w,E){this._contributedVariables=new Map,this._context=y,this._labelService=h,this._userHomePromise=w,E&&(this._envVariablesPromise=E.then(g=>this.prepareEnv(g)))}prepareEnv(y){if(T.isWindows){const h=Object.create(null);return Object.keys(y).forEach(w=>{h[w.toLowerCase()]=y[w]}),h}return y}resolveWithEnvironment(y,h,w){return this.recursiveResolve({env:this.prepareEnv(y),userHome:void 0},h?h.uri:void 0,w)}async resolveAsync(y,h){const w={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(w,y?y.uri:void 0,h)}async resolveAnyBase(y,h,w,E){const g=C.deepClone(h);T.isWindows&&g.windows?Object.keys(g.windows).forEach(u=>g[u]=g.windows[u]):T.isMacintosh&&g.osx?Object.keys(g.osx).forEach(u=>g[u]=g.osx[u]):T.isLinux&&g.linux&&Object.keys(g.linux).forEach(u=>g[u]=g.linux[u]),delete g.windows,delete g.osx,delete g.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,y?y.uri:void 0,g,w,E)}async resolveAnyAsync(y,h,w){return this.resolveAnyBase(y,h,w)}async resolveAnyMap(y,h,w){const E=new Map;return{newConfig:await this.resolveAnyBase(y,h,w,E),resolvedVariables:E}}resolveWithInteractionReplace(y,h,w,E){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,h,w,E){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,h){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,h)}async recursiveResolve(y,h,w,E,g){if(D.isString(w))return this.resolveString(y,h,w,E,g);if(Array.isArray(w))return Promise.all(w.map(m=>this.recursiveResolve(y,h,m,E,g)));if(D.isObject(w)){const m=Object.create(null),u=await Promise.all(Object.keys(w).map(async l=>[await this.resolveString(y,h,l,E,g),await this.recursiveResolve(y,h,w[l],E,g)]));for(const[l,f]of u)m[l]=f;return m}return w}resolveString(y,h,w,E,g){return(0,R.replaceAsync)(w,k.VARIABLE_REGEXP,async(m,u)=>{if(u.includes(k.VARIABLE_LHS))return m;let l=await this.evaluateSingleVariable(y,m,u,h,E);return g?.set(u,l),l!==m&&D.isString(l)&&l.match(k.VARIABLE_REGEXP)&&(l=await this.resolveString(y,h,l,E,g)),l})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}async evaluateSingleVariable(y,h,w,E,g){let m;const u=w.split(":");u.length>1&&(w=u[0],m=u[1]);const l=o=>{const n=this._context.getFilePath();if(n)return n;throw new b.VariableError(o,(0,p.localize)(0,null,h))},f=o=>{const n=l(o);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new b.VariableError(o,(0,p.localize)(1,null,h,v.basename(n)))},r=o=>{if(m){const n=this._context.getFolderUri(m);if(n)return n;throw new b.VariableError(o,(0,p.localize)(2,null,h,m))}if(E)return E;throw this._context.getWorkspaceFolderCount()>1?new b.VariableError(o,(0,p.localize)(3,null,h)):new b.VariableError(o,(0,p.localize)(4,null,h))};switch(w){case"env":if(m){if(y.env){const o=y.env[T.isWindows?m.toLowerCase():m];if(D.isString(o))return o}return""}throw new b.VariableError(b.VariableKind.Env,(0,p.localize)(5,null,h));case"config":if(m){const o=this._context.getConfigurationValue(E,m);if(D.isUndefinedOrNull(o))throw new b.VariableError(b.VariableKind.Config,(0,p.localize)(6,null,h,m));if(D.isObject(o))throw new b.VariableError(b.VariableKind.Config,(0,p.localize)(7,null,h,m));return o}throw new b.VariableError(b.VariableKind.Config,(0,p.localize)(8,null,h));case"command":return this.resolveFromMap(b.VariableKind.Command,h,m,g,"command");case"input":return this.resolveFromMap(b.VariableKind.Input,h,m,g,"input");case"extensionInstallFolder":if(m){const o=await this._context.getExtension(m);if(!o)throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,h,m));return this.fsPath(o.extensionLocation)}throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,h));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(r(b.VariableKind.WorkspaceFolder)));case"cwd":return E||m?(0,I.normalizeDriveLetter)(this.fsPath(r(b.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(r(b.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(y.userHome)return y.userHome;throw new b.VariableError(b.VariableKind.UserHome,(0,p.localize)(11,null,h))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new b.VariableError(b.VariableKind.LineNumber,(0,p.localize)(12,null,h))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new b.VariableError(b.VariableKind.SelectedText,(0,p.localize)(13,null,h))}case"file":return l(b.VariableKind.File);case"fileWorkspaceFolder":return f(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return E||m?v.relative(this.fsPath(r(b.VariableKind.RelativeFile)),l(b.VariableKind.RelativeFile)):l(b.VariableKind.RelativeFile);case"relativeFileDirname":{const o=v.dirname(l(b.VariableKind.RelativeFileDirname));if(E||m){const n=v.relative(this.fsPath(r(b.VariableKind.RelativeFileDirname)),o);return n.length===0?".":n}return o}case"fileDirname":return v.dirname(l(b.VariableKind.FileDirname));case"fileExtname":return v.extname(l(b.VariableKind.FileExtname));case"fileBasename":return v.basename(l(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=v.basename(l(b.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-v.extname(o).length)}case"fileDirnameBasename":return v.basename(v.dirname(l(b.VariableKind.FileDirnameBasename)));case"execPath":{const o=this._context.getExecPath();return o||h}case"execInstallFolder":{const o=this._context.getAppRoot();return o||h}case"pathSeparator":return v.sep;default:try{const o=m?`${w}:${m}`:w;return this.resolveFromMap(b.VariableKind.Unknown,h,o,g,void 0)}catch{return h}}}}resolveFromMap(y,h,w,E,g){if(w&&E){const m=g===void 0?E[w]:E[g+":"+w];if(typeof m=="string")return m;throw new b.VariableError(y,(0,p.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[250],ye([1,0,5,80]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var D;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var I;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var p;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(p=e.MergeGroupMode||(e.MergeGroupMode={}));function b(h){const w=h;return(0,t.isEditorInput)(w?.editor)&&(0,t.isEditorInput)(w?.replacement)}e.isEditorReplacement=b;var R;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function S(h){const w=h;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=S;function y(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(we[124],ye([1,0,5,250]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(C){const T=C;return typeof C=="number"||(0,t.isEditorGroup)(T)}e.isPreferredGroup=D}),define(we[251],ye([1,0,11,248,13,107,78,120,123,80,124,12,204,119]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let h=class{get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}constructor(E,g,m,u,l,f,r,o,n,i){this._remoteAuthority=E,this._channel=g,this._configurationService=m,this._workspaceContextService=u,this._resolverService=l,this._environmentVariableService=f,this._remoteAuthorityResolverService=r,this._logService=o,this._editorService=n,this._labelService=i}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(E,g,m,u,l,f,r,o){await this._configurationService.whenRemoteConfigurationLoaded();const n=Object.create(null),i=m?(0,v.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(m)):void 0;let s;try{s=(await this._resolverService.resolveAnyMap(i,{shellLaunchConfig:E,configuration:g})).resolvedVariables}catch(_){this._logService.error(_)}if(s)for(const[_,ee]of s.entries())(/^config:/.test(_)||_==="selectedText"||_==="lineNumber")&&(n[_]=ee);const a=[];for(const[_,ee]of this._environmentVariableService.collections.entries())a.push([_,(0,I.serializeEnvironmentVariableCollection)(ee.map)]);const c=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),d=c.options&&c.options.extensionHostEnv,P=this._workspaceContextService.getWorkspace(),F=P.folders,$=m?this._workspaceContextService.getWorkspaceFolder(m):null,Z=b.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:b.SideBySideEditor.PRIMARY,filterByScheme:[k.Schemas.file,k.Schemas.vscodeUserData,k.Schemas.vscodeRemote]}),J={configuration:g,resolvedVariables:n,envVariableCollections:a,shellLaunchConfig:E,workspaceId:P.id,workspaceName:this._labelService.getWorkspaceLabel(P),workspaceFolders:F,activeWorkspaceFolder:$,activeFileResource:Z,shouldPersistTerminal:l,options:u,cols:f,rows:r,unicodeVersion:o,resolverEnv:d};return await this._channel.call("$createProcess",J)}requestDetachInstance(E,g){return this._channel.call("$requestDetachInstance",[E,g])}acceptDetachInstanceReply(E,g){return this._channel.call("$acceptDetachInstanceReply",[E,g])}attachToProcess(E){return this._channel.call("$attachToProcess",[E])}detachFromProcess(E,g){return this._channel.call("$detachFromProcess",[E,g])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(E,g){return this._channel.call("$processBinary",[E,g])}start(E){return this._channel.call("$start",[E])}input(E,g){return this._channel.call("$input",[E,g])}acknowledgeDataEvent(E,g){return this._channel.call("$acknowledgeDataEvent",[E,g])}setUnicodeVersion(E,g){return this._channel.call("$setUnicodeVersion",[E,g])}shutdown(E,g){return this._channel.call("$shutdown",[E,g])}resize(E,g,m){return this._channel.call("$resize",[E,g,m])}getInitialCwd(E){return this._channel.call("$getInitialCwd",[E])}getCwd(E){return this._channel.call("$getCwd",[E])}orphanQuestionReply(E){return this._channel.call("$orphanQuestionReply",[E])}sendCommandResult(E,g,m){return this._channel.call("$sendCommandResult",[E,g,m])}freePortKillProcess(E,g){return this._channel.call("$freePortKillProcess",[E,g])}installAutoReply(E,g){return this._channel.call("$installAutoReply",[E,g])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(E){return this._channel.call("$getDefaultSystemShell",[E])}getProfiles(E,g,m){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,E,g,m])}acceptPtyHostResolvedVariables(E,g){return this._channel.call("$acceptPtyHostResolvedVariables",[E,g])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(E){return this._channel.call("$getWslPath",[E])}setTerminalLayoutInfo(E){const m={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:E?E.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",m)}updateTitle(E,g,m){return this._channel.call("$updateTitle",[E,g,m])}updateIcon(E,g,m,u){return this._channel.call("$updateIcon",[E,g,m,u])}refreshProperty(E,g){return this._channel.call("$refreshProperty",[E,g])}updateProperty(E,g,m){return this._channel.call("$updateProperty",[E,g,m])}getTerminalLayoutInfo(){const g={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",g)}reviveTerminalProcesses(E,g){return this._channel.call("$reviveTerminalProcesses",[E,g])}getRevivedPtyNewId(E){return this._channel.call("$getRevivedPtyNewId",[E])}serializeTerminalState(E){return this._channel.call("$serializeTerminalState",[E])}};h=Re([_e(2,t.IWorkbenchConfigurationService),_e(3,T.IWorkspaceContextService),_e(4,p.IConfigurationResolverService),_e(5,y.IEnvironmentVariableService),_e(6,C.IRemoteAuthorityResolverService),_e(7,D.ILogService),_e(8,R.IEditorService),_e(9,S.ILabelService)],h),e.RemoteTerminalChannelClient=h}),define(we[252],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var v;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(v=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(k){k[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class C{constructor(){this.type=3}serialize(k){k[C.ENV_KEY]="1"}}e.MessagePortExtHostConnection=C,C.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function T(R){delete R[t.ENV_KEY],delete R[D.ENV_KEY],delete R[C.ENV_KEY]}function I(R,k){T(k),R.serialize(k)}e.writeExtHostConnection=I;function p(R){if(R[t.ENV_KEY])return b(R,new t(R[t.ENV_KEY]));if(R[D.ENV_KEY])return b(R,new D);if(R[C.ENV_KEY])return b(R,new C);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=p;function b(R,k){return T(R),k}}),define(we[125],ye([1,0,48,91,79,12,6,16,7,57,77,13,40,3,56,116,2,252]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function m(n={},i,s,a,c){const d=await(0,D.getNLSConfiguration)(s,a.userDataPath);let P={};if(i)try{P=await(0,R.getResolvedShellEnv)(c,a.args,process.env)}catch(ee){c.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ee)}const $={...process.env,...P,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(d,void 0,0),...n},Z=a.isBuilt?(0,T.join)(a.appRoot,"bin"):(0,T.join)(a.appRoot,"resources","server","bin-dev"),J=(0,T.join)(Z,"remote-cli");let _=f($,"PATH");return _?_=J+T.delimiter+_:_=J,r($,"PATH",_),a.args["without-browser-env-var"]||($.BROWSER=(0,T.join)(Z,"helpers",y.isWindows?"browser.cmd":"browser.sh")),o($),$}e.buildUserEnvironment=m;class u{constructor(i,s){this.socket=i,this.initialDataChunk=s}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let i,s,a;return this.socket instanceof b.NodeSocket?(i=!0,s=!1,a=I.VSBuffer.alloc(0)):(i=!1,s=this.socket.permessageDeflate,a=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:i,permessageDeflate:s,inflateBytes:a.buffer.toString("base64")}}}let l=class{constructor(i,s,a,c,d,P,F){this._reconnectionToken=i,this._environmentService=d,this._logService=P,this._extensionHostStatusService=F,this._onClose=new p.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!y.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=s,this._extensionHostProcess=null,this._connectionData=new u(a,c),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(i){this._logService.info(`${this._logPrefix}${i}`)}_logError(i){this._logService.error(`${this._logPrefix}${i}`)}async _pipeSockets(i,s){const a=new E.DisposableStore;a.add(s.socket),a.add((0,E.toDisposable)(()=>{i.destroy()}));const c=()=>{a.dispose()};a.add(s.socket.onEnd(c)),a.add(s.socket.onClose(c)),a.add(p.Event.fromNodeEventEmitter(i,"end")(c)),a.add(p.Event.fromNodeEventEmitter(i,"close")(c)),a.add(p.Event.fromNodeEventEmitter(i,"error")(c)),a.add(s.socket.onData(d=>i.write(d.buffer))),a.add(p.Event.fromNodeEventEmitter(i,"data")(d=>{s.socket.write(I.VSBuffer.wrap(d))})),s.initialDataChunk.byteLength>0&&i.write(s.initialDataChunk.buffer)}async _sendSocketToExtensionHost(i,s){await s.socketDrain();const a=s.toIExtHostSocketMessage();let c;s.socket instanceof b.NodeSocket?c=s.socket.socket:c=s.socket.socket.socket,i.send(a,c)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const i={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(i)}acceptReconnection(i,s,a){this._remoteAddress=i,this._log("The client has reconnected.");const c=new u(s,a);if(!this._extensionHostProcess){this._connectionData=c;return}this._sendSocketToExtensionHost(this._extensionHostProcess,c)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(i){try{let s=process.execArgv?process.execArgv.filter(_=>!/^--inspect(-brk)?=/.test(_)):[];i.port&&!process.pkg&&(s=[`--inspect${i.break?"-brk":""}=${i.port}`]);const a=await m(i.env,!0,i.language,this._environmentService,this._logService);(0,h.removeDangerousEnvVariables)(a);let c;if(this._canSendSocket)(0,g.writeExtHostConnection)(new g.SocketExtHostConnection,a),c=null;else{const{namedPipeServer:_,pipeName:ee}=await this._listenOnPipe();(0,g.writeExtHostConnection)(new g.IPCExtHostConnection(ee),a),c=_}const d={env:a,execArgv:s,silent:!0},P=["--type=extensionHost","--transformURIs"],F=this._environmentService.args["use-host-proxy"];P.push(`--useHostProxy=${F?"true":"false"}`),this._extensionHostProcess=v.fork(C.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,P,d);const $=this._extensionHostProcess.pid;this._log(`<${$}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const Z=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),J=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(Z(_=>this._log(`<${$}> ${_}`)),J(_=>this._log(`<${$}><stderr> ${_}`)),this._extensionHostProcess.on("error",_=>{this._logError(`<${$}> Extension Host Process had an error`),this._logService.error(_),this._cleanResources()}),this._extensionHostProcess.on("exit",(_,ee)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:_,signal:ee}),this._log(`<${$}> Extension Host Process exited with code: ${_}, signal: ${ee}.`),this._cleanResources()}),c)c.on("connection",_=>{c.close(),this._pipeSockets(_,this._connectionData)});else{const _=ee=>{ee.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",_),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",_)}}catch(s){console.error("ExtensionHostConnection errored"),s&&console.error(s)}}_listenOnPipe(){return new Promise((i,s)=>{const a=(0,b.createRandomIPCHandle)(),c=t.createServer();c.on("error",s),c.listen(a,()=>{c?.removeListener("error",s),i({pipeName:a,namedPipeServer:c})})})}};l=Re([_e(4,S.IServerEnvironmentService),_e(5,k.ILogService),_e(6,w.IExtensionHostStatusService)],l),e.ExtensionHostConnection=l;function f(n,i){const s=Object.keys(n).filter(c=>c.toLowerCase()===i.toLowerCase()),a=s.length>0?s[0]:i;return n[a]}function r(n,i,s){const a=Object.keys(n).filter(d=>d.toLowerCase()===i.toLowerCase()),c=a.length>0?a[0]:i;n[c]=s}function o(n){for(const i of Object.keys(n))n[i]===null&&delete n[i]}}),define(we[253],ye([1,0,7,4,5,35,32]),function(oe,e,v,t,D,C,T){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class p{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=p;class b{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=b;class R{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class k{constructor(a){this.dependency=a}}e.MissingExtensionDependency=k;var S;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=y;class h{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(a,c){const d=[],P=[],F=[],$=[],Z=g(this._allExtensions),J=g(a),_=(ue,z)=>ue.extensionLocation.toString()===z.extensionLocation.toString()||ue.isBuiltin===z.isBuiltin||ue.isUserBuiltin===z.isUserBuiltin||ue.isUnderDevelopment===z.isUnderDevelopment;for(const ue of this._allExtensions){const z=J.get(C.ExtensionIdentifier.toKey(ue.identifier));if(!z){d.push(ue.identifier),Z.delete(C.ExtensionIdentifier.toKey(ue.identifier));continue}if(!_(ue,z)){d.push(ue.identifier),Z.delete(C.ExtensionIdentifier.toKey(ue.identifier));continue}}for(const ue of a){const z=Z.get(C.ExtensionIdentifier.toKey(ue.identifier));if(!z){P.push(ue);continue}if(!_(z,ue)){d.push(z.identifier),Z.delete(C.ExtensionIdentifier.toKey(z.identifier));continue}}const ee=E(this._myExtensions),ne=E(c);for(const ue of this._myExtensions)ne.has(C.ExtensionIdentifier.toKey(ue))||F.push(ue);for(const ue of c)ee.has(C.ExtensionIdentifier.toKey(ue))||$.push(ue);const B={toRemove:d,toAdd:P,myToRemove:F,myToAdd:$};return this.delta(B),B}delta(a){const{toRemove:c,toAdd:d,myToRemove:P,myToAdd:F}=a,$=E(c),Z=E(P);for(let J=0;J<this._allExtensions.length;J++)$.has(C.ExtensionIdentifier.toKey(this._allExtensions[J].identifier))&&(this._allExtensions.splice(J,1),J--);for(let J=0;J<this._myExtensions.length;J++)Z.has(C.ExtensionIdentifier.toKey(this._myExtensions[J]))&&(this._myExtensions.splice(J,1),J--);for(const J of d)this._allExtensions.push(J);for(const J of F)this._myExtensions.push(J)}containsExtension(a){for(const c of this._myExtensions)if(C.ExtensionIdentifier.equals(c,a))return!0;return!1}}e.ExtensionHostExtensions=h;class w{constructor(a){if(this[I]="ExtensionIdentifierSet",this._map=new Map,this._toKey=C.ExtensionIdentifier.toKey,a)for(const c of a)this.add(c)}get size(){return this._map.size}add(a){return this._map.set(this._toKey(a),a),this}clear(){this._map.clear()}delete(a){return this._map.delete(this._toKey(a))}has(a){return this._map.has(this._toKey(a))}forEach(a,c){this._map.forEach(d=>a.call(c,d,d,this))}*entries(){for(const[a,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=w;function E(s){const a=new Set;for(const c of s)a.add(C.ExtensionIdentifier.toKey(c));return a}e.extensionIdentifiersArrayToSet=E;function g(s){const a=new Map;for(const c of s)a.set(C.ExtensionIdentifier.toKey(c.identifier),c);return a}function m(s,a){return!0}e.isProposedApiEnabled=m;function u(s,a){if(!m(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=u;class l{constructor(a,c,d,P){this.codeLoadingTime=a,this.activateCallTime=c,this.activateResolvedTime=d,this.activationReason=P}}e.ActivationTimes=l;class f{constructor(a,c){this.description=a,this.value=c}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var r;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function o(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function n(s,a){return{identifier:new C.ExtensionIdentifier((0,T.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,c){return Promise.resolve(0)}getInspectPorts(a,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,c){return Promise.resolve()}}e.NullExtensionService=i});var Rt=this&&this.__classPrivateFieldSet||function(oe,e,v,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,v):D?D.value=v:e.set(oe,v),v},nt=this&&this.__classPrivateFieldGet||function(oe,e,v,t){if(v==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?t:v==="a"?t.call(oe):t?t.value:e.get(oe)};define(we[126],ye([1,0,18,8,88,24,66,15,11,4,23,17,107,118,253]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h){"use strict";var w,E,g,m,u,l,f,r,o,n,i,s,a,c,d,P,F,$,Z,J,_,ee,ne;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function B(N){function A(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(A,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(A,N),Object.setPrototypeOf(A.prototype,N.prototype),A}let ue=l=class{static from(...A){let se=A;return new l(function(){if(se){for(const ge of se)ge&&typeof ge.dispose=="function"&&ge.dispose();se=void 0}})}constructor(A){w.set(this,void 0),Rt(this,w,A,"f")}dispose(){typeof nt(this,w,"f")=="function"&&(nt(this,w,"f").call(this),Rt(this,w,void 0,"f"))}};w=new WeakMap,ue=l=Re([B],ue),e.Disposable=ue;let z=f=class{static Min(...A){if(A.length===0)throw new TypeError;let se=A[0];for(let ge=1;ge<A.length;ge++){const Ue=A[ge];Ue.isBefore(se)&&(se=Ue)}return se}static Max(...A){if(A.length===0)throw new TypeError;let se=A[0];for(let ge=1;ge<A.length;ge++){const Ue=A[ge];Ue.isAfter(se)&&(se=Ue)}return se}static isPosition(A){if(!A)return!1;if(A instanceof f)return!0;const{line:se,character:ge}=A;return typeof se=="number"&&typeof ge=="number"}static of(A){if(A instanceof f)return A;if(this.isPosition(A))return new f(A.line,A.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(A,se){if(A<0)throw(0,t.illegalArgument)("line must be non-negative");if(se<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=A,this._character=se}isBefore(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<A._character}isBeforeOrEqual(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<=A._character}isAfter(A){return!this.isBeforeOrEqual(A)}isAfterOrEqual(A){return!this.isBefore(A)}isEqual(A){return this._line===A._line&&this._character===A._character}compareTo(A){return this._line<A._line?-1:this._line>A.line?1:this._character<A._character?-1:this._character>A._character?1:0}translate(A,se=0){if(A===null||se===null)throw(0,t.illegalArgument)();let ge;return typeof A>"u"?ge=0:typeof A=="number"?ge=A:(ge=typeof A.lineDelta=="number"?A.lineDelta:0,se=typeof A.characterDelta=="number"?A.characterDelta:0),ge===0&&se===0?this:new f(this.line+ge,this.character+se)}with(A,se=this.character){if(A===null||se===null)throw(0,t.illegalArgument)();let ge;return typeof A>"u"?ge=this.line:typeof A=="number"?ge=A:(ge=typeof A.line=="number"?A.line:this.line,se=typeof A.character=="number"?A.character:this.character),ge===this.line&&se===this.character?this:new f(ge,se)}toJSON(){return{line:this.line,character:this.character}}};z=f=Re([B],z),e.Position=z;let X=r=class{static isRange(A){return A instanceof r?!0:A?z.isPosition(A.start)&&z.isPosition(A.end):!1}static of(A){if(A instanceof r)return A;if(this.isRange(A))return new r(A.start,A.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(A,se,ge,Ue){let He,Je;if(typeof A=="number"&&typeof se=="number"&&typeof ge=="number"&&typeof Ue=="number"?(He=new z(A,se),Je=new z(ge,Ue)):z.isPosition(A)&&z.isPosition(se)&&(He=z.of(A),Je=z.of(se)),!He||!Je)throw new Error("Invalid arguments");He.isBefore(Je)?(this._start=He,this._end=Je):(this._start=Je,this._end=He)}contains(A){return r.isRange(A)?this.contains(A.start)&&this.contains(A.end):z.isPosition(A)?!(z.of(A).isBefore(this._start)||this._end.isBefore(A)):!1}isEqual(A){return this._start.isEqual(A._start)&&this._end.isEqual(A._end)}intersection(A){const se=z.Max(A.start,this._start),ge=z.Min(A.end,this._end);if(!se.isAfter(ge))return new r(se,ge)}union(A){if(this.contains(A))return this;if(A.contains(this))return A;const se=z.Min(A.start,this._start),ge=z.Max(A.end,this.end);return new r(se,ge)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(A,se=this.end){if(A===null||se===null)throw(0,t.illegalArgument)();let ge;return A?z.isPosition(A)?ge=A:(ge=A.start||this.start,se=A.end||this.end):ge=this.start,ge.isEqual(this._start)&&se.isEqual(this.end)?this:new r(ge,se)}toJSON(){return[this.start,this.end]}};X=r=Re([B],X),e.Range=X;let O=o=class extends X{static isSelection(A){return A instanceof o?!0:A?X.isRange(A)&&z.isPosition(A.anchor)&&z.isPosition(A.active)&&typeof A.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(A,se,ge,Ue){let He,Je;if(typeof A=="number"&&typeof se=="number"&&typeof ge=="number"&&typeof Ue=="number"?(He=new z(A,se),Je=new z(ge,Ue)):z.isPosition(A)&&z.isPosition(se)&&(He=z.of(A),Je=z.of(se)),!He||!Je)throw new Error("Invalid arguments");super(He,Je),this._anchor=He,this._active=Je}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=o=Re([B],O),e.Selection=O;class U{constructor(A,se,ge){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,t.illegalArgument)("port");if(typeof ge<"u"&&(typeof ge!="string"||ge.length===0||!/^[0-9A-Za-z\-]+$/.test(ge)))throw(0,t.illegalArgument)("connectionToken");this.host=A,this.port=Math.round(se),this.connectionToken=ge}}e.ResolvedAuthority=U;class x extends Error{static NotAvailable(A,se){return new x(A,S.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(A){return new x(A,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(A,se=S.RemoteAuthorityResolverErrorCode.Unknown,ge){super(A),this._message=A,this._code=se,this._detail=ge,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}}e.RemoteAuthorityResolverError=x;var ae;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(ae=e.EndOfLine||(e.EndOfLine={}));var fe;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(fe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=n=class{static isTextEdit(A){return A instanceof n?!0:A?X.isRange(A)&&typeof A.newText=="string":!1}static replace(A,se){return new n(A,se)}static insert(A,se){return n.replace(new X(A,A),se)}static delete(A){return n.replace(A,"")}static setEndOfLine(A){const se=new n(new X(new z(0,0),new z(0,0)),"");return se.newEol=A,se}get range(){return this._range}set range(A){if(A&&!X.isRange(A))throw(0,t.illegalArgument)("range");this._range=A}get newText(){return this._newText||""}set newText(A){if(A&&typeof A!="string")throw(0,t.illegalArgument)("newText");this._newText=A}get newEol(){return this._newEol}set newEol(A){if(A&&typeof A!="number")throw(0,t.illegalArgument)("newEol");this._newEol=A}constructor(A,se){this._range=A,this._newText=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=n=Re([B],K),e.TextEdit=K;let ie=i=class{static isNotebookCellEdit(A){return A instanceof i?!0:A?Pt.isNotebookRange(A)&&Array.isArray(A.newCells):!1}static replaceCells(A,se){return new i(A,se)}static insertCells(A,se){return new i(new Pt(A,A),se)}static deleteCells(A){return new i(A,[])}static updateCellMetadata(A,se){const ge=new i(new Pt(A,A),[]);return ge.newCellMetadata=se,ge}static updateNotebookMetadata(A){const se=new i(new Pt(0,0),[]);return se.newNotebookMetadata=A,se}constructor(A,se){this.range=A,this.newCells=se}};ie=i=Re([B],ie),e.NotebookEdit=ie;class L{static isSnippetTextEdit(A){return A instanceof L?!0:A?X.isRange(A.range)&&re.isSnippetString(A.snippet):!1}static replace(A,se){return new L(A,se)}static insert(A,se){return L.replace(new X(A,A),se)}constructor(A,se){this.range=A,this.snippet=se}}e.SnippetTextEdit=L;var M;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace",N[N.Snippet=6]="Snippet"})(M=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(A,se,ge,Ue){this._edits.push({_type:1,from:A,to:se,options:ge,metadata:Ue})}createFile(A,se,ge){this._edits.push({_type:1,from:void 0,to:A,options:se,metadata:ge})}deleteFile(A,se,ge){this._edits.push({_type:1,from:A,to:void 0,options:se,metadata:ge})}replaceNotebookMetadata(A,se,ge){this._edits.push({_type:3,metadata:ge,uri:A,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(A,se,ge,Ue){const He=se.start,Je=se.end;(He!==Je||ge.length>0)&&this._edits.push({_type:5,uri:A,index:He,count:Je-He,cells:ge,metadata:Ue})}replaceNotebookCellMetadata(A,se,ge,Ue){this._edits.push({_type:3,metadata:Ue,uri:A,edit:{editType:8,index:se,metadata:ge}})}replace(A,se,ge,Ue){this._edits.push({_type:2,uri:A,edit:new K(se,ge),metadata:Ue})}insert(A,se,ge,Ue){this.replace(A,new X(se,se),ge,Ue)}delete(A,se,ge){this.replace(A,se,"",ge)}has(A){return this._edits.some(se=>se._type===2&&se.uri.toString()===A.toString())}set(A,se){if(se)for(const ge of se){if(!ge)continue;let Ue,He;Array.isArray(ge)?(Ue=ge[0],He=ge[1]):Ue=ge,ie.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.replaceNotebookCellMetadata(A,Ue.range.start,Ue.newCellMetadata,He):Ue.newNotebookMetadata?this.replaceNotebookMetadata(A,Ue.newNotebookMetadata,He):this.replaceNotebookCells(A,Ue.range,Ue.newCells,He):L.isSnippetTextEdit(Ue)?this._edits.push({_type:6,uri:A,range:Ue.range,edit:Ue.snippet,metadata:He}):this._edits.push({_type:2,uri:A,edit:Ue,metadata:He})}else{for(let ge=0;ge<this._edits.length;ge++){const Ue=this._edits[ge];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===A.toString()&&(this._edits[ge]=void 0);break}}(0,v.coalesceInPlace)(this._edits)}}get(A){const se=[];for(const ge of this._edits)ge._type===2&&ge.uri.toString()===A.toString()&&se.push(ge.edit);return se}entries(){const A=new C.ResourceMap;for(const se of this._edits)if(se._type===2){let ge=A.get(se.uri);ge||(ge=[se.uri,[]],A.set(se.uri,ge)),ge[1].push(se.edit)}return[...A.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Re([B],G),e.WorkspaceEdit=G;let re=s=class{static isSnippetString(A){return A instanceof s?!0:A?typeof A.value=="string":!1}static _escape(A){return A.replace(/\$|}|\\/g,"\\$&")}constructor(A){this._tabstop=1,this.value=A||""}appendText(A){return this.value+=s._escape(A),this}appendTabstop(A=this._tabstop++){return this.value+="$",this.value+=A,this}appendPlaceholder(A,se=this._tabstop++){if(typeof A=="function"){const ge=new s;ge._tabstop=this._tabstop,A(ge),this._tabstop=ge._tabstop,A=ge.value}else A=s._escape(A);return this.value+="${",this.value+=se,this.value+=":",this.value+=A,this.value+="}",this}appendChoice(A,se=this._tabstop++){const ge=A.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ge,this.value+="|}",this}appendVariable(A,se){if(typeof se=="function"){const ge=new s;ge._tabstop=this._tabstop,se(ge),this._tabstop=ge._tabstop,se=ge.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=A,se&&(this.value+=":",this.value+=se),this.value+="}",this}};re=s=Re([B],re),e.SnippetString=re;var he;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(he=e.DiagnosticTag||(e.DiagnosticTag={}));var ve;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(ve=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let H=a=class{static isLocation(A){return A instanceof a?!0:A?X.isRange(A.range)&&b.URI.isUri(A.uri):!1}constructor(A,se){if(this.uri=A,se)if(X.isRange(se))this.range=X.of(se);else if(z.isPosition(se))this.range=new X(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};H=a=Re([B],H),e.Location=H;let Y=class{static is(A){return A?typeof A.message=="string"&&A.location&&X.isRange(A.location.range)&&b.URI.isUri(A.location.uri):!1}constructor(A,se){this.location=A,this.message=se}static isEqual(A,se){return A===se?!0:!A||!se?!1:A.message===se.message&&A.location.range.isEqual(se.location.range)&&A.location.uri.toString()===se.location.uri.toString()}};Y=Re([B],Y),e.DiagnosticRelatedInformation=Y;let te=class{constructor(A,se,ge=ve.Error){if(!X.isRange(A))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=A,this.message=se,this.severity=ge}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(A,se){return A===se?!0:!A||!se?!1:A.message===se.message&&A.severity===se.severity&&A.code===se.code&&A.severity===se.severity&&A.source===se.source&&A.range.isEqual(se.range)&&(0,v.equals)(A.tags,se.tags)&&(0,v.equals)(A.relatedInformation,se.relatedInformation,Y.isEqual)}};te=Re([B],te),e.Diagnostic=te;let W=class{constructor(A,se){if(!A)throw new Error("Illegal argument, contents must be defined");Array.isArray(A)?this.contents=A:this.contents=[A],this.range=se}};W=Re([B],W),e.Hover=W;var q;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(q=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let j=class{constructor(A,se=q.Text){this.range=A,this.kind=se}toJSON(){return{range:this.range,kind:q[this.kind]}}};j=Re([B],j),e.DocumentHighlight=j;var Q;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Q=e.SymbolKind||(e.SymbolKind={}));var le;(function(N){N[N.Deprecated=1]="Deprecated"})(le=e.SymbolTag||(e.SymbolTag={}));let pe=c=class{static validate(A){if(!A.name)throw new Error("name must not be falsy")}constructor(A,se,ge,Ue,He){this.name=A,this.kind=se,this.containerName=He,typeof ge=="string"&&(this.containerName=ge),Ue instanceof H?this.location=Ue:ge instanceof X&&(this.location=new H(Ue,ge)),c.validate(this)}toJSON(){return{name:this.name,kind:Q[this.kind],location:this.location,containerName:this.containerName}}};pe=c=Re([B],pe),e.SymbolInformation=pe;let ke=d=class{static validate(A){if(!A.name)throw new Error("name must not be falsy");if(!A.range.contains(A.selectionRange))throw new Error("selectionRange must be contained in fullRange");A.children?.forEach(d.validate)}constructor(A,se,ge,Ue,He){this.name=A,this.detail=se,this.kind=ge,this.range=Ue,this.selectionRange=He,this.children=[],d.validate(this)}};ke=d=Re([B],ke),e.DocumentSymbol=ke;var Te;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(Te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Ne=class{constructor(A,se){this.title=A,this.kind=se}};Ne=Re([B],Ne),e.CodeAction=Ne;let Le=P=class{constructor(A){this.value=A}append(A){return new P(this.value?this.value+P.sep+A:A)}intersects(A){return this.contains(A)||A.contains(this)}contains(A){return this.value===A.value||A.value.startsWith(this.value+P.sep)}};Le.sep=".",Le=P=Re([B],Le),e.CodeActionKind=Le,Le.Empty=new Le(""),Le.QuickFix=Le.Empty.append("quickfix"),Le.Refactor=Le.Empty.append("refactor"),Le.RefactorExtract=Le.Refactor.append("extract"),Le.RefactorInline=Le.Refactor.append("inline"),Le.RefactorMove=Le.Refactor.append("move"),Le.RefactorRewrite=Le.Refactor.append("rewrite"),Le.Source=Le.Empty.append("source"),Le.SourceOrganizeImports=Le.Source.append("organizeImports"),Le.SourceFixAll=Le.Source.append("fixAll");let me=class{constructor(A,se){if(this.range=A,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=Re([B],me),e.SelectionRange=me;class be{constructor(A,se,ge,Ue,He,Je){this.kind=A,this.name=se,this.detail=ge,this.uri=Ue,this.range=He,this.selectionRange=Je}}e.CallHierarchyItem=be;class Ee{constructor(A,se){this.fromRanges=se,this.from=A}}e.CallHierarchyIncomingCall=Ee;class Me{constructor(A,se){this.fromRanges=se,this.to=A}}e.CallHierarchyOutgoingCall=Me;var Be;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Be=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ve=class{constructor(A,se){this.range=A,this.command=se}get isResolved(){return!!this.command}};Ve=Re([B],Ve),e.CodeLens=Ve;let ze=F=class{static isMarkdownString(A){return A instanceof F?!0:A&&A.appendCodeblock&&A.appendMarkdown&&A.appendText&&A.value!==void 0}constructor(A,se=!1){E.set(this,void 0),Rt(this,E,new D.MarkdownString(A,{supportThemeIcons:se}),"f")}get value(){return nt(this,E,"f").value}set value(A){nt(this,E,"f").value=A}get isTrusted(){return nt(this,E,"f").isTrusted}set isTrusted(A){nt(this,E,"f").isTrusted=A}get supportThemeIcons(){return nt(this,E,"f").supportThemeIcons}set supportThemeIcons(A){nt(this,E,"f").supportThemeIcons=A}get supportHtml(){return nt(this,E,"f").supportHtml}set supportHtml(A){nt(this,E,"f").supportHtml=A}get baseUri(){return nt(this,E,"f").baseUri}set baseUri(A){nt(this,E,"f").baseUri=A}appendText(A){return nt(this,E,"f").appendText(A),this}appendMarkdown(A){return nt(this,E,"f").appendMarkdown(A),this}appendCodeblock(A,se){return nt(this,E,"f").appendCodeblock(se??"",A),this}};E=new WeakMap,ze=F=Re([B],ze),e.MarkdownString=ze;let Ye=class{constructor(A,se){this.label=A,this.documentation=se}};Ye=Re([B],Ye),e.ParameterInformation=Ye;let Ke=class{constructor(A,se){this.label=A,this.documentation=se,this.parameters=[]}};Ke=Re([B],Ke),e.SignatureInformation=Ke;let qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};qe=Re([B],qe),e.SignatureHelp=qe;var je;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(je=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var xe;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(xe=e.InlayHintKind||(e.InlayHintKind={}));let Ge=class{constructor(A){this.value=A}};Ge=Re([B],Ge),e.InlayHintLabelPart=Ge;let ce=class{constructor(A,se,ge){this.position=A,this.label=se,this.kind=ge}};ce=Re([B],ce),e.InlayHint=ce;var Ce;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ie;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ie=e.CompletionItemKind||(e.CompletionItemKind={}));var Ae;(function(N){N[N.Deprecated=1]="Deprecated"})(Ae=e.CompletionItemTag||(e.CompletionItemTag={}));let Fe=class{constructor(A,se){this.label=A,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Ie[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Fe=Re([B],Fe),e.CompletionItem=Fe;let $e=class{constructor(A=[],se=!1){this.items=A,this.isIncomplete=se}};$e=Re([B],$e),e.CompletionList=$e;let Qe=class{constructor(A,se,ge){this.insertText=A,this.range=se,this.command=ge}};Qe=Re([B],Qe),e.InlineSuggestion=Qe;let rt=class{constructor(A){this.commands=void 0,this.items=A}};rt=Re([B],rt),e.InlineSuggestionList=rt;let it=class{constructor(A,se,ge){this.insertText=A,this.range=se,this.command=ge}};it=Re([B],it),e.InlineSuggestionNew=it;let Ze=class{constructor(A,se){this.items=A,this.commands=se}};Ze=Re([B],Ze),e.InlineSuggestionsNew=Ze;var at;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(at=e.ViewColumn||(e.ViewColumn={}));var st;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(st=e.StatusBarAlignment||(e.StatusBarAlignment={}));var dt;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var At;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(At=e.TextEditorRevealType||(e.TextEditorRevealType={}));var St;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(St=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var _t;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(_t=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ot;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ot=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function A(se){switch(se){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=A}(St=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let vt=class{constructor(A,se){if(se&&!b.URI.isUri(se))throw(0,t.illegalArgument)("target");if(!X.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.target=se}};vt=Re([B],vt),e.DocumentLink=vt;let ht=class{constructor(A,se,ge,Ue){this.red=A,this.green=se,this.blue=ge,this.alpha=Ue}};ht=Re([B],ht),e.Color=ht;let ut=class{constructor(A,se){if(se&&!(se instanceof ht))throw(0,t.illegalArgument)("color");if(!X.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.color=se}};ut=Re([B],ut),e.ColorInformation=ut;let kt=class{constructor(A){if(!A||typeof A!="string")throw(0,t.illegalArgument)("label");this.label=A}};kt=Re([B],kt),e.ColorPresentation=kt;var Se;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var De;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(De=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var de;(function(N){N[N.Unknown=0]="Unknown",N[N.Shutdown=1]="Shutdown",N[N.Process=2]="Process",N[N.User=3]="User",N[N.Extension=4]="Extension"})(de=e.TerminalExitReason||(e.TerminalExitReason={}));class V{constructor(A,se,ge){if(this.startIndex=A,this.length=se,this.tooltip=ge,typeof A!="number"||A<0)throw(0,t.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,t.illegalArgument)("length");if(ge!==void 0&&typeof ge!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=V;var Pe;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Pe=e.TerminalLocation||(e.TerminalLocation={}));class Oe{constructor(A){if(this.options=A,typeof A!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Oe;var Xe;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Xe=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=$=class{static from(A){switch(A){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(A,se){if(this.label=se,typeof A!="string"||typeof se!="string")throw(0,t.illegalArgument)("name");this._id=A}get id(){return this._id}};tt.Clean=new $("clean","Clean"),tt.Build=new $("build","Build"),tt.Rebuild=new $("rebuild","Rebuild"),tt.Test=new $("test","Test"),tt=$=Re([B],tt),e.TaskGroup=tt;function lt(N){let A="";for(let se=0;se<N.length;se++)A+=N[se].replace(/,/g,",,")+",";return A}let bt=class{constructor(A,se,ge){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=A,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ge):this._options=se)}get process(){return this._process}set process(A){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._process=A}get args(){return this._args}set args(A){Array.isArray(A)||(A=[]),this._args=A}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("process"),this._process!==void 0&&A.push(this._process),this._args&&this._args.length>0)for(const se of this._args)A.push(se);return lt(A)}};bt=Re([B],bt),e.ProcessExecution=bt;let mt=class{constructor(A,se,ge){if(this._args=[],Array.isArray(se)){if(!A)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A,this._args=se,this._options=ge}else{if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A,this._options=se}}get commandLine(){return this._commandLine}set commandLine(A){if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A}get command(){return this._command?this._command:""}set command(A){if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A}get args(){return this._args}set args(A){this._args=A||[]}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("shell"),this._commandLine!==void 0&&A.push(this._commandLine),this._command!==void 0&&A.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)A.push(typeof se=="string"?se:se.value);return lt(A)}};mt=Re([B],mt),e.ShellExecution=mt;var gt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(gt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class Sn{constructor(A){this._callback=A}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(A){this._callback=A}get callback(){return this._callback}}e.CustomExecution=Sn;let Tt=Z=class{constructor(A,se,ge,Ue,He,Je){this.__deprecated=!1,this._definition=this.definition=A;let et;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ge,this.execution=Ue,et=He,this.__deprecated=!0):se===wt.Global||se===wt.Workspace?(this.target=se,this._name=this.name=ge,this._source=this.source=Ue,this.execution=He,et=Je):(this.target=se,this._name=this.name=ge,this._source=this.source=Ue,this.execution=He,et=Je),typeof et=="string"?(this._problemMatchers=[et],this._hasDefinedMatchers=!0):Array.isArray(et)?(this._problemMatchers=et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(A){this.__id=A}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof bt?this._definition={type:Z.ProcessType,id:this._execution.computeId()}:this._execution instanceof mt?this._definition={type:Z.ShellType,id:this._execution.computeId()}:this._execution instanceof Sn?this._definition={type:Z.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:Z.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(A){if(A==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=A}get scope(){return this._scope}set target(A){this.clear(),this._scope=A}get name(){return this._name}set name(A){if(typeof A!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=A}get execution(){return this._execution}set execution(A){A===null&&(A=void 0),this.clear(),this._execution=A;const se=this._definition.type;(Z.EmptyType===se||Z.ProcessType===se||Z.ShellType===se||Z.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(A){if(Array.isArray(A))this.clear(),this._problemMatchers=A,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(A){A!==!0&&A!==!1&&(A=!1),this.clear(),this._isBackground=A}get source(){return this._source}set source(A){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=A}get group(){return this._group}set group(A){A===null&&(A=void 0),this.clear(),this._group=A}get detail(){return this._detail}set detail(A){A===null&&(A=void 0),this._detail=A}get presentationOptions(){return this._presentationOptions}set presentationOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._presentationOptions=A}get runOptions(){return this._runOptions}set runOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._runOptions=A}};Tt.ExtensionCallbackType="customExecution",Tt.ProcessType="process",Tt.ShellType="shell",Tt.EmptyType="$empty",Tt=Z=Re([B],Tt),e.Task=Tt;var Cn;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Cn=e.ProgressLocation||(e.ProgressLocation={}));var In;(function(N){function A(se){const ge=se;return(0,p.isNumber)(ge.value)?ge.tooltip&&!(0,p.isString)(ge.tooltip)?(console.log("INVALID view badge, invalid tooltip",ge.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ge.value),!1)}N.isViewBadge=A})(In=e.ViewBadge||(e.ViewBadge={}));let zt=J=class{static isTreeItem(A,se){if(A instanceof J)return!0;const ge=A;if(ge.label!==void 0&&!(0,p.isString)(ge.label)&&!ge.label?.label)return console.log("INVALID tree item, invalid label",ge.label),!1;if(ge.id!==void 0&&!(0,p.isString)(ge.id))return console.log("INVALID tree item, invalid id",ge.id),!1;if(ge.iconPath!==void 0&&!(0,p.isString)(ge.iconPath)&&!b.URI.isUri(ge.iconPath)&&(!ge.iconPath||!(0,p.isString)(ge.iconPath.id))){const Ue=ge.iconPath;if(!Ue||!(0,p.isString)(Ue.light)&&!b.URI.isUri(Ue.light)&&!(0,p.isString)(Ue.dark)&&!b.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",ge.iconPath),!1}if(ge.description!==void 0&&!(0,p.isString)(ge.description)&&typeof ge.description!="boolean")return console.log("INVALID tree item, invalid description",ge.description),!1;if(ge.resourceUri!==void 0&&!b.URI.isUri(ge.resourceUri))return console.log("INVALID tree item, invalid resourceUri",ge.resourceUri),!1;if(ge.tooltip!==void 0&&!(0,p.isString)(ge.tooltip)&&!(ge.tooltip instanceof ze))return console.log("INVALID tree item, invalid tooltip",ge.tooltip),!1;if(ge.command!==void 0&&!ge.command.command)return console.log("INVALID tree item, invalid command",ge.command),!1;if(ge.collapsibleState!==void 0&&ge.collapsibleState<Mt.None&&ge.collapsibleState>Mt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",ge.collapsibleState),!1;if(ge.contextValue!==void 0&&!(0,p.isString)(ge.contextValue))return console.log("INVALID tree item, invalid contextValue",ge.contextValue),!1;if(ge.accessibilityInformation!==void 0&&!ge.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",ge.accessibilityInformation),!1;if(ge.checkboxState!==void 0){(0,h.checkProposedApiEnabled)(se,"treeItemCheckbox");const Ue=(0,p.isNumber)(ge.checkboxState)?ge.checkboxState:(0,p.isObject)(ge.checkboxState)&&(0,p.isNumber)(ge.checkboxState.state)?ge.checkboxState.state:void 0,He=!(0,p.isNumber)(ge.checkboxState)&&(0,p.isObject)(ge.checkboxState)?ge.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==Ht.Checked&&Ue!==Ht.Unchecked||He!==void 0&&!(0,p.isString)(He))return console.log("INVALID tree item, invalid checkboxState",ge.checkboxState),!1}return!0}constructor(A,se=Mt.None){this.collapsibleState=se,b.URI.isUri(A)?this.resourceUri=A:this.label=A}};zt=J=Re([B],zt),e.TreeItem=zt;var Mt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Ht;(function(N){N[N.Unchecked=0]="Unchecked",N[N.Checked=1]="Checked"})(Ht=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(A,se){this.value=A,this.id=se??(0,R.generateUuid)()}};jt=Re([B],jt),e.DataTransferItem=jt;let Vt=class{constructor(A){g.set(this,new Map);for(const[se,ge]of A??[]){const Ue=nt(this,g,"f").get(se);Ue?Ue.push(ge):nt(this,g,"f").set(se,[ge])}}get(A){return nt(this,g,"f").get(A)?.[0]}set(A,se){nt(this,g,"f").set(A,[se])}forEach(A,se){for(const[ge,Ue]of nt(this,g,"f"))for(const He of Ue)A.call(se,He,ge,this)}*[(g=new WeakMap,Symbol.iterator)](){for(const[A,se]of nt(this,g,"f"))for(const ge of se)yield[A,ge]}};Vt=Re([B],Vt),e.DataTransfer=Vt;let qt=class{constructor(A){this.insertText=A}};qt=Re([B],qt),e.DocumentDropEdit=qt;let xt=class{constructor(A){this.insertText=A}};xt=Re([B],xt),e.DocumentPasteEdit=xt;let Dt=class{constructor(A,se){this.id=A,this.color=se}};Dt=Re([B],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let Gt=class{constructor(A){this.id=A}};Gt=Re([B],Gt),e.ThemeColor=Gt;var Dn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Dn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{get base(){return this._base}set base(A){this._base=A,this._baseUri=b.URI.file(A)}get baseUri(){return this._baseUri}set baseUri(A){this._baseUri=A,this._base=A.fsPath}constructor(A,se){if(typeof A!="string"&&(!A||!b.URI.isUri(A)&&!b.URI.isUri(A.uri)))throw(0,t.illegalArgument)("base");if(typeof se!="string")throw(0,t.illegalArgument)("pattern");typeof A=="string"?this.baseUri=b.URI.file(A):b.URI.isUri(A)?this.baseUri=A:this.baseUri=A.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Kt=Re([B],Kt),e.RelativePattern=Kt;let Lt=class{constructor(A,se,ge,Ue){this.enabled=typeof A=="boolean"?A:!0,typeof se=="string"&&(this.condition=se),typeof ge=="string"&&(this.hitCondition=ge),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Lt=Re([B],Lt),e.Breakpoint=Lt;let Qt=class extends Lt{constructor(A,se,ge,Ue,He){if(super(se,ge,Ue,He),A===null)throw(0,t.illegalArgument)("location");this.location=A}};Qt=Re([B],Qt),e.SourceBreakpoint=Qt;let Yt=class extends Lt{constructor(A,se,ge,Ue,He){super(se,ge,Ue,He),this.functionName=A}};Yt=Re([B],Yt),e.FunctionBreakpoint=Yt;let Xt=class extends Lt{constructor(A,se,ge,Ue,He,Je,et){if(super(Ue,He,Je,et),!se)throw(0,t.illegalArgument)("dataId");this.label=A,this.dataId=se,this.canPersist=ge}};Xt=Re([B],Xt),e.DataBreakpoint=Xt;let Jt=class{constructor(A,se,ge){this.command=A,this.args=se||[],this.options=ge}};Jt=Re([B],Jt),e.DebugAdapterExecutable=Jt;let Zt=class{constructor(A,se){this.port=A,this.host=se}};Zt=Re([B],Zt),e.DebugAdapterServer=Zt;let en=class{constructor(A){this.path=A}};en=Re([B],en),e.DebugAdapterNamedPipeServer=en;let tn=class{constructor(A){this.implementation=A}};tn=Re([B],tn),e.DebugAdapterInlineImplementation=tn;let nn=class{constructor(A,se){this.range=A,this.expression=se}};nn=Re([B],nn),e.EvaluatableExpression=nn;var Pn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(Pn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var kn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let rn=class{constructor(A,se){this.range=A,this.text=se}};rn=Re([B],rn),e.InlineValueText=rn;let sn=class{constructor(A,se,ge=!0){this.range=A,this.variableName=se,this.caseSensitiveLookup=ge}};sn=Re([B],sn),e.InlineValueVariableLookup=sn;let on=class{constructor(A,se){this.range=A,this.expression=se}};on=Re([B],on),e.InlineValueEvaluatableExpression=on;let an=class{constructor(A,se){this.frameId=A,this.stoppedLocation=se}};an=Re([B],an),e.InlineValueContext=an;var Tn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Tn=e.FileChangeType||(e.FileChangeType={}));let ln=_=class extends Error{static FileExists(A){return new _(A,k.FileSystemProviderErrorCode.FileExists,_.FileExists)}static FileNotFound(A){return new _(A,k.FileSystemProviderErrorCode.FileNotFound,_.FileNotFound)}static FileNotADirectory(A){return new _(A,k.FileSystemProviderErrorCode.FileNotADirectory,_.FileNotADirectory)}static FileIsADirectory(A){return new _(A,k.FileSystemProviderErrorCode.FileIsADirectory,_.FileIsADirectory)}static NoPermissions(A){return new _(A,k.FileSystemProviderErrorCode.NoPermissions,_.NoPermissions)}static Unavailable(A){return new _(A,k.FileSystemProviderErrorCode.Unavailable,_.Unavailable)}constructor(A,se=k.FileSystemProviderErrorCode.Unknown,ge){super(b.URI.isUri(A)?A.toString(!0):A),this.code=ge?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype),typeof Error.captureStackTrace=="function"&&typeof ge=="function"&&Error.captureStackTrace(this,ge)}};ln=_=Re([B],ln),e.FileSystemError=ln;let cn=class{constructor(A,se,ge){this.start=A,this.end=se,this.kind=ge}};cn=Re([B],cn),e.FoldingRange=cn;var Rn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Rn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var An;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(An=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));var Ln;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(Ln=e.CommentThreadState||(e.CommentThreadState={}));class On{constructor(A,se=[]){this.tokenTypes=A,this.tokenModifiers=se}}e.SemanticTokensLegend=On;function Fn(N){return typeof N>"u"||(0,p.isStringArray)(N)}class un{constructor(A){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,A){this._hasLegend=!0;for(let se=0,ge=A.tokenTypes.length;se<ge;se++)this._tokenTypeStrToInt.set(A.tokenTypes[se],se);for(let se=0,ge=A.tokenModifiers.length;se<ge;se++)this._tokenModifierStrToInt.set(A.tokenModifiers[se],se)}}push(A,se,ge,Ue,He){if(typeof A=="number"&&typeof se=="number"&&typeof ge=="number"&&typeof Ue=="number"&&(typeof He=="number"||typeof He>"u"))return typeof He>"u"&&(He=0),this._pushEncoded(A,se,ge,Ue,He);if(X.isRange(A)&&typeof se=="string"&&Fn(ge))return this._push(A,se,ge);throw(0,t.illegalArgument)()}_push(A,se,ge){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(A.start.line!==A.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ue=A.start.line,He=A.start.character,Je=A.end.character-A.start.character,et=this._tokenTypeStrToInt.get(se);let ct=0;if(ge)for(const pt of ge){if(!this._tokenModifierStrToInt.has(pt))throw new Error("`tokenModifier` is not in the provided legend");const Et=this._tokenModifierStrToInt.get(pt);ct|=1<<Et>>>0}this._pushEncoded(Ue,He,Je,et,ct)}_pushEncoded(A,se,ge,Ue,He){if(this._dataIsSortedAndDeltaEncoded&&(A<this._prevLine||A===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ct=this._data.length/5|0;let pt=0,Et=0;for(let Ct=0;Ct<ct;Ct++){let It=this._data[5*Ct],Ft=this._data[5*Ct+1];It===0?(It=pt,Ft+=Et):It+=pt,this._data[5*Ct]=It,this._data[5*Ct+1]=Ft,pt=It,Et=Ft}}let Je=A,et=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Je-=this._prevLine,Je===0&&(et-=this._prevChar)),this._data[this._dataLen++]=Je,this._data[this._dataLen++]=et,this._data[this._dataLen++]=ge,this._data[this._dataLen++]=Ue,this._data[this._dataLen++]=He,this._prevLine=A,this._prevChar=se}static _sortAndDeltaEncode(A){const se=[],ge=A.length/5|0;for(let et=0;et<ge;et++)se[et]=et;se.sort((et,ct)=>{const pt=A[5*et],Et=A[5*ct];if(pt===Et){const Ct=A[5*et+1],It=A[5*ct+1];return Ct-It}return pt-Et});const Ue=new Uint32Array(A.length);let He=0,Je=0;for(let et=0;et<ge;et++){const ct=5*se[et],pt=A[ct+0],Et=A[ct+1],Ct=A[ct+2],It=A[ct+3],Ft=A[ct+4],bn=pt-He,wi=bn===0?Et-Je:Et,Nt=5*et;Ue[Nt+0]=bn,Ue[Nt+1]=wi,Ue[Nt+2]=Ct,Ue[Nt+3]=It,Ue[Nt+4]=Ft,He=pt,Je=Et}return Ue}build(A){return this._dataIsSortedAndDeltaEncoded?new fn(new Uint32Array(this._data),A):new fn(un._sortAndDeltaEncode(this._data),A)}}e.SemanticTokensBuilder=un;class fn{constructor(A,se){this.resultId=se,this.data=A}}e.SemanticTokens=fn;class Nn{constructor(A,se,ge){this.start=A,this.deleteCount=se,this.data=ge}}e.SemanticTokensEdit=Nn;class Mn{constructor(A,se){this.resultId=se,this.edits=A}}e.SemanticTokensEdits=Mn;var Un;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Un=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new Dt("arrow-left")},Ut=Re([B],Ut),e.QuickInputButtons=Ut;var Bn;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Bn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Wn;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(Wn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var $n;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})($n=e.ExtensionKind||(e.ExtensionKind={}));class zn{static validate(A){if(A.badge){let se=(0,I.nextCharLength)(A.badge,0);if(se<A.badge.length&&(se+=(0,I.nextCharLength)(A.badge,se)),A.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}if(!A.color&&!A.badge&&!A.tooltip)throw new Error("The decoration is empty");return!0}constructor(A,se,ge){this.badge=A,this.tooltip=se,this.color=ge}}e.FileDecoration=zn;let hn=class{constructor(A){this.kind=A}};hn=Re([B],hn),e.ColorTheme=hn;var Hn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(Hn=e.ColorThemeKind||(e.ColorThemeKind={}));class Pt{static isNotebookRange(A){return A instanceof Pt?!0:A?typeof A.start=="number"&&typeof A.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(A,se){if(A<0)throw(0,t.illegalArgument)("start must be positive");if(se<0)throw(0,t.illegalArgument)("end must be positive");A<=se?(this._start=A,this._end=se):(this._start=se,this._end=A)}with(A){let se=this._start,ge=this._end;return A.start!==void 0&&(se=A.start),A.end!==void 0&&(ge=A.end),se===this._start&&ge===this._end?this:new Pt(se,ge)}}e.NotebookRange=Pt;class Bt{static validate(A){if(typeof A.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof A.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof A.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(A){return Array.isArray(A)&&A.every(se=>Bt.isNotebookCellData(se))}static isNotebookCellData(A){return!0}constructor(A,se,ge,Ue,He,Je,et){this.kind=A,this.value=se,this.languageId=ge,this.mime=Ue,this.outputs=He??[],this.metadata=Je,this.executionSummary=et,Bt.validate(this)}}e.NotebookCellData=Bt;class jn{constructor(A){this.cells=A}}e.NotebookData=jn;class yt{static isNotebookCellOutputItem(A){return A instanceof yt?!0:A?typeof A.mime=="string"&&A.data instanceof Uint8Array:!1}static error(A){const se={name:A.name,message:A.message,stack:A.stack};return yt.json(se,"application/vnd.code.notebook.error")}static stdout(A){return yt.text(A,"application/vnd.code.notebook.stdout")}static stderr(A){return yt.text(A,"application/vnd.code.notebook.stderr")}static bytes(A,se="application/octet-stream"){return new yt(A,se)}static text(A,se=T.Mimes.text){const ge=nt(yt,m,"f",u).encode(String(A));return new yt(ge,se)}static json(A,se="text/x-json"){const ge=JSON.stringify(A,void 0,"	");return yt.text(ge,se)}constructor(A,se){this.data=A,this.mime=se;const ge=(0,T.normalizeMimeType)(se,!0);if(!ge)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ge}}e.NotebookCellOutputItem=yt,m=yt,u={value:new TextEncoder};class Wt{static isNotebookCellOutput(A){return A instanceof Wt?!0:!A||typeof A!="object"?!1:typeof A.id=="string"&&Array.isArray(A.items)}static ensureUniqueMimeTypes(A,se=!1){const ge=new Set,Ue=new Set;for(let He=0;He<A.length;He++){const Je=A[He],et=(0,T.normalizeMimeType)(Je.mime);if(!ge.has(et)||(0,y.isTextStreamMime)(et)){ge.add(et);continue}Ue.add(He),se&&console.warn(`DUPLICATED mime type '${Je.mime}' will be dropped`)}return Ue.size===0?A:A.filter((He,Je)=>!Ue.has(Je))}constructor(A,se,ge){this.items=Wt.ensureUniqueMimeTypes(A,!0),typeof se=="string"?(this.id=se,this.metadata=ge):(this.id=(0,R.generateUuid)(),this.metadata=se??ge)}}e.NotebookCellOutput=Wt;var Vn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Vn=e.NotebookCellKind||(e.NotebookCellKind={}));var qn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(qn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(xn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Gn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Kn{constructor(A,se){this.text=A,this.alignment=se}}e.NotebookCellStatusBarItem=Kn;var Qn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Qn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Yn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred",N[N.Hidden=-1]="Hidden"})(Yn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Xn{constructor(A,se=[]){this.uri=A,this.provides=(0,v.asArray)(se)}}e.NotebookRendererScript=Xn;let dn=class{constructor(A,se){this.label=A,this.timestamp=se}};dn=Re([B],dn),e.TimelineItem=dn;var Jn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Jn=e.ExtensionMode||(e.ExtensionMode={}));var Zn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Zn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ei;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(ei=e.StandardTokenType||(e.StandardTokenType={}));class ti{constructor(A,se){this.ranges=A,this.wordPattern=se}}e.LinkedEditingRanges=ti;class ni{constructor(A,se){this._port=A,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ni;var ii;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(ii=e.TestResultState||(e.TestResultState={}));var ri;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(ri=e.TestRunProfileKind||(e.TestRunProfileKind={}));let mn=class{constructor(A=void 0,se=void 0,ge=void 0){this.include=A,this.exclude=se,this.profile=ge}};mn=Re([B],mn),e.TestRunRequest=mn;let gn=ee=class{static diff(A,se,ge){const Ue=new ee(A);return Ue.expectedOutput=se,Ue.actualOutput=ge,Ue}constructor(A){this.message=A}};gn=ee=Re([B],gn),e.TestMessage=gn;let pn=class{constructor(A){this.id=A}};pn=Re([B],pn),e.TestTag=pn;let Ot=class{constructor(A,se){this.covered=A,this.total=se}};Ot=Re([B],Ot),e.CoveredCount=Ot;let vn=ne=class{static fromDetails(A,se){const ge=new Ot(0,0),Ue=new Ot(0,0),He=new Ot(0,0);for(const et of se)if("branches"in et){ge.total+=1,ge.covered+=et.executionCount>0?1:0;for(const ct of et.branches)Ue.total+=1,Ue.covered+=ct.executionCount>0?1:0}else He.total+=1,He.covered+=et.executionCount>0?1:0;const Je=new ne(A,ge,Ue.total>0?Ue:void 0,He.total>0?He:void 0);return Je.detailedCoverage=se,Je}constructor(A,se,ge,Ue){this.uri=A,this.statementCoverage=se,this.branchCoverage=ge,this.functionCoverage=Ue}};vn=ne=Re([B],vn),e.FileCoverage=vn;let wn=class{constructor(A,se,ge=[]){this.executionCount=A,this.location=se,this.branches=ge}};wn=Re([B],wn),e.StatementCoverage=wn;let yn=class{constructor(A,se){this.executionCount=A,this.location=se}};yn=Re([B],yn),e.BranchCoverage=yn;let En=class{constructor(A,se){this.executionCount=A,this.location=se}};En=Re([B],En),e.FunctionCoverage=En;var si;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(si=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var oi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(oi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ai;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(ai=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class li{constructor(A,se,ge,Ue,He,Je){this.kind=A,this.name=se,this.detail=ge,this.uri=Ue,this.range=He,this.selectionRange=Je}}e.TypeHierarchyItem=li;class ci{constructor(A){this.uri=A}}e.TextTabInput=ci;class ui{constructor(A,se){this.original=A,this.modified=se}}e.TextDiffTabInput=ui;class fi{constructor(A,se,ge,Ue){this.base=A,this.input1=se,this.input2=ge,this.result=Ue}}e.TextMergeTabInput=fi;class hi{constructor(A,se){this.uri=A,this.viewType=se}}e.CustomEditorTabInput=hi;class di{constructor(A){this.viewType=A}}e.WebviewEditorTabInput=di;class mi{constructor(A,se){this.uri=A,this.notebookType=se}}e.NotebookEditorTabInput=mi;class gi{constructor(A,se,ge){this.original=A,this.modified=se,this.notebookType=ge}}e.NotebookDiffEditorTabInput=gi;class pi{constructor(){}}e.TerminalEditorTabInput=pi;class vi{constructor(A,se){this.uri=A,this.inputBoxUri=se}}e.InteractiveWindowInput=vi}),define(we[127],ye([1,0,18,16,88,24,136,46,22,11,4,49,151,208,122,80,118,81,82,124,126,64]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Se){function De(V){const{selectionStartLineNumber:Pe,selectionStartColumn:Oe,positionLineNumber:Xe,positionColumn:We}=V,tt=new l.Position(Pe-1,Oe-1),lt=new l.Position(Xe-1,We-1);return new l.Selection(tt,lt)}Se.to=De;function de(V){const{anchor:Pe,active:Oe}=V;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}Se.from=de})(r=e.Selection||(e.Selection={}));var o;(function(Se){function De(V){if(!V)return;const{start:Pe,end:Oe}=V;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}Se.from=De;function de(V){if(!V)return;const{startLineNumber:Pe,startColumn:Oe,endLineNumber:Xe,endColumn:We}=V;return new l.Range(Pe-1,Oe-1,Xe-1,We-1)}Se.to=de})(o=e.Range||(e.Range={}));var n;(function(Se){function De(de){switch(de){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Se.to=De})(n=e.TokenType||(e.TokenType={}));var i;(function(Se){function De(V){return new l.Position(V.lineNumber-1,V.column-1)}Se.to=De;function de(V){return{lineNumber:V.line+1,column:V.character+1}}Se.from=de})(i=e.Position||(e.Position={}));var s;(function(Se){function De(Pe,Oe){return(0,v.coalesce)((0,v.asArray)(Pe).map(Xe=>de(Xe,Oe)))}Se.from=De;function de(Pe,Oe){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:V(Pe.scheme,Oe),pattern:xe.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function V(Pe,Oe){return Oe&&typeof Pe=="string"?Oe.transformOutgoingScheme(Pe):Pe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function De(V){switch(V){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Se.from=De;function de(V){switch(V){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Se.to=de})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Se){function De(V){let Pe;return V.code&&((0,b.isString)(V.code)||(0,b.isNumber)(V.code)?Pe=String(V.code):Pe={value:String(V.code.value),target:V.code.target}),{...o.from(V.range),message:V.message,source:V.source,code:Pe,severity:P.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(d.from),tags:Array.isArray(V.tags)?(0,v.coalesce)(V.tags.map(a.from)):void 0}}Se.from=De;function de(V){const Pe=new l.Diagnostic(o.to(V),V.message,P.to(V.severity));return Pe.source=V.source,Pe.code=(0,b.isString)(V.code)?V.code:V.code?.value,Pe.relatedInformation=V.relatedInformation&&V.relatedInformation.map(d.to),Pe.tags=V.tags&&(0,v.coalesce)(V.tags.map(a.to)),Pe}Se.to=de})(c=e.Diagnostic||(e.Diagnostic={}));var d;(function(Se){function De(V){return{...o.from(V.location.range),message:V.message,resource:V.location.uri}}Se.from=De;function de(V){return new l.DiagnosticRelatedInformation(new l.Location(V.resource,o.to(V)),V.message)}Se.to=de})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var P;(function(Se){function De(V){switch(V){case l.DiagnosticSeverity.Error:return y.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return y.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return y.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return y.MarkerSeverity.Hint}return y.MarkerSeverity.Error}Se.from=De;function de(V){switch(V){case y.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case y.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case y.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case y.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Se.to=de})(P=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var F;(function(Se){function De(V){return typeof V=="number"&&V>=l.ViewColumn.One?V-1:V===l.ViewColumn.Beside?u.SIDE_GROUP:u.ACTIVE_GROUP}Se.from=De;function de(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(F=e.ViewColumn||(e.ViewColumn={}));function $(Se){return typeof Se.range<"u"}function Z(Se){return Se.length===0?!0:!!$(Se[0])}e.isDecorationOptionsArr=Z;var J;(function(Se){function De(We){return We.map(Se.from)}Se.fromMany=De;function de(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function V(We){let tt;if(de(We)){const{language:gt,value:wt}=We;tt={value:"```"+gt+`
`+wt+"\n```\n"}}else l.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?tt={value:We}:tt={value:""};const lt=Object.create(null);tt.uris=lt;const bt=gt=>{try{let wt=R.URI.parse(gt,!0);wt=wt.with({query:Pe(wt.query,lt)}),lt[gt]=wt}catch{}return""},mt=new T.marked.Renderer;return mt.link=bt,mt.image=gt=>typeof gt=="string"?bt(D.parseHrefAndDimensions(gt).href):"",(0,T.marked)(tt.value,{renderer:mt}),tt}Se.from=V;function Pe(We,tt){if(!We)return We;let lt;try{lt=(0,I.parse)(We)}catch{}if(!lt)return We;let bt=!1;return lt=(0,p.cloneAndChange)(lt,mt=>{if(R.URI.isUri(mt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[gt]=mt,bt=!0,gt}else return}),bt?JSON.stringify(lt):We}function Oe(We){const tt=new l.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt.baseUri=We.baseUri?R.URI.from(We.baseUri):void 0,tt}Se.to=Oe;function Xe(We){if(!!We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=Xe})(J=e.MarkdownString||(e.MarkdownString={}));function _(Se){return Z(Se)?Se.map(De=>({range:o.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?J.fromMany(De.hoverMessage):De.hoverMessage?J.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):Se.map(De=>({range:o.from(De)}))}e.fromRangeOrRangeWithMessage=_;function ee(Se){return typeof Se>"u"?Se:typeof Se=="string"?R.URI.file(Se):Se}e.pathOrURIToURI=ee;var ne;(function(Se){function De(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?ee(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=De})(ne=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Se){function De(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ee(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?ne.from(de.before):void 0,after:de.after?ne.from(de.after):void 0}}Se.from=De})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var ue;(function(Se){function De(de){if(typeof de>"u")return de;switch(de){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=De})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(Se){function De(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?ue.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?B.from(de.light):void 0,dark:de.dark?B.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ee(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?ne.from(de.before):void 0,after:de.after?ne.from(de.after):void 0}}Se.from=De})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var X;(function(Se){function De(V){return{text:V.newText,eol:V.newEol&&ze.from(V.newEol),range:o.from(V.range)}}Se.from=De;function de(V){const Pe=new l.TextEdit(o.to(V.range),V.text);return Pe.newEol=typeof V.eol>"u"?void 0:ze.to(V.eol),Pe}Se.to=de})(X=e.TextEdit||(e.TextEdit={}));var O;(function(Se){function De(V,Pe){const Oe={edits:[]};if(V instanceof l.WorkspaceEdit){const Xe=new C.ResourceSet;for(const We of V._allEntries())We._type===1&&R.URI.isUri(We.to)&&We.from===void 0&&Xe.add(We.to);for(const We of V._allEntries())We._type===1?Oe.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Oe.edits.push({resource:We.uri,textEdit:X.from(We.edit),versionId:Xe.has(We.uri)?void 0:Pe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Oe.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Xe.has(We.uri)?void 0:Pe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Oe.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Oe.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map($e.from)}})}return Oe}Se.from=De;function de(V){const Pe=new l.WorkspaceEdit;for(const Oe of V.edits)Oe.textEdit?Pe.replace(R.URI.revive(Oe.resource),o.to(Oe.textEdit.range),Oe.textEdit.text):Pe.renameFile(R.URI.revive(Oe.oldResource),R.URI.revive(Oe.newResource),Oe.options);return Pe}Se.to=de})(O=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(Se){const De=Object.create(null);De[l.SymbolKind.File]=0,De[l.SymbolKind.Module]=1,De[l.SymbolKind.Namespace]=2,De[l.SymbolKind.Package]=3,De[l.SymbolKind.Class]=4,De[l.SymbolKind.Method]=5,De[l.SymbolKind.Property]=6,De[l.SymbolKind.Field]=7,De[l.SymbolKind.Constructor]=8,De[l.SymbolKind.Enum]=9,De[l.SymbolKind.Interface]=10,De[l.SymbolKind.Function]=11,De[l.SymbolKind.Variable]=12,De[l.SymbolKind.Constant]=13,De[l.SymbolKind.String]=14,De[l.SymbolKind.Number]=15,De[l.SymbolKind.Boolean]=16,De[l.SymbolKind.Array]=17,De[l.SymbolKind.Object]=18,De[l.SymbolKind.Key]=19,De[l.SymbolKind.Null]=20,De[l.SymbolKind.EnumMember]=21,De[l.SymbolKind.Struct]=22,De[l.SymbolKind.Event]=23,De[l.SymbolKind.Operator]=24,De[l.SymbolKind.TypeParameter]=25;function de(Pe){return typeof De[Pe]=="number"?De[Pe]:6}Se.from=de;function V(Pe){for(const Oe in De)if(De[Oe]===Pe)return Number(Oe);return l.SymbolKind.Property}Se.to=V})(U=e.SymbolKind||(e.SymbolKind={}));var x;(function(Se){function De(V){switch(V){case l.SymbolTag.Deprecated:return 1}}Se.from=De;function de(V){switch(V){case 1:return l.SymbolTag.Deprecated}}Se.to=de})(x=e.SymbolTag||(e.SymbolTag={}));var ae;(function(Se){function De(V){return{name:V.name,kind:U.from(V.kind),tags:V.tags&&V.tags.map(x.from),containerName:V.containerName,location:M.from(V.location)}}Se.from=De;function de(V){const Pe=new l.SymbolInformation(V.name,U.to(V.kind),V.containerName,M.to(V.location));return Pe.tags=V.tags&&V.tags.map(x.to),Pe}Se.to=de})(ae=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(Se){function De(V){const Pe={name:V.name||"!!MISSING: name!!",detail:V.detail,range:o.from(V.range),selectionRange:o.from(V.selectionRange),kind:U.from(V.kind),tags:V.tags?.map(x.from)??[]};return V.children&&(Pe.children=V.children.map(De)),Pe}Se.from=De;function de(V){const Pe=new l.DocumentSymbol(V.name,V.detail,U.to(V.kind),o.to(V.range),o.to(V.selectionRange));return(0,v.isNonEmptyArray)(V.tags)&&(Pe.tags=V.tags.map(x.to)),V.children&&(Pe.children=V.children.map(de)),Pe}Se.to=de})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var K;(function(Se){function De(V){const Pe=new l.CallHierarchyItem(U.to(V.kind),V.name,V.detail||"",R.URI.revive(V.uri),o.to(V.range),o.to(V.selectionRange));return Pe._sessionId=V._sessionId,Pe._itemId=V._itemId,Pe}Se.to=De;function de(V,Pe,Oe){if(Pe=Pe??V._sessionId,Oe=Oe??V._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,name:V.name,detail:V.detail,kind:U.from(V.kind),uri:V.uri,range:o.from(V.range),selectionRange:o.from(V.selectionRange),tags:V.tags?.map(x.from)}}Se.from=de})(K=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ie;(function(Se){function De(de){return new l.CallHierarchyIncomingCall(K.to(de.from),de.fromRanges.map(V=>o.to(V)))}Se.to=De})(ie=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(Se){function De(de){return new l.CallHierarchyOutgoingCall(K.to(de.to),de.fromRanges.map(V=>o.to(V)))}Se.to=De})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(Se){function De(V){return{range:V.range&&o.from(V.range),uri:V.uri}}Se.from=De;function de(V){return new l.Location(R.URI.revive(V.uri),o.to(V.range))}Se.to=de})(M=e.location||(e.location={}));var G;(function(Se){function De(V){const Pe=V,Oe=V;return{originSelectionRange:Pe.originSelectionRange?o.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Oe.uri,range:o.from(Pe.targetRange?Pe.targetRange:Oe.range),targetSelectionRange:Pe.targetSelectionRange?o.from(Pe.targetSelectionRange):void 0}}Se.from=De;function de(V){return{targetUri:R.URI.revive(V.uri),targetRange:o.to(V.range),targetSelectionRange:V.targetSelectionRange?o.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?o.to(V.originSelectionRange):void 0}}Se.to=de})(G=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(Se){function De(V){return{range:o.from(V.range),contents:J.fromMany(V.contents)}}Se.from=De;function de(V){return new l.Hover(V.contents.map(J.to),o.to(V.range))}Se.to=de})(re=e.Hover||(e.Hover={}));var he;(function(Se){function De(V){return{range:o.from(V.range),expression:V.expression}}Se.from=De;function de(V){return new l.EvaluatableExpression(o.to(V.range),V.expression)}Se.to=de})(he=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(Se){function De(V){if(V instanceof l.InlineValueText)return{type:"text",range:o.from(V.range),text:V.text};if(V instanceof l.InlineValueVariableLookup)return{type:"variable",range:o.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=De;function de(V){switch(V.type){case"text":return{range:o.to(V.range),text:V.text};case"variable":return{range:o.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:o.to(V.range),expression:V.expression}}}Se.to=de})(ve=e.InlineValue||(e.InlineValue={}));var H;(function(Se){function De(V){return{frameId:V.frameId,stoppedLocation:o.from(V.stoppedLocation)}}Se.from=De;function de(V){return new l.InlineValueContext(V.frameId,o.to(V.stoppedLocation))}Se.to=de})(H=e.InlineValueContext||(e.InlineValueContext={}));var Y;(function(Se){function De(V){return{range:o.from(V.range),kind:V.kind}}Se.from=De;function de(V){return new l.DocumentHighlight(o.to(V.range),V.kind)}Se.to=de})(Y=e.DocumentHighlight||(e.DocumentHighlight={}));var te;(function(Se){function De(de){switch(de){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Se.to=De})(te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var W;(function(Se){function De(de){return{triggerKind:te.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=De})(W=e.CompletionContext||(e.CompletionContext={}));var q;(function(Se){function De(V){switch(V){case l.CompletionItemTag.Deprecated:return 1}}Se.from=De;function de(V){switch(V){case 1:return l.CompletionItemTag.Deprecated}}Se.to=de})(q=e.CompletionItemTag||(e.CompletionItemTag={}));var j;(function(Se){const De=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function de(Oe){return De.get(Oe)??9}Se.from=de;const V=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Pe(Oe){return V.get(Oe)??l.CompletionItemKind.Property}Se.to=Pe})(j=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Se){function De(de,V){const Pe=new l.CompletionItem(de.label);return Pe.insertText=de.insertText,Pe.kind=j.to(de.kind),Pe.tags=de.tags?.map(q.to),Pe.detail=de.detail,Pe.documentation=D.isMarkdownString(de.documentation)?J.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,k.Range.isIRange(de.range)?Pe.range=o.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:o.to(de.range.insert),replacing:o.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new l.SnippetString(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof l.Range?new l.TextEdit(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Oe=>X.to(Oe))),Pe.command=V&&de.command?V.fromInternal(de.command):void 0,Pe}Se.to=De})(Q=e.CompletionItem||(e.CompletionItem={}));var le;(function(Se){function De(V){if(typeof V.label!="string"&&!Array.isArray(V.label))throw new TypeError("Invalid label");return{label:V.label,documentation:J.fromStrict(V.documentation)}}Se.from=De;function de(V){return{label:V.label,documentation:D.isMarkdownString(V.documentation)?J.to(V.documentation):V.documentation}}Se.to=de})(le=e.ParameterInformation||(e.ParameterInformation={}));var pe;(function(Se){function De(V){return{label:V.label,documentation:J.fromStrict(V.documentation),parameters:Array.isArray(V.parameters)?V.parameters.map(le.from):[],activeParameter:V.activeParameter}}Se.from=De;function de(V){return{label:V.label,documentation:D.isMarkdownString(V.documentation)?J.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(le.to):[],activeParameter:V.activeParameter}}Se.to=de})(pe=e.SignatureInformation||(e.SignatureInformation={}));var ke;(function(Se){function De(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(pe.from):[]}}Se.from=De;function de(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(pe.to):[]}}Se.to=de})(ke=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Se){function De(de,V){const Pe=new l.InlayHint(i.to(V.position),typeof V.label=="string"?V.label:V.label.map(Ne.to.bind(void 0,de)),V.kind&&Le.to(V.kind));return Pe.textEdits=V.textEdits&&V.textEdits.map(X.to),Pe.tooltip=D.isMarkdownString(V.tooltip)?J.to(V.tooltip):V.tooltip,Pe.paddingLeft=V.paddingLeft,Pe.paddingRight=V.paddingRight,Pe}Se.to=De})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(Se){function De(de,V){const Pe=new l.InlayHintLabelPart(V.label);return Pe.tooltip=D.isMarkdownString(V.tooltip)?J.to(V.tooltip):V.tooltip,S.Command.is(V.command)&&(Pe.command=de.fromInternal(V.command)),V.location&&(Pe.location=M.to(V.location)),Pe}Se.to=De})(Ne=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Le;(function(Se){function De(V){return V}Se.from=De;function de(V){return V}Se.to=de})(Le=e.InlayHintKind||(e.InlayHintKind={}));var me;(function(Se){function De(V){return{range:o.from(V.range),url:V.target,tooltip:V.tooltip}}Se.from=De;function de(V){let Pe;if(V.url)try{Pe=typeof V.url=="string"?R.URI.parse(V.url,!0):R.URI.revive(V.url)}catch{}return new l.DocumentLink(o.to(V.range),Pe)}Se.to=de})(me=e.DocumentLink||(e.DocumentLink={}));var be;(function(Se){function De(V){const Pe=new l.ColorPresentation(V.label);return V.textEdit&&(Pe.textEdit=X.to(V.textEdit)),V.additionalTextEdits&&(Pe.additionalTextEdits=V.additionalTextEdits.map(Oe=>X.to(Oe))),Pe}Se.to=De;function de(V){return{label:V.label,textEdit:V.textEdit?X.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(Pe=>X.from(Pe)):void 0}}Se.from=de})(be=e.ColorPresentation||(e.ColorPresentation={}));var Ee;(function(Se){function De(V){return new l.Color(V[0],V[1],V[2],V[3])}Se.to=De;function de(V){return[V.red,V.green,V.blue,V.alpha]}Se.from=de})(Ee=e.Color||(e.Color={}));var Me;(function(Se){function De(V){return{range:o.from(V.range)}}Se.from=De;function de(V){return new l.SelectionRange(o.to(V.range))}Se.to=de})(Me=e.SelectionRange||(e.SelectionRange={}));var Be;(function(Se){function De(de){switch(de){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Se.to=De})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ve;(function(Se){function De(V){switch(V){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=De;function de(V){switch(V){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Se.to=de})(Ve=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ze;(function(Se){function De(V){if(V===l.EndOfLine.CRLF)return 1;if(V===l.EndOfLine.LF)return 0}Se.from=De;function de(V){if(V===1)return l.EndOfLine.CRLF;if(V===0)return l.EndOfLine.LF}Se.to=de})(ze=e.EndOfLine||(e.EndOfLine={}));var Ye;(function(Se){function De(de){if(typeof de=="object")return de.viewId;switch(de){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=De})(Ye=e.ProgressLocation||(e.ProgressLocation={}));var Ke;(function(Se){function De(de){const V={start:de.start+1,end:de.end+1};return de.kind&&(V.kind=qe.from(de.kind)),V}Se.from=De})(Ke=e.FoldingRange||(e.FoldingRange={}));var qe;(function(Se){function De(de){if(de)switch(de){case l.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Se.from=De})(qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var je;(function(Se){function De(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?o.from(de.selection):void 0,override:typeof de.override=="boolean"?w.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=De})(je=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var xe;(function(Se){function De(Oe){return Oe instanceof l.RelativePattern?Oe.toJSON():typeof Oe=="string"?Oe:de(Oe)||V(Oe)?new l.RelativePattern(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}Se.from=De;function de(Oe){const Xe=Oe;return Xe?R.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function V(Oe){const Xe=Oe;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Pe(Oe){return typeof Oe=="string"?Oe:new l.RelativePattern(R.URI.revive(Oe.baseUri),Oe.pattern)}Se.to=Pe})(xe=e.GlobPattern||(e.GlobPattern={}));var Ge;(function(Se){function De(de){if(de){if(Array.isArray(de))return de.map(De);if(typeof de=="string")return de;{const V=de;return{language:V.language,scheme:V.scheme,pattern:xe.from(V.pattern),exclusive:V.exclusive,notebookType:V.notebookType}}}else return}Se.from=De})(Ge=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(Se){function De(V){return{start:V.start,end:V.end}}Se.from=De;function de(V){return new l.NotebookRange(V.start,V.end)}Se.to=de})(ce=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(Se){function De(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}Se.to=De;function de(V){return{lastRunSuccess:V.success,runStartTime:V.timing?.startTime,runEndTime:V.timing?.endTime,executionOrder:V.executionOrder}}Se.from=de})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(Se){function De(de){if(de===E.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(de===E.NotebookCellExecutionState.Pending)return;if(de===E.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=De})(Ie=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ae;(function(Se){function De(V){switch(V){case l.NotebookCellKind.Markup:return E.CellKind.Markup;case l.NotebookCellKind.Code:default:return E.CellKind.Code}}Se.from=De;function de(V){switch(V){case E.CellKind.Markup:return l.NotebookCellKind.Markup;case E.CellKind.Code:default:return l.NotebookCellKind.Code}}Se.to=de})(Ae=e.NotebookCellKind||(e.NotebookCellKind={}));var Fe;(function(Se){function De(V){const Pe={metadata:V.metadata??Object.create(null),cells:[]};for(const Oe of V.cells)l.NotebookCellData.validate(Oe),Pe.cells.push($e.from(Oe));return Pe}Se.from=De;function de(V){const Pe=new l.NotebookData(V.cells.map($e.to));return(0,b.isEmptyObject)(V.metadata)||(Pe.metadata=V.metadata),Pe}Se.to=de})(Fe=e.NotebookData||(e.NotebookData={}));var $e;(function(Se){function De(V){return{cellKind:Ae.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:Ce.from(V.executionSummary??{}),outputs:V.outputs?V.outputs.map(rt.from):[]}}Se.from=De;function de(V){return new l.NotebookCellData(Ae.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(rt.to):void 0,V.metadata,V.internalMetadata?Ce.to(V.internalMetadata):void 0)}Se.to=de})($e=e.NotebookCellData||(e.NotebookCellData={}));var Qe;(function(Se){function De(V){return{mime:V.mime,valueBytes:t.VSBuffer.wrap(V.data)}}Se.from=De;function de(V){return new l.NotebookCellOutputItem(V.valueBytes.buffer,V.mime)}Se.to=de})(Qe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var rt;(function(Se){function De(V){return{outputId:V.id,items:V.items.map(Qe.from),metadata:V.metadata}}Se.from=De;function de(V){const Pe=V.items.map(Qe.to);return new l.NotebookCellOutput(Pe,V.outputId,V.metadata)}Se.to=de})(rt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Se){function De(Pe){return V(Pe)?{include:(0,b.withNullAsUndefined)(xe.from(Pe.include)),exclude:(0,b.withNullAsUndefined)(xe.from(Pe.exclude))}:(0,b.withNullAsUndefined)(xe.from(Pe))}Se.from=De;function de(Pe){return V(Pe)?{include:xe.to(Pe.include),exclude:xe.to(Pe.exclude)}:xe.to(Pe)}Se.to=de;function V(Pe){const Oe=Pe;return Oe?!(0,b.isUndefinedOrNull)(Oe.include)&&!(0,b.isUndefinedOrNull)(Oe.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ze;(function(Se){function De(de,V,Pe){const Oe=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Oe,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=De})(Ze=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var at;(function(Se){function De(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Se.from=De})(at=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var st;(function(Se){function De(V){return{uri:V.uri,provides:V.provides}}Se.from=De;function de(V){return new l.NotebookRendererScript(R.URI.revive(V.uri),V.provides)}Se.to=de})(st=e.NotebookRendererScript||(e.NotebookRendererScript={}));var dt;(function(Se){function De(V){return{message:J.fromStrict(V.message)||"",type:0,expected:V.expectedOutput,actual:V.actualOutput,location:V.location&&{range:o.from(V.location.range),uri:V.location.uri}}}Se.from=De;function de(V){const Pe=new l.TestMessage(typeof V.message=="string"?V.message:J.to(V.message));return Pe.actualOutput=V.actual,Pe.expectedOutput=V.expected,Pe.location=V.location?M.to(V.location):void 0,Pe}Se.to=de})(dt=e.TestMessage||(e.TestMessage={}));var ft;(function(Se){Se.namespace=m.namespaceTestTag,Se.denamespace=m.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var At;(function(Se){function De(V){const Pe=(0,h.getPrivateApiFor)(V).controllerId;return{extId:g.TestId.fromExtHostTestItem(V,Pe).toString(),label:V.label,uri:R.URI.revive(V.uri),busy:V.busy,tags:V.tags.map(Oe=>ft.namespace(Pe,Oe.id)),range:k.Range.lift(o.from(V.range)),description:V.description||null,sortText:V.sortText||null,error:V.error&&J.fromStrict(V.error)||null}}Se.from=De;function de(V){return{parent:void 0,error:void 0,id:g.TestId.fromString(V.extId).localId,label:V.label,uri:R.URI.revive(V.uri),tags:(V.tags||[]).map(Pe=>{const{tagId:Oe}=ft.denamespace(Pe);return new l.TestTag(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(V.range||void 0),canResolveChildren:!1,busy:V.busy,description:V.description||void 0,sortText:V.sortText||void 0}}Se.toPlain=de})(At=e.TestItem||(e.TestItem={})),function(Se){function De(V){return{id:V.id}}Se.from=De;function de(V){return new l.TestTag(V.id)}Se.to=de}(ft=e.TestTag||(e.TestTag={}));var St;(function(Se){const De=(V,Pe)=>{const Oe=[];for(const[We,tt]of Pe)g.TestId.compare(tt.item.extId,We)===2&&(Pe.delete(We),Oe.push(tt));const Xe={...At.toPlain(V.item),parent:void 0,taskStates:V.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(tt=>tt.type===0).map(dt.to)})),children:Oe.map(We=>De(We,Pe))};for(const We of Xe.children)We.parent=Xe;return Xe};function de(V){const Pe=[],Oe=new Map;for(const Xe of V.items)Oe.set(Xe.item.extId,Xe),V.request.targets.some(We=>We.controllerId===Xe.controllerId&&We.testIds.includes(Xe.item.extId))&&Pe.push(Xe);return{completedAt:V.completedAt,results:Pe.map(Xe=>De(Xe,Oe))}}Se.to=de})(St=e.TestResults||(e.TestResults={}));var _t;(function(Se){function De(Oe){return{covered:Oe.covered,total:Oe.covered}}function de(Oe){return"line"in Oe?i.from(Oe):o.from(Oe)}function V(Oe){return"branches"in Oe?{count:Oe.executionCount,location:de(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&de(Xe.location)})):void 0}:{type:0,count:Oe.executionCount,location:de(Oe.location)}}Se.fromDetailed=V;function Pe(Oe){return{uri:Oe.uri,statement:De(Oe.statementCoverage),branch:Oe.branchCoverage&&De(Oe.branchCoverage),function:Oe.functionCoverage&&De(Oe.functionCoverage),details:Oe.detailedCoverage?.map(V)}}Se.fromFile=Pe})(_t=e.TestCoverage||(e.TestCoverage={}));var ot;(function(Se){function De(de){switch(de){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Se.to=De})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var vt;(function(Se){function De(V){const Pe=new l.TypeHierarchyItem(U.to(V.kind),V.name,V.detail||"",R.URI.revive(V.uri),o.to(V.range),o.to(V.selectionRange));return Pe._sessionId=V._sessionId,Pe._itemId=V._itemId,Pe}Se.to=De;function de(V,Pe,Oe){if(Pe=Pe??V._sessionId,Oe=Oe??V._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,kind:U.from(V.kind),name:V.name,detail:V.detail??"",uri:V.uri,range:o.from(V.range),selectionRange:o.from(V.selectionRange),tags:V.tags?.map(x.from)}}Se.from=de})(vt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var ht;(function(Se){function De(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}Se.from=De})(ht=e.ViewBadge||(e.ViewBadge={}));var ut;(function(Se){function De(de,V){const Pe=de.fileData;return Pe?new class extends l.DataTransferItem{asFile(){return{name:Pe.name,uri:R.URI.revive(Pe.uri),data:(0,f.once)(()=>V())}}}("",de.id):new l.DataTransferItem(de.asString)}Se.toDataTransferItem=De})(ut=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(Se){function De(V,Pe){const Oe=V.items.map(([Xe,We])=>[Xe,ut.toDataTransferItem(We,()=>Pe(We.id))]);return new l.DataTransfer(Oe)}Se.toDataTransfer=De;async function de(V){const Pe={items:[]},Oe=[];return V.forEach((Xe,We)=>{Oe.push((async()=>{const tt=await Xe.asString(),lt=Xe.asFile();Pe.items.push([We,{id:Xe.id,asString:tt,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(Oe),Pe}Se.toDataTransferDTO=de})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(we[254],ye([1,0,49,122,81,121,82,127,4]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const b=(u,l,f,r)=>{let o=l;return{enumerable:!0,configurable:!1,get(){return o},set(n){if(!f(o,n)){const i=o;o=n,u.listener?.(r(n,i))}}}},R=(u,l)=>u===l,k={range:(u,l)=>u===l?!0:!u||!l?!1:u.isEqual(l),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(u,l)=>!(u.length!==l.length||u.some(f=>!l.find(r=>f.id===r.id)))},S=u=>l=>({op:4,update:u(l)}),y=(u,l)=>({range:(()=>{let f;const r=S(o=>({range:v.Range.lift(I.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return f},set(o){u.listener?.({op:6}),k.range(f,o)||(f=o,u.listener?.(r(o)))}}})(),label:b(u,l,k.label,S(f=>({label:f}))),description:b(u,void 0,k.description,S(f=>({description:f}))),sortText:b(u,void 0,k.sortText,S(f=>({sortText:f}))),canResolveChildren:b(u,!1,k.canResolveChildren,f=>({op:2,state:f})),busy:b(u,!1,k.busy,S(f=>({busy:f}))),error:b(u,void 0,k.error,S(f=>({error:I.MarkdownString.fromStrict(f)||null}))),tags:b(u,[],k.tags,(f,r)=>({op:1,new:f.map(I.TestTag.from),old:r.map(I.TestTag.from)}))}),h=u=>{const l=D.TestId.fromString(u.extId),f=new E(l.controllerId,l.localId,u.label,p.URI.revive(u.uri)||void 0);return f.range=I.Range.to(u.range||void 0),f.description=u.description||void 0,f.sortText=u.sortText||void 0,f.tags=u.tags.map(r=>I.TestTag.to({id:(0,T.denamespaceTestTag)(r).tagId})),f},w=u=>{let l;for(const f of u.tests){const r=h(f.item);(0,t.getPrivateApiFor)(r).parent=l,l=r}return l};e.toItemFromContext=w;class E{constructor(l,f,r,o){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const n=(0,t.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof g?void 0:n.parent}},children:{value:(0,C.createTestItemChildren)(n,t.getPrivateApiFor,E),enumerable:!0,writable:!1},...y(n,r)})}}e.TestItemImpl=E;class g extends E{constructor(l,f){super(l,l,f,void 0)}}e.TestItemRootImpl=g;class m extends C.TestItemCollection{constructor(l,f,r){super({controllerId:l,getDocumentVersion:o=>o&&r.getDocument(o)?.version,getApiFor:t.getPrivateApiFor,getChildren:o=>o.children,root:new g(l,f),toITestItem:I.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(we[255],ye([1,0,35,185,50]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function C(T,I,p,b){const R=new Map;T.forEach(S=>{const y=v.ExtensionIdentifier.toKey(S.identifier),h=R.get(y);h&&b.warn((0,t.localize)(0,null,h.extensionLocation.fsPath,S.extensionLocation.fsPath)),R.set(y,S)}),I.forEach(S=>{const y=v.ExtensionIdentifier.toKey(S.identifier),h=R.get(y);if(h)if(h.isBuiltin){if(D.gte(h.version,S.version)){b.warn(`Skipping extension ${S.extensionLocation.path} in favour of the builtin extension ${h.extensionLocation.path}.`);return}S.isBuiltin=!0}else b.warn((0,t.localize)(1,null,h.extensionLocation.fsPath,S.extensionLocation.fsPath));else if(S.isBuiltin){b.warn(`Skipping obsolete builtin extension ${S.extensionLocation.path}`);return}R.set(y,S)}),p.forEach(S=>{b.info((0,t.localize)(2,null,S.extensionLocation.fsPath));const y=v.ExtensionIdentifier.toKey(S.identifier),h=R.get(y);h&&h.isBuiltin&&(S.isBuiltin=!0),R.set(y,S)});const k=[];return R.forEach(S=>k.push(S)),k}e.dedupExtensions=C}),define(we[256],ye([1,0,3,47,4,63,12,69,99,94,218,6,27,55,255]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class w{constructor(g,m,u,l,f,r,o){if(this._connectionToken=g,this._environmentService=m,this._userDataProfilesService=u,this._logService=f,this._extensionHostStatusService=r,this._extensionsScannerService=o,m.args["install-builtin-extension"]){const i={isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]};this.whenExtensionsReady=l.installExtensions([],m.args["install-builtin-extension"],i,!!m.args.force).then(null,s=>{f.error(s)})}else this.whenExtensionsReady=Promise.resolve();const n=m.args["install-extension"];if(n){const i=n.map(s=>/\.vsix$/i.test(s)?D.URI.file((0,k.isAbsolute)(s)?s:(0,k.join)((0,S.cwd)(),s)):s);this.whenExtensionsReady.then(()=>l.installExtensions(i,[],{isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]},!!m.args.force)).then(null,s=>{f.error(s)})}}async call(g,m,u){switch(m){case"getEnvironmentData":{const l=u,f=(0,C.createURITransformer)(l.remoteAuthority);let r=await this._getEnvironmentData();return r=(0,I.transformOutgoingURIs)(r,f),r}case"getExtensionHostExitInfo":{const l=u;return this._extensionHostStatusService.getExitInfo(l.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const l=u,f=l.language;this._logService.trace(`Scanning extensions using UI language: ${f}`);const r=(0,C.createURITransformer)(l.remoteAuthority),o=l.extensionDevelopmentPath&&l.extensionDevelopmentPath.map(s=>D.URI.revive(r.transformIncoming(s))),n=o?o.filter(s=>s.scheme===T.Schemas.file).map(s=>s.fsPath):void 0;let i=await this._scanExtensions(f,n);return i=(0,I.transformOutgoingURIs)(i,r),this._logService.trace("Scanned Extensions",i),w._massageWhenConditions(i),i}case"scanSingleExtension":{await this.whenExtensionsReady;const l=u,f=l.language,r=l.isBuiltin,o=(0,C.createURITransformer)(l.remoteAuthority),n=D.URI.revive(o.transformIncoming(l.extensionLocation)),i=n.scheme===T.Schemas.file?n.fsPath:null;if(!i)return null;let s=await this._scanSingleExtension(i,r,f);return s?(s=(0,I.transformOutgoingURIs)(s,o),w._massageWhenConditions([s]),s):null}case"getDiagnosticInfo":{const l=u,f={machineInfo:(0,R.getMachineInfo)()},r=l.includeProcesses?(0,b.listProcesses)(process.pid):Promise.resolve();let o=[];const n={};if(l.folders){const i=(0,C.createURITransformer)("");o=l.folders.map(a=>D.URI.revive(i.transformIncoming(a))).filter(a=>a.scheme==="file").map(a=>(0,R.collectWorkspaceStats)(a.fsPath,["node_modules",".git"]).then(c=>{n[(0,k.basename)(a.fsPath)]=c}))}return Promise.all([r,...o]).then(([i,s])=>(f.processes=i||void 0,f.workspaceMetadata=l.folders?n:void 0,f))}}throw new Error(`IPC Command ${m} not found`)}listen(g,m,u){throw new Error("Not supported")}static _massageWhenConditions(g){const m=(n,i)=>n.replace(/file/g,"vscode-remote"),u=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(m(n.source,!0),i)},l=new class{mapDefined(n){return p.ContextKeyDefinedExpr.create(n)}mapNot(n){return p.ContextKeyNotExpr.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.ContextKeyEqualsExpr.create(n,m(i,!1)):p.ContextKeyEqualsExpr.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.ContextKeyNotEqualsExpr.create(n,m(i,!1)):p.ContextKeyNotEqualsExpr.create(n,i)}mapGreater(n,i){return p.ContextKeyGreaterExpr.create(n,i)}mapGreaterEquals(n,i){return p.ContextKeyGreaterEqualsExpr.create(n,i)}mapSmaller(n,i){return p.ContextKeySmallerExpr.create(n,i)}mapSmallerEquals(n,i){return p.ContextKeySmallerEqualsExpr.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?p.ContextKeyRegexExpr.create(n,u(i)):p.ContextKeyRegexExpr.create(n,i)}mapIn(n,i){return p.ContextKeyInExpr.create(n,i)}mapNotIn(n,i){return p.ContextKeyNotInExpr.create(n,i)}},f=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=p.ContextKeyExpr.deserialize(n.when);if(!i)return;const s=i.map(l);n.when=s.serialize()},r=n=>{if(Array.isArray(n))for(const i of n)f(i);else f(n)},o=n=>{for(const i in n)r(n[i])};g.forEach(n=>{n.contributes&&(n.contributes.menus&&o(n.contributes.menus),n.contributes.keybindings&&r(n.contributes.keybindings),n.contributes.views&&o(n.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:D.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:D.URI.file(this._environmentService.logsPath),extensionsPath:D.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:D.URI.file((0,k.join)(this._environmentService.logsPath,`exthost${w._namePool++}`)),globalStorageHome:this._userDataProfilesService.defaultProfile.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:v.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(g,m){const[u,l,f]=await Promise.all([this._scanBuiltinExtensions(g),this._scanInstalledExtensions(g),this._scanDevelopedExtensions(g,m)]);return(0,h.dedupExtensions)(u,l,f,this._logService)}async _scanDevelopedExtensions(g,m){return m?(await Promise.all(m.map(u=>this._extensionsScannerService.scanOneOrMultipleExtensions(D.URI.file((0,k.resolve)(u)),1,{language:g})))).flat().map(u=>(0,y.toExtensionDescription)(u,!0)):[]}async _scanBuiltinExtensions(g){return(await this._extensionsScannerService.scanSystemExtensions({language:g,useCache:!0})).map(u=>(0,y.toExtensionDescription)(u,!1))}async _scanInstalledExtensions(g){return(await this._extensionsScannerService.scanUserExtensions({language:g,useCache:!0})).map(u=>(0,y.toExtensionDescription)(u,!1))}async _scanSingleExtension(g,m,u){const l=D.URI.file((0,k.resolve)(g)),f=m?0:1,r=await this._extensionsScannerService.scanExistingExtension(l,f,{language:u});return r?(0,y.toExtensionDescription)(r,!1):null}}e.RemoteAgentEnvironmentChannel=w,w._namePool=1}),define(we[128],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const t=[];function D(I){const p=new v(I);return t[p.nid]=p,p}e.createProxyIdentifier=D;function C(I){return t[I].sid}e.getStringIdentifierForProxy=C;class T{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=T}),define(we[257],ye([1,0,128]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var C;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(C=e.TabModelOperationKind||(e.TabModelOperationKind={}));var T;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var I;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(I=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var p;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(p=e.CellOutputKind||(e.CellOutputKind={}));var b;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(b=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(E){return E._id=k._n++,E}}e.IdObject=k,k._n=0;var S;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.command="m",w.kindModifier="n"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var y;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(y=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(h=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,v.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,v.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,v.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,v.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,v.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,v.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,v.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,v.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,v.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,v.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,v.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,v.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,v.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,v.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,v.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,v.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,v.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,v.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,v.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,v.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,v.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,v.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,v.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,v.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,v.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,v.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,v.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,v.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,v.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,v.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,v.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,v.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,v.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,v.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,v.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,v.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,v.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,v.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,v.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,v.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,v.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,v.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,v.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,v.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,v.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,v.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,v.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,v.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,v.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,v.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,v.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,v.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,v.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,v.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,v.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,v.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,v.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,v.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,v.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,v.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,v.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,v.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,v.createProxyIdentifier)("ExtHostLocalization")}});var Rt=this&&this.__classPrivateFieldSet||function(oe,e,v,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,v):D?D.value=v:e.set(oe,v),v},nt=this&&this.__classPrivateFieldGet||function(oe,e,v,t){if(v==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?t:v==="a"?t.call(oe):t?t.value:e.get(oe)};define(we[258],ye([1,0,11,126,127,22,257,18,13,46,49,97,4,2,5,244,254,16,128,38]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u){"use strict";var l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(c,d){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,f.set(this,void 0),Rt(this,l,c.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=d,Rt(this,f,c.getProxy(T.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,P=>{const F=this._apiCommands.get(P);return F?.result===i.Void?F:void 0},d),this._argumentProcessors=[{processArgument(P){return(0,b.revive)(P)}},{processArgument(P){return(0,C.cloneAndChange)(P,function(F){if(R.Range.isIRange(F))return D.Range.to(F);if(k.Position.isIPosition(F))return D.Position.to(F);if(R.Range.isIRange(F.range)&&S.URI.isUri(F.uri))return D.location.to(F);if(F instanceof g.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const d=this.registerCommand(!1,c.id,async(...P)=>{const F=c.args.map((Z,J)=>{if(!Z.validate(P[J]))throw new Error(`Invalid argument '${Z.name}' when running '${c.id}', received: ${P[J]}`);return Z.convert(P[J])}),$=await this.executeCommand(c.internalId,...F);return c.result.convert($,P,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{d.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,d,P,F,$,Z){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:P,thisArg:F,description:$,extension:Z}),c&&nt(this,l,"f").$registerCommand(d),new t.Disposable(()=>{this._commands.delete(d)&&c&&nt(this,l,"f").$unregisterCommand(d)})}executeCommand(c,...d){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,d,!0)}async _doExecuteCommand(c,d,P){if(this._commands.has(c))return nt(this,l,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,d,!1);{let F=!1;const $=(0,C.cloneAndChange)(d,function(Z){if(Z instanceof t.Position)return D.Position.from(Z);if(Z instanceof t.Range)return D.Range.from(Z);if(Z instanceof t.Location)return D.location.from(Z);if(t.NotebookRange.isNotebookRange(Z))return D.NotebookRange.from(Z);if(Z instanceof ArrayBuffer)return F=!0,g.VSBuffer.wrap(new Uint8Array(Z));if(Z instanceof Uint8Array)return F=!0,g.VSBuffer.wrap(Z);if(Z instanceof g.VSBuffer)return F=!0,Z;if(!Array.isArray(Z))return Z});try{const Z=await nt(this,l,"f").$executeCommand(c,F?new m.SerializableObjectWithBuffers($):$,P);return(0,b.revive)(Z)}catch(Z){if(Z instanceof Error&&Z.message==="$executeCommand:retry")return this._doExecuteCommand(c,d,!1);throw Z}}}async _executeContributedCommand(c,d,P){const F=this._commands.get(c);if(!F)throw new Error("Unknown command");this._reportTelemetry(F,c);const{callback:$,thisArg:Z,description:J}=F;if(J)for(let _=0;_<J.args.length;_++)try{(0,v.validateConstraint)(d[_],J.args[_].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${J.args[_].name}' - ${J.args[_].description}`)}try{return await $.apply(Z,d)}catch(_){if(c===this.converter.delegatingCommandId){const ee=this.converter.getActualCommand(...d);ee&&(c=ee.command)}throw this._logService.error(_,c,F.extension?.identifier),P?new class extends Error{constructor(){super((0,u.toErrorMessage)(_)),this.id=c,this.source=F.extension?.displayName??F.extension?.name}}:_}}_reportTelemetry(c,d){!c.extension||c.extension.isBuiltin||nt(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:d})}$executeContributedCommand(c,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(d=d.map(P=>this._argumentProcessors.reduce((F,$)=>$.processArgument(F),P)),this._executeContributedCommand(c,d,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),nt(this,l,"f").$getCommands().then(d=>(c&&(d=d.filter(P=>P[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[d,P]of this._commands){const{description:F}=P;F&&(c[d]=F)}return Promise.resolve(c)}};l=new WeakMap,f=new WeakMap,r=Re([_e(0,w.IExtHostRpcService),_e(1,p.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class o{constructor(c,d,P){this._commands=c,this._lookupApiCommand=d,this._logService=P,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,d){if(!c)return;const P={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return P;const F=this._lookupApiCommand(c.command);if(F)P.id=F.internalId,P.arguments=F.args.map(($,Z)=>$.convert(c.arguments&&c.arguments[Z]));else if((0,I.isNonEmptyArray)(c.arguments)){const $=++this._cachIdPool;this._cache.set($,c),d.add((0,y.toDisposable)(()=>{this._cache.delete($),this._logService.trace("CommandsConverter#DISPOSE",$)})),P.$ident=$,P.id=this.delegatingCommandId,P.arguments=[$],this._logService.trace("CommandsConverter#CREATE",c.command,$)}return P}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const d=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class n{constructor(c,d,P,F){this.name=c,this.description=d,this.validate=P,this.convert=F}optional(){return new n(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,d){return new n(c??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",a=>S.URI.isUri(a),a=>a),n.Position=new n("position","A position in a text document",a=>t.Position.isPosition(a),D.Position.from),n.Range=new n("range","A range in a text document",a=>t.Range.isRange(a),D.Range.from),n.Selection=new n("selection","A selection in a text document",a=>t.Selection.isSelection(a),D.Selection.from),n.Number=new n("number","",a=>typeof a=="number",a=>a),n.String=new n("string","",a=>typeof a=="string",a=>a),n.CallHierarchyItem=new n("item","A call hierarchy item",a=>a instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",a=>a instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",a=>a instanceof E.TestItemImpl,D.TestItem.from);class i{constructor(c,d){this.description=c,this.convert=d}}e.ApiCommandResult=i,i.Void=new i("no result",a=>a);class s{constructor(c,d,P,F,$){this.id=c,this.internalId=d,this.description=P,this.args=F,this.result=$}}e.ApiCommand=s}),define(we[259],ye([1,0,57,242,30,258,4,13,78]),function(oe,e,v,t,D,C,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class b{constructor(S,y,h){this._commands=S,this.logService=y,this._ipcHandlePath=h,this._server=t.createServer((w,E)=>this.onRequest(w,E)),this.setup().catch(w=>(y.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,y){const h=(E,g)=>{y.writeHead(E,{"content-type":"application/json"}),y.end(JSON.stringify(g||null),m=>m&&this.logService.error(m))},w=[];S.setEncoding("utf8"),S.on("data",E=>w.push(E)),S.on("end",async()=>{try{const E=JSON.parse(w.join(""));let g;switch(E.type){case"open":g=await this.open(E);break;case"openExternal":g=await this.openExternal(E);break;case"status":g=await this.getStatus(E);break;case"extensionManagement":g=await this.manageExtensions(E);break;default:h(404,`Unknown message type: ${E.type}`);break}h(200,g)}catch(E){const g=E instanceof Error?E.message:JSON.stringify(E);h(500,g),this.logService.error("Error while processing pipe request",E)}})}async open(S){const{fileURIs:y,folderURIs:h,forceNewWindow:w,diffMode:E,mergeMode:g,addMode:m,forceReuseWindow:u,gotoLineMode:l,waitMarkerFilePath:f,remoteAuthority:r}=S,o=[];if(Array.isArray(h))for(const a of h)try{o.push({folderUri:T.URI.parse(a)})}catch{}if(Array.isArray(y))for(const a of y)try{(0,p.hasWorkspaceFileExtension)(a)?o.push({workspaceUri:T.URI.parse(a)}):o.push({fileUri:T.URI.parse(a)})}catch{}const n=f?T.URI.file(f):void 0,s={forceNewWindow:w,diffMode:E,mergeMode:g,addMode:m,gotoLineMode:l,forceReuseWindow:u,preferNewWindow:!u&&!n&&!m,waitMarkerFileURI:n,remoteAuthority:r};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(S){for(const y of S.uris){const h=T.URI.parse(y),w=h.scheme==="file"?h:y;await this._commands.executeCommand("_remoteCLI.openExternal",w)}}async manageExtensions(S){const y=w=>w?.map(E=>/\.vsix$/i.test(E)?T.URI.parse(E):E),h={list:S.list,install:y(S.install),uninstall:y(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",h)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=b;let R=class extends b{constructor(S,y){super(S,y,(0,v.createRandomIPCHandle)())}};R=Re([_e(0,C.IExtHostCommands),_e(1,I.ILogService)],R),e.CLIServer=R}),define(we[260],ye([1,0,28,7,22,2,6,3,4,57,63,259,246,120,247,249,125]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class g extends w.AbstractVariableResolverService{constructor(l,f,r,o,n){super({getFolderUri:i=>{const s=f.filter(a=>a.name===i);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(i,s)=>o[`config:${s}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(r)return T.normalize(r.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber,getExtension:async i=>{const a=(await n.getInstalled()).find(c=>c.identifier.id===i);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(v.homedir()),Promise.resolve(l))}}class m extends C.Disposable{constructor(l,f,r,o,n){super(),this._environmentService=l,this._logService=f,this._ptyService=r,this._productService=o,this._extensionManagementService=n,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,f,r){switch(f){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,r);case"$createProcess":{const o=(0,R.createURITransformer)(l.remoteAuthority);return this._createProcess(o,r)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,r);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,r);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,r);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,r);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,r);case"$start":return this._ptyService.start.apply(this._ptyService,r);case"$input":return this._ptyService.input.apply(this._ptyService,r);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,r);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,r);case"$resize":return this._ptyService.resize.apply(this._ptyService,r);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,r);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,r);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,r);case"$sendCommandResult":return this._sendCommandResult(r[0],r[1],r[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,r);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,r);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,r);case"$getProfiles":return this._getProfiles.apply(this,r);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(r[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,r);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,r);case"$getRevivedPtyNewId":return this._ptyService.getRevivedPtyNewId.apply(this._ptyService,r);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,r);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,r);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,r);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,r);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,r);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(r[0],r[1]);case"$freePortKillProcess":return this._ptyService.freePortKillProcess?.apply(r[0],r[1])}throw new Error(`IPC Command ${f} not found`)}listen(l,f,r){switch(f){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(l,f){const r={name:f.shellLaunchConfig.name,executable:f.shellLaunchConfig.executable,args:f.shellLaunchConfig.args,cwd:typeof f.shellLaunchConfig.cwd=="string"||typeof f.shellLaunchConfig.cwd>"u"?f.shellLaunchConfig.cwd:p.URI.revive(l.transformIncoming(f.shellLaunchConfig.cwd)),env:f.shellLaunchConfig.env,useShellEnvironment:f.shellLaunchConfig.useShellEnvironment,reconnectionProperties:f.shellLaunchConfig.reconnectionProperties,type:f.shellLaunchConfig.type,isFeatureTerminal:f.shellLaunchConfig.isFeatureTerminal},o=await(0,E.buildUserEnvironment)(f.resolverEnv,!!f.shellLaunchConfig.useShellEnvironment,I.language,this._environmentService,this._logService);this._logService.trace("baseEnv",o);const n=B=>({uri:p.URI.revive(l.transformIncoming(B.uri)),name:B.name,index:B.index,toResource:()=>{throw new Error("Not implemented")}}),i=f.workspaceFolders.map(n),s=f.activeWorkspaceFolder?n(f.activeWorkspaceFolder):void 0,a=f.activeFileResource?p.URI.revive(l.transformIncoming(f.activeFileResource)):void 0,c=new g(o,i,a,f.resolvedVariables,this._extensionManagementService),d=h.createVariableResolver(s,process.env,c),P=await h.getCwd(r,v.homedir(),d,s?.uri,f.configuration["terminal.integrated.cwd"],this._logService);r.cwd=P;const F=I.isWindows?"terminal.integrated.env.windows":I.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",$=f.configuration[F],Z=await h.createTerminalEnvironment(r,$,d,this._productService.version,f.configuration["terminal.integrated.detectLocale"],o);if(!r.strictEnv){const B=[];for(const[X,O]of f.envVariableCollections)B.push([X,{map:(0,y.deserializeEnvironmentVariableCollection)(O)}]);const ue=new Map(B);await new S.MergedEnvironmentVariableCollection(ue).applyToProcessEnvironment(Z,d)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:P,cols:f.cols,rows:f.rows,env:Z});const J=(0,b.createRandomIPCHandle)();Z.VSCODE_IPC_HOOK_CLI=J;const _=await this._ptyService.createProcess(r,P,f.cols,f.rows,f.unicodeVersion,Z,o,f.options,f.shouldPersistTerminal,f.workspaceId,f.workspaceName),ee={executeCommand:(B,...ue)=>this._executeCommand(_,B,ue,l)},ne=new k.CLIServerBase(ee,this._logService,J);return this._ptyService.onProcessExit(B=>B.id===_&&ne.dispose()),{persistentTerminalId:_,resolvedShellLaunchConfig:r}}_executeCommand(l,f,r,o){let n,i;const s=new Promise((d,P)=>{n=d,i=P}),a=++this._lastReqId;this._pendingCommands.set(a,{resolve:n,reject:i,uriTransformer:o});const c=(0,D.cloneAndChange)(r,d=>{if(d&&d.$mid===1)return o.transformOutgoing(d);if(d&&d instanceof p.URI)return o.transformOutgoingURI(d)});return this._onExecuteCommand.fire({reqId:a,persistentProcessId:l,commandId:f,commandArgs:c}),s}_sendCommandResult(l,f,r){const o=this._pendingCommands.get(l);if(!o)return;this._pendingCommands.delete(l);const n=(0,D.cloneAndChange)(r,i=>{if(i&&i.$mid===1)return o.uriTransformer.transformIncoming(i)});f?o.reject(n):o.resolve(n)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,f,r,o){return this._ptyService.getProfiles?.(l,f,r,o)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=m}),define(we[129],ye([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(we[261],ye([1,0,8,2,12,199]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class T extends C.DiskFileSystemProviderClient{static register(p,b,R){const k=p.getConnection();if(!k)return t.Disposable.None;const S=new t.DisposableStore,y=(async()=>{try{const h=await p.getRawEnvironment();h?b.registerProvider(D.Schemas.vscodeRemote,S.add(new T(h,k))):R.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(h){R.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,v.getErrorMessage)(h))}})();return S.add(b.onWillActivateFileSystemProvider(h=>{h.scheme===D.Schemas.vscodeRemote&&h.join(y)})),S}constructor(p,b){super(b.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:p.os===3})}}e.RemoteFileSystemProviderClient=T}),define(we[130],ye([1,0,30,14,6,11,21,157,272,273]),function(oe,e,v,t,D,C,T,I,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(r,o){let n=o.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=r,this.cause=o}}e.ExtractError=R;function k(f){const r=f.externalFileAttributes>>16||33188;return[448,56,7].map(o=>r&o).reduce((o,n)=>o+n,r&61440)}function S(f){if(f instanceof R)return f;let r;return/end of central directory record signature not found/.test(f.message)&&(r="CorruptZip"),new R(r,f)}function y(f,r,o,n,i,s){const a=D.dirname(r),c=D.join(n,a);if(!c.startsWith(n))return Promise.reject(new Error(I.localize(0,null,r)));const d=D.join(n,r);let P;return s.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(T.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((F,$)=>{if(!s.isCancellationRequested)try{P=(0,v.createWriteStream)(d,{mode:o}),P.once("close",()=>F()),P.once("error",$),f.once("error",$),f.pipe(P)}catch(Z){$(Z)}}))}function h(f,r,o,n){let i=(0,t.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{i.cancel(),f.close()}),new Promise((a,c)=>{const d=new t.Sequencer,P=F=>{F.isCancellationRequested||(s++,f.readEntry())};f.once("error",c),f.once("close",()=>i.then(()=>{n.isCancellationRequested||f.entryCount===s?a():c(new R("Incomplete",new Error(I.localize(1,null,s,f.entryCount))))},c)),f.readEntry(),f.on("entry",F=>{if(n.isCancellationRequested)return;if(!o.sourcePathRegex.test(F.fileName)){P(n);return}const $=F.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test($)){const _=D.join(r,$);i=(0,t.createCancelablePromise)(ee=>T.Promises.mkdir(_,{recursive:!0}).then(()=>P(ee)).then(void 0,c));return}const Z=E(f,F),J=k(F);i=(0,t.createCancelablePromise)(_=>d.queue(()=>Z.then(ee=>y(ee,$,J,r,o,_).then(()=>P(_)))).then(null,c))})})}function w(f,r=!1){return new Promise((o,n)=>{(0,p.open)(f,r?{lazyEntries:!0}:void 0,(i,s)=>{i?n(S(i)):o((0,C.assertIsDefined)(s))})})}function E(f,r){return new Promise((o,n)=>{f.openReadStream(r,(i,s)=>{i?n(S(i)):o((0,C.assertIsDefined)(s))})})}function g(f,r){return new Promise((o,n)=>{const i=new b.ZipFile;r.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const s=(0,v.createWriteStream)(f);i.outputStream.pipe(s),i.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>o(f))})}e.zip=g;function m(f,r,o={},n){const i=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=w(f,!0);return o.overwrite&&(s=s.then(a=>T.Promises.rm(r).then(()=>a))),s.then(a=>h(a,r,{sourcePathRegex:i},n))}e.extract=m;function u(f,r){return w(f).then(o=>new Promise((n,i)=>{o.on("entry",s=>{s.fileName===r&&E(o,s).then(a=>n(a),a=>i(a))}),o.once("close",()=>i(new Error(I.localize(2,null,r))))}))}function l(f,r){return u(f,r).then(o=>new Promise((n,i)=>{const s=[];o.once("error",i),o.on("data",a=>s.push(a)),o.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=l}),define(we[262],ye([1,0,130,167]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(C){return(0,v.buffer)(C,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=D}),define(we[131],ye([1,0,14,38,8,2,12,6,3,19,50,11,4,23,21,130,166,72,29,234,31,32,53,55,211,235,262,212,233,35,70,17,5,13,26,33,39,37]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l,f,r,o,n,i,s,a,c,d,P,F,$,Z,J,_,ee,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,$.refineServiceDecorator)(l.IExtensionManagementService);let B=class extends u.AbstractExtensionManagementService{constructor(K,ie,L,M,G,re,he,ve,H,Y,te,W){super(K,ie,L,Y,W),this.extensionsScannerService=G,this.extensionsProfileScannerService=re,this.downloadService=he,this.fileService=H,this.installGalleryExtensionsTasks=new Map;const q=this._register(ve.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(ve.createInstance(ue,Q=>q.postUninstall(Q))),this.manifestCache=this._register(new a.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(ve.createInstance(n.ExtensionsDownloader));const j=this._register(new c.ExtensionsWatcher(this,H,M,L,te));this._register(j.onDidChangeExtensionsByAnotherSource(({added:Q,removed:le})=>{Q.length&&this._onDidInstallExtensions.fire(Q.map(pe=>({identifier:pe.identifier,operation:1,local:pe}))),le.forEach(pe=>this._onDidUninstallExtension.fire({identifier:pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(K){this.logService.trace("ExtensionManagementService#zip",K.identifier.id);const ie=await this.collectFiles(K),L=await(0,w.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)()).fsPath,ie);return S.URI.file(L)}async unzip(K){return this.logService.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:ie,cleanup:L}=await this.downloadVsix(K),M=I.resolve(ie.fsPath);try{return await(0,s.getManifest)(M)}finally{await L()}}getInstalled(K,ie){return this.extensionsScanner.scanExtensions(K??null,ie)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(K,ie={}){this.logService.trace("ExtensionManagementService#install",K.toString());const{location:L,cleanup:M}=await this.downloadVsix(K);try{const G=await(0,s.getManifest)(I.resolve(L.fsPath));if(G.engines&&G.engines.vscode&&!(0,P.isEngineValid)(G.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,(0,f.getGalleryExtensionId)(G.publisher,G.name),this.productService.version));return await this.installExtension(G,L,ie)}finally{await M()}}getMetadata(K){return this.extensionsScannerService.scanMetadata(K.location)}async updateMetadata(K,ie){this.logService.trace("ExtensionManagementService#updateMetadata",K.identifier.id);const L={...ie};return ie.isPreReleaseVersion&&(L.preRelease=!0),K=await this.extensionsScanner.updateMetadata(K,L),this.manifestCache.invalidate(),K}async updateExtensionScope(K,ie){return this.logService.trace("ExtensionManagementService#updateExtensionScope",K.identifier.id),K=await this.extensionsScanner.updateMetadata(K,{isMachineScoped:ie}),this.manifestCache.invalidate(),K}removeUninstalledExtensions(K){return this.extensionsScanner.cleanUp(K)}async downloadVsix(K){if(K.scheme===T.Schemas.file)return{location:K,async cleanup(){}};this.logService.trace("Downloading extension from",K.toString());const ie=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)());return await this.downloadService.download(K,ie),this.logService.info("Downloaded extension to",ie.toString()),{location:ie,cleanup:async()=>{try{await this.fileService.del(ie)}catch(M){this.logService.error(M)}}}}doCreateInstallExtensionTask(K,ie,L){let M;if(S.URI.isUri(ie))M=new O(K,ie,L,this.galleryService,this.extensionsScanner,this.logService);else{const G=f.ExtensionKey.create(ie).toString();M=this.installGalleryExtensionsTasks.get(G),M||(this.installGalleryExtensionsTasks.set(G,M=new X(K,ie,L,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(G)))}return L.profileLocation?new U(M,L.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(K,ie){return ie.profileLocation?new ae(K,ie.profileLocation,this.extensionsProfileScannerService):new x(K,ie,this.extensionsScanner)}async collectFiles(K){const ie=async M=>{let G=await h.Promises.readdir(M);G=G.map(ve=>I.join(M,ve));const re=await Promise.all(G.map(ve=>h.Promises.stat(ve)));let he=Promise.resolve([]);return re.forEach((ve,H)=>{const Y=G[H];ve.isFile()&&(he=he.then(te=>[...te,Y])),ve.isDirectory()&&(he=he.then(te=>ie(Y).then(W=>[...te,...W])))}),he};return(await ie(K.location.fsPath)).map(M=>({path:`extension/${I.relative(K.location.fsPath,M)}`,localPath:M}))}};B=Re([_e(0,l.IExtensionGalleryService),_e(1,_.ITelemetryService),_e(2,Z.ILogService),_e(3,m.INativeEnvironmentService),_e(4,o.IExtensionsScannerService),_e(5,r.IExtensionsProfileScannerService),_e(6,g.IDownloadService),_e(7,$.IInstantiationService),_e(8,F.IFileService),_e(9,J.IProductService),_e(10,ee.IUriIdentityService),_e(11,ne.IUserDataProfilesService)],B),e.ExtensionManagementService=B;let ue=class extends C.Disposable{constructor(K,ie,L,M){super(),this.beforeRemovingExtension=K,this.fileService=ie,this.extensionsScannerService=L,this.logService=M,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new v.Queue}async cleanUp(K){await this.removeUninstalledExtensions(),K&&await this.removeOutdatedExtensions()}async scanExtensions(K,ie){const L={includeInvalid:!0,profileLocation:ie};let M=[];return K===null||K===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},L,!1)):K===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(L)),M=K!==null?M.filter(G=>G.type===K):M,Promise.all(M.map(G=>this.toLocalExtension(G)))}async scanUserExtensions(K){const ie=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(ie.map(L=>this.toLocalExtension(L)))}async extractUserExtension(K,ie,L,M){const G=K.toString(),re=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),he=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,G);try{await h.Promises.rm(he)}catch{throw new l.ExtensionManagementError(E.localize(1,null,he,K.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(K,ie,re,M),await this.extensionsScannerService.updateMetadata(S.URI.file(re),L);try{await this.rename(K,re,he,Date.now()+2*60*1e3),this.logService.info("Renamed to",he)}catch(ve){try{await h.Promises.rm(re)}catch{}if(ve.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(ve)}. Deleted from extracted location`,re),ve}return this.scanLocalExtension(S.URI.file(he),1)}async updateMetadata(K,ie){return await this.extensionsScannerService.updateMetadata(K.location,ie),this.scanLocalExtension(K.location,K.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...K){const ie=K.map(L=>f.ExtensionKey.create(L));await this.withUninstalledExtensions(L=>{ie.forEach(M=>L[M.toString()]=!0)})}async setInstalled(K){await this.withUninstalledExtensions(M=>delete M[K.toString()]);const L=(await this.scanUserExtensions(!0)).find(M=>f.ExtensionKey.create(M).equals(K))||null;return L?this.updateMetadata(L,{installedTimestamp:Date.now()}):null}async removeExtension(K,ie){this.logService.trace(`Deleting ${ie} extension from disk`,K.identifier.id,K.location.fsPath),await h.Promises.rm(K.location.fsPath),this.logService.info("Deleted from disk",K.identifier.id,K.location.fsPath)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.withUninstalledExtensions(ie=>delete ie[f.ExtensionKey.create(K).toString()])}async withUninstalledExtensions(K){return this.uninstalledFileLimiter.queue(async()=>{let ie;try{ie=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let L={};if(ie)try{L=JSON.parse(ie)}catch{}return K&&(K(L),Object.keys(L).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(L)):await h.Promises.rm(this.uninstalledPath)),L})}async extractAtLocation(K,ie,L,M){this.logService.trace(`Started extracting the extension from ${ie} to ${L}`);try{await h.Promises.rm(L)}catch(G){throw new l.ExtensionManagementError(this.joinErrors(G).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(ie,L,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${L}:`,K.id)}catch(G){try{await h.Promises.rm(L)}catch{}let re=l.ExtensionManagementErrorCode.Extract;throw G instanceof w.ExtractError&&(G.type==="CorruptZip"?re=l.ExtensionManagementErrorCode.CorruptZip:G.type==="Incomplete"&&(re=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(G.message,re)}}async rename(K,ie,L,M){try{await h.Promises.rename(ie,L)}catch(G){if(p.isWindows&&G&&G.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${ie} to ${L} with 'EPERM' error. Trying again...`,K.id),this.rename(K,ie,L,M);throw new l.ExtensionManagementError(G.message||E.localize(2,null,ie,L),G.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(K,ie){const L=await this.extensionsScannerService.scanExistingExtension(K,ie,{includeInvalid:!0});if(L)return this.toLocalExtension(L);throw new Error(E.localize(3,null,K.path))}async toLocalExtension(K){const ie=await this.fileService.resolve(K.location);let L,M;return ie.children&&(L=ie.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,M=ie.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:L,changelogUrl:M,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated}}async removeUninstalledExtensions(){const K=await this.getUninstalledExtensions(),ie=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const re of ie)K[f.ExtensionKey.create(re).toString()]||L.add(re.identifier.id.toLowerCase());const M=(0,f.groupByExtension)(ie,re=>re.identifier);await v.Promises.settled(M.map(async re=>{const he=re.sort((ve,H)=>R.rcompare(ve.manifest.version,H.manifest.version))[0];L.has(he.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(he))}));const G=ie.filter(re=>K[f.ExtensionKey.create(re).toString()]);await v.Promises.settled(G.map(re=>this.removeUninstalledExtension(re)))}async removeOutdatedExtensions(){const K=await this.extensionsScannerService.scanSystemExtensions({}),ie=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=[],M=await this.extensionsScannerService.getTargetPlatform(),G=(0,f.groupByExtension)(ie,re=>re.identifier);for(const re of G)if(re.length>1&&L.push(...re.sort((he,ve)=>{const H=R.rcompare(he.manifest.version,ve.manifest.version);return H!==0?H:he.targetPlatform===M?-1:1}).slice(1)),re[0].type===0){const he=K.find(ve=>(0,f.areSameExtensions)(ve.identifier,re[0].identifier));(!he||R.gte(he.manifest.version,re[0].manifest.version))&&L.push(re[0])}await v.Promises.settled(L.map(re=>this.removeExtension(re,"outdated")))}joinErrors(K){const ie=Array.isArray(K)?K:[K];return ie.length===1?ie[0]instanceof Error?ie[0]:new Error(ie[0]):ie.reduce((L,M)=>new Error(`${L.message}${L.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};ue=Re([_e(1,F.IFileService),_e(2,o.IExtensionsScannerService),_e(3,Z.ILogService)],ue);class z extends u.AbstractExtensionTask{get operation(){return(0,k.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(K,ie,L,M,G){super(),this.identifier=K,this.source=ie,this.options=L,this.extensionsScanner=M,this.logService=G,this._operation=2}async installExtension(K,ie){try{const L=await this.unsetUninstalledAndGetLocal(K.key);if(L)return this.extensionsScanner.updateMetadata(L,K.metadata)}catch{throw p.isMacintosh?new l.ExtensionManagementError(E.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(E.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(K,ie)}async unsetUninstalledAndGetLocal(K){if(!await this.isUninstalled(K))return null;this.logService.trace("Removing the extension from uninstalled list:",K.id);const L=await this.extensionsScanner.setInstalled(K);return this.logService.info("Removed the extension from uninstalled list:",K.id),L}async isUninstalled(K){return!!(await this.extensionsScanner.getUninstalledExtensions())[K.toString()]}async extract({zipPath:K,key:ie,metadata:L},M){const G=await this.extensionsScanner.extractUserExtension(ie,K,L,M);return this.logService.info("Extracting completed.",ie.id),G}}class X extends z{constructor(K,ie,L,M,G,re){super(ie.identifier,ie,L,G,re),this.manifest=K,this.gallery=ie,this.extensionsDownloader=M}async doRun(K){const L=(await this.extensionsScanner.scanExtensions(null,void 0)).find(re=>(0,f.areSameExtensions)(re.identifier,this.gallery.identifier));L&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,d.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,k.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:L?.preRelease)};if(L?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(L,M),metadata:M};const G=await this.downloadExtension(this.gallery,this._operation);try{const re=await this.installExtension({zipPath:G,key:f.ExtensionKey.create(this.gallery),metadata:M},K);return L&&!this.options.profileLocation&&(L.targetPlatform!==re.targetPlatform||R.neq(L.manifest.version,re.manifest.version))&&await this.extensionsScanner.setUninstalled(L),{local:re,metadata:M}}catch(re){throw await this.deleteDownloadedVSIX(G),re}}async deleteDownloadedVSIX(K){try{await this.extensionsDownloader.delete(S.URI.file(K))}catch(ie){this.logService.warn("Error while deleting the downloaded vsix",K.toString(),(0,D.getErrorMessage)(ie))}}async downloadExtension(K,ie){let L;try{this.logService.trace("Started downloading extension:",K.identifier.id),L=(await this.extensionsDownloader.downloadExtension(K,ie)).fsPath,this.logService.info("Downloaded extension:",K.identifier.id,L)}catch(M){throw new l.ExtensionManagementError((0,u.joinErrors)(M).message,l.ExtensionManagementErrorCode.Download)}try{return await(0,s.getManifest)(L),L}catch(M){throw await this.deleteDownloadedVSIX(L),new l.ExtensionManagementError((0,u.joinErrors)(M).message,l.ExtensionManagementErrorCode.Invalid)}}}class O extends z{constructor(K,ie,L,M,G,re){super({id:(0,f.getGalleryExtensionId)(K.publisher,K.name)},ie,L,G,re),this.manifest=K,this.location=ie,this.galleryService=M}async doRun(K){const ie=new f.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(he=>(0,f.areSameExtensions)(this.identifier,he.identifier)),G=await this.getMetadata(this.identifier.id,this.manifest.version,K);if(G.isApplicationScoped=(0,d.isApplicationScopedExtension)(this.manifest),G.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||M?.isBuiltin,G.installedTimestamp=Date.now(),M)if(this._operation=3,ie.equals(new f.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(E.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&R.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const he=await this.unsetUninstalledAndGetLocal(ie);if(he)try{await this.extensionsScanner.removeExtension(he,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:I.resolve(this.location.fsPath),key:ie,metadata:G},K),metadata:G}}async getMetadata(K,ie,L){try{let[M]=await this.galleryService.getExtensions([{id:K,version:ie}],L);if(M||([M]=await this.galleryService.getExtensions([{id:K}],L)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class U{constructor(K,ie,L){this.task=K,this.profileLocation=ie,this.extensionsProfileScannerService=L,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const K=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[K.local,K.metadata]],this.profileLocation),K}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class x extends u.AbstractExtensionTask{constructor(K,ie,L){super(),this.extension=K,this.options=ie,this.extensionsScanner=L}async doRun(K){const ie=[],L=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=f.ExtensionKey.create(this.extension);ie.push(...L.filter(G=>M.equals(f.ExtensionKey.create(G))))}else ie.push(...L.filter(M=>(0,f.areSameExtensions)(M.identifier,this.extension.identifier)));if(!ie.length)throw new Error(E.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ie),this.options.remove)for(const M of ie)try{K.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(G){throw new Error(E.localize(9,null,(0,t.toErrorMessage)(G)))}}}class ae extends u.AbstractExtensionTask{constructor(K,ie,L){super(),this.extension=K,this.profileLocation=ie,this.extensionsProfileScannerService=L}async doRun(K){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(we[132],ye([1,0,76,14,16,8,2,11,25,29,77,13,215,274]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let h=class extends T.Disposable{constructor(E,g,m){super(),this.environmentService=g,this.logService=m,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,g){this.logService.trace("RequestService#request (node) - begin",E.url);const{proxyUrl:m,strictSSL:u}=this;let l;try{l=await(0,R.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const f={...process.env,...l},r=E.agent?E.agent:await(0,S.getProxyAgent)(E.url||"",f,{proxyUrl:m,strictSSL:u});E.agent=r,E.strictSSL=u,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(E,g);return this.logService.trace("RequestService#request (node) - success",E.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",E.url,o),o}}async getNodeRequest(E){return((0,v.parse)(E.url).protocol==="https:"?await new Promise((u,l)=>{oe(["https"],u,l)}):await new Promise((u,l)=>{oe(["http"],u,l)})).request}_request(E,g){return t.Promises.withAsyncBody(async(m,u)=>{const l=(0,v.parse)(E.url),f=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),r={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,I.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(r.auth=E.user+":"+E.password);const o=f(r,n=>{const i=(0,I.isNumber)(E.followRedirects)?E.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...E,url:n.headers.location,followRedirects:i-1},g).then(m,u);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,y.createGunzip)())),m({res:n,stream:(0,D.streamToBufferReadableStream)(s)})}});o.on("error",u),E.timeout&&o.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&o.write(E.data),o.end(),g.onCancellationRequested(()=>{o.abort(),u(new C.CancellationError)})})}async resolveProxy(E){}};h=Re([_e(0,p.IConfigurationService),_e(1,b.INativeEnvironmentService),_e(2,k.ILogService)],h),e.RequestService=h}),define(we[263],ye([1,0,73,13,59,106,25,54,132,43,33,31,115,131,101,51,2,102,61,12,17,26,104,129,40,108,74,109,8,4,6,27,213,72,39,114,58,3,55,117,37,53,62]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l,f,r,o,n,i,s,a,c,d,P,F,$,Z,J,_,ee,ne,B,ue,z,X,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class U extends E.Disposable{constructor(K,ie){super(),this.args=K,this.remoteDataFolder=ie,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const K=await this.initServices();await K.invokeFunction(async ie=>{const L=ie.get(t.ILogService);try{await this.doRun(K.createInstance(i.ExtensionManagementCLI))}catch(M){throw L.error(M),console.error((0,c.getErrorMessage)(M)),M}})}async initServices(){const K=new v.ServiceCollection,ie={_serviceBrand:void 0,...w.default};K.set(f.IProductService,ie);const L=new n.ServerEnvironmentService(this.args,ie);K.set(n.IServerEnvironmentService,L);const M=new t.LogService(new r.SpdLogLogger(o.RemoteExtensionLogFileName,(0,P.join)(L.logsPath,`${o.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(L)));K.set(t.ILogService,M),M.trace(`Remote configuration data at ${this.remoteDataFolder}`),M.trace("process arguments:",this.args);const G=this._register(new g.FileService(M));K.set(l.IFileService,G),G.registerProvider(u.Schemas.file,this._register(new m.DiskFileSystemProvider(M)));const re=new _.UriIdentityService(G);K.set(J.IUriIdentityService,re);const he=this._register(new z.UserDataProfilesService(L,G,re,M));K.set(z.IUserDataProfilesService,he);const ve=this._register(new C.ConfigurationService(he.defaultProfile.settingsResource,G,new O.NullPolicyService,M));return await ve.initialize(),K.set(T.IConfigurationService,ve),K.set(I.IRequestService,new D.SyncDescriptor(p.RequestService)),K.set(Z.IDownloadService,new D.SyncDescriptor($.DownloadService)),K.set(R.ITelemetryService,b.NullTelemetryService),K.set(k.IExtensionGalleryService,new D.SyncDescriptor(S.ExtensionGalleryServiceWithNoStorageService)),K.set(X.IExtensionsProfileScannerService,new D.SyncDescriptor(X.ExtensionsProfileScannerService)),K.set(B.IExtensionsScannerService,new D.SyncDescriptor(ue.ExtensionsScannerService)),K.set(y.INativeServerExtensionManagementService,new D.SyncDescriptor(y.ExtensionManagementService)),K.set(s.ILanguagePackService,new D.SyncDescriptor(a.NativeLanguagePackService)),new h.InstantiationService(K)}async doRun(K){if(this.args["list-extensions"])return K.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const ie={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return K.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],ie,!!this.args.force)}else{if(this.args["uninstall-extension"])return K.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return K.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(K){return K.map(ie=>/\.vsix$/i.test(ie)?d.URI.file((0,P.isAbsolute)(ie)?ie:(0,P.join)((0,F.cwd)(),ie)):ie)}}function x(fe){setTimeout(()=>process.exit(fe),0)}async function ae(fe,K,ie){if(fe.help){const M=w.default.serverApplicationName+(ne.isWindows?".cmd":"");console.log((0,ee.buildHelpMessage)(w.default.nameLong,M,w.default.version,ie,{noInputFiles:!0,noPipe:!0}));return}if(fe.version){console.log((0,ee.buildVersionMessage)(w.default.version,w.default.commit));return}const L=new U(fe,K);try{await L.run(),x(0)}catch{x(1)}finally{L.dispose()}}e.run=ae}),define(we[264],ye([1,0,28,7,2,12,6,90,21,42,25,106,71,240,186,72,187,197,188,29,115,31,108,198,131,17,102,61,59,101,73,74,109,13,103,104,51,26,54,214,132,111,33,43,225,112,232,39,114,256,245,217,222,260,63,40,251,129,261,116,55,117,53,37,241,62,223]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l,f,r,o,n,i,s,a,c,d,P,F,$,Z,J,_,ee,ne,B,ue,z,X,O,U,x,ae,fe,K,ie,L,M,G,re,he,ve,H,Y,te,W,q,j,Q,le,pe,ke,Te,Ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Le="monacoworkbench";async function me(Ke,qe,je,xe){const Ge=new P.ServiceCollection,ce=new Me,Ce={_serviceBrand:void 0,...ee.default};Ge.set(ne.IProductService,Ce);const Ie=new H.ServerEnvironmentService(qe,Ce);Ge.set(u.IEnvironmentService,Ie),Ge.set(u.INativeEnvironmentService,Ie);const Ae=new Z.LogService(new _.SpdLogLogger(te.RemoteExtensionLogFileName,T.join(Ie.logsPath,`${te.RemoteExtensionLogFileName}.log`),!0,!1,(0,Z.getLogLevel)(Ie))),Fe=new Z.MultiplexLogService([new Be((0,Z.getLogLevel)(Ie)),Ae]);Ge.set(Z.ILogService,Fe),setTimeout(()=>Ye(Ie.logsPath).then(null,ot=>Fe.error(ot)),1e4),Fe.trace(`Remote configuration data at ${je}`),Fe.trace("process arguments:",Ie.args),Array.isArray(Ce.serverGreeting)&&Ae.info(`

${Ce.serverGreeting.join(`
`)}

`),ce.registerChannel(h.ExtensionHostDebugBroadcastChannel.ChannelName,new h.ExtensionHostDebugBroadcastChannel);const $e=new b.StaticRouter(ot=>ot.clientId==="renderer");ce.registerChannel("logger",new J.LogLevelChannel(Fe));const Qe=xe.add(new s.FileService(Fe));Ge.set(i.IFileService,Qe),Qe.registerProvider(C.Schemas.file,xe.add(new a.DiskFileSystemProvider(Fe)));const rt=new ie.UriIdentityService(Qe);Ge.set(K.IUriIdentityService,rt);const it=new pe.UserDataProfilesService(Ie,Qe,rt,Fe);Ge.set(pe.IUserDataProfilesService,it);const Ze=new k.ConfigurationService(Ie.machineSettingsResource,Qe,new Te.NullPolicyService,Fe);Ge.set(R.IConfigurationService,Ze),await Ze.initialize();const at=new q.ExtensionHostStatusService;Ge.set(q.IExtensionHostStatusService,at),Ge.set(B.IRequestService,new c.SyncDescriptor(z.RequestService));let st=U.NullAppender;const dt=await(0,I.getMachineId)(),ft=(0,U.isInternalTelemetry)(Ce,Ze);if((0,U.supportsTelemetry)(Ce,Ie)){const ot=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";ot?st=new Ne.OneDataSystemAppender(!1,Le,null,()=>new ke.TelemetryClient(ot)):Ce.aiConfig&&Ce.aiConfig.ariaKey&&(st=new Ne.OneDataSystemAppender(ft,Le,null,Ce.aiConfig.ariaKey)),xe.add((0,D.toDisposable)(()=>st?.flush()));const vt={appenders:[st],commonProperties:(0,X.resolveCommonProperties)(Qe,(0,v.release)(),(0,v.hostname)(),process.arch,Ce.commit,Ce.version+"-remote",dt,ft,Ie.installSourcePath,"remoteAgent"),piiPaths:(0,U.getPiiPathsFromEnvironment)(Ie)},ht=Ie.args["telemetry-level"];let ut=3;ht==="all"?ut=3:ht==="error"?ut=2:ht==="crash"?ut=1:ht!==void 0&&(ut=0),Ge.set(re.IServerTelemetryService,new c.SyncDescriptor(re.ServerTelemetryService,[vt,ut]))}else Ge.set(re.IServerTelemetryService,re.ServerNullTelemetryService);Ge.set(f.IExtensionGalleryService,new c.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService));const At=ce.getChannel("download",$e);Ge.set(w.IDownloadService,new E.DownloadServiceChannelClient(At,()=>Ee("renderer"))),Ge.set(le.IExtensionsProfileScannerService,new c.SyncDescriptor(le.ExtensionsProfileScannerService)),Ge.set(j.IExtensionsScannerService,new c.SyncDescriptor(Q.ExtensionsScannerService)),Ge.set(n.INativeServerExtensionManagementService,new c.SyncDescriptor(n.ExtensionManagementService));const St=new d.InstantiationService(Ge);Ge.set(F.ILanguagePackService,St.createInstance($.NativeLanguagePackService));const _t=St.createInstance(fe.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:Ze.getValue("terminal.integrated.persistentSessionScrollback")??100});return Ge.set(ae.IPtyService,_t),Ge.set(g.IEncryptionMainService,new c.SyncDescriptor(m.EncryptionMainService,[dt])),Ge.set(S.ICredentialsMainService,new c.SyncDescriptor(y.CredentialsWebMainService)),St.invokeFunction(ot=>{const vt=ot.get(n.INativeServerExtensionManagementService),ht=ot.get(j.IExtensionsScannerService),ut=new L.RemoteAgentEnvironmentChannel(Ke,Ie,it,St.createInstance(r.ExtensionManagementCLI),Fe,at,ht);ce.registerChannel("remoteextensionsenvironment",ut);const kt=new G.ServerTelemetryChannel(ot.get(re.IServerTelemetryService),st);ce.registerChannel("telemetry",kt),ce.registerChannel(Y.REMOTE_TERMINAL_CHANNEL_NAME,new he.RemoteTerminalChannel(Ie,Fe,_t,Ce,vt));const Se=new M.RemoteAgentFileSystemProviderChannel(Fe,Ie);ce.registerChannel(W.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Se),ce.registerChannel("request",new ue.RequestChannel(ot.get(B.IRequestService)));const De=new o.ExtensionManagementChannel(vt,Oe=>Ee(Oe.remoteAuthority));ce.registerChannel("extensions",De);const de=b.ProxyChannel.fromService(ot.get(F.ILanguagePackService));ce.registerChannel("languagePacks",de);const V=b.ProxyChannel.fromService(ot.get(g.IEncryptionMainService));ce.registerChannel("encryption",V);const Pe=b.ProxyChannel.fromService(ot.get(S.ICredentialsMainService));return ce.registerChannel("credentials",Pe),vt.removeUninstalledExtensions(!0),xe.add(new x.default(ot.get(O.ITelemetryService))),{telemetryService:ot.get(O.ITelemetryService)}}),{socketServer:ce,instantiationService:St}}e.setupServerServices=me;const be=Object.create(null);function Ee(Ke){return be[Ke]||(be[Ke]=(0,ve.createURITransformer)(Ke)),be[Ke]}class Me extends b.IPCServer{constructor(){const qe=new t.Emitter;super(qe.event),this._onDidConnectEmitter=qe}acceptConnection(qe,je){this._onDidConnectEmitter.fire({protocol:qe,onDidClientDisconnect:je})}}e.SocketServer=Me;class Be extends Z.AbstractLogger{constructor(qe=Z.DEFAULT_LOG_LEVEL){super(),this.setLevel(qe),this.useColors=Boolean(process.stdout.isTTY)}trace(qe,...je){this.getLevel()<=Z.LogLevel.Trace&&(this.useColors?console.log(`\x1B[90m[${Ve()}]\x1B[0m`,qe,...je):console.log(`[${Ve()}]`,qe,...je))}debug(qe,...je){this.getLevel()<=Z.LogLevel.Debug&&(this.useColors?console.log(`\x1B[90m[${Ve()}]\x1B[0m`,qe,...je):console.log(`[${Ve()}]`,qe,...je))}info(qe,...je){this.getLevel()<=Z.LogLevel.Info&&(this.useColors?console.log(`\x1B[90m[${Ve()}]\x1B[0m`,qe,...je):console.log(`[${Ve()}]`,qe,...je))}warn(qe,...je){this.getLevel()<=Z.LogLevel.Warning&&(this.useColors?console.warn(`\x1B[93m[${Ve()}]\x1B[0m`,qe,...je):console.warn(`[${Ve()}]`,qe,...je))}error(qe,...je){this.getLevel()<=Z.LogLevel.Error&&(this.useColors?console.error(`\x1B[91m[${Ve()}]\x1B[0m`,qe,...je):console.error(`[${Ve()}]`,qe,...je))}critical(qe,...je){this.getLevel()<=Z.LogLevel.Critical&&(this.useColors?console.error(`\x1B[90m[${Ve()}]\x1B[0m`,qe,...je):console.error(`[${Ve()}]`,qe,...je))}dispose(){}flush(){}}function Ve(){const Ke=new Date;return`${ze(Ke.getHours())}:${ze(Ke.getMinutes())}:${ze(Ke.getSeconds())}`}function ze(Ke){return Ke<10?`0${Ke}`:String(Ke)}async function Ye(Ke){const qe=T.basename(Ke),je=T.dirname(Ke),ce=(await p.Promises.readdir(je)).filter(Ie=>/^\d{8}T\d{6}$/.test(Ie)).sort().filter(Ie=>Ie!==qe),Ce=ce.slice(0,Math.max(0,ce.length-9));await Promise.all(Ce.map(Ie=>p.Promises.rm(T.join(je,Ie))))}}),define(we[265],ye([1,0,110,30,91,266,76,133,16,8,36,2,12,6,47,3,15,4,23,147,95,57,5,13,26,75,33,125,237,238,40,264,243]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S,y,h,w,E,g,m,u,l,f,r,o,n,i,s,a,c,d,P,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const Z=5*60*1e3;let J=class extends k.Disposable{constructor(B,ue,z,X,O,U,x,ae){super(),this._socketServer=B,this._connectionToken=ue,this._vsdaMod=z,this._environmentService=O,this._productService=U,this._logService=x,this._instantiationService=ae,this._webEndpointOriginChecker=ee.create(this._productService),this._serverRootPath=(0,i.getRemoteServerRootPath)(U),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=X?this._instantiationService.createInstance($.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(B,ue){if(B.method!=="GET")return(0,$.serveError)(B,ue,405,`Unsupported method ${B.method}`);if(!B.url)return(0,$.serveError)(B,ue,400,"Bad request.");const z=T.parse(B.url,!0);let X=z.pathname;if(!X)return(0,$.serveError)(B,ue,400,"Bad request.");if(X.startsWith(this._serverRootPath)&&X.charCodeAt(this._serverRootPath.length)===47&&(X=X.substring(this._serverRootPath.length)),X==="/version")return ue.writeHead(200,{"Content-Type":"text/plain"}),ue.end(this._productService.commit||"");if(X==="/delay-shutdown")return this._delayShutdown(),ue.writeHead(200),ue.end("OK");if(!(0,d.requestHasValidConnectionToken)(this._connectionToken,B,z))return(0,$.serveError)(B,ue,403,"Forbidden.");if(X==="/vscode-remote-resource"){const O=z.query.path;if(typeof O!="string")return(0,$.serveError)(B,ue,400,"Bad request.");let U;try{U=g.URI.from({scheme:S.Schemas.file,path:O}).fsPath}catch{return(0,$.serveError)(B,ue,400,"Bad request.")}const x=Object.create(null);this._environmentService.isBuilt&&((0,R.isEqualOrParent)(U,this._environmentService.builtinExtensionsPath,!w.isLinux)||(0,R.isEqualOrParent)(U,this._environmentService.extensionsPath,!w.isLinux))&&(x["Cache-Control"]="public, max-age=31536000"),x.Vary="Origin";const ae=B.headers.origin;return ae&&this._webEndpointOriginChecker.matches(ae)&&(x["Access-Control-Allow-Origin"]=ae),(0,$.serveFile)(U,1,this._logService,B,ue,x)}if(this._webClientServer){this._webClientServer.handle(B,ue,z);return}return ue.writeHead(404,{"Content-Type":"text/plain"}),ue.end("Not found")}handleUpgrade(B,ue){let z=(0,m.generateUuid)(),X=!1,O=!1;if(B.url){const ie=T.parse(B.url,!0).query;typeof ie.reconnectionToken=="string"&&(z=ie.reconnectionToken),ie.reconnection==="true"&&(X=!0),ie.skipWebSocketFrames==="true"&&(O=!0)}if(B.headers.upgrade===void 0||B.headers.upgrade.toLowerCase()!=="websocket"){ue.end("HTTP/1.1 400 Bad Request");return}const U=B.headers["sec-websocket-key"],x=v.createHash("sha1");x.update(U+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ae=x.digest("base64"),fe=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ae}`];let K=!1;if(!O&&!this._environmentService.args["disable-websocket-compression"]&&B.headers["sec-websocket-extensions"]){const ie=Array.isArray(B.headers["sec-websocket-extensions"])?B.headers["sec-websocket-extensions"]:[B.headers["sec-websocket-extensions"]];for(const L of ie)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(L)){if(/\b(permessage-deflate)\b/.test(L)){K=!0,fe.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(L)){K=!0,fe.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ue.write(fe.join(`\r
`)+`\r
\r
`),ue.setTimeout(0),ue.setNoDelay(!0),O?this._handleWebSocketConnection(new f.NodeSocket(ue,`server-connection-${z}`),X,z):this._handleWebSocketConnection(new f.WebSocketNodeSocket(new f.NodeSocket(ue,`server-connection-${z}`),K,null,!0),X,z)}handleServerError(B){this._logService.error("Error occurred in server"),this._logService.error(B)}_getRemoteAddress(B){let ue;return B instanceof f.NodeSocket?ue=B.socket:ue=B.socket.socket,ue.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(B,ue,z){const X=ue.getSocket();this._logService.error(`${B} ${z}.`);const O={type:"error",reason:z};ue.sendControl(p.VSBuffer.fromString(JSON.stringify(O))),ue.dispose(),await X.drain(),X.dispose()}_handleWebSocketConnection(B,ue,z){const X=this._getRemoteAddress(B),O=`[${X}][${z.substr(0,8)}]`,U=new l.PersistentProtocol(B),x=this._vsdaMod?new this._vsdaMod.validator:null,ae=this._vsdaMod?new this._vsdaMod.signer:null;let fe;(function(M){M[M.WaitingForAuth=0]="WaitingForAuth",M[M.WaitingForConnectionType=1]="WaitingForConnectionType",M[M.Done=2]="Done",M[M.Error=3]="Error"})(fe||(fe={}));let K=0;const ie=M=>{K=3,L.dispose(),this._rejectWebSocketConnection(O,U,M)},L=U.onControlMessage(M=>{if(K===0){let G;try{G=JSON.parse(M.toString())}catch{return ie("Malformed first message")}if(G.type!=="auth")return ie("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(G.auth))return ie("Unauthorized client refused: auth mismatch");let re=(0,m.generateUuid)();if(ae)try{re=ae.sign(G.data)}catch{}let he=(0,m.generateUuid)();if(x)try{he=x.createNewMessage(he)}catch{}const ve={type:"sign",data:he,signedData:re};U.sendControl(p.VSBuffer.fromString(JSON.stringify(ve))),K=1}else if(K===1){let G;try{G=JSON.parse(M.toString())}catch{return ie("Malformed second message")}if(G.type!=="connectionType")return ie("Invalid second message");if(typeof G.signedData!="string")return ie("Invalid second message field type");const re=G.commit,he=this._productService.commit;if(re&&he&&re!==he)return ie("Client refused: version mismatch");let ve=!1;if(!x)ve=!0;else if(this._connectionToken.validate(G.signedData))ve=!0;else try{ve=x.validate(G.signedData)==="ok"}catch{}if(!ve){if(this._environmentService.isBuilt)return ie("Unauthorized client refused");this._logService.error(`${O} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const H in this._managementConnections)this._managementConnections[H].shortenReconnectionGraceTimeIfNecessary();for(const H in this._extHostConnections)this._extHostConnections[H].shortenReconnectionGraceTimeIfNecessary();K=2,L.dispose(),this._handleConnectionType(X,O,U,B,ue,z,G)}})}async _handleConnectionType(B,ue,z,X,O,U,x){const ae=x.desiredConnectionType===1?`${ue}[ManagementConnection]`:x.desiredConnectionType===2?`${ue}[ExtensionHostConnection]`:ue;if(x.desiredConnectionType===1)if(O){if(!this._managementConnections[U])return this._allReconnectionTokens.has(U)?this._rejectWebSocketConnection(ae,z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ae,z,"Unknown reconnection token (never seen)");z.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const fe=z.readEntireBuffer();z.dispose(),this._managementConnections[U].acceptReconnection(B,X,fe)}else{if(this._managementConnections[U])return this._rejectWebSocketConnection(ae,z,"Duplicate reconnection token");z.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const fe=new c.ManagementConnection(this._logService,U,B,z);this._socketServer.acceptConnection(fe.protocol,fe.onClose),this._managementConnections[U]=fe,this._allReconnectionTokens.add(U),fe.onClose(()=>{delete this._managementConnections[U]})}else if(x.desiredConnectionType===2){const fe=x.args||{language:"en"},K=await this._updateWithFreeDebugPort(fe);if(K.port&&this._logService.trace(`${ae} - startParams debug port ${K.port}`),this._logService.trace(`${ae} - startParams language: ${K.language}`),this._logService.trace(`${ae} - startParams env: ${JSON.stringify(K.env)}`),O){if(!this._extHostConnections[U])return this._allReconnectionTokens.has(U)?this._rejectWebSocketConnection(ae,z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ae,z,"Unknown reconnection token (never seen)");z.sendPause(),z.sendControl(p.VSBuffer.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const ie=z.readEntireBuffer();z.dispose(),this._extHostConnections[U].acceptReconnection(B,X,ie)}else{if(this._extHostConnections[U])return this._rejectWebSocketConnection(ae,z,"Duplicate reconnection token");z.sendPause(),z.sendControl(p.VSBuffer.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const ie=z.readEntireBuffer();z.dispose();const L=this._instantiationService.createInstance(a.ExtensionHostConnection,U,B,X,ie);this._extHostConnections[U]=L,this._allReconnectionTokens.add(U),L.onClose(()=>{delete this._extHostConnections[U],this._onDidCloseExtHostConnection()}),L.start(K)}}else if(x.desiredConnectionType===3){const fe=x.args;this._createTunnel(z,fe)}else return this._rejectWebSocketConnection(ae,z,"Unknown initial data received")}async _createTunnel(B,ue){const z=B.getSocket().socket,X=B.readEntireBuffer();B.dispose(),z.pause();const O=await this._connectTunnelSocket(ue.host,ue.port);X.byteLength>0&&O.write(X.buffer),O.on("end",()=>z.end()),O.on("close",()=>z.end()),O.on("error",()=>z.destroy()),z.on("end",()=>O.end()),z.on("close",()=>O.end()),z.on("error",()=>O.destroy()),O.pipe(z),z.pipe(O)}_connectTunnelSocket(B,ue){return new Promise((z,X)=>{const O=D.createConnection({host:B,port:ue},()=>{O.removeListener("error",X),O.pause(),z(O)});O.once("error",X)})}_updateWithFreeDebugPort(B){return typeof B.port=="number"?(0,u.findFreePort)(B.port,10,5e3).then(ue=>(B.port=ue,B)):(B.debugId=void 0,B.port=void 0,B.break=void 0,Promise.resolve(B))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},Z))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};J=Re([_e(4,P.IServerEnvironmentService),_e(5,n.IProductService),_e(6,o.ILogService),_e(7,r.IInstantiationService)],J),e.RemoteExtensionHostAgentServer=J;async function _(ne,B,ue){const z=await(0,d.determineServerConnectionToken)(B);z instanceof d.ServerConnectionTokenParseError&&(console.warn(z.message),process.exit(1));const X=new k.DisposableStore,{socketServer:O,instantiationService:U}=await(0,F.setupServerServices)(z,B,ue,X);U.invokeFunction(G=>{const re=G.get(o.ILogService);(0,b.setUnexpectedErrorHandler)(he=>{he&&he.code==="EPIPE"&&he.syscall==="write"&&he.stack&&/unexpectedErrorHandler/.test(he.stack)||re.error(he)}),process.on("SIGPIPE",()=>{(0,b.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),U.invokeFunction(G=>{const re=G.get(o.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const he=(0,y.join)(process.env.HOMEDRIVE,"node_modules"),ve=(0,y.dirname)((0,y.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),H=(0,y.join)(ve,"node_modules");if(t.existsSync(he)||t.existsSync(H)){const Y=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${he}
* ${H}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;re.warn(Y),console.warn(Y),process.exit(0)}}});const x=U.invokeFunction(G=>{const re=G.get(o.ILogService);if(t.existsSync((0,y.join)(S.FileAccess.asFileUri("",oe).fsPath,"../node_modules/vsda")))try{return oe.__$__nodeRequire("vsda")}catch(ve){re.error(ve)}return null}),ae=t.existsSync(S.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",oe).fsPath);if(ae&&ne&&typeof ne!="string"){const G=z.type!==0?`?${S.connectionTokenQueryName}=${z.value}`:"";console.log(`Web UI available at http://localhost${ne.port===80?"":`:${ne.port}`}/${G}`)}const fe=U.createInstance(J,O,z,x,ae);h.mark("code/server/ready");const K=C.performance.now(),ie=global.vscodeServerStartTime,L=global.vscodeServerListenTime,M=global.vscodeServerCodeLoadedTime;if(U.invokeFunction(G=>{G.get(s.ITelemetryService).publicLog2("serverStart",{startTime:ie,startedTime:L,codeLoadedTime:M,readyTime:K})}),B["print-startup-performance"]){const G=I.LoaderStats.get();let re="";re+=`

### Load AMD-module
`,re+=I.LoaderStats.toMarkdownTable(["Module","Duration"],G.amdLoad),re+=`

### Load commonjs-module
`,re+=I.LoaderStats.toMarkdownTable(["Module","Duration"],G.nodeRequire),re+=`

### Invoke AMD-module factory
`,re+=I.LoaderStats.toMarkdownTable(["Module","Duration"],G.amdInvoke),re+=`

### Invoke commonjs-module
`,re+=I.LoaderStats.toMarkdownTable(["Module","Duration"],G.nodeEval),re+=`Start-up time: ${L-ie}
`,re+=`Code loading time: ${M-ie}
`,re+=`Initialized time: ${K-ie}
`,re+=`
`,console.log(re)}return fe}e.createServer=_;class ee{static create(B){const ue=B.webEndpointUrlTemplate,z=B.commit,X=B.quality;if(!ue||!z||!X)return new ee(null);const O=(0,m.generateUuid)(),x=new URL(ue.replace("{{uuid}}",O).replace("{{commit}}",z).replace("{{quality}}",X)).origin,ae=(0,E.escapeRegExpCharacters)(x).replace(O,"[a-zA-Z0-9\\-]+");try{const fe=(0,E.createRegExp)(`^${ae}$`,!0,{matchCase:!1});return new ee(fe)}catch{return new ee(null)}}constructor(B){this._originRegExp=B}matches(B){return this._originRegExp?this._originRegExp.test(B):!1}}}),define(we[275],ye([1,0,28,30,12,263,265,58,6,266,40,51,47]),function(oe,e,v,t,D,C,T,I,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,S.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=b.performance.now();const y={onMultipleValues:(m,u)=>{console.error(`Option '${m}' can only be defined once. Using value ${u}.`)},onEmptyValue:m=>{console.error(`Ignoring option '${m}': Value must not be empty.`)},onUnknownOption:m=>{console.error(`Ignoring option '${m}': not supported for server.`)},onDeprecatedOption:(m,u)=>{console.warn(`Option '${m}' is deprecated: ${u}`)}};function h(){return(0,I.parseArgs)(process.argv.slice(2),R.serverOptions,y)}function w(m){const u=m["server-data-dir"]||m["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,p.join)(v.homedir(),k.default.serverDataFolderName||".vscode-remote"),l=m["user-data-dir"]||(0,p.join)(u,"data"),f=(0,p.join)(l,"User"),r=(0,p.join)(f,"globalStorage"),o=(0,p.join)(f,"History"),n=(0,p.join)(l,"Machine");m["user-data-dir"]=l;const i=(0,p.dirname)(D.FileAccess.asFileUri("",oe).fsPath),s=m["builtin-extensions-dir"]||(0,p.join)(i,"extensions");return m["builtin-extensions-dir"]=s,m["extensions-dir"]=m["extensions-dir"]||(0,p.join)(u,"extensions"),[u,m["extensions-dir"],l,f,n,r,o].forEach(a=>{try{t.existsSync(a)||t.mkdirSync(a,{mode:448})}catch(c){console.error(c)}}),u}function E(m=h()){return(0,C.run)(m,w(m),R.serverOptions)}e.spawnCli=E;function g(m,u=h()){return(0,T.createServer)(m,u,w(u))}e.createServer=g})}).call(this);

//# sourceMappingURL=server.main.js.map
